#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";


$hbox = acs::get_heading_box("$web_url/add.gif", "How to use images in your templates", qq[Instructions on using images in Templates]); 


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
<p><strong>How to use images in your templates<br>
</strong><br>
Templates are used in conjunction with all aspects of<strong> displaying your directory to
end users </strong>. Each template <strong>consists of</strong> <strong>HTML code</strong>
with <strong>variable words</strong> that is used in combination with each other. These
variable words are enclosed by %% or !! characters. For example: <strong>%%date%%</strong>.
Most of these variables words need to be present to do a certain task. These <strong>variable
words are replaced by data</strong> when displayed to end users viewing your directory.</p>

<p>Probably the easiest way to understand how templates work is to <strong>play around
with the HTML code of templates:</strong> Open the HTML templates with your web editor or
copy and paste the HTML code into your web editor and start editing. Experiment with the
templates and try different combinations. You'll be surprised with what you can come up.
The templates gives you total control on the look and feel of your search engine and
directory.</p>

<p>Note that when you <strong>make use of images</strong> in the HTML code of templates,
you must use a URL link to indicate their locations. <br>
For example:</p>

<blockquote>
  <p><strong><font color="#ff8000">&lt;img src=&quot;someimage.gif&quot;&gt; </font>will not
  work.</strong><br>
  &nbsp; <br>
  You have to <strong>indicate the entire URL</strong> where someimage.gif is located. For
  example:<br>
  &nbsp;&nbsp;&nbsp;&nbsp; <br>
  <font color="#ff8000"><strong>&lt;img
  src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt;</strong><br>
  </font>&nbsp;&nbsp;&nbsp; <br>
  The <strong>&lt;img</strong> is an HTML tag indicating that you want to insert an image in
  the HTML page. The <strong>src= </strong>part indicates that you want to specify the
  location of the image to be inserted. Some web editors will support inserting images from
  a web url and some won't. If your web editor does not support this, insert the image into
  the HTML page like usual and, when finished, edit the the HTML source code and manually
  insert the URL path's to the images. Ensure that the images are on the server for the URL
  path's you specify.</p>
  <blockquote>
    <p><strong>Example: Editing the HTML source code:</strong></p>
  </blockquote>
  <blockquote>
    <p><strong>Replace <font color="#ff8000">&lt;img src=&quot;someimage.gif&quot;&gt; </font>with<br>
    <font color="#ff8000">&lt;img src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt;</font></strong></p>
  </blockquote>
</blockquote>
</body>
</html>
];


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

