#!/usr/bin/perl

#<ENC>46</ENC>

package fmparse;

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use MIME::Base64 qw(decode_base64 encode_base64);

require Exporter;
use vars qw/@ISA @EXPORT @EXPORT_OK $copyright $prgname/;

@ISA = qw(Exporter);

@EXPORT = qw(extract_matches); 

@EXPORT_OK = qw($disp_table);

&get_setup;

####################################################################


sub extract_matches
{

my ($pcontents, $pstart, $pend) = @_;

if ($pcontents =~ m/$pstart/g) { $startpos = pos($pcontents); }
if ($pcontents =~ m/$pend/g) { $endpos = pos($pcontents); }

$matchret = substr($pcontents, $startpos, ($endpos - $startpos - length($pend)));

return ($matchret);

}



sub extract_matches_ar
{

my ($pcontents, $pstart, $pend) = @_;

my ($mcnt, $mposition, @startv, @endv, $ms, $chunk, @retmatches);


$mcnt = 0;
while ($pcontents =~ m/$pstart/g)
{
	$mposition = pos($pcontents);
	$startv[$mcnt] = $mposition;
	$mcnt++;

}


$mcnt = 0;
while ($pcontents =~ m/$pend/g)
{
	$mposition = pos($pcontents);
	$endv[$mcnt] = $mposition;
	$mcnt++;
}


for ($ms = 0; $ms < $mcnt; $ms++) 
	{
	$chunk = substr($pcontents, $startv[$ms], ($endv[$ms] - $startv[$ms] - length($pend)));
	push(@retmatches, $chunk);
	}

return (@retmatches);
}



sub get_css_used
{
my ($pcontents) = @_;
my (@matchlines, $cssret);

while ($pcontents =~ m/<link/gi)
{

	$startpos = pos($pcontents);
	if ($pcontents =~ m/>/g) { $endpos = pos($pcontents); }
	$matchret = substr($pcontents, $startpos, ($endpos - $startpos - 1));

	if ($matchret =~ /stylesheet/i)
		{
		push(@matchlines, $matchret);
		}
}

foreach $mitem (@matchlines)
	{
		if ($mitem =~ m/href\="/gi) { $startpos = pos($mitem);}
		if ($mitem =~ m/"/gi) { $endpos = pos($mitem); }
		$cssfile = substr($mitem, $startpos, ($endpos - $startpos - 1));
		$cssret =  $cssret . $cssfile . ",";
	}

chop($cssret);
return ($cssret);

}






sub get_setup
{

if ((-e "config.cgi") and (length($config_cgi) < 15))
	{
	$cofile = "config.cgi"; $exists = 1;
	}
	elsif (-e "$config_cgi") 
	{
	$cofile = "$config_cgi"; $exists = 1;
	}
	else
	{
	print "Content-type: text/html\n\n"; 
	print "Could not find config.cgi"; exit;
	}

#$exists = (-e "config.cgi");

if ($exists > 0)
	{
	open (STP, $cofile);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line2($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line2($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line2($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line2($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line2($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line2($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line2($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line2($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line2($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line2($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line2($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line2($line, PASSWORD);}

if ($line =~ /^MAIL_METHOD/){$mail_method = &get_setup_line2($line, MAIL_METHOD);}
if ($line =~ /^SENDMAIL/){$sendmail = &get_setup_line2($line, SENDMAIL);}
if ($line =~ /^SMTP_SERVER/){$smtp_server = &get_setup_line2($line, SMTP_SERVER);}


			}
	close (STP);
	
	}
}





sub get_setup_line2
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}


1; 
