#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Extra Add URL / Modify Forms
# DIZ: This plugin let's you create extra 'Add URL' and 'Modify' forms for the submission of special links or listings. If you have for example a Directory of links and an Article section and you also want people to submit Articles then you would for example use an extra 'Add URL' especially available for the submission of Articles.
# GRAPHIC: ic_add.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "add") {&new_set;}
if ($q->param('fct') eq "add_include") {&add_include;}
if ($q->param('fct') eq "edit") {&edit_templates;}
if ($q->param('fct') eq "delete") {&delete_set;}
if ($q->param('fct') eq "edit_settings") {&edit_settings;}
if ($q->param('fct') eq "save_settings") {&save_settings;}
if ($q->param('fct') eq "getlink") {&get_link;}
if ($q->param('fct') eq "edit_email") {&edit_email;}
if ($q->param('fct') eq "edit_email_scr") {&edit_email_scr;}
if ($q->param('fct') eq "save_email") {&save_email;}
if ($q->param('fct') eq "help") {&help;}


sub help
{

$hbox = acs::get_heading_box("$web_url/ic_kb.gif", qq[<a href="$admin_url/p_addurl.cgi">Extra Add URL / Modify Forms</a> >> Instructions], qq[Extra Add URL / Modiy Forms Help & Instructions]);

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Modify</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox

<p><strong>Why would you want to us extra Add URL and Modify Form Sets?</strong></p>
<blockquote>
  <p>This functionality has specifically been created to be able to accept different types of submissions. With this functionality you could for example accept Standard Link Submissions, Articles, and Classified Ads submissions. You could then for example have a standard Directory that lists standard links, a Classified Ads section and a Articles section all with one installation of PowerSeek. In this kind of setup you could then categorize the Standard Links in one Main category, the Classifieds in another one and the Articles in another main category. You can change the look and feel of links that is listed in specific categories by using '<a href="$admin_url/admin27.cgi">Custom Category Template Sets</a>'.</p>
  <p><strong>Important Note: </strong>You will need to be familiar on how to edit PowerSeek templates to use this functionality. If you don't know how to customize the PowerSeek templates then it would be best to first customize your Directory to the look and feel you have in mind and then come back to this section when the look and feel of your Directory has been customized. </p>
  <p><strong>Recommended Reading: </strong><a href="http://www.focalmedia.net/pseekmanual/pseek3.html#3_5" target="_blank"></a><a href="http://www.focalmedia.net/pseekmanual/pseek6.html#6_10" target="_blank">How to use Custom Category Template Sets</a>, <a href="http://www.focalmedia.net/pseekmanual/pseek3.html#3_5" target="_blank">How to Add Extra Fields</a>, <a href="http://www.focalmedia.net/pseekmanual/pseek6.html#6_8" target="_blank">Template Includes</a></p>
</blockquote>
<p><strong>How to implement extra Add URL / Modify Forms:</strong></p>
<blockquote>
  <p><strong>Step 1: Create a Custom Category Template Set </strong>(This step can be skipped in some situations)</p>
  <blockquote>
    <p>You will most likely want to give listings a different look and feel than the standard listings used throughout the Directory. PowerSeek has the ability where you can give links a different look and feel in specific categories. To do this go to the <strong>PowerSeek Control Panel &gt;&gt; Template Manager &gt;&gt; 1. Default Category/Directory Templates &gt;&gt; <a href="$admin_url/admin27.cgi">Create or Edit Custom Category/Directory Template Sets </a></strong></p>
    <p>Now click on the <strong>'Add New Category/Directory Template' </strong>button. You will now be presented with templates that you can customize. These templates will be used in categories you specify. Customize the templates and click the '<strong>Add New Custom Template Set</strong>' button.</p>
    <p>Now that a new Custom Category Template Set has been created click the 'Dir Manager' tab and browse to the categories where you want to use these templates. Underneath the column 'Templates' (in the Dir Manager) you can click on 'Default' next to any category to assign a Custom Category Template Set to that category. Do that now.</p>
  </blockquote>
  <p><strong>Step 2: Create an extra Add URL / Modify Form Set</strong></p>
  <blockquote>
    <p>Now that you have created and assigned a custom category template set to categories, you can now create a set of Add URL / Modify forms for listings that will be submitted to these categories.</p>
    <p>To create an extra Add URL / Modify Form Set go to the <strong>PowerSeek Control Panel &gt;&gt; Settings &gt;&gt; Extra Add URL / Modify Forms </strong>and click the<strong> 'Add a New Set of Add URL and Modify Forms' </strong>button.</p>
    <p>Specify all the settings you require for the Add URL / Modify Form Set and click the 'Next' button and the extra Add URL / Modify Form set will be created.</p>
  </blockquote>
  <p><strong>Step 3: Edit Add URL / Modify Templates</strong></p>
  <blockquote>
    <p>Now that the 'Add URL / Modify Form Set' has been created click the 'Edit Templates' link next to the name you specified for it. After clicking the link, you can now customize the 'Add URL / Modify' templates used. Customize these templates according to your needs.</p>
    <p>Note that PowerSeek will automatically generate the 'Add URL' and 'Modify' templates for you but you will need to customize them as they won't contain your logo, graphics, menu bars, etc.</p>
  </blockquote>
  <p><strong>Step 4: </strong><strong>Customize Notification Emails</strong></p>
  <blockquote>
    <p>After customizing the Add URL / Modify templates, click the 'Edit Notification Emails' for the 'Add URL / Modify' form set. Then customize all the email responses sent out to users for this 'Add URL / Modify' form set.</p>
  </blockquote>
  <p><strong>Step 5: </strong><strong>Place links from PowerSeek templates </strong></p>
  <blockquote>
    <p>Now that the 'Add URL / Modify' form set has been created, you will need to place links from your PowerSeek templates to the 'Add URL' forms. You can click 'Get Links' to obtain the URLs to the 'Add URL / Modify' form set that you just created.</p>
    <p>It is strongly recommended that you place 'Add URL' links inside the User Control Panel template. You can edit this template by going to the PowerSeek Control Panel &gt;&gt; Template Manager &gt;&gt;  3. Add URL Templates &gt;&gt; Control Panel Templates</p>
  </blockquote>
</blockquote>
<p><strong>Additional Notes:</strong></p>
<ul>
  <li>
    <p>You can create as many 'Add URL / Modify' form sets as you require.</p>
  </li>
  <li>
    <p>You can place the links to the Add URL forms for the 'Add URL / Modify' form set on any external web pages, <a href="$admin_url/admin6.cgi" target="_blank">PowerSeek Templates</a> or <a href="$admin_url/admin17.cgi" target="_blank">PowerSeek Template Includes.</a></p>
  </li>
  <li>
    <p>You can only use custom Add URL / Modify forms if you use the <a href="http://www.focalmedia.net/pseekmanual/pseek8.html" target="_blank">User Registration System</a>. The User Registration System requires users to register an account to be able to submit links.</p>
  </li>
  <li>
    <p>All types of PowerSeek extra fields can be used inside custom 'Add URL / Modify' form sets. You can also require or not require specific fields to be completed by users.</p>
  </li>
  <li>
    <p>When listings are submitted from custom 'Add URL / Modify' form sets then it will be indicated with the listings from PowerSeek's 'New Submission Approval Area'.</p>
  </li>
</ul>
<blockquote>
  <p>&nbsp;</p>
</blockquote>

</body>
</html>
];




}




sub save_email
{

$email_name = $q->param('email_name');
$tname = $q->param('tname');

$efilename = "$data_dir/$tname" . "_" . $email_name . ".eml";

if ($q->param('htmlemail') eq "Y") 		{ $html_email_s = "::Y"; }

open (AME, "> $efilename");
	print AME $q->param('e_name') . $html_email_s . "\n";
	print AME $q->param('e_from_email') . "\n";
	print AME $q->param('e_subject') . "\n";
	print AME $q->param('e_message') . "\n";
close (AME);


$hbox = acs::get_heading_box("$web_url/ic_add.gif", qq[<a href="$admin_url/p_addurl.cgi">Extra Add URL / Modify Forms</a> >> <a href="$admin_url/p_addurl.cgi?fct=edit_email&tname=$tname">Notification Emails For: $tname</a> >> Email Saved], qq[<a href="$admin_url/p_addurl.cgi?fct=edit_email&tname=$tname">Click Here</a> to continue.]);

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Modify</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];


}



sub get_vars_cemail
{

my ($cemail_name) = @_;


($extradfk) = acs::get_extra_vars;

if ($extradfk ne ""){$extradfk = "<font color=\"#8080FF\"><b>Listed below is extra field/key variables that may be used with this email.</b><br><br></b>$extradfk<b></font>";}

if (($email_name eq "welcome") or ($email_name eq "pwelcome"))
{

$boxdh = qq[
<p align="left"><strong>%%title%% <br>
</strong>The title of the newly submitted link. </p>

<p align="left"><strong>%%description%% </strong><br>
The description of the newly submitted link. </p>

<p align="left"><strong>%%url%% <br>
</strong>The url of the newly submitted link. </p>

<p align="left"><strong>%%keywords%% <br>
</strong>The keywords of the newly submitted link. </p>

<p align="left"><strong>%%name%% <br>
</strong>Name of the submitter. </p>

<p align="left"><strong>%%email%% </strong><br>
Email of the submitter. </p>

<p><strong>%%date%% <br>
</strong>The date when the new submission has been made. </p>

<p><strong>%%category_submitted%% <br>
</strong>The category where the link has been submitted. </p>

<p>$extradfk </p>
];

$cretvars = acs::quick_help("Variables Available For Use In This Email ",$boxdh);  


}
elsif (($email_name eq "accept") or  ($email_name eq "paccept"))
{

$boxdhl = qq[
<p align="left"><strong>%%title%% <br>
</strong>The title of the newly submitted link. </p>

<p align="left"><strong>%%description%% </strong><br>
The description of the newly submitted link. </p>

<p align="left"><strong>%%url%% <br>
</strong>The url of the newly submitted link. </p>

<p align="left"><strong>%%keywords%% <br>
</strong>The keywords of the newly submitted link. </p>

<p align="left"><strong>%%name%% <br>
</strong>Name of the submitter. </p>

<p align="left"><strong>%%email%% </strong><br>
Email of the submitter. </p>

<p><strong>%%date%% <br>
</strong>The date when the new submission has been made. </p>

<p><strong>%%rating_code_url%% <br>
</strong>This is replaced by a URL that provides the user with instructions on adding a
rating box to his/her web site. </p>

<p><strong>%%category_submitted%% <br>
</strong>The category where the link has been submitted. </p>

<p>$extradfk </p>
];

$cretvars = acs::quick_help("Variables Available For Use In This Email ",$boxdhl);  


}
elsif (($email_name eq "reject") or ($email_name eq "preject"))
{ 

$boxhg = qq[
<p align="left"><strong>%%title%% <br>
</strong>The title of the newly submitted link. </p>

<p align="left"><strong>%%description%% </strong><br>
The description of the newly submitted link. </p>

<p align="left"><strong>%%url%% <br>
</strong>The url of the newly submitted link. </p>

<p align="left"><strong>%%keywords%% <br>
</strong>The keywords of the newly submitted link. </p>

<p align="left"><strong>%%name%% <br>
</strong>Name of the submitter. </p>

<p align="left"><strong>%%email%% </strong><br>
Email of the submitter. </p>

<p><strong>%%date%% <br>
</strong>The date when the new submission has been made. </p>

<p><strong>%%category_submitted%% <br>
</strong>The category where the link has been submitted. </p>

<p>$extradfk </p>
];

$cretvars = acs::quick_help("Variables Available For Use In This Email ",$boxhg);


}
elsif (($email_name eq "inform") or ($email_name eq "pinform") or ($email_name eq "pinformupgrade"))
{ 

$boxhj = qq[
<p align="left"><strong>%%title%% <br>
</strong>The title of the modified link. </p>

<p align="left"><strong>%%description%% </strong><br>
The description of the modified link. </p>

<p align="left"><strong>%%url%% <br>
</strong>The url of the link where modification changes has been approved. </p>

<p align="left"><strong>%%keywords%% <br>
</strong>The url of the link where modification changes has been approved. </p>

<p align="left"><strong>%%approve_email%% <br>
</strong>Approval link that Administrator can click to approve new submission from informer email. When link is approved an email is sent to the user informing him/her that his/her link has been approved. </p>

<p align="left"><strong>%%approve%% <br>
</strong>Approval link that Administrator can click to approve new submission from informer email. An email is not sent to the owner to inform him/her that his/her link has been approved. </p>

<p align="left"><strong>%%delete_email%% <br>
</strong>Delete the new submission and inform the user that his/her link has been declined/rejected. </p>

<p align="left"><strong>%%delete%% <br>
</strong>Delete the new submission and don't inform the user that his/her link has been declined/rejected.</p>
<p>$extradfk </p>
];

$cretvars = acs::quick_help("Variables Available For Use In This Email ",$boxhj);

}
elsif ($email_name eq "maccept") 
{

$boxhr = qq[
<p align="left"><strong>%%title%% <br>
</strong>The title of the modified link. </p>

<p align="left"><strong>%%description%% </strong><br>
The description of the modified link. </p>

<p align="left"><strong>%%url%% <br>
</strong>The url of the link where modification changes has been approved. </p>

<p align="left"><strong>%%keywords%% <br>
</strong>The url of the link where modification changes has been approved. </p>

<p>$extradfk </p>
];

$cretvars = acs::quick_help("Variables Available For Use In This Email ",$boxhr); 

}
elsif ($email_name eq "mreject") 
{

$boxhh = qq[
<p><strong>%%title%% <br>
</strong>The title of the modified link. </p>

<p><strong>%%description%% </strong><br>
The description of the modified link. </p>

<p><strong>%%url%% <br>
</strong>The url of the link where modification changes has been approved. </p>

<p><strong>%%keywords%% <br>
</strong>The url of the link where modification changes has been approved. </p>

<p>$extradfk</p>
];

$cretvars = acs::quick_help("Variables Available For Use In This Email ",$boxhh); 

}

return ($cretvars);

}




sub edit_email_scr
{

$tname = $q->param('tname');
$email_name = $q->param('email');

if ($email_name eq "welcome") { $emname = "Welcome Email"; $ediz = "This email is sent when a submission takes place. It almost acts like an autoresponder because it is sent just after a user added a new listing via the 'add url' form.";}
if ($email_name eq "accept") 	{ $emname = "New Submission Acceptance Email"; $ediz = "This email is sent to a user when his new submission has been approved for inclusion into the directory. ";}
if ($email_name eq "reject") 	{ $emname = "New Submission Rejection Email"; $ediz = "This email is sent to a user when his new submission has not been approved for inclusion into the directory. ";}
if ($email_name eq "inform") 	{ $emname = "New Submission Informer Email"; $ediz = "This email is sent to you, to inform you that a new submission has been made.";}

if ($email_name eq "pwelcome") { $emname = "Welcome Email"; $ediz = "This email is sent when a premium submission takes place. It almost acts like an autoresponder, because it is sent just after a user added a premium listing/link via the 'premium add url' form.";}
if ($email_name eq "paccept") { $emname = "New Premium Submission Acceptance Email"; $ediz = "This email is sent to a user when his new premium submission has been approved for inclusion into the directory. ";}
if ($email_name eq "preject") { $emname = "New Premium Submission Rejection Email"; $ediz = "This email is sent to a user when his new premium submission has not been approved for inclusion into the directory. This might be due to non-payment or other reasons. ";}
if ($email_name eq "pinform") { $emname = "New Premium Submission Informer Email"; $ediz = "This email is sent to you, to inform you that a new premium submission has been made.";}

if ($email_name eq "maccept") { $emname = "Modify Acceptance Email"; $ediz = "This email is sent to a user when a link has been modified by the user and the users modification has been accepted."; }
if ($email_name eq "mreject") { $emname = "Modify Rejection Email"; $ediz = "This email is sent to a user when a link has been modified by the user and the users modification has not been accepted. "; }

if ($email_name eq "pinformupgrade") { $emname = "Upgrade From Standard to Premium Informer Email (PayPal Only)"; $ediz = "This email is sent to you, to inform you that a standard link was upgraded to a premium link. This email is only sent when PayPal is in use."; }




$etfname = $tname . "_" . $email_name . ".eml";

$emailmsg = acs::get_file_contents("$data_dir/$etfname");

@elines = split (/\n/, $emailmsg);

$e_name = $elines[0];

if ($e_name =~ /::/) { ($e_name, $html_email) = split (/::/, $e_name); }
if ($html_email eq "Y") { $html_email_checked = "checked"; }

$e_from_email = $elines[1];
$e_subject = $elines[2];

$lnc = 0;
foreach $line (@elines)
	{
	if ($lnc > 2)
		{
		$e_message = $e_message . $line . "\n";
		}
	$lnc++;
	}


$vardbox = &get_vars_cemail($email_name);

$hbox = acs::get_heading_box("$web_url/ic_add.gif", qq[<a href="$admin_url/p_addurl.cgi">Extra Add URL / Modify Forms</a> >> <a href="$admin_url/p_addurl.cgi?fct=edit_email&tname=$tname">Notification Emails</a> >> Email For: $tname ], qq[Editing custom Email Message: <b>$emname</b><BR>$ediz]);




if (($email_name eq "inform") or ($email_name eq "pinform") or ($email_name eq "pinformupgrade"))  { $cufrome = "To Email Address:"; }
else {  $cufrome = "From Name:";  }


$html_email_help = acs::get_html_email_detials;


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Modify</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script SRC="$web_url/qtip.js"></script>
<style type="text/css">
<!--
div#qTip {
 padding: 10px;
 border: 1px solid #DBDBDB;
 display: none;
 background: url("$web_url/tooltback.gif");
 color: #000;
 font: 11px Arial, sans-serif;
 text-align: left;
 position: absolute;
 z-index: 1000;
}
-->
</style>

</head>
<body>
$hbox
<form method="POST" action="$admin_url/p_addurl.cgi" style="margin-bottom:0; margin-top:0;" >
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD" height="46">
    <tr>
      <td height="30" colspan="2" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Email Details:</strong></td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">$cufrome </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="e_name" size="40"
      value="$e_name" style="width:100%" id="e_name"> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">From Email:</td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="e_from_email" size="40"
      value="$e_from_email" style="width:100%" id="e_from_email"> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">Email Subject: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="e_subject" size="57"
      value="$e_subject" style="width:100%" id="e_subject"> </td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">Html Email:</td>
      <td bgcolor="#FFFFFF" class="normaltext"><input type="checkbox" name="htmlemail" id="htmlemail" value="Y" $html_email_checked />
        <img src="$web_url/est_help.gif" style="vertical-align:middle" 
    onmouseover=" tooltip.show('If checked then the email below will be sent as HTML. Note that your message will need to contain HTML elements like &lt; br &gt; for the spacing for example. Also see the &lt;b&gt;HTML Design Email Guidelines&lt;/b&gt; and &lt;b&gt;Spam Filter Details and Guidelines&lt;/b&gt; below if sending out HTML email.');" onmouseout="tooltip.hide();" /></td>
    </tr>
    <tr>
      <td width="15%" valign="top" bgcolor="#FFFFFF" class="normaltext">Message:</td>
      <td width="85%" bgcolor="#FFFFFF"><textarea rows="24" name="e_message" cols="77" style="width:100%" id="e_message">$e_message</textarea> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF"></td>

      <td width="85%" bgcolor="#FFFFFF"><input type="submit" class="psbutton" value="   Save   " name="B1">
        <input type="hidden" name="fct" value="save_email">
      <input name="tname" type="hidden" id="tname" value="$tname">
      <input name="email_name" type="hidden" id="email_name"
  value="$email_name"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
$vardbox
$html_email_help
</body>
</html>
];

}




sub edit_email
{

$tname = $q->param('tname');

$hbox = acs::get_heading_box("$web_url/ic_add.gif", qq[<a href="$admin_url/p_addurl.cgi">Extra Add URL / Modify Forms</a> >> Notification Emails For: $tname], qq[Choose an Email Notification Message to customize below:]);


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0"
    cellpadding="6">
        <tr>
          <td background="$web_url/bar6.gif"><strong class="normaltext">New Submission Emails
              (Standard Listings) For Custom Add URL Forms: $tname</strong></td>
        </tr>
        <tr>
          <td class="normaltext">When a standard link is submitted then the email responses below
            are sent.
            <ul>
              <li><strong><a href="$admin_url/p_addurl.cgi?fct=edit_email_scr&email=welcome&tname=$tname">Welcome Email</a><br>
                </strong>This email is sent when a submission takes place. It almost acts like an
                autoresponder because it is sent just after a user added a new listing via the 'add url'
                form.<strong><br>
              </strong>&nbsp;&nbsp; </li>
              <li><strong><a href="$admin_url/p_addurl.cgi?fct=edit_email_scr&email=accept&tname=$tname">New Submission
                Acceptance Email</a><br>
                </strong>This email is sent to a user when his new submission has been approved for
                inclusion into the directory. <br>
              &nbsp;&nbsp; </li>
              <li><strong><a href="$admin_url/p_addurl.cgi?fct=edit_email_scr&email=reject&tname=$tname">New Submission
                Rejection Email</a><br>
                </strong>This email is sent to a user when his new submission has not been approved for
                inclusion into the directory. <br>
              &nbsp;&nbsp;&nbsp; </li>
              <li><strong><a href="$admin_url/p_addurl.cgi?fct=edit_email_scr&email=inform&tname=$tname">New Submission
                Informer Email</a><br>
              </strong>This email is sent to you, to inform you that a new submission has been made.</li>
          </ul></td>
        </tr>
      </table></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>
</center>
</div>
<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="99%" valign="top" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0"
    cellpadding="6">
        <tr>
          <td background="$web_url/bar6.gif"><strong class="normaltext">New Premium Submission Emails (Premium
            Listings) For Custom Add URL Forms: $tname</strong></td>
        </tr>
        <tr>
          <td class="normaltext">When a premium link is submitted then the email responses below are
            sent.
            <ul>
              <li><strong><a href="$admin_url/p_addurl.cgi?fct=edit_email_scr&email=pwelcome&tname=$tname">Welcome Email </a><br>
                </strong>This email is sent when a premium submission takes place. It almost acts like an
                autoresponder, because it is sent just after a user added a premium listing/link via the
                'premium add url' form. <strong><br>
                </strong>&nbsp;&nbsp; </li>
              <li><strong><a href="$admin_url/p_addurl.cgi?fct=edit_email_scr&email=paccept&tname=$tname">New Premium:
                Submission Acceptance Email </a><br>
                </strong>This email is sent to a user when his new premium submission has been approved
                for inclusion into the directory. <br>
                &nbsp;&nbsp;&nbsp; &nbsp;&nbsp; </li>
              <li><strong><a href="$admin_url/p_addurl.cgi?fct=edit_email_scr&email=preject&tname=$tname">New Premium
                Submission Rejection Email </a><br>
                </strong>This email is sent to a user when his new premium submission has not been
                approved for inclusion into the directory. This might be due to non-payment or other
                reasons. <br>
                &nbsp;&nbsp;&nbsp;&nbsp; </li>
              <li><strong><a href="$admin_url/p_addurl.cgi?fct=edit_email_scr&email=pinform&tname=$tname">New Premium
                Submission Informer Email </a><br>
                </strong>This email is sent to you, to inform you that a new premium submission has been
                made.<br />
                <br />
              </li>
              <li><strong><a href="$admin_url/p_addurl.cgi?fct=edit_email_scr&amp;email=pinformupgrade&amp;tname=$tname">Upgrade From Standard to Premium Informer Email (PayPal Only)</a><br />
              </strong>This email is sent to you, to inform you that a standard link was upgraded to a premium link. This email is only sent when PayPal is in use.<br />
              </li>
            </ul></td>
        </tr>
      </table></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
    <td width="99%"></td>
  </tr>
</table>
<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0"
    cellpadding="6">
        <tr>
          <td background="$web_url/bar6.gif"><strong class="normaltext">Link Modification Emails For Custom Modify Forms: $tname</strong></td>
        </tr>
        <tr>
          <td class="normaltext">The responses below are sent when a link is modified.
            <ul>
              <li><strong><a href="$admin_url/p_addurl.cgi?fct=edit_email_scr&email=maccept&tname=$tname">Modify Acceptance Email </a><br>
                </strong>This email is sent to a user when a link has been modified by the user and the
                users modification has been accepted. <strong><br>
                </strong>&nbsp;&nbsp; </li>
              <li><a href="$admin_url/p_addurl.cgi?fct=edit_email_scr&email=mreject&tname=$tname"><strong>Modify Rejection Email <br>
                </strong></a>This email is sent to a user when a link has been modified by the user and
                the users modification has not been accepted. <br>
              </li>
            </ul></td>
        </tr>
      </table></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>
</body>
</html>
];



}



sub get_link
{

$tname = $q->param('tname');

$boxdiz = qq[
Use the links below to link to the 'Add URL' form for the form set: <b>$tname</b> <BR><BR>
<b>Link to 'Add URL' form:</b><br>
<a href="$script_url/addurl.cgi?f=$tname" target="_blank">$script_url/addurl.cgi?f=$tname</a><BR><BR>

<b>Link to 'Premium Add URL' form:</b><br>
<a href="$script_url/addurl.cgi?f=$tname&p=1" target="_blank">$script_url/addurl.cgi?f=$tname&p=1</a><BR><BR>

<b>Notes:</b><br>
<ul>
<li>You can include these links inside the 'User Control Panel' Templates. They are available for editing from the PowerSeek Control Panel >> 
Template Manager >> 3. Add URL Templates >> Control Panel Templates </li>
<li>These links can also be included in any PowerSeek template or any external web page</li><BR>
</ul>
];

$hbox = acs::get_heading_box("$web_url/ic_add.gif", "Get link to 'Add URL'/'Modify' Form Set", $boxdiz);

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Modify</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}




sub save_settings
{

$tname = $q->param('tname');

if ($q->param('r_diz') eq "description") { $required_link = "description" . "::"; }
if ($q->param('r_keywords') eq "keywords") { $required_link = $required_link . "keywords" . "::"; }
if ($q->param('r_url') eq "url") { $required_link = $required_link . "url" . "::"; }
if ($q->param('r_catsugg') eq "csuggestion") { $required_link = $required_link . "csuggestion" . "::"; }
if ($q->param('r_contact') eq "sname") { $required_link = $required_link . "sname" . "::"; }
if ($q->param('r_email') eq "email") { $required_link = $required_link . "email" . "::"; }


$keydata = &get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

$kcount = 0;
foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
	if ($q->param($keyname) eq "$keyname") { $required_link = $required_link . $keyname . "::"; }
	}

$conf_file = "addmod_" . $tname . ".dat";

open (ADDMOD, "> $data_dir/$conf_file");
 	print ADDMOD $q->param('tname') . "\n";
 	print ADDMOD $q->param('add_diz') . "\n";
 	print ADDMOD $required_link . "\n";
	print ADDMOD $q->param('incl_subs') . "::" . $q->param('related_categories') . "\n"; 	
	print ADDMOD $q->param('duplic') . "\n";
	print ADDMOD $q->param('premium_payment') . "\n";
	print ADDMOD $q->param('standard_payment') . "\n";


 	print ADDMOD $q->param('usepaypal') . "\n"; 		############# 7 USE PAYPAL
 	
 	print ADDMOD $q->param('paypaluser') . "\n";		# 8
 	print ADDMOD $q->param('paypalpass') . "\n";		# 9
 	print ADDMOD $q->param('paypalsign') . "\n";		# 10
 	print ADDMOD $q->param('pmode') . "\n";			# 11 

 	print ADDMOD $q->param('usdprice') . "\n";	   ############## 12 PREMIUM LINK ORDER OPTIONS
 	print ADDMOD $q->param('premium_expire_days') . "\n";		# 13
 	print ADDMOD $q->param('premium_orderform_url') . "\n";	# 14
 	
 	print ADDMOD $q->param('usdprice2') . "\n";					   # 15
 	print ADDMOD $q->param('premium_expire_days2') . "\n";	   # 16
 	print ADDMOD $q->param('premium_orderform_url2') . "\n";		# 17

 	print ADDMOD $q->param('usdprice3') . "\n";						# 18
 	print ADDMOD $q->param('premium_expire_days3') . "\n";		# 19
 	print ADDMOD $q->param('premium_orderform_url3') . "\n";		# 20

 	print ADDMOD $q->param('usdprice4') . "\n";						# 21
 	print ADDMOD $q->param('premium_expire_days4') . "\n";		# 22
 	print ADDMOD $q->param('premium_orderform_url4') . "\n";		# 23

 	print ADDMOD $q->param('usdprice5') . "\n";						# 24
 	print ADDMOD $q->param('premium_expire_days5') . "\n";		# 25
 	print ADDMOD $q->param('premium_orderform_url5') . "\n";		# 26

 	print ADDMOD $q->param('usdprice6') . "\n";						# 27
 	print ADDMOD $q->param('premium_expire_days6') . "\n";		# 28
 	print ADDMOD $q->param('premium_orderform_url6') . "\n";		# 29

 	print ADDMOD $q->param('usdprice7') . "\n";						# 30
 	print ADDMOD $q->param('premium_expire_days7') . "\n";		# 31
 	print ADDMOD $q->param('premium_orderform_url7') . "\n";		# 32

 	print ADDMOD $q->param('usdprice8') . "\n";						# 33
 	print ADDMOD $q->param('premium_expire_days8') . "\n";		# 34
 	print ADDMOD $q->param('premium_orderform_url8') . "\n";		# 35

 	print ADDMOD $q->param('usdprice9') . "\n";						# 36
 	print ADDMOD $q->param('premium_expire_days9') . "\n";		# 37
 	print ADDMOD $q->param('premium_orderform_url9') . "\n";		# 38

 	print ADDMOD $q->param('usdprice10') . "\n";						# 39
 	print ADDMOD $q->param('premium_expire_days10') . "\n";		# 40
 	print ADDMOD $q->param('premium_orderform_url10') . "\n";	# 41
 	
 	print ADDMOD $q->param('currency') . "\n";	# 42
	print ADDMOD $q->param('pitemname') . "\n";	# 43 	
	
close (ADDMOD);




### Expiry Options

if ($q->param('premium_expire_days2') ne "")
	{
		$prem_expiry_options = qq[
		&lt;strong&gt;Please choose an option:&lt;/strong&gt;&lt;br&gt; <br>
		];
		
		for ($ms = 1; $ms < 11; $ms++) 
			{
				$pexpiry = "pexpiry" . $ms;
				$usdprice = "";
				
				if ($ms == 1) 
					{
						$chcked = "checked"; 
						$usdprice = $q->param('usdprice');
						$days = $q->param('premium_expire_days');
						$pexpiryid = "pexpiry" . $ms;
					}
					else 
					{
						$chcked = ""; 
						$usdprice = $q->param("usdprice" . $ms);
						$days = $q->param("premium_expire_days" . $ms);
						$pexpiryid = "pexpiry" . $ms;
					}
				
					if ($usdprice ne "")
						{
						$prem_expiry_options = $prem_expiry_options . qq[&lt;input type=&quot;radio&quot; name=&quot;premoption&quot; id=&quot;$pexpiryid&quot; value=&quot;$ms&quot; $chcked&gt; ($days days) \$$usdprice &lt;br&gt; <br>\n];
						$prem_upgrade_options = $prem_upgrade_options  . qq[&lt;input type=&quot;radio&quot; name=&quot;premoption&quot; id=&quot;$pexpiryid&quot; value=&quot;$ms&quot; $chcked&gt; ($days days) \$$usdprice&lt;br&gt; <br>\n];
						}
						
			}
		
		
		
				
		$premdisp = qq[
	
		<span class="normaltext"><strong class="redtext">Important Please Read:<br />
			</strong>If you changed or added expiry options (different expiry periods with different prices) then follow the instructions below:
			</span>
			<blockquote>
			  <p><span class="normaltext">Go to the PowerSeek Control Panel &gt;&gt; Settings &gt;&gt; <a onclick="popup('$admin_url/p_addurl.cgi', 850, 600); return false;" href="$admin_url/p_addurl.cgi">Extra Add URL / Modify Forms</a> &gt;&gt; Click on: <strong>Edit Templates</strong> next to <strong>$tname</strong><br />
			    <br />
			  </span>After clicking <strong>Edit Templates</strong> click on <a onclick="popup('$admin_url/admin57.cgi?fct=edit_template&amp;template=tester_rgs_add_url_medp&amp;extraform=tester',screen.width-200,screen.height-200);return false;" href="$admin_url/admin57.cgi?fct=edit_template&amp;template=$tname_rgs_add_url_medp&amp;extraform=$tname">Paid Add URL Template</a> to edit the Premium Add Url Template.</p>
			  <p><span class="normaltext"><strong>Inside the Premium Add URL Template Place the following HTML Code between the <a href="http://www.focalmedia.net/tutorials/chapter13.html" target="_blank">&lt;FORM&gt;</a> tags:</strong><br />
			    (The HTML Code below will provide your users with duration options when adding a Premium link) </span> </p>
			  <blockquote>
			    <p class="normaltext"> $prem_expiry_options<br />
			    </p>
			  </blockquote>
			  <p class="normaltext"><strong>If you would like to provide the option where users can upgrade standard listings to premium listings then do the following:</strong></p>
			  <p class="normaltext">1.  Go to the  Control Panel &gt;&gt; Template Manager &gt;&gt; <a href="admin6.cgi?t=3#3" target="_blank">3. Add URL Templates</a> &gt;&gt; Control Panel Templates &gt;&gt; <a href="$admin_url/admin57.cgi?fct=edit_template&amp;template=rgs_acclinks" target="_blank">Account Link Style</a></p>
			  <p class="normaltext">2. Place the following somewhere inside the Account Link Style Template:</p>
			  <blockquote>
			    <p class="normaltext">&lt;a href=&quot;!!upgrade_to_premium!!&quot;&gt;Upgrade to Premium Listing&lt;/a&gt;</p>
			  </blockquote>
			  <p class="normaltext">3. Go to the PowerSeek Control Panel &gt;&gt; Settings &gt;&gt; <a onclick="popup('$admin_url/p_addurl.cgi', 850, 600); return false;" href="$admin_url/p_addurl.cgi">Extra Add URL / Modify Forms</a> &gt;&gt; Click on: <strong>Edit Templates</strong> next to <strong>$tname</strong><br />
	            <br />
	          After clicking <strong>Edit Templates</strong> click on <a onclick="popup('$admin_url/admin57.cgi?fct=edit_template&amp;template=$tname_rgs_upgrade&amp;extraform=$tname',screen.width-200,screen.height-200);return false;" href="$admin_url/admin57.cgi?fct=edit_template&amp;template=$tname_rgs_upgrade&amp;extraform=$tname">Upgrade Page Standard to Premium</a> to edit the Premium Add Url Template.</p>
			  <p class="normaltext">4. Add the following to the template:<br />
		      (The HTML code below represents the upgrade options available)</p>
			  <blockquote>
			    
			    <p class="normaltext">
			    &lt;form id=&quot;upgradeform&quot; name=&quot;upgradeform&quot; method=&quot;post&quot; action=&quot;!!upgradescript!!&quot;&gt; <br>
				 &lt;strong&gt;Please choose an option:&lt;/strong&gt; &lt;br&gt;&lt;br&gt; <br>
			    $prem_upgrade_options
			    &lt;br&gt;&lt;input type=&quot;submit&quot; name=&quot;purchase&quot; id=&quot;purchase&quot; value=&quot; Purchase with Paypal &quot;&gt;<br />
				 &lt;input name=&quot;lnkid&quot; type=&quot;hidden&quot; id=&quot;lnkid&quot; value=&quot;!!lnkid!!&quot;&gt;<br />
				 &lt;/form&gt;
			    </p>
			    
			  </blockquote>
			</blockquote>
		];
		
		
	}


#<form id="upgradeform" name="upgradeform" method="post" action="!!upgradescript!!">
# <strong>Please choose an option:</strong> <br><br>
# <input type="radio" name="premoption" id="pexpiry1" value="1" checked > (30 days) $10 <br>
#<input type="radio" name="premoption" id="pexpiry2" value="2"> (183 days) $30 <br>
#<input type="radio" name="premoption" id="pexpiry3" value="3"> (365 days) $50 <br>
# <br><input type="submit" name="purchase" id="purchase" value=" Purchase with Paypal ">
# <input name="lnkid" type="hidden" id="lnkid" value="!!lnkid!!">
# </form> 



$pcode = acs::get_popupjs;

$hbox = acs::get_heading_box("$web_url/ic_add.gif", "Settings Saved", qq[<a href="$admin_url/p_addurl.cgi">Click Here</a> to Continue.]);

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Modify</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
$pcode
</script>

</head>
<body>
$hbox
$premdisp
</body>
</html>
];


}





sub edit_settings
{

$tname = $q->param('tname');

$sfile = "addmod_" . $tname . ".dat";
$setdetails = &get_file_contents("$data_dir/$sfile");
@setdet = split (/\n/, $setdetails);

$diz = $setdet[1];

@reqsettings = split (/::/, $setdet[2]);

($inclsubs, $catids) = split (/::/, $setdet[3]);

if ($inclsubs eq "Y") { $incl_checked = "checked"; }

$ccount = 0;
@cids = split (/,/,$catids);
foreach $cid (@cids)
	{
	if (int($cid) > 0)
		{
		$ccount++;
		$catstring = $catstring . $cid . ",";
		$sqlstr = $sqlstr . " (cid = '$cid') OR";
		}
	}


chop($sqlstr); chop($sqlstr);


$keydata = &get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

$kcount = 0;
foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
		
		$checkval = "";
		foreach $item (@reqsettings)
		{
		if ($keyname eq $item) { $checkval = "checked"; }
		}
	
	$ce_options = $ce_options . qq[<input name="$keyname" type="checkbox" value="$keyname" $checkval> <font color="#8080C0">$description</font> <br>];
	}


foreach $item (@reqsettings)
	{
	if ($item eq "description") { $c_description = "checked"; }
	if ($item eq "keywords") { $c_keywords = "checked"; }
	if ($item eq "url") { $c_url = "checked"; }
	if ($item eq "csuggestion") { $c_csuggestion = "checked"; }
	if ($item eq "sname") { $c_sname = "checked"; }
	if ($item eq "email") { $c_email = "checked"; }
	}


### GET SELECTED CATEGORIES IF ANY
if ($ccount > 0)
{

	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

	$sql_crit = "SELECT * FROM dirs WHERE $sqlstr";
	$sth = $dbh->prepare($sql_crit);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}

	while ( @row = $sth->fetchrow() )
	{ 
	
		for ($ms = 2; $ms < 18; $ms++) 
					{
					if ($row[$ms] ne "")
						{
	
							if ($lvc == 0) { $enc_cats = $enc_cats . acs::encode_dir($row[$ms]); }
												else
												{ $enc_cats = $enc_cats . "-" . acs::encode_dir($row[$ms]); }
												
							$lvc++;
							$clink = "$admin_url/admin2.cgi?fct=edit_dir&lv=$lvc&cid=$row[0]&ct=$enc_cats";
							$cats = $cats . " / " . "$row[$ms]";
						}
			} 
		$cats = $cats . "<BR>";
	
	}
	
$sth->finish;
$dbh->disconnect; 

$initcats = "<b>Initial Categories Selected:</b><BR><blockquote>$cats</blockquote>";

}

if ($setdet[4] eq "Y") { $duplic_checked = "checked"; }

$premium_payment = $setdet[5];
$standard_payment = $setdet[6];

###########

$usepaypal = $setdet[7];
if ($usepaypal eq "Y") 
	{
	$usepaypalchecked = "checked"; 
	$prem_option1 = qq[style="display:none"];
	}
	else
	{
	$pp1 = qq[style="display:none"];
	$pp2 = qq[style="display:none"];
	$pp3 = qq[style="display:none"];
	$pp4 = qq[style="display:none"];
	$prem_option1 = qq[style="display:block"];
	}

$paypaluser = $setdet[8];
$paypalpass = $setdet[9];
$paypalsign = $setdet[10];
$pmode = $setdet[11];
$pcurrency = $setdet[42];
$pitemname = $setdet[43];


if ($pcurrency eq "USD") { $curs[0] = "selected"; }
if ($pcurrency eq "GBP") { $curs[1] = "selected"; }
if ($pcurrency eq "EUR") { $curs[2] = "selected"; }
if ($pcurrency eq "AUD") { $curs[3] = "selected"; }
if ($pcurrency eq "CAD") { $curs[4] = "selected"; }
if ($pcurrency eq "CZK") { $curs[5] = "selected"; }
if ($pcurrency eq "DKK") { $curs[6] = "selected"; }
if ($pcurrency eq "HKD") { $curs[7] = "selected"; }
if ($pcurrency eq "HUF") { $curs[8] = "selected"; }
if ($pcurrency eq "ILS") { $curs[9] = "selected"; }
if ($pcurrency eq "JPY") { $curs[10] = "selected"; }
if ($pcurrency eq "MXN") { $curs[11] = "selected"; }
if ($pcurrency eq "NOK") { $curs[12] = "selected"; }
if ($pcurrency eq "NZD") { $curs[13] = "selected"; }
if ($pcurrency eq "PHP") { $curs[14] = "selected"; }
if ($pcurrency eq "PLN") { $curs[15] = "selected"; }
if ($pcurrency eq "SGD") { $curs[16] = "selected"; }
if ($pcurrency eq "SEK") { $curs[17] = "selected"; }
if ($pcurrency eq "CHF") { $curs[18] = "selected"; }
if ($pcurrency eq "TWD") { $curs[19] = "selected"; }
if ($pcurrency eq "THB") { $curs[20] = "selected"; }



if ($pmode eq "sandbox")
	{
	$sandboxsel = "selected";
	}
	else
	{
	$paypalprod = "selected";
	}

$usdprice = $setdet[12];
$premium_expire_days = $setdet[13];
$premium_orderform_url = $setdet[14];

#####################

$premurl_nopaypal_help = qq[
Please specify the URL to the order form of your order processor here. <br>
  Users will be redirected to this URL so that they can make payment. <br>
  You will normally be able to obtain this URL from your order processor. <br><br>
  
  Note that you can use variables inside the URL. This is so that the ID,<br>
  or Title, etc. of the premium link submitted can be passed on to your order <br>
  processor.  This is so that you may know for what link payment was received.<br><br> 
  
  <strong>The following variables can be used inside the URL:</strong><br>
  <strong>!!lnkid!!</strong> = Link id of the link.<br>
  <strong>!!cid!!</strong> = Category id of the link.<br>
  <strong>!!title!!</strong> = Title of the link.<br>
  <strong>!!url!!</strong> = URL of the link.<br>
  <strong>!!email!!</strong> = Email address for link.<br>
  <strong>!!name!!</strong> = Contact person for the link.
];
$premurl_nopaypal_help =~ s/\n//gi;



###### Get lastbox

$cntr = 15; $expoc = 2;
for ($ms = 2; $ms < 11; $ms++) 
	{
		$cntr++;
		$c_premium_expire_days = $setdet[$cntr];
		$cntr++; $cntr++;
		
			if ($c_premium_expire_days ne "")
			{
			$last_pbox = $expoc;
			}
	
	$expoc++;
	}



#######

$cntr = 15; $expoc = 2;
for ($ms = 2; $ms < 11; $ms++) 
	{

		$c_usdprice = $setdet[$cntr];
		$cntr++;
		
		$c_premium_expire_days = $setdet[$cntr];
		$cntr++;
		
		$c_premium_orderform_url = $setdet[$cntr];
		$cntr++;
		
		if ($c_premium_expire_days ne "")
			{
			
				$usdprice_name = "usdprice" . $expoc;
				$premium_expire_days_name = "premium_expire_days" . $expoc;
				$premium_orderform_url_name = "premium_orderform_url" . $expoc;
				$standard_orderform_url_name = "standard_orderform_url" . $expoc; 

				$premspan = "premspan" . $expoc;
				$stanspan = "stanspan" . $expoc;
			
				$expoption = "exp" . $expoc;
				
				if ($usepaypal eq "Y") { $paypaltrue = qq[style="display:none"]; }
				
						$closewin = "closewin" . $expoc;
						
						if ($last_pbox == $expoc)
							{
							#$cdisp = "block";
							$cdisp = qq[<img src="$web_url/blank.gif" width="16" height="1"><a href="javascript:void(0)" OnClick="RemoveExpiry('$expoc')" id="$closewin" style="display: block"></a>];
							}
							else
							{
							#$cdisp = "none";
							$cdisp = qq[<img src="$web_url/blank.gif" width="16" height="1"><a href="javascript:void(0)" OnClick="RemoveExpiry('$expoc')" id="$closewin" style="display: none"></a>];
							}
							
				$expoptions{$expoption} = qq[
					<br>
					<table width="80%" border="0" align="center" cellpadding="3" cellspacing="0" class="aborder">
					<tr>
					<td width="49%">Price in USD:</td>
					<td width="50%"><input name="$usdprice_name" type="text" id="$usdprice_name" value="$c_usdprice" size="10" /></td>
					<td width="1%" align="right">$cdisp</td>
					</tr>
					<tr>
					<td width="49%">For how many days is a premium URL/Listing valid? </td>
					<td colspan="2"><input name="$premium_expire_days_name" type="text" id="$premium_expire_days_name" value="$c_premium_expire_days" size="6" />
					<strong>Days </strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('When the link is older than this number of days, then it will not be available as a premium listing anymore and only show as an ordinary link/listing.');" onmouseout="tooltip.hide();" /></td>
					</tr>
					<tr $paypaltrue id="$premspan">
					<td>Premium Link Order Form URL:
					 <img id="esthelp" src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('$premurl_nopaypal_help');" onmouseout="tooltip.hide();" />
					</td>
					<td colspan="2"><input name="$premium_orderform_url_name" type="text" id="$premium_orderform_url_name" value="$c_premium_orderform_url" size="50"/></td>
					</tr>
					</table>
				];
			
				$expoc++;
			}
		
		
	}	





$tophelp = qq[
<strong>If you use PayPal:</strong><br><br>
If you use PayPal then users submitting premium links will be redirected to PayPal<br>
  to make payment for the premium link. Note that the premium link being submitted <br>
  will only become a premium link once payment was successfully processed by <br>
PayPal.<br><br>
In the event where the user does not complete the transaction (chickens out) <br>
the premium link    that was  submitted will just be a standard link instead of a <br>
  premium link. The link can then be upgraded to a premium link from the user <br>
  control panel in future.<br><br>
It is important to note that the premium link that was submitted and successfully<br>
paid for with PayPal still needs to be approved by the Administrator.<br>
This can be done in the <br><em>PowerSeek Control Panel &gt;&gt; To Do &gt;&gt;  Approve/Edit New Submissions </em><br>
  Premium submissions will always be listed first (at the top) in this section.
<br><br>
<strong>If you don\\'t use PayPal:</strong><br><br>
The easiest method of handling payments would be to use PayPal as it is integrated<br>
into PowerSeek. If you are using another order processor then you can disable<br>
the use of PayPal and use the other order processor instead.<br><br>
When using another order processor you can place the URLs to the order <br>
processor order forms in the <em>premium link settings</em> section. When payment<br>
time arrives PowerSeek will then redirect users to the URLs you specified<br>
to the order processor.
];
$tophelp =~ s/\n//gi;



$hbox = acs::get_heading_box("$web_url/ic_add.gif", "<a href=\"$admin_url/p_addurl.cgi\">Extra Add URL / Modify Forms</a> >> Editing Form Set: $tname", qq[Edit options below:]);

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Modify</title>
$HTML_ENCODING_USE
<script LANGUAGE="JavaScript">

var popupwin = null;
  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=0,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
      if (popupwin == null || popupwin.closed)
			{
            popupwin = window.open (loc, 'popupwin2', myspecs);
           }
		 else
		   {
            popupwin.focus();
            popupwin.location.href = loc;
          }
    }

function checkall(formname,thestate)
	{
	BoxNames=new Array()
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}


function RemoveExpiry(expItem)
	{
		var agree=confirm("Are you sure you want to remove this option?");
		if (agree)
			{
			var pitem = 'exp' + expItem;
			document.getElementById(pitem).innerHTML = '';			
			document.getElementById('addbutton').style.display = 'block';
			}
			else
			{
			return false;
			}
		
		 var cwin; var lastb = 1;
				 for (i=1; i<=10; i++)
				 {
				  cwin = 'closewin' + i;
				  if (document.getElementById(cwin))
				  	 {
				  		lastb = i;
				  	 }
			 	 }
			if (lastb > 1) { document.getElementById('closewin' + lastb).style.display = 'block'; }
		
	}


function clickpaypal()
	{
	if (document.getElementById('usepaypal').checked == true)
		{
			document.getElementById('pp1').style.display = 'block';
			document.getElementById('pp2').style.display = 'block';
			document.getElementById('pp3').style.display = 'block';
			document.getElementById('pp4').style.display = 'block';
			document.getElementById('pp5').style.display = 'block';
			document.getElementById('pp6').style.display = 'block';
			
			document.getElementById('premurl1').style.display = 'none';
			
				 var foundnr = 0; var boxtocreate = 0;
					 for (i=1; i<=10; i++)
					 {
						var premdisp = 'premspan' + i;
						var standisp = 'stanspan' + i;
						
						if (document.getElementById(premdisp)) { 	document.getElementById(premdisp).style.display = 'none'; }
						if (document.getElementById(standisp)) {  document.getElementById(standisp).style.display = 'none'; }
					 }

		}
		else
		{
			document.getElementById('pp1').style.display = 'none';
			document.getElementById('pp2').style.display = 'none';
			document.getElementById('pp3').style.display = 'none';
			document.getElementById('pp4').style.display = 'none';
			document.getElementById('pp5').style.display = 'none';
			document.getElementById('pp6').style.display = 'none';

			document.getElementById('premurl1').style.display = 'block';
			
				 var foundnr = 0; var boxtocreate = 0;
					 for (i=1; i<=10; i++)
					 {
						var premdisp = 'premspan' + i;
						var standisp = 'stanspan' + i;
						
						if (document.getElementById(premdisp)) { 	document.getElementById(premdisp).style.display = 'block'; }
						if (document.getElementById(standisp)) {  document.getElementById(standisp).style.display = 'block'; }
					 }
			
		}
	}

function xmlhttpPost(strURL, action_img)
	 {
	 	
	 	 var foundnr = 0; var boxtocreate = 0;
		 for (i=2; i<=10; i++)
		 {
		 	var usdnm = 'usdprice' + i;
			if (document.getElementById(usdnm) == null) 
				{
					if (foundnr == 0)
						{
							boxtocreate = i;
							foundnr++;
						}
				}
			
			var cwin = 'closewin' + i;
			if (document.getElementById(cwin))
				{
				document.getElementById(cwin).style.display = 'none';
				}
		 }
	 	foundnr = 0;
	 	display_area = 'exp' + boxtocreate;
	 	
	 	if (boxtocreate == 10)
	 		{
	 		document.getElementById('addbutton').style.display = 'none';
	 		}
	 	
	 	strURL = strURL + '&create=' + boxtocreate;
	 	
	 	if (document.getElementById('usepaypal').checked == true)
	 		{
	 		strURL = strURL + '&create=' + boxtocreate + '&paypal=true';
	 		}

	 document.getElementById(action_img).style.display='block';
 
    var xmlHttpReq = false;
    var self = this;
 		
    // Mozilla/Safari
    if (window.XMLHttpRequest) { self.xmlHttpReq = new XMLHttpRequest(); }
 
    // IE
    else if (window.ActiveXObject) { self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP"); }
 
    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	 self.xmlHttpReq.onreadystatechange = function()
    	   {
         if (self.xmlHttpReq.readyState == 4)
         		{
         		document.getElementById(display_area).innerHTML  = self.xmlHttpReq.responseText;
         		document.getElementById(action_img).style.display='none';
         		}
    		}
 
    // Mozilla/Safari
    if (window.XMLHttpRequest) {self.xmlHttpReq.send(strURL);}
 
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq.send();}
   }

function check_errors()
	{
		
		if (document.getElementById('usepaypal').checked == true)
			{
				if (document.getElementById('paypaluser').value == '') { alert ('You have to provide a PayPal API user name.'); return false; }
				if (document.getElementById('paypalpass').value == '') { alert ('You have to provide a PayPal API password.');  return false; }
				if (document.getElementById('paypalsign').value == '') { alert ('You have to provide a PayPal API signature.'); return false; }
				if (document.getElementById('usdprice').value == '') { alert ('You have to provide a price in USD for the first expiry option.'); return false; }
				if (document.getElementById('premium_expire_days').value == '') { alert ('You have to provide the number of days which the premium link will be valid for the first expiry option.'); return false; }
				
				var usdprice; 
				var premium_expire_days; 
				
				 for (i=2; i<11; i++)
				 {
				 	usdprice = 'usdprice' + i;
				 	premium_expire_days = 'premium_expire_days' + i;
				 
						if (document.getElementById(usdprice)) 
							{
							if (document.getElementById(usdprice).value == '') { alert ('You have to provide a price for option box ' + i); return false; }
							}

						if (document.getElementById(premium_expire_days)) 
							{
							if (document.getElementById(premium_expire_days).value == '') { alert ('You have to provide the number of days the premium URL will be valid for option box ' + i); return false; }
							}
				 }
				
			}
			else
			{
				if (document.getElementById('premium_expire_days').value == '') { alert ('You have to provide the number of days which the premium link will be valid for the first expiry option.'); return false; }
				if (document.getElementById('premium_orderform_url').value == '') { alert ('You have to provide a URL to the order form of your order processor.'); return false; }

					var usdprice; 
					var premium_expire_days; 
					var premium_orderform_url;

					 for (i=2; i<11; i++)
					 {
						usdprice = 'usdprice' + i;
						premium_expire_days = 'premium_expire_days' + i;
						premium_orderform_url = 'premium_orderform_url' + i;

							if (document.getElementById(usdprice)) 
								{
								if (document.getElementById(usdprice).value == '') { alert ('You have to provide a price for option box ' + i); return false; }
								}

							if (document.getElementById(premium_expire_days)) 
								{
								if (document.getElementById(premium_expire_days).value == '') { alert ('You have to provide the number of days the premium URL will be valid for option box ' + i); return false; }
								}

							if (document.getElementById(premium_orderform_url)) 
								{
								if (document.getElementById(premium_orderform_url).value == '') { alert ('You have to provide a URL to your order processor for option box ' + i); return false; }
								}
					 }
				
			}
	}		

</script>

<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script SRC="$web_url/qtip.js"></script>

<style type="text/css">

div#qTip {
 padding: 10px;
 border: 1px solid #DBDBDB;
 display: none;
 background: url("$web_url/tooltback.gif");
 color: #000;
 font: 11px Arial, sans-serif;
 text-align: left;
 position: absolute;
 z-index: 1000;
}

#closewin { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin:hover { background-position: 0 -16px; } 
#closewin span {display: none; } 

#closewin1 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin1:hover { background-position: 0 -16px; } 
#closewin1 span {display: none; } 

#closewin2 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin2:hover { background-position: 0 -16px; } 
#closewin2 span {display: none; } 

#closewin3 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin3:hover { background-position: 0 -16px; } 
#closewin3 span {display: none; } 

#closewin4 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin4:hover { background-position: 0 -16px; } 
#closewin4 span {display: none; } 

#closewin5 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin5:hover { background-position: 0 -16px; } 
#closewin5 span {display: none; } 

#closewin6 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin6:hover { background-position: 0 -16px; } 
#closewin6 span {display: none; } 

#closewin7 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin7:hover { background-position: 0 -16px; } 
#closewin7 span {display: none; } 

#closewin8 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin8:hover { background-position: 0 -16px; } 
#closewin8 span {display: none; } 

#closewin9 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin9:hover { background-position: 0 -16px; } 
#closewin9 span {display: none; } 

#closewin10 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin10:hover { background-position: 0 -16px; } 
#closewin10 span {display: none; } 

</style> 


</head>
<body>
$hbox


<form method="POST" action="$admin_url/p_addurl.cgi" name="addu" style="margin-bottom:0; margin-top:0;" onSubmit="return check_errors();">
  <table width="100%" border="0" cellspacing="0" cellpadding="0">
    <tr></tr>
    <tr>
      <td width="1%" valign="top" class="saveback"><img src="$web_url/saveback3.png" width="15" height="34" /></td>
      <td width="99%" valign="top"><table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DFDFDF">
          <tr>
            <td colspan="2" valign="top" background="$web_url/bar7.gif" class="normaltext"><strong>Extra 'Add URL'/'Modify' Forms Settings:</strong><strong></strong></td>
          </tr>
          <tr>
            <td width="40%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Name for this 'Add URL'/'Modify' Form Set:</strong></td>
            <td width="60%" valign="top" bgcolor="#FFFFFF" class="normaltext"><label> <strong>$tname</strong></label></td>
          </tr>
          <tr>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Description for this  'Add URL'/'Modify' Form Set: </strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('This description is only for your own informational purposes.');" onMouseOut="tooltip.hide();"></td>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext"><input name="add_diz" type="text" id="add_diz" style="width:100%" value="$diz"></td>
          </tr>
          <tr>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>What fields would require values with submissions? </strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('If you tick fields here then users will be required to provide a value when doing a <br>new submission or when modifying a listing.');" onMouseOut="tooltip.hide();"></td>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext"><input name="r_title" type="checkbox" checked disabled>
              Title<br>
              <input name="r_diz" 		type="checkbox" value="description" $c_description>
              Description<br>
              <input name="r_keywords" type="checkbox" value="keywords" $c_keywords>
              Keywords <br>
              <input name="r_url" 		type="checkbox" value="url" $c_url>
              URL <br>
              <input name="r_contact" 	type="checkbox" value="sname" $c_sname>
              Contact Person for Listing<br>
              <input name="r_email" 	type="checkbox" value="email" $c_email>
              Contact Email for Listing <br>
              $ce_options<br></td>
          </tr>
          <tr>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Category Limiting:</strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('To let users only submit to specific categories and it\\'s <br>sub categories, supply category IDs here seperated by comma\\'s. Leave blank <br>for all categories to be listed in the \\'Add URL\\' form. Use the \\'Category Browser\\' function to find categories.');" onMouseOut="tooltip.hide();"></td>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext">
            
             <input type="text" name="related_categories" style="width:100%" value="$catstring">
              (<a href="$admin_url/admin67.cgi?fct=related" onClick="popup('$admin_url/admin67.cgi?fct=related',750,600);return false;">Category Browser</a>)
              <br>
            
                <input name="incl_subs" type="checkbox" id="incl_subs" value="Y" $incl_checked>
                Include Subcategories of categories specified above when listing categories where submissions can be done.<br>
                <br>
                $initcats
            </td>
          </tr>
          <tr>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Check for duplicates? </strong><img src="$web_url/est_help.gif" style="vertical-align:middle" 
      onMouseOver=" tooltip.show('If a duplicate URL is found in the database then the user won\\'t be able to submit the listing. <br>This setting will be ignored if you don\\'t require the user to enter a URL.');" onMouseOut="tooltip.hide();"></td>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext"><input name="duplic" type="checkbox" value="Y" $duplic_checked>
              Do URL Duplicate Checking</td>
          </tr>
          <tr>
            <td  valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Would you like to use PayPal for premium link submissions?</strong>
            </td>
            <td  valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox" name="usepaypal" id="usepaypal" onclick="clickpaypal();" value="Y" $usepaypalchecked/>
            <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('$tophelp');" onmouseout="tooltip.hide();">
            </td>
          </tr>
          <tr id="pp1" $pp1>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext">PayPal API UserName:</td>
            <td valign="top" bgcolor="#FFFFFF"><input type="text" name="paypaluser" size="50" value="$paypaluser" id="paypaluser" />
              <img src="$web_url/est_help.gif" stapyle="vertical-align:middle" 
      onmouseover=" tooltip.show('To get a PayPal API Username, API Password and signature do the following:&lt;br&gt;&lt;br&gt;1.Log in to your PayPal Premier or Business account. (You have to have a Business or Premier Account)&lt;br&gt;2.Click the Profile subtab located in the top navigation area.&lt;br&gt;3.Click on \\'My selling tools\\'&lt;br&gt;4.Click \\'Update\\' next to \\'API Access\\'.&lt;br&gt;');" onmouseout="tooltip.hide();" /></td>
          </tr>
          <tr class="tdtable" id="pp2" $pp2>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext" >PayPal API Password:</td>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext" ><input
			name="paypalpass" type="text" id="paypalpass" value="$paypalpass" size="50" />
              <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('To get a PayPal API Username, API Password and signature do the following:&lt;br&gt;&lt;br&gt;1.Log in to your PayPal Premier or Business account. (You have to have a Business or Premier Account)&lt;br&gt;2.Click the Profile subtab located in the top navigation area.&lt;br&gt;3.Click on \\'My selling tools\\'&lt;br&gt;4.Click \\'Update\\' next to \\'API Access\\'.&lt;br&gt;');" onmouseout="tooltip.hide();" /></td>
          </tr>
          <tr class="tdtable" id="pp3" $pp3>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext">Sinature:</td>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext"><input name="paypalsign" type="text" id="paypalsign" value="$paypalsign" size="50" />
              <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('To get a PayPal API Username, API Password and signature do the following:&lt;br&gt;&lt;br&gt;1.Log in to your PayPal Premier or Business account. (You have to have a Business or Premier Account)&lt;br&gt;2.Click the Profile subtab located in the top navigation area.&lt;br&gt;3.Click on \\'My selling tools\\'&lt;br&gt;4.Click \\'Update\\' next to \\'API Access\\'.&lt;br&gt;');" onmouseout="tooltip.hide();" /></td>
          </tr>
          <tr class="tdtable" id="pp5" $pp4>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext">Currency:</td>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext">

      <select name="currency" id="currency">
        <option value="USD" $curs[0]>U.S. Dollar</option>
        <option value="GBP" $curs[1]>Pound Sterling</option>
        <option value="EUR" $curs[2]>Euro</option>
        <option value="AUD" $curs[3]>Australian Dollar </option>
        <option value="CAD" $curs[4]>Canadian Dollar </option>
        <option value="CZK" $curs[5]>Czech Koruna </option>
        <option value="DKK" $curs[6]>Danish Krone  </option>
        <option value="HKD" $curs[7]>Hong Kong Dollar</option>
        <option value="HUF" $curs[8]>Hungarian Forint</option>        
        <option value="ILS" $curs[9]>Israeli New Sheqel</option>
        <option value="JPY" $curs[10]>Japanese Yen</option>
        <option value="MXN" $curs[11]>Mexican Peso</option>
        <option value="NOK" $curs[12]>Norwegian Krone</option>
        <option value="NZD" $curs[13]>New Zealand Dollar</option>
        <option value="PHP" $curs[14]>Philippine Peso</option>
        <option value="PLN" $curs[15]>Polish Zloty</option>
        <option value="SGD" $curs[16]>Singapore Dollar</option>                
        <option value="SEK" $curs[17]>Swedish Krona</option>                
        <option value="CHF" $curs[18]>Swiss Franc</option>                
        <option value="TWD" $curs[19]>Taiwan New Dollar</option>                
        <option value="THB" $curs[20]>Thai Baht</option>
        
      </select>            
            
            </td>
          </tr>
          <tr class="tdtable" id="pp4" $pp4>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext">PayPal Mode:</td>
            <td valign="top" bgcolor="#FFFFFF" class="normaltext"><select name="pmode" id="pmode">
              <option value="live" $paypalprod>PayPal Live Production Mode</option>
              <option value="sandbox" $sandboxsel>Use PayPal Sandbox</option>
            </select>
              <img src="$web_url/est_help.gif" style="vertical-align:middle" 
        onmouseover=" tooltip.show('<b>Live Production Mode:</b> Payments will be handled by PayPal and is the system is \\'live\\' <br><br> <b>Use PayPal Sandbox:</b> PayPal Test mode using the PayPal sandbox. PayPal is not \\'live\\' and payments will not be processed. This mode is only for testing purposes. ');" onmouseout="tooltip.hide();" /></td>
          </tr>

        <tr class="tdtable" id="pp6">
          <td valign="top" bgcolor="#FFFFFF" class="normaltext">Purchase Item Name:</td>
          <td valign="top" bgcolor="#FFFFFF" class="normaltext">
		     <input name="pitemname" type="text" id="pitemname" size="50" value="$pitemname">
           <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('This name will be displayed with the price when making the purchase at Paypal');" onmouseout="tooltip.hide();" />        
        </td>
        </tr>
          
          <tr>
            <td  colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium Link Order Form Options:</strong><br>
              <br>
              <table width="80%" border="0" align="center" cellpadding="3" cellspacing="0" class="aborder">
                <tr>
                  <td width="49%"><span class="normaltext">Price in USD:</span></td>
                  <td width="50%"><span class="normaltext">
                    <input name="usdprice" type="text" id="usdprice" size="10" value="$usdprice"/>
                  </span></td>
                  <td width="1%" align="right"><span class="normaltext"><img src="$web_url/blank.gif" width="16" height="1"></span></td>
                </tr>
                <tr>
                  <td><span class="normaltext">For how many days is a premium URL/Listing valid? </span></td>
                  <td colspan="2"><span class="normaltext">
                    <input type="text" name="premium_expire_days" id="premium_expire_days" size="6" value="$premium_expire_days" />
                    <strong>Days </strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('When the link is older than this number of days, it will not be available as a premium listing anymore and only show as an ordinary link/listing.');" onmouseout="tooltip.hide();" /></span></td>
                </tr>
                <tr id="premurl1" $prem_option1>
                  <td><span class="normaltext">Premium Link Order Form URL:</span>
                    <img id="esthelp" src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('$premurl_nopaypal_help');" onmouseout="tooltip.hide();" />
                  </td>
                  <td colspan="2">
                    <input type="text" name="premium_orderform_url" size="50" value="$premium_orderform_url" id="premium_orderform_url"/>
                    </td>
                </tr>
              </table>
              <span id="exp1">$expoptions{'exp1'}</span> <span id="exp2">$expoptions{'exp2'}</span> <span id="exp3">$expoptions{'exp3'}</span> <span id="exp4">$expoptions{'exp4'}</span> <span id="exp5">$expoptions{'exp5'}</span> <span id="exp6">$expoptions{'exp6'}</span> <span id="exp7">$expoptions{'exp7'}</span> <span id="exp8">$expoptions{'exp8'}</span> <span id="exp9">$expoptions{'exp9'}</span> <span id="exp10">$expoptions{'exp10'}</span>
              <table width="80%" border="0" align="center" cellpadding="0" cellspacing="0">
                <tr>
                  <td align="right"><br />
                    <span id="addbutton" $bdisplay>
                      <table width="80%" border="0" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="98%" align="right"><img src="$web_url/ajload3.gif" style="display:none" id="loader" /></td>
                          <td width="1%"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('You can add additional expiry options here. If you would like to have options where links expire within 30 days, 60 days or 120 days then you would add two additional options for 60 and 120 days for example. The first option would be 30 days.&lt;br&gt;&lt;Br&gt;For Example: You could provide the options where it\\'s \$5 for 30 days, \$7 for 60 days and \$15 for 120 days.&lt;br&gt;&lt;Br&gt;Note that you can add up to 9 additional options.');" onmouseout="tooltip.hide();" /></td>
                          <td width="1%"><input type="submit" name="adddays" id="adddays" value="Add additional expiry options" class="psbutton" onclick="xmlhttpPost('$admin_url/admin23.cgi?fct=addexpiry&amp;d=' + parseInt(Math.random()*10000) + '&amp;', 'loader'); return false;" /></td>
                        </tr>
                      </table>
                    </span></td>
                </tr>
              </table></td>
          </tr>
        </table>
        <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
          <tr>
            <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
            <td width="147%"></td>
          </tr>
      </table></td>
    </tr>
    <tr>
      <td valign="top"><img src="$web_url/saveback2.png" width="15" height="34" /></td>
      <td height="42"><span class="normaltext">
        <input type="submit" class="psbutton" name="button" id="button" value="   Save Settings   ">
        <input type="hidden" name="fct" value="save_settings">
        <input type="hidden" name="tname" value="$tname">
      </span></td>
    </tr>
  </table>
  <br><br><br>
  <p></p>
  <p>&nbsp;</p>
  <p>&nbsp;</p>
</form>


</body>
</html>
];

}




sub delete_set
{

$tname = $q->param('tname');

$fdata = "addmod_" . $tname . ".dat";
unlink ("$data_dir/$fdata");

$rgs_add_url_med = $tname . "_" . "rgs_add_url_med" . ".html"; unlink ("$data_dir/$rgs_add_url_med"); 
$rgs_add_url_medp = $tname . "_" . "rgs_add_url_medp" . ".html"; unlink ("$data_dir/$rgs_add_url_medp"); 
$rgs_add_url_problem = $tname . "_" . "rgs_add_url_problem" . ".html"; unlink ("$data_dir/$rgs_add_url_problem"); 
$rgs_add_url_success = $tname . "_" . "rgs_add_url_success" . ".html"; unlink ("$data_dir/$rgs_add_url_success"); 
$rgs_modify_link_edit = $tname . "_" . "rgs_modify_link_edit" . ".html"; unlink ("$data_dir/$rgs_modify_link_edit"); 
$rgs_modify_link_editp = $tname . "_" . "rgs_modify_link_editp" . ".html"; unlink ("$data_dir/$rgs_modify_link_editp"); 
$rgs_modify_link_problem = $tname . "_" . "rgs_modify_link_problem" . ".html"; unlink ("$data_dir/$rgs_modify_link_problem"); 
$rgs_modify_link_success = $tname . "_" . "rgs_modify_link_success" . ".html"; unlink ("$data_dir/$rgs_modify_link_success"); 


$rgs_rgs_upgrade = $tname . "_" . "rgs_regsuccess_paypal" . ".html"; unlink ("$data_dir/$rgs_rgs_upgrade"); 
$rgs_rgs_upgrade = $tname . "_" . "rgs_upgrade" . ".html"; unlink ("$data_dir/$rgs_rgs_upgrade"); 
$rgs_rgs_upgrade = $tname . "_" . "rgs_upgrade_paypal_success" . ".html"; unlink ("$data_dir/$rgs_rgs_upgrade"); 



unlink ("$data_dir/" . $tname . "_" . "welcome" . ".eml");
unlink ("$data_dir/" . $tname . "_" . "accept" . ".eml");
unlink ("$data_dir/" . $tname . "_" . "reject" . ".eml");
unlink ("$data_dir/" . $tname . "_" . "inform" . ".eml");
unlink ("$data_dir/" . $tname . "_" . "pwelcome" . ".eml");
unlink ("$data_dir/" . $tname . "_" . "paccept" . ".eml");
unlink ("$data_dir/" . $tname . "_" . "preject" . ".eml");
unlink ("$data_dir/" . $tname . "_" . "pinform" . ".eml");
unlink ("$data_dir/" . $tname . "_" . "maccept" . ".eml");
unlink ("$data_dir/" . $tname . "_" . "mreject" . ".eml");
unlink ("$data_dir/" . $tname . "_" . "pinformupgrade" . ".eml");


$hbox = acs::get_heading_box("$web_url/ic_add.gif", "Form Set Deleted", qq[<b><a href="$admin_url/p_addurl.cgi">Click Here to Continue</a></b>]);

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Modify</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}







sub edit_templates
{

$tname = $q->param('tname');

$rgs_add_url_med = $tname . "_" . "rgs_add_url_med";
$rgs_add_url_medp = $tname . "_" . "rgs_add_url_medp";
$rgs_add_url_problem = $tname . "_" . "rgs_add_url_problem";
$rgs_add_url_success = $tname . "_" . "rgs_add_url_success";
$rgs_upgrade = $tname . "_" . "rgs_upgrade";

#Premium Add URL Order Form (Link to your order processor)

$rgs_modify_link_edit = $tname . "_" . "rgs_modify_link_edit";
$rgs_modify_link_editp = $tname . "_" . "rgs_modify_link_editp";
$rgs_modify_link_problem = $tname . "_" . "rgs_modify_link_problem";
$rgs_modify_link_success = $tname . "_" . "rgs_modify_link_success";

$adduc = &get_file_contents("$data_dir/$rgs_add_url_med.html");
$adducp = &get_file_contents("$data_dir/$rgs_add_url_medp.html");

if ($adduc !~ /!!error_text!!/)
	{
		$prbpage = qq[<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
	          <td valign="top" class="normaltext"><a href="$admin_url/admin57.cgi?fct=edit_template&template=$rgs_add_url_problem&extraform=$tname" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=$rgs_add_url_problem&extraform=$tname',screen.width-200,screen.height-200);return false;">Problem Page</a></td>
	          <td valign="top" class="normaltext">$rgs_add_url_problem.html</td>
	          <td align="center" valign="top" class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$rgs_add_url_problem&f=$tname" target="_blank">Preview</a></td>
	        </tr>
	        ];
	}

if ($adducp !~ /!!error_text!!/)
	{
		$prbpage = qq[<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top" class="normaltext"><a href="$admin_url/admin57.cgi?fct=edit_template&template=$rgs_add_url_problem&extraform=$tname" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=$rgs_add_url_problem&extraform=$tname',screen.width-200,screen.height-200);return false;">Problem Page</a></td>
          <td valign="top" class="normaltext">$rgs_add_url_problem.html</td>
          <td align="center" valign="top" class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$rgs_add_url_problem&f=$tname" target="_blank">Preview</a></td>
        </tr>
        ];
	}


$modifc = &get_file_contents("$data_dir/$rgs_modify_link_edit.html");
$modifcp = &get_file_contents("$data_dir/$rgs_modify_link_editp.html");


if ($modifc !~ /!!error_text!!/)
	{
		$modprbp = qq[<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top" class="normaltext"><a href="$admin_url/admin57.cgi?fct=edit_template&template=$rgs_modify_link_problem&extraform=$tname" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=$rgs_modify_link_problem&extraform=$tname',screen.width-200,screen.height-200);return false;">Modify Link Problem Page</a></td>
          <td valign="top" class="normaltext">$rgs_modify_link_problem.html</td>
          <td align="center" valign="top" class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$rgs_modify_link_problem&f=$tname" target="_blank">Preview</a></td>
        </tr>
	        ];
	}

if ($modifcp !~ /!!error_text!!/)
	{
		$modprbp = qq[<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top" class="normaltext"><a href="$admin_url/admin57.cgi?fct=edit_template&template=$rgs_modify_link_problem&extraform=$tname" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=$rgs_modify_link_problem&extraform=$tname',screen.width-200,screen.height-200);return false;">Modify Link Problem Page</a></td>
          <td valign="top" class="normaltext">$rgs_modify_link_problem.html</td>
          <td align="center" valign="top" class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$rgs_modify_link_problem&f=$tname" target="_blank">Preview</a></td>
        </tr>
        ];
	}


### Get settings

$sfile = "addmod_" . $tname . ".dat";
$setdetails = &get_file_contents("$data_dir/$sfile");
@setdet = split (/\n/, $setdetails);
$usepaypal = $setdet[7];


if ($setdet[16] ne "") ### premium_expire_days2
	{
		$upgrade_standard_to_premium = qq[		
		<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
		<td valign="top" class="normaltext"><a href="$admin_url/admin57.cgi?fct=edit_template&template=$rgs_upgrade&extraform=$tname" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=$rgs_upgrade&extraform=$tname',screen.width-200,screen.height-200);return false;"
		onMouseOver=" tooltip.show('This template is displayed to a user that chooses to upgrade a link to a premium link.<br>This template will typically present the user with expiry options with different pricings.');" onMouseOut="tooltip.hide();">Upgrade Page Standard to Premium</a> $upgrade_in_use</td>
		<td valign="top" class="normaltext">$rgs_upgrade.html</td>
		<td align="center" valign="top" class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$rgs_upgrade&f=$tname" target="_blank">Preview</a></td>
		</tr>
		];
	}




if ($usepaypal eq "Y") 
	{
	#Success Page PayPal Purchase 
	#Upgrade Page PayPal Purchase Success 
	
		$rgs_regsuccess_paypal = $tname . "_" . "rgs_regsuccess_paypal";
		$paypal_success = qq[
	        <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
	          <td valign="top" class="normaltext"><a 
	          href="$admin_url/admin57.cgi?fct=edit_template&template=$rgs_regsuccess_paypal&extraform=$tname" 
	          onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=$rgs_regsuccess_paypal&extraform=$tname',screen.width-200,screen.height-200);return false;"
	          onMouseOver=" tooltip.show('This template is displayed to a user after he/she successfully submitted a <br>premium link and paid for it with PayPal.');" onMouseOut="tooltip.hide();">
	          Success Page PayPal Purchase</a></td>
	          <td valign="top" class="normaltext">$rgs_regsuccess_paypal.html</td>
	          <td align="center" valign="top" class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$rgs_regsuccess_paypal&f=$tname" target="_blank">Preview</a></td>
	        </tr>
			 ];


		$rgs_upgrade_paypal_success = $tname . "_" . "rgs_upgrade_paypal_success";
		$paypal_upgrade_success = qq[
	        <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
	          <td valign="top" class="normaltext"><a 
	          href="$admin_url/admin57.cgi?fct=edit_template&template=$rgs_upgrade_paypal_success&extraform=$tname" 
	          onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=$rgs_upgrade_paypal_success&extraform=$tname',screen.width-200,screen.height-200);return false;"
	          onMouseOver=" tooltip.show('This template is displayed to a user after he/she successfully upgraded a <br>standard link to a premium link and paid for it with PayPal.');" onMouseOut="tooltip.hide();">
	          Upgrade Page PayPal Purchase Success</a></td>
	          <td valign="top" class="normaltext">$rgs_upgrade_paypal_success.html</td>
	          <td align="center" valign="top" class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$rgs_upgrade_paypal_success&f=$tname" target="_blank">Preview</a></td>
	        </tr>
			 ];
	}


print qq[<table width="100%" border="0" cellpadding="0" cellspacing="0">
  <tr>
    <td width="1%" valign="top"><span class="normaltext"><img src="$web_url/dbut.gif"></span></td>
    <td width="99%"><table width="100%" border="0" align="center" cellpadding="3" cellspacing="1" style="border: 1px solid rgb(221,221,221)">
        <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top" bgcolor="#F5F5F5" class="normaltext"><strong>Add URL Templates: (Click to Edit)</strong></td>
          <td valign="top" bgcolor="#F5F5F5" class="normaltext"><strong>Filename:</strong></td>
          <td valign="top" bgcolor="#F5F5F5" class="normaltext">&nbsp;</td>
        </tr>
        <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td width="49%" valign="top" class="normaltext"><a href="$admin_url/admin57.ci?fct=edit_template&template=$rgs_add_url_med&extraform=$tname"  onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=$rgs_add_url_med&extraform=$tname',screen.width-200,screen.height-200);return false;"
onMouseOver=" tooltip.show('This template is displayed to a user that submits a standard link');" onMouseOut="tooltip.hide();">Add URL Template</a></td>
          <td width="50%" valign="top" class="normaltext">$rgs_add_url_med.html</td>
          <td width="1%" align="center" valign="top" class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$rgs_add_url_med&f=$tname" target="_blank">Preview</a></td>
        </tr>
        <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top" class="normaltext"><a href="$admin_url/admin57.cgi?fct=edit_template&template=$rgs_add_url_medp&extraform=$tname" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=$rgs_add_url_medp&extraform=$tname',screen.width-200,screen.height-200);return false;"
onMouseOver=" tooltip.show('This template is displayed to a user that submits a premium link');" onMouseOut="tooltip.hide();">Paid Add URL Template</a></td>
          <td valign="top" class="normaltext">$rgs_add_url_medp.html</td>
          <td align="center" valign="top" class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$rgs_add_url_medp&f=$tname" target="_blank">Preview</a></td>
        </tr>
$prbpage
        <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top" class="normaltext"><a href="$admin_url/admin57.cgi?fct=edit_template&template=$rgs_add_url_success&extraform=$tname" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=$rgs_add_url_success&extraform=$tname',screen.width-200,screen.height-200);return false;"
onMouseOver=" tooltip.show('This template is displayed to a user that successfully submitted a link');" onMouseOut="tooltip.hide();">Success Page</a></td>
          <td valign="top" class="normaltext">$rgs_add_url_success.html</td>
          <td align="center" valign="top" class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$rgs_add_url_success&f=$tname" target="_blank">Preview</a></td>
        </tr>
$paypal_success

$upgrade_standard_to_premium
        
$paypal_upgrade_success
        <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td colspan="3" valign="top" bgcolor="#F5F5F5" class="normaltext"><strong>Modify Templates: (Click to Edit)</strong></td>
        </tr>
        <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top" class="normaltext"><a href="$admin_url/admin57.cgi?fct=edit_template&template=$rgs_modify_link_edit&extraform=$tname" 
          		onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=$rgs_modify_link_edit&extraform=$tname',screen.width-200,screen.height-200);return false;"
          		onMouseOver=" tooltip.show('This template is displayed to a user that has chosen to modify a link that was<br> submitted from a custom Add URL form.');" onMouseOut="tooltip.hide();"
          		>Modify/Edit Link Standard</a></td>
          <td valign="top" class="normaltext">$rgs_modify_link_edit.html</td>
          <td align="center" valign="top" class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$rgs_modify_link_edit&f=$tname" target="_blank">Preview</a></td>
        </tr>
        <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top" class="normaltext"><a href="$admin_url/admin57.cgi?fct=edit_template&template=$rgs_modify_link_editp&extraform=$tname" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=$rgs_modify_link_editp&extraform=$tname',screen.width-200,screen.height-200);return false;"
          onMouseOver=" tooltip.show('This template is displayed to a user that has chosen to modify a premium link that was<br> submitted from a custom Add URL form.');" onMouseOut="tooltip.hide();"
          >Modify/Edit Link Premium</a></td>
          <td valign="top" class="normaltext">$rgs_modify_link_editp.html</td>
          <td align="center" valign="top" class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$rgs_modify_link_editp&f=$tname" target="_blank">Preview</a></td>
        </tr>
   $modprbp
        <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top" class="normaltext"><a href="$admin_url/admin57.cgi?fct=edit_template&template=$rgs_modify_link_success&extraform=$tname" onClick="popup('$admin_url/admin57.cgi?fct=edit_template&template=$rgs_modify_link_success&extraform=$tname',screen.width-200,screen.height-200);return false;"
          onMouseOver=" tooltip.show('This template is displayed to a user when a link was modified.');" onMouseOut="tooltip.hide();"
          >Modify Link Success</a></td>
          <td valign="top" class="normaltext">$rgs_modify_link_success.html</td>
          <td align="center" valign="top" class="normaltext"><a href="$admin_url/admin68.cgi?fct=prev&template=$rgs_modify_link_success&f=$tname" target="_blank">Preview</a></td>
        </tr>
      </table>
      </td>
  </tr>
</table>
];

}







sub add_include
{

$existname = "addmod_" . $q->param('add_name') . ".dat";
if ((-e "$data_dir/$existname") > 0)
	{
	acs::problem_popup("The name you have chosen is already used for a 'Form Set'. Please choose a different name.");
	}


if ($q->param('add_name') eq "")
	{
	acs::problem_popup("You have to supply a name for the extra 'Add URL'/'Modify' form set you are about to create.");
	}


for ($ms = 0; $ms < length($q->param('add_name')); $ms++) 
	{
	$oneletter = substr($q->param('add_name'), $ms, 1);
	if ($oneletter !~ /[0-9a-zA-Z]/)
		{
		acs::problem_popup("The name you specified contains invalid characters. Please use only numerical characters or characters present in the english alphabet.");
		exit;
		}
	}

$conf_file = $q->param('add_name'); $formset_name = $q->param('add_name');
$conf_file = "addmod_" . $conf_file . ".dat";


if ($q->param('r_diz') eq "description") { $required_link = "description" . "::"; }
if ($q->param('r_keywords') eq "keywords") { $required_link = $required_link . "keywords" . "::"; }
if ($q->param('r_url') eq "url") { $required_link = $required_link . "url" . "::"; }
if ($q->param('r_catsugg') eq "csuggestion") { $required_link = $required_link . "csuggestion" . "::"; }
if ($q->param('r_contact') eq "sname") { $required_link = $required_link . "sname" . "::"; }
if ($q->param('r_email') eq "email") { $required_link = $required_link . "email" . "::"; }


$keydata = &get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

$kcount = 0;
foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
	if ($q->param($keyname) eq "$keyname") { $required_link = $required_link . $keyname . "::"; }
	}


open (ADDMOD, "> $data_dir/$conf_file");
 	print ADDMOD $q->param('add_name') . "\n";				# 0 
 	print ADDMOD $q->param('add_diz') . "\n";					# 1	
 	print ADDMOD $required_link . "\n";							# 2
 	print ADDMOD $q->param('incl_subs') . "::" . $q->param('related_categories') . "\n";		# 3 
 	print ADDMOD $q->param('duplic') . "\n";					# 4 
 	print ADDMOD $q->param('premium_payment') . "\n";		# 5 
 	print ADDMOD $q->param('standard_payment') . "\n";		# 6 
 	
 	print ADDMOD $q->param('usepaypal') . "\n"; 		############# 7 USE PAYPAL
 	
 	print ADDMOD $q->param('paypaluser') . "\n";		# 8
 	print ADDMOD $q->param('paypalpass') . "\n";		# 9
 	print ADDMOD $q->param('paypalsign') . "\n";		# 10
 	print ADDMOD $q->param('pmode') . "\n";			# 11 

 	print ADDMOD $q->param('usdprice') . "\n";	   ############## 12 PREMIUM LINK ORDER OPTIONS
 	print ADDMOD $q->param('premium_expire_days') . "\n";		# 13
 	print ADDMOD $q->param('premium_orderform_url') . "\n";	# 14
 	
 	print ADDMOD $q->param('usdprice2') . "\n";					   # 15
 	print ADDMOD $q->param('premium_expire_days2') . "\n";	   # 16
 	print ADDMOD $q->param('premium_orderform_url2') . "\n";		# 17

 	print ADDMOD $q->param('usdprice3') . "\n";						# 18
 	print ADDMOD $q->param('premium_expire_days3') . "\n";		# 19
 	print ADDMOD $q->param('premium_orderform_url3') . "\n";		# 20

 	print ADDMOD $q->param('usdprice4') . "\n";						# 21
 	print ADDMOD $q->param('premium_expire_days4') . "\n";		# 22
 	print ADDMOD $q->param('premium_orderform_url4') . "\n";		# 23

 	print ADDMOD $q->param('usdprice5') . "\n";						# 24
 	print ADDMOD $q->param('premium_expire_days5') . "\n";		# 25
 	print ADDMOD $q->param('premium_orderform_url5') . "\n";		# 26

 	print ADDMOD $q->param('usdprice6') . "\n";						# 27
 	print ADDMOD $q->param('premium_expire_days6') . "\n";		# 28
 	print ADDMOD $q->param('premium_orderform_url6') . "\n";		# 29

 	print ADDMOD $q->param('usdprice7') . "\n";						# 30
 	print ADDMOD $q->param('premium_expire_days7') . "\n";		# 31
 	print ADDMOD $q->param('premium_orderform_url7') . "\n";		# 32

 	print ADDMOD $q->param('usdprice8') . "\n";						# 33
 	print ADDMOD $q->param('premium_expire_days8') . "\n";		# 34
 	print ADDMOD $q->param('premium_orderform_url8') . "\n";		# 35

 	print ADDMOD $q->param('usdprice9') . "\n";						# 36
 	print ADDMOD $q->param('premium_expire_days9') . "\n";		# 37
 	print ADDMOD $q->param('premium_orderform_url9') . "\n";		# 38

 	print ADDMOD $q->param('usdprice10') . "\n";						# 39
 	print ADDMOD $q->param('premium_expire_days10') . "\n";		# 40
 	print ADDMOD $q->param('premium_orderform_url10') . "\n";	# 41

 	print ADDMOD $q->param('currency') . "\n";						# 42 CURRENCY
 	print ADDMOD $q->param('pitemname') . "\n";						# 43 CURRENCY

close (ADDMOD);


#### CREATE ADD URL FORM

if ($q->param('a_diz') eq "a_description") 		{ $f_diz = qq[Description: <textarea rows="5" name="description" cols="33">!!description!!</textarea><br>\n]; }
if ($q->param('a_keywords') eq "a_keywords") 	{ $f_keywords = qq[Keywords: <input type="text" name="keywords" size="50" value="!!keywords!!"><br>\n]; }
if ($q->param('a_url') eq "a_url") 					{ $f_url = qq[URL: <input type="text" name="url" size="50" value="!!url!!"><br>\n]; }
if ($q->param('a_catsugg') eq "a_csuggestion") 	{ $f_csuggestion = qq[Suggest a Category: <input type="text" name="csuggestion" size="50" value="!!csuggestion!!"><br>\n]; }
if ($q->param('a_contact') eq "a_sname") 			{ $f_sname = qq[Contact Person for This Link: <input type="text" name="sname" size="30" value="!!sname!!"><br>\n]; }
if ($q->param('a_email') eq "a_email") 			{ $f_email = qq[Contact Email Address For This Link: <input type="text" name="email" size="50" value="!!email!!"><br>\n]; }

### CREATE MODIFY FORM

if ($q->param('a_diz') eq "a_description") 		{ $m_diz = qq[Description: <textarea rows="5" name="description" cols="33">%%description%%</textarea><br>\n]; }
if ($q->param('a_keywords') eq "a_keywords") 	{ $m_keywords = qq[Keywords: <input type="text" name="keywords" size="50" value="%%keywords%%"><br>\n]; }
if ($q->param('a_url') eq "a_url") 					{ $m_url = qq[URL: <input type="text" name="url" size="50" value="%%url%%"><br>\n]; }
if ($q->param('a_contact') eq "a_sname") 			{ $m_sname = qq[Contact Person for This Link: <input type="text" name="sname" size="30" value="%%name%%"><br>\n]; }
if ($q->param('a_email') eq "a_email") 			{ $m_email = qq[Contact Email Address For This Link: <input type="text" name="email" size="50" value="%%email%%"><br>\n]; }



foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $kdescription, $na, $imgk, $nmbr) = split (/\t/, $kitem);
	
		$kvname = "a_" . $keyname;
		
		if ($q->param($kvname) eq $keyname)
			{
			
					if ($nmbr eq "Upload")
						{
						$extra_form_fields = $extra_form_fields . qq[$kdescription: <input type="file" name="$keyname" size="20"><BR><BR>];
						
						$upf1 = "%%" . $keyname . "_file_with_link%%";
						$upf2 = "[" . $keyname . "_no_filename_text]No File Available [" . $keyname . "_no_filename_text_end]";
						$upf3 = qq[<br><input type="file" name="$keyname" size="20"><br>];
						$upf4 = "[" . $keyname . "_del_text]Delete File? [" . $keyname . "_del_text_end] %%" . $keyname . "_checkbox%% ";
						$extra_mform_fields = $extra_mform_fields . qq[$kdescription: $upf1 $upf2 $upf3 $upf4<BR><BR>];
						
						$enct = qq[ENCTYPE="multipart/form-data"];
						}
					elsif ($nmbr eq "Content")
						{
						$jscontent = qq[<script language="Javascript" src="$web_url/edt/scripts/innovaeditor.js"></script>];
						
						$txtaid = $keyname . "_txtContent";
						$twidth = $keyname . "_Edit.width";
						$theight = $keyname . "_Edit.height";
						$tmode = $keyname . "_Edit.mode";
						$tcss = $keyname . "_Edit.css";
						$tbstyles = $keyname . "_Edit.btnStyles";
						$treplace = $keyname . "_Edit.REPLACE";
						$teditb = $keyname . "_Edit";
						
						$extra_form_fields = $extra_form_fields . qq[
						<textarea id="$txtaid" name="$keyname" rows=4 cols=30>!!$keyname!!</textarea>
						<script>
						var $teditb = new InnovaEditor("$teditb");
						$twidth="100%";
						$theight="85%";
						$tmode="HTMLBody";
						$tcss="$web_url/ps.css";
						$tbstyles=true;
						$treplace("$txtaid");
						</script><br><br>
						];
						
						$tmodif = "!!" . $keyname . "!!";
						
						$extra_mform_fields = $extra_mform_fields . qq[
						<textarea id="$txtaid" name="$keyname" rows=4 cols=30>!!$keyname!!</textarea>
						<script>
						var $teditb = new InnovaEditor("$teditb");
						$twidth="100%";
						$theight="85%";
						$tmode="HTMLBody";
						$tcss="$web_url/ps.css";
						$tbstyles=true;
						$treplace("$txtaid");
						</script><br><br>
						];
						}
						else
						{
						$mvalue = "!!" . $keyname . "!!";
						$extra_form_fields = $extra_form_fields . $kdescription . ": " . qq[<input type="text" name="$keyname" size="50" value="$mvalue"><br><br>\n];
						$extra_mform_fields = $extra_mform_fields . $kdescription . ": " . qq[<input type="text" name="$keyname" size="50" value="$mvalue"><br><br>\n];
						}

			}
	}




### Expiry Options

if ($q->param('premium_expire_days2') ne "")
	{
		$prem_expiry_options = qq[
		<strong>Please choose an option:</strong> <br>
		];
		
		for ($ms = 1; $ms < 11; $ms++) 
			{
				$pexpiry = "pexpiry" . $ms;
				$usdprice = "";
				
				if ($ms == 1) 
					{
						$chcked = "checked"; 
						$usdprice = $q->param('usdprice');
						$days = $q->param('premium_expire_days');
						$pexpiryid = "pexpiry" . $ms;
					}
					else 
					{
						$chcked = ""; 
						$usdprice = $q->param("usdprice" . $ms);
						$days = $q->param("premium_expire_days" . $ms);
						$pexpiryid = "pexpiry" . $ms;
					}
				
				
					if ($usdprice ne "")
						{
						$prem_expiry_options = $prem_expiry_options . qq[<input type="radio" name="premoption" id="$pexpiryid" value="$ms" $chcked> ($days days) \$$usdprice <br>\n];
						}
			}
		
		$prem_expiry_options = $prem_expiry_options . "<BR>";
	}



### WRITE ADD URL FORM

$add_url_form = qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Submit</title>
$HTML_ENCODING_USE
$jscontent
</head>
<body>
Recommended links to have in this template: <a href="!!my_links!!">Links</a> | <a href="!!account_details!!">Account Details</a> | <a href="!!log_out!!">Log Out</a><BR>
<font color="red">!!error_text!!</font>
<form method="POST" action="!!addurlcgi!!" $enct>
<input type="hidden" name="p" value="!!p!!">
<input type="hidden" name="ia" value="!!ia!!">
<input type="hidden" name="custom" value="$formset_name">
!!prem!!
Category: %%category_dropdown%%<br>
Title: <input type="text" name="title" size="30" value="!!title!!"><BR>
$f_diz $f_keywords $f_url $f_csuggestion $f_sname $f_email 
$extra_form_fields
<br>%%imgbox%%<br>
Type the letters listed above: <br>
<input type="text" name="letters" size="17"><br>
<br><input type="submit" class="psbutton" value="   Submit   " name="B1">
</form>
</body>
</html>
];

##########

$addurl_template_fname = $q->param('add_name') . "_" . "rgs_add_url_med" . ".html";

$add_url_form_nonprem = $add_url_form;
$add_url_form_nonprem =~ s/!!prem!!//gi;

open (TMPL, "> $data_dir/$addurl_template_fname");
	print TMPL $add_url_form_nonprem;
close (TMPL);

##########

$paddurl_template_fname = $q->param('add_name') . "_" . "rgs_add_url_medp" . ".html";

$add_url_form_prem = $add_url_form;
$add_url_form_prem =~ s/!!prem!!/$prem_expiry_options/gi;

open (TMPL, "> $data_dir/$paddurl_template_fname");
	print TMPL $add_url_form_prem;
close (TMPL);


### WRITE MODIFY FORM

$modify_url_form = qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Modify</title>
$HTML_ENCODING_USE
$jscontent
</head>
<body>
Recommended links to have in this template: <a href="!!my_links!!">Links</a> | <a href="!!account_details!!">Account Details</a> | <a href="!!log_out!!">Log Out</a><BR>
<font color="red">!!error_text!!</font>
<form method="POST" action="!!modify_cgi!!" ENCTYPE="multipart/form-data">
<input type="hidden" name="p" value="!!p!!">
 <input type="hidden" name="cid" value="!!cid!!">
 <input type="hidden" name="id" value="!!id!!">
<input type="hidden" name="custom" value="$formset_name">
Title: <input type="text" name="title" size="30" value="%%title%%"><BR>
$m_diz $m_keywords $m_url $m_sname $m_email
Comments/notes regarding the modification of this link. (Optional)
<textarea rows="5" name="notes" cols="29">!!notes!!</textarea><BR><BR>
$extra_mform_fields
<br><input type="submit" class="psbutton" value="   Submit   " name="B1">
</form>
</body>
</html>
];

$modify_url_form =~ s/sname/name/gi;

$modify_template_fname = $q->param('add_name') . "_" . "rgs_modify_link_edit" . ".html";

open (TMPL, "> $data_dir/$modify_template_fname");
print TMPL $modify_url_form;
close (TMPL);

$pmodify_template_fname = $q->param('add_name') . "_" . "rgs_modify_link_editp" . ".html";

open (TMPL, "> $data_dir/$pmodify_template_fname");
print TMPL $modify_url_form;
close (TMPL);

#################

$fcontents = &get_file_contents("$data_dir/rgs_add_url_problem.html");
$ftw = $formset_name . "_" . "rgs_add_url_problem.html";
open (FRMS, "> $data_dir/$ftw");
print FRMS $fcontents;
close (FRMS);

$fcontents = &get_file_contents("$data_dir/rgs_add_url_success.html");
$ftw = $formset_name . "_" . "rgs_add_url_success.html";
open (FRMS, "> $data_dir/$ftw");
print FRMS $fcontents;
close (FRMS);

$fcontents = &get_file_contents("$data_dir/rgs_modify_link_problem.html");
$ftw = $formset_name . "_" . "rgs_modify_link_problem.html";
open (FRMS, "> $data_dir/$ftw");
print FRMS $fcontents;
close (FRMS);

$fcontents = &get_file_contents("$data_dir/rgs_modify_link_success.html");
$ftw = $formset_name . "_" . "rgs_modify_link_success.html";
open (FRMS, "> $data_dir/$ftw");
print FRMS $fcontents;
close (FRMS);
	

### CREATE EMAILS

&write_email("welcome.eml", "welcome");
&write_email("acceptance.eml", "accept");
&write_email("rejection.eml", "reject");
&write_email("informer.eml", "inform");
&write_email("pwelcome.eml", "pwelcome");
&write_email("pacceptance.eml", "paccept");
&write_email("prejection.eml", "preject");
&write_email("pinformer.eml", "pinform");
&write_email("accept_modify.eml", "maccept");
&write_email("reject_modify.eml", "mreject");
&write_email("pinformerupgrade.eml", "pinformupgrade");


### Success Page PayPal Purchase 

$rgs_add_url_success = &get_file_contents("$data_dir/rgs_add_url_success.html");

$sfnm = $q->param('add_name') . "_rgs_regsuccess_paypal.html"; 
open (FRMS, "> $data_dir/$sfnm");
print FRMS $rgs_add_url_success;
close (FRMS);

$sfnm = $q->param('add_name') . "_rgs_upgrade_paypal_success.html"; 
open (FRMS, "> $data_dir/$sfnm");
print FRMS $rgs_add_url_success;
close (FRMS);



#### Write Upgrade standard to premium link template

if ($q->param('premium_expire_days2') eq "")
	{
		$upgrade_options = qq[Place upgrade options here if any. If you only have one upgrade option (expiry option) then this template will not be used.];
	}
	else
	{
		for ($ms = 1; $ms < 11; $ms++) 
			{
				$pexpiry = "pexpiry" . $ms;
				$usdprice = "";
				
				if ($ms == 1) 
					{
						$chcked = "checked"; 
						$usdprice = $q->param('usdprice');
						$days = $q->param('premium_expire_days');
						$pexpiryid = "pexpiry" . $ms;
					}
					else 
					{
						$chcked = ""; 
						$usdprice = $q->param("usdprice" . $ms);
						$days = $q->param("premium_expire_days" . $ms);
						$pexpiryid = "pexpiry" . $ms;
					}
				
					if ($usdprice ne "")
						{
							$prem_upgrade_options = $prem_upgrade_options  . qq[<input type="radio" name="premoption" id="$pexpiryid" value="$ms" $chcked> ($days days) \$$usdprice<br> \n];
						}			
			}
			
			####################
			if ($q->param('usepaypal') eq "Y") { $withpaypal = "with Paypal"; }
	
		$upgrade_options = qq[
			<form id="upgradeform" name="upgradeform" method="post" action="!!upgradescript!!">
			<strong>Please choose an option:</strong> <br><br>
			$prem_upgrade_options <br><input type="submit" name="purchase" id="purchase" value=" Purchase $withpaypal ">
			<input name="lnkid" type="hidden" id="lnkid" value="!!lnkid!!">
			</form>
			];
	}

$upgrade_template = qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>Upgrade</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head>
<body>
<b>Recommended links to have in this template: <a href="!!my_links!!">Links</a> | <a href="!!account_details!!">Account Details</a> | <a href="!!log_out!!">Log Out</a></b>
<BR><br>
$upgrade_options
</body>
</html>
];


$upg_template_name = $q->param('add_name') . "_rgs_upgrade.html";
open (UPGT, "> $data_dir/$upg_template_name");
	print UPGT $upgrade_template;
close (UPGT);



################

$boxd1 = qq[
<b>Important Note:</b> You will need to <b>customize the 'Add URL' and 'Modify' forms</b> according to your needs. 
(They have been created for you according to the options you configured in the previous screen.) 
Remember that you can use <b>'Template Includes'</b> from these templates as they act like standard PowerSeek templates.
You can edit the templates of the Form Set you have just created in the next screen after clicking the 'Continue' link below.
<BR><b><a href="$admin_url/p_addurl.cgi">Click Here to Continue</a></b>
<br><Br>

<p class="normaltext"><strong>If you would like to provide the option where users can upgrade standard listings to premium listings then do the following:</strong></p>
<p class="normaltext">1.  Go to the  Control Panel &gt;&gt; Template Manager &gt;&gt; <a href="admin6.cgi?t=3#3" target="_blank">3. Add URL Templates</a> &gt;&gt; Control Panel Templates &gt;&gt; <a href="$admin_url/admin57.cgi?fct=edit_template&amp;template=rgs_acclinks" target="_blank">Account Link Style</a></p>
<p class="normaltext">2. Place the following somewhere inside the Account Link Style Template:</p>
<blockquote>
  <p class="normaltext">&lt;a href=&quot;!!upgrade_to_premium!!&quot;&gt;Upgrade to Premium Listing&lt;/a&gt;</p>
</blockquote>
];

$hbox = acs::get_heading_box("$web_url/ic_add.gif", "The New Set of 'Add URL'/'Modify' forms has been created", $boxd1);

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Modify</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}





sub write_email
{
my ($readfile, $writefile) = @_;
$readfilecont = &get_file_contents("$data_dir/$readfile");
$write_fname = $q->param('add_name') . "_" . "$writefile" . ".eml";
open (EMW, "> $data_dir/$write_fname");
print EMW $readfilecont;
close (EMW);
}







sub new_set
{

$hbox = acs::get_heading_box("$web_url/ic_add.gif", qq[<a href="$admin_url/p_addurl.cgi">Extra Add URL / Modify Forms</a> >> Add a New Set of 'Add URL'/'Modify forms], qq[Choose options below.]);

$keydata = &get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

$kcount = 0;
foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
	
	$add_name = "a_" . $keyname;
	$exinput = $exinput . qq[<input name="$add_name" type="checkbox" value="$keyname" checked> <font color="#8080C0">$description</font><br>];
	
	$extra_req_fields = $extra_req_fields . qq[<input name="$keyname" type="checkbox" value="$keyname"> <font color="#8080C0">$description</font><br>];
	
	$kcount++;
	}


$jser = acs::get_js_errors;
$pcode = acs::get_popupjs;


$psetdata = &get_file_contents("$data_dir/paypalset.dat");
@ppdata = split (/\n/, $psetdata);
$paypaluser = $ppdata[1];
$paypalpass = $ppdata[2];
$paypalsign = $ppdata[3];



$premurl_nopaypal_help = qq[
Please specify the URL to the order form of your order processor here. <br>
  Users will be redirected to this URL so that they can make payment. <br>
  You will normally be able to obtain this URL from your order processor. <br><br>
  
  Note that you can use variables inside the URL. This is so that the ID,<br>
  or Title, etc. of the premium link submitted can be passed on to your order <br>
  processor.  This is so that you may know for what link payment was received.<br><br> 
  
  <strong>The following variables can be used inside the URL:</strong><br>
  <strong>!!lnkid!!</strong> = Link id of the link.<br>
  <strong>!!cid!!</strong> = Category id of the link.<br>
  <strong>!!title!!</strong> = Title of the link.<br>
  <strong>!!url!!</strong> = URL of the link.<br>
  <strong>!!email!!</strong> = Email address for link.<br>
  <strong>!!name!!</strong> = Contact person for the link.
];
$premurl_nopaypal_help =~ s/\n//gi;



$tophelp = qq[
<strong>If you use PayPal:</strong><br><br>
If you use PayPal then users submitting premium links will be redirected to PayPal<br>
  to make payment for the premium link. Note that the premium link being submitted <br>
  will only become a premium link once payment was successfully processed by <br>
PayPal.<br><br>
In the event where the user does not complete the transaction (chickens out) <br>
the premium link    that was  submitted will just be a standard link instead of a <br>
  premium link. The link can then be upgraded to a premium link from the user <br>
  control panel in future.<br><br>
It is important to note that the premium link that was submitted and successfully<br>
paid for with PayPal still needs to be approved by the Administrator.<br>
This can be done in the <br><em>PowerSeek Control Panel &gt;&gt; To Do &gt;&gt;  Approve/Edit New Submissions </em><br>
  Premium submissions will always be listed first (at the top) in this section.
<br><br>
<strong>If you don\\'t use PayPal:</strong><br><br>
The easiest method of handling payments would be to use PayPal as it is integrated<br>
into PowerSeek. If you are using another order processor then you can disable<br>
the use of PayPal and use the other order processor instead.<br><br>
When using another order processor you can place the URLs to the order <br>
processor order forms in the <em>premium link settings</em> section. When payment<br>
time arrives PowerSeek will then redirect users to the URLs you specified<br>
to the order processor.
];
$tophelp =~ s/\n//gi;




print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

$jser

<script LANGUAGE="JavaScript">

function checkall(formname,thestate)
	{
	BoxNames=new Array($sel_allv)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}

$pcode

function RemoveExpiry(expItem)
	{
		var agree=confirm("Are you sure you want to remove this option?");
		if (agree)
			{
			var pitem = 'exp' + expItem;
			document.getElementById(pitem).innerHTML = '';			
			document.getElementById('addbutton').style.display = 'block';
			}
			else
			{
			return false;
			}
		
		 var cwin; var lastb = 1;
				 for (i=1; i<=10; i++)
				 {
				  cwin = 'closewin' + i;
				  if (document.getElementById(cwin))
				  	 {
				  		lastb = i;
				  	 }
			 	 }
			if (lastb > 1) { document.getElementById('closewin' + lastb).style.display = 'block'; }
		
	}


function clickpaypal()
	{
	if (document.getElementById('usepaypal').checked == true)
		{
			document.getElementById('pp1').style.display = 'block';
			document.getElementById('pp2').style.display = 'block';
			document.getElementById('pp3').style.display = 'block';
			document.getElementById('pp4').style.display = 'block';
			document.getElementById('pp5').style.display = 'block';
			document.getElementById('pp6').style.display = 'block';
			
			document.getElementById('premurl1').style.display = 'none';
			
				 var foundnr = 0; var boxtocreate = 0;
					 for (i=1; i<=10; i++)
					 {
						var premdisp = 'premspan' + i;
						var standisp = 'stanspan' + i;
						
						if (document.getElementById(premdisp)) { 	document.getElementById(premdisp).style.display = 'none'; }
						if (document.getElementById(standisp)) {  document.getElementById(standisp).style.display = 'none'; }
					 }

		}
		else
		{
			document.getElementById('pp1').style.display = 'none';
			document.getElementById('pp2').style.display = 'none';
			document.getElementById('pp3').style.display = 'none';
			document.getElementById('pp4').style.display = 'none';
			document.getElementById('pp5').style.display = 'none';
			document.getElementById('pp6').style.display = 'none';

			document.getElementById('premurl1').style.display = 'block';
			
				 var foundnr = 0; var boxtocreate = 0;
					 for (i=1; i<=10; i++)
					 {
						var premdisp = 'premspan' + i;
						var standisp = 'stanspan' + i;
						
						if (document.getElementById(premdisp)) { 	document.getElementById(premdisp).style.display = 'block'; }
						if (document.getElementById(standisp)) {  document.getElementById(standisp).style.display = 'block'; }
					 }
			
		}
	}

function xmlhttpPost(strURL, action_img)
	 {
	 	
	 	 var foundnr = 0; var boxtocreate = 0;
		 for (i=2; i<=10; i++)
		 {
		 	var usdnm = 'usdprice' + i;
			if (document.getElementById(usdnm) == null) 
				{
					if (foundnr == 0)
						{
							boxtocreate = i;
							foundnr++;
						}
				}
			
			var cwin = 'closewin' + i;
			if (document.getElementById(cwin))
				{
				document.getElementById(cwin).style.display = 'none';
				}
		 }
	 	foundnr = 0;
	 	display_area = 'exp' + boxtocreate;
	 	
	 	if (boxtocreate == 10)
	 		{
	 		document.getElementById('addbutton').style.display = 'none';
	 		}
	 	
	 	strURL = strURL + '&create=' + boxtocreate;
	 	
	 	if (document.getElementById('usepaypal').checked == true)
	 		{
	 		strURL = strURL + '&create=' + boxtocreate + '&paypal=true';
	 		}

	 document.getElementById(action_img).style.display='block';
 
    var xmlHttpReq = false;
    var self = this;
 		
    // Mozilla/Safari
    if (window.XMLHttpRequest) { self.xmlHttpReq = new XMLHttpRequest(); }
 
    // IE
    else if (window.ActiveXObject) { self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP"); }
 
    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	 self.xmlHttpReq.onreadystatechange = function()
    	   {
         if (self.xmlHttpReq.readyState == 4)
         		{
         		document.getElementById(display_area).innerHTML  = self.xmlHttpReq.responseText;
         		document.getElementById(action_img).style.display='none';
         		}
    		}
 
    // Mozilla/Safari
    if (window.XMLHttpRequest) {self.xmlHttpReq.send(strURL);}
 
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq.send();}
   }

function check_errors()
	{
		if (document.getElementById('add_name').value == '') { alert ('Please provide a name for this \\'Add URL\\'/\\'Modify\\' Form Set.'); return false; }
		
		if (document.getElementById('usepaypal').checked == true)
			{
				if (document.getElementById('paypaluser').value == '') { alert ('You have to provide a PayPal API user name.'); return false; }
				if (document.getElementById('paypalpass').value == '') { alert ('You have to provide a PayPal API password.');  return false; }
				if (document.getElementById('paypalsign').value == '') { alert ('You have to provide a PayPal API signature.'); return false; }
				if (document.getElementById('usdprice').value == '') { alert ('You have to provide a price in USD for the first expiry option.'); return false; }
				if (document.getElementById('premium_expire_days').value == '') { alert ('You have to provide the number of days which the premium link will be valid for the first expiry option.'); return false; }
				
				var usdprice; 
				var premium_expire_days; 
				
				 for (i=2; i<11; i++)
				 {
				 	usdprice = 'usdprice' + i;
				 	premium_expire_days = 'premium_expire_days' + i;
				 
						if (document.getElementById(usdprice)) 
							{
							if (document.getElementById(usdprice).value == '') { alert ('You have to provide a price for option box ' + i); return false; }
							}

						if (document.getElementById(premium_expire_days)) 
							{
							if (document.getElementById(premium_expire_days).value == '') { alert ('You have to provide the number of days the premium URL will be valid for option box ' + i); return false; }
							}
				 }
				
			}
			else
			{
				if (document.getElementById('premium_expire_days').value == '') { alert ('You have to provide the number of days which the premium link will be valid for the first expiry option.'); return false; }
				if (document.getElementById('premium_orderform_url').value == '') { alert ('You have to provide a URL to the order form of your order processor.'); return false; }

					var usdprice; 
					var premium_expire_days; 
					var premium_orderform_url;

					 for (i=2; i<11; i++)
					 {
						usdprice = 'usdprice' + i;
						premium_expire_days = 'premium_expire_days' + i;
						premium_orderform_url = 'premium_orderform_url' + i;

							if (document.getElementById(usdprice)) 
								{
								if (document.getElementById(usdprice).value == '') { alert ('You have to provide a price for option box ' + i); return false; }
								}

							if (document.getElementById(premium_expire_days)) 
								{
								if (document.getElementById(premium_expire_days).value == '') { alert ('You have to provide the number of days the premium URL will be valid for option box ' + i); return false; }
								}

							if (document.getElementById(premium_orderform_url)) 
								{
								if (document.getElementById(premium_orderform_url).value == '') { alert ('You have to provide a URL to your order processor for option box ' + i); return false; }
								}
					 }
				
			}
	}		


 
</script>

<script SRC="$web_url/qtip.js"></script>

<style type="text/css">


div#qTip {
 padding: 10px;
 border: 1px solid #DBDBDB;
 display: none;
 background: url("$web_url/tooltback.gif");
 color: #000;
 font: 11px Arial, sans-serif;
 text-align: left;
 position: absolute;
 z-index: 1000;
}


#closewin { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin:hover { background-position: 0 -16px; } 
#closewin span {display: none; } 

#closewin1 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin1:hover { background-position: 0 -16px; } 
#closewin1 span {display: none; } 

#closewin2 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin2:hover { background-position: 0 -16px; } 
#closewin2 span {display: none; } 

#closewin3 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin3:hover { background-position: 0 -16px; } 
#closewin3 span {display: none; } 

#closewin4 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin4:hover { background-position: 0 -16px; } 
#closewin4 span {display: none; } 

#closewin5 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin5:hover { background-position: 0 -16px; } 
#closewin5 span {display: none; } 

#closewin6 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin6:hover { background-position: 0 -16px; } 
#closewin6 span {display: none; } 

#closewin7 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin7:hover { background-position: 0 -16px; } 
#closewin7 span {display: none; } 

#closewin8 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin8:hover { background-position: 0 -16px; } 
#closewin8 span {display: none; } 

#closewin9 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin9:hover { background-position: 0 -16px; } 
#closewin9 span {display: none; } 

#closewin10 { display: block; width: 16px; height: 16px; background: url("$web_url/closewin2.png") no-repeat 0 0; } 
#closewin10:hover { background-position: 0 -16px; } 
#closewin10 span {display: none; } 

</style> 

</head>
<body>
$hbox



<form method="POST" action="$admin_url/p_addurl.cgi" name="addu" style="margin-bottom:0; margin-top:0;" onSubmit="return check_errors();">
  <table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr></tr>
  <tr>
    <td width="1%" valign="top" class="saveback"><img src="$web_url/saveback3.png" width="15" height="34" /></td>
    <td width="99%" valign="top"><table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DFDFDF">
      <tr>
        <td colspan="2" valign="top" background="$web_url/bar7.gif" class="normaltext"><strong>Create Extra 'Add URL'/'Modify' forms:</strong><strong></strong></td>
        </tr>
      <tr>
        <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Choose a Name for this 'Add URL'/'Modify' Form Set: <br>
          </strong></td>
        <td width="61%"  valign="top" bgcolor="#FFFFFF" class="normaltext"><label>
          <input name="add_name" type="text" id="add_name" size="30">
          (Only use characters in the English Alphabet or Numerical's) </label></td>
        </tr>
      <tr>
        <td valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Description for this  'Add URL'/'Modify' Form Set: </strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('This description is only for your own informational purposes.');" onMouseOut="tooltip.hide();"></td>
        <td  valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="add_diz" id="add_diz" style="width:100%"></td>
        </tr>
      <tr>
        <td width="39%"  valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Fields to include in 'Add URL' and 'Modify' forms:</strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('The following fields are normally available from the \\'Add URL\\' and \\'Modify\\' forms. <br>Select the fields you would like included inside the Add URL and Modify forms.');" onMouseOut="tooltip.hide();"></td>
        <td  valign="top" bgcolor="#FFFFFF" class="normaltext"><input name="a_title" type="checkbox"  checked disabled>
          Title<br>
          <input name="a_diz" type="checkbox" value="a_description" checked>
          Description<br>
          <input name="a_keywords" type="checkbox" value="a_keywords" checked>
          Keywords <br>
          <input name="a_url" type="checkbox" value="a_url" checked>
          URL <br>
          <input name="a_catsugg" type="checkbox" value="a_csuggestion" checked>
          New Category Suggestion<br>
          <input name="a_contact" type="checkbox" value="a_sname" checked>
          Contact Person for Listing<br>
          <input name="a_email" type="checkbox"  value="a_email" checked>
          Contact Email for Listing $extra_add_fields<br>
          $exinput </td>
        </tr>
      <tr>
        <td  valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>What fields would require values with submissions? </strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('If you tick fields here then users will be required to provide a value when doing a <br>new submission or when modifying a listing.');" onMouseOut="tooltip.hide();"></td>
        <td valign="top" bgcolor="#FFFFFF" class="normaltext"><input name="r_title" type="checkbox" checked disabled>
          Title<br>
          <input name="r_diz" type="checkbox" value="description">
          Description<br>
          <input name="r_keywords" type="checkbox" value="keywords">
          Keywords <br>
          <input name="r_url" type="checkbox" value="url">
          URL <br>
          <input name="r_contact" type="checkbox" value="sname">
          Contact Person for Listing<br>
          <input name="r_email" type="checkbox" value="email">
          Contact Email for Listing <br>
          $extra_req_fields</td>
        </tr>
      <tr>
        <td  valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Category Limiting:</strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('To let users only submit to specific categories and it\\'s <br>sub categories, supply category IDs here seperated by comma\\'s. Leave blank <br>for all categories to be listed in the \\'Add URL\\' form. Use the \\'Category Browser\\' function to find categories.');" onMouseOut="tooltip.hide();"></td>
        <td valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="related_categories" style="width:100%">
          <br>
          (<a href="$admin_url/admin67.cgi?fct=related" onClick="popup('$admin_url/admin67.cgi?fct=related',750,600, 600, 100);return false;">Category Browser</a>) <br>
          <input name="incl_subs" type="checkbox" id="incl_subs" value="Y" checked>
          Include Sub-categories of categories specified above?<BR>
          <BR></td>
        </tr>
      <tr>
        <td  valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Check for duplicates? </strong><img src="$web_url/est_help.gif" style="vertical-align:middle" 
      onMouseOver=" tooltip.show('If a duplicate URL is found in the database then the user won\\'t be able to submit the listing. <br>This setting will be ignored if you don\\'t require the user to enter a URL.');" onMouseOut="tooltip.hide();"></td>
        <td  valign="top" bgcolor="#FFFFFF" class="normaltext"><input name="duplic" type="checkbox" value="Y" id="duplic">
          Do URL Duplicate Checking</td>
        </tr>
      <tr>
        <td  valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Would you like to use PayPal for premium link submissions?</strong></td>
        <td  valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox" name="usepaypal" id="usepaypal" onclick="clickpaypal();" value="Y" checked/>
        <img src="$web_url/est_help.gif" style="vertical-align:top" onmouseover=" tooltip.show('$tophelp');" onmouseout="tooltip.hide();">
        </td>
        </tr>
      <tr id="pp1" >
        <td valign="top" bgcolor="#FFFFFF" class="normaltext">PayPal API UserName:</td>
        <td valign="top" bgcolor="#FFFFFF"><input type="text" name="paypaluser" size="50" value="$paypaluser" id="paypaluser" />
          <img src="$web_url/est_help.gif" stapyle="vertical-align:middle" 
      onmouseover=" tooltip.show('To get a PayPal API Username, API Password and signature do the following:&lt;br&gt;&lt;br&gt;1.Log in to your PayPal Premier or Business account. (You have to have a Business or Premier Account)&lt;br&gt;2.Click the Profile subtab located in the top navigation area.&lt;br&gt;3.Click on \\'My selling tools\\'&lt;br&gt;4.Click \\'Update\\' next to \\'API Access\\'.&lt;br&gt;');" onmouseout="tooltip.hide();" /></td>
        </tr>
      <tr class="tdtable" id="pp2" >
        <td valign="top" bgcolor="#FFFFFF" class="normaltext" >PayPal API Password:</td>
        <td valign="top" bgcolor="#FFFFFF" class="normaltext" ><input type="text" name="paypalpass" size="50" id="paypalpass" value="$paypalpass" />
          <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('To get a PayPal API Username, API Password and signature do the following:&lt;br&gt;&lt;br&gt;1.Log in to your PayPal Premier or Business account. (You have to have a Business or Premier Account)&lt;br&gt;2.Click the Profile subtab located in the top navigation area.&lt;br&gt;3.Click on \\'My selling tools\\'&lt;br&gt;4.Click \\'Update\\' next to \\'API Access\\'.&lt;br&gt;');" onmouseout="tooltip.hide();" /></td>
        </tr>
      <tr class="tdtable" id="pp3" >
        <td valign="top" bgcolor="#FFFFFF" class="normaltext">Sinature:</td>
        <td valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="paypalsign" size="50" id="paypalsign" value="$paypalsign" />
          <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('To get a PayPal API Username, API Password and signature do the following:&lt;br&gt;&lt;br&gt;1.Log in to your PayPal Premier or Business account. (You have to have a Business or Premier Account)&lt;br&gt;2.Click the Profile subtab located in the top navigation area.&lt;br&gt;3.Click on \\'My selling tools\\'&lt;br&gt;4.Click \\'Update\\' next to \\'API Access\\'.&lt;br&gt;');" onmouseout="tooltip.hide();" /></td>
        </tr>
      <tr class="tdtable" id="pp5">
        <td valign="top" bgcolor="#FFFFFF" class="normaltext">Currency:</td>
        <td valign="top" bgcolor="#FFFFFF" class="normaltext">
        
              <select name="currency" id="currency">
				  <option value="USD" $curs[0]>U.S. Dollar</option>
				  <option value="GBP" $curs[1]>Pound Sterling</option>
				  <option value="EUR" $curs[2]>Euro</option>
				  <option value="AUD" $curs[3]>Australian Dollar </option>
				  <option value="CAD" $curs[4]>Canadian Dollar </option>
				  <option value="CZK" $curs[5]>Czech Koruna </option>
				  <option value="DKK" $curs[6]>Danish Krone  </option>
				  <option value="HKD" $curs[7]>Hong Kong Dollar</option>
				  <option value="HUF" $curs[8]>Hungarian Forint</option>        
				  <option value="ILS" $curs[9]>Israeli New Sheqel</option>
				  <option value="JPY" $curs[10]>Japanese Yen</option>
				  <option value="MXN" $curs[11]>Mexican Peso</option>
				  <option value="NOK" $curs[12]>Norwegian Krone</option>
				  <option value="NZD" $curs[13]>New Zealand Dollar</option>
				  <option value="PHP" $curs[14]>Philippine Peso</option>
				  <option value="PLN" $curs[15]>Polish Zloty</option>
				  <option value="SGD" $curs[16]>Singapore Dollar</option>                
				  <option value="SEK" $curs[17]>Swedish Krona</option>                
				  <option value="CHF" $curs[18]>Swiss Franc</option>                
				  <option value="TWD" $curs[19]>Taiwan New Dollar</option>                
				  <option value="THB" $curs[20]>Thai Baht</option>
		        </select>
        
        </td>
      </tr>
      <tr class="tdtable" id="pp4" >
       <td valign="top" bgcolor="#FFFFFF" class="normaltext">PayPal Mode:</td>
        <td valign="top" bgcolor="#FFFFFF" class="normaltext"><select name="pmode" id="pmode">
          <option value="live" selected>PayPal Live Production Mode</option>
          <option value="sandbox" >Use PayPal Sandbox</option>
          </select>
          <img src="$web_url/est_help.gif" style="vertical-align:middle" 
        onmouseover=" tooltip.show('<b>Live Production Mode:</b> Payments will be handled by PayPal and is the system is \\'live\\' <br><br> <b>Use PayPal Sandbox:</b> PayPal Test mode using the PayPal sandbox. PayPal is not \\'live\\' and payments will not be processed. This mode is only for testing purposes. ');" onmouseout="tooltip.hide();" /></td>
        </tr>

      <tr class="tdtable" id="pp6">
       <td valign="top" bgcolor="#FFFFFF" class="normaltext">Purchase Item Name:</td>
        <td valign="top" bgcolor="#FFFFFF" class="normaltext">

		   <input name="pitemname" type="text" id="pitemname" size="50" value="Premium Listing">
        <img src="$web_url/est_help.gif" style="vertical-align:middle" 
        onmouseover=" tooltip.show('This name will be displayed with the price when making the purchase at Paypal');" onmouseout="tooltip.hide();" />        

        </td>
        </tr>

      <tr>
        <td  colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium Link Order Form Options:</strong><br>
          <br>
          <table width="80%" border="0" align="center" cellpadding="3" cellspacing="0" class="aborder">
            <tr>
              <td width="49%">Price in USD:</td>
              <td width="50%"><input name="usdprice" type="text" id="usdprice" size="10" value="$usdprice"/></td>
              <td width="1%" align="right"><img src="$web_url/blank.gif" width="16" height="1"></td>
              </tr>
            <tr>
              <td>For how many days is a premium URL/Listing valid? </td>
              <td colspan="2"><input type="text" name="premium_expire_days" id="premium_expire_days" size="6" value="$premium_expire_days" />
                <strong>Days </strong> <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('When the link is older than this number of days, it will not be available as a premium listing anymore and only show as an ordinary link/listing.');" onmouseout="tooltip.hide();" /></td>
              </tr>
            <tr id="premurl1" style="display:none">
              <td>Premium Link Order Form URL:
              <img id="esthelp" src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('$premurl_nopaypal_help');" onmouseout="tooltip.hide();" />
              </td>
              <td colspan="2"><input type="text" name="premium_orderform_url" size="50" value="$premium_orderform_url" id="premium_orderform_url"/></td>
              </tr>
            </table>
          <span id="exp1">$expoptions{'exp1'}</span> <span id="exp2">$expoptions{'exp2'}</span> <span id="exp3">$expoptions{'exp3'}</span> <span id="exp4">$expoptions{'exp4'}</span> <span id="exp5">$expoptions{'exp5'}</span> <span id="exp6">$expoptions{'exp6'}</span> <span id="exp7">$expoptions{'exp7'}</span> <span id="exp8">$expoptions{'exp8'}</span> <span id="exp9">$expoptions{'exp9'}</span> <span id="exp10">$expoptions{'exp10'}</span>
          <table width="80%" border="0" align="center" cellpadding="0" cellspacing="0">
            <tr>
              <td align="right"><br />
                <span id="addbutton" $bdisplay>
                  <table width="80%" border="0" cellspacing="0" cellpadding="0">
                    <tr>
                      <td width="98%" align="right"><img src="$web_url/ajload3.gif" style="display:none" id="loader" /></td>
                      <td width="1%"><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover="tooltip.show('You can add additional expiry options here. If you would like to have options where links expire within 30 days, 60 days or 120 days then you would add two additional options for 60 and 120 days for example. The first option would be 30 days.&lt;br&gt;&lt;Br&gt;For Example: You could provide the options where it\\'s \$5 for 30 days, \$7 for 60 days and \$15 for 120 days.&lt;br&gt;&lt;Br&gt;Note that you can add up to 9 additional options.');" onmouseout="tooltip.hide();" /></td>
                      <td width="1%"><input type="submit" name="adddays" id="adddays" value="Add additional expiry options" class="psbutton" onclick="xmlhttpPost('$admin_url/admin23.cgi?fct=addexpiry&amp;d=' + parseInt(Math.random()*10000) + '&amp;', 'loader'); return false;" /></td>
                      </tr>
                    </table>
                  </span></td>
              </tr>
            </table></td>
        </tr>
    </table>
      <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
        <tr>
          <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
          <td width="147%"></td>
        </tr>
      </table></td>
  </tr>
  <tr>
    <td valign="top"><img src="$web_url/saveback2.png" width="15" height="34" /></td>
    <td height="42"><span class="normaltext">
      <input type="submit" class="psbutton" name="button" id="button" value="   Create Form Set   ">
      <input type="hidden" name="fct" value="add_include">
    </span></td>
  </tr>
  </table>
  <p>&nbsp;</p>
  </center>
</form>
<p><BR>
  <BR><BR><BR><BR><BR><BR><BR>
</p>


</body>
</html>
];

}







sub start
{

### CHECK IF exaddurl TABLE exists

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$create_tbl = "true";

$wsql = "SHOW TABLES";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}

while ( @row = $sth->fetchrow() ) { if ($row[0] eq "exaddurl") { $create_tbl = "false"; }	}

	if ($create_tbl ne "false")
	{
			$sql = "CREATE TABLE exaddurl
							(
							id				int NOT NULL auto_increment,
							lnkid			int,
							formname		varchar(255),
							tmpwork		int,
							PRIMARY KEY(id),
							INDEX (lnkid), 
							INDEX (formname),
							INDEX (tmpwork)
							)";

			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
	
	open (DTA, "> $data_dir/customforms.dat");
	print DTA "true";
	close (DTA);
	} 


$gsettings = new_gsettings acs;

if ($gsettings->{addurl_reg_system} ne "Yes")
	{
	$dizbox = qq[
	At present the use of this plugin is not possible because the User Registration System is not turned on. The user registration system needs to be turned on to use this Plugin.
	<ul>
	<li>You can find documentation on the use of the User Registration System <a href="$admin_url/help.cgi?fct=userreg" target="_blank">Here</a>.</li>
	<li>You can turn on the User Registration System by <a href="$admin_url/admin10.cgi?fct=global_settings#5" onClick="popup('$admin_url/admin10.cgi?fct=global_settings#5',800,600);return false;">clicking here.</a></li>
	</ul>
	];
	
	$hbox = acs::get_heading_box("$web_url/ic_add.gif", "Extra Add URL / Modify Forms", $dizbox);

	print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
	<title>Modify</title>
	$HTML_ENCODING_USE
	<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
	
	<script LANGUAGE="JavaScript">
	<!-- Hide
	var popupwin = null;
	  function popup(loc,ww,hh)
		{
		 var mywidth = (ww + 0);
		 var myheight = (hh + 0);
		 var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
			if (popupwin == null || popupwin.closed)
				{
					popupwin = window.open (loc, 'popupwin2', myspecs);
				  }
			 else
				{
					popupwin.focus();
					popupwin.location.href = loc;
				 }
		 }

	</script>
	</head>
	<body>
	$hbox
	</body>
	</html>
	];
	exit;
	}
##############


opendir(DIR,"$data_dir");
@files = readdir(DIR);

foreach $filename (@files)
	{
	
	if ((substr($filename, 0, 7) eq "addmod_") and (substr($filename, length($filename) - 4, 4) eq ".dat"))
		{
		$setdata = &get_file_contents("$data_dir/$filename");
		my @sdata = split (/\n/, $setdata);
		
		#print "$data_dir/$filename<BR>";
		
		$resc++;
		$resulta = "result" . $resc;
		$iloader_nm = "imload" . $resc;
		
$setlins = $setlins . qq[<tr>
<td valign="top" class="normaltext" bgcolor="#FFFFFF"><a href="" title="$sdata[1]" STYLE="text-decoration:none"><b>$sdata[0]</b></a></td>
<td valign="top" bgcolor="#FFFFFF">
	<table width="100%" border="0" class="normaltext"><tr><td width="99%">
	<a href="$admin_url/p_addurl.cgi?fct=edit&tname=$sdata[0]" onClick="xmlhttpPost('$admin_url/p_addurl.cgi?fct=edit&tname=$sdata[0]&' + parseInt(Math.random()*10000), '$resulta', $resc, '$iloader_nm');return false;"
	title="Edit templates used for this <b>Add URL/Modify Template Set</b>">Edit Templates</a></td>
	<td width="1%"><img src="$web_url/ajload3.gif" width="16" height="16" id="$iloader_nm" style="display: none;"></td></tr></table>
	<span id="$resulta"></span></td>
<td valign="top" align="center" class="normaltext" bgcolor="#FFFFFF">
<a href="$admin_url/p_addurl.cgi?fct=getlink&tname=$sdata[0]" onClick="popup('$admin_url/p_addurl.cgi?fct=getlink&tname=$sdata[0]',600,400);return false;" title="This is the link that you can use to link from any PowerSeek templates to the 'Add URL' form of this 'Add URL'/'Modify' form set." class="bordtext">Links</a> 
<a href="$admin_url/p_addurl.cgi?fct=edit_settings&tname=$sdata[0]" title="Edit fields that are required when new users are doing submissions/modifications" class="bordtext">Settings</a>  
<a href="$admin_url/p_addurl.cgi?fct=edit_email&tname=$sdata[0]" title="Customize auto-email-responses sent when listings are added or modified." class="bordtext">Email</a>  
<a href="$admin_url/admin68.cgi?id=72&f=$sdata[0]" target="_blank" title="View the 'Add URL' form of this form set" class="bordtext">Preview</a>  
<a href="javascript:confirmDelete('$admin_url/p_addurl.cgi?fct=delete&tname=$sdata[0]')" title="Delete this form set" class="bordtext">Delete</a></td>
</tr>
];


		}
	}
closedir(DIR); 


$hbox = acs::get_heading_box("$web_url/ic_add.gif", "Extra Add URL / Modify Forms", qq[This plugin let's you create extra 'Add URL' and 'Modify' forms for the submission of special links or listings. If you have for example a Directory of links and an Article section and you also want people to submit Articles then you would for example use an extra 'Add URL' especially available for the submission of Articles.]);
 
$qhelp = acs::quick_help("Instructions", qq[<a href="$admin_url/p_addurl.cgi?fct=help">Click Here</a> for instructions on implementing additional 'Add URL'/'Modify' forms.]);


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 


<SCRIPT LANGUAGE="JavaScript">

var dropdownstat = ['0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0','0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0','0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0','0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0','0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0','0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0'] ;

function xmlhttpPost(strURL, display_area, ddown, iloader) 
	 {

	 document.getElementById(iloader).style.display='inline';
	 
    var xmlHttpReq = false;
    var self = this;
  
  	 if (dropdownstat[ddown] == 1)
  	 	{
  	 	strURL = '$admin_url/admin77.cgi?fct=blank'; dropdownstat[ddown] = 0;
  	 	}
  	 else if  (dropdownstat[ddown] == 0)
  	 	{
  	 	dropdownstat[ddown] = 1; 
  	 	}
  
    // Mozilla/Safari
    if (window.XMLHttpRequest) { self.xmlHttpReq = new XMLHttpRequest();  }
    
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");}
	
    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	 self.xmlHttpReq.onreadystatechange = function() 
    	   {
         if (self.xmlHttpReq.readyState == 4) 
         		{
         		document.getElementById(display_area).innerHTML  = self.xmlHttpReq.responseText; 
         		document.getElementById(iloader).style.display='none';
         		}
    		}

    // Mozilla/Safari
    if (window.XMLHttpRequest) {self.xmlHttpReq.send(strURL);}
    
    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq.send();}
 
}

 	function confirmDelete(delUrl) 
 		{
 		  if (confirm("Are you sure you want to Delete this Form Set?")) 
 		  	{
 		  	document.location = delUrl; 
 		  	}

 		  	
		}

</script>

<script LANGUAGE="JavaScript">
<!-- Hide
var popupwin = null;
  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
      if (popupwin == null || popupwin.closed)
			{
            popupwin = window.open (loc, 'popupwin2', myspecs);
           }
		 else
		   {
            popupwin.focus();
            popupwin.location.href = loc;
          }
    }

function checkall(formname,thestate)
	{
	BoxNames=new Array($sel_allv)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}

 // End Hide -->
 </script>

<style type="text/css">
<!--
div#qTip {
 padding: 10px;
 border: 1px solid #DBDBDB;
 display: none;
 background: url("$web_url/tooltback.gif");
 color: #000;
 font: 11px Arial, sans-serif;
 text-align: left;
 position: absolute;
 z-index: 1000;
}
-->
</style>
<script SRC="$web_url/qtip.js"></script>

</head>
<body>
$hbox

<table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#E5E5E5">
  <tr>
    <td colspan="3" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>'Add URL'/'Modify' Form Sets:</strong><strong></strong></td>
  </tr>
  <tr>
    <td width="10%" valign="top" bgcolor="#F5F5F5" class="normaltext"><label><strong>Name:</strong></label></td>
    <td width="55%" valign="top" bgcolor="#F5F5F5" class="normaltext"><strong>Edit Templates:</strong></td>
    <td width="35%" valign="top" bgcolor="#F5F5F5" class="normaltext" align="center"><strong>Other Functions:</strong></td>
  </tr>
$setlins
</table>

  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="147%"></td>
    </tr>
  </table>

<form id="form1" name="form1" method="post" action="$admin_url/p_addurl.cgi" style="margin-bottom:0; margin-top:0;">
  <input type="submit" class="psbutton" name="button" id="button" value="Add a New Set of Add URL and Modify Forms" />
  <input name="fct" type="hidden" id="fct" value="add" />
</form>
<BR>
$qhelp
</body>
</html>
];

}



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

