#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Listing Expiration for Classifieds
# DIZ: This plugin enables you to expire/remove listings automatically when they have reached a certain age. Note that this plugin only supports a static (HTML generated) Directory.
# GRAPHIC: ic_classi.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
#use psfp;
&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
# not below if's - else bypassed...
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "save_settings") {&save_settings;}


sub save_settings
{

if (($q->param('days') < 1) and ($q->param('enable') eq "Y"))
	{
	acs::problem_popup("You have to specify an amount of days."); 
	}

	

open (SFILE, "> $data_dir/p_classi.dat");
	print SFILE $q->param('enable') 	. "\n";
	print SFILE $q->param('days') 		. "\n";
	print SFILE $q->param('del_prem') 	. "\n";
	print SFILE $q->param('del_stand')	. "\n";
close (SFILE);

$hbox = acs::get_heading_box("$web_url/ic_classi.gif", "Settings Saved", qq[<a href="$admin_url/p_classi.cgi">Click Here to continue.</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Comment/Review Editor</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox 
</body>
</html>
];

}


sub start
{

$hbox = acs::get_heading_box("$web_url/ic_classi.gif", "Listing Expiration for Classifieds", qq[This plugin enables you to expire/remove listings automatically when they have reached a certain age. Note that this plugin only supports a static (HTML generated) Directory.]);
 
 $boxdh = qq[
	<ul>
	  <li>Also see: <a href="$admin_url/p_expire.cgi" onClick="popup('$admin_url/p_expire.cgi',950, 700);return false;">The Link Expiry Plugin</a></li>
	  <li>Use <a href="$admin_url/p_expire.cgi" onClick="popup('$admin_url/admin45.cgi',950, 700);return false;">'New Link Includes'</a> to list the latest links in any PowerSeek template or web page.</li>
	</ul> 
 ];
 
$qhelp = acs::quick_help("Tips", $boxdh);


$classdata = acs::get_file_contents("$data_dir/p_classi.dat");
@classi_items = split (/\n/, $classdata);
 
if ($classi_items[0] eq "Y") { $checkval = "checked"; }
$days = $classi_items[1];
if ($days < 1) { $days = 30; }

if ($classi_items[2] eq "Y") { $del_prem =  "checked"; }
if ($classi_items[3] eq "Y") { $del_stand = "checked"; }

$jspopup_code = acs::get_popupjs;
 
print qq[

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Comment/Review Editor</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
<!-- Hide

$jspopup_code 

// End Hide -->
</script>
</head>
<body>
$hbox 

<form method="POST" action="$admin_url/p_classi.cgi">
  <input type="hidden" name="fct" value="save_settings">
   <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DADADA">
    <tr>
      <td colspan="2" background="$web_url/bar7.gif" bgcolor="#F4F4F4" class="normaltext"><strong>Expiration Configuration </strong></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext">Enable this plugin: </td>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="enable" type="checkbox" id="enable"
      value="Y" $checkval> 
      (Caution: Listings will be removed if they are older than the amount of days specified below when you generate HTML files)</td>
    </tr>
    <tr>
      <td width="250" bgcolor="#FFFFFF" class="normaltext">Remove listings if they are older than: </td>
      <td width="954" bgcolor="#FFFFFF" class="normaltext"><label>
        <input name="days" type="text" id="days" size="5" value="$days">
      Days</label></td>
    </tr>
    <tr>
      <td colspan="2" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox" name="del_prem"
      value="Y" $del_prem> Delete Premium listings. (If not checked then older premium
      listings won't be deleted) </td>
    </tr>
    <tr>
      <td colspan="2" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox" name="del_stand"
      value="Y" $del_stand> Delete Standard listings. </td>
    </tr>
    <tr>
      <td colspan="2" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton" value="Apply"
      name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>

      <td width="99%"></td>
    </tr>
  </table>
</form>

$qhelp	

</body>
</html>
];

}



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

