#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Raw SQL Query Tool
# DIZ: Enables you to do raw SQL queries on your database.
# GRAPHIC: ic_sql.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;


&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "configure") { &configure; }
if ($q->param('fct') eq "savesettings") { &savesettings; }
if ($q->param('fct') eq "instructions") { &instructions; }

####################################################################################

sub instructions
{

$fbcsettings = &get_file_contents("$data_dir/fbcomments.dat");  
@fbset = split (/\n/, $fbcsettings);


if ($fbset[0] eq "") 
	{

		$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Comments Plugin", "The PowerSeek Facebook Comments Plugin needs to be configured. <a href='p_fbcomments.cgi?fct=configure'>Click Here to configure</a>");

		print qq[
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<title>Facebook Plugin</title>
		$HTML_ENCODING_USE
		<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
		</head>
		<body>
		$hbox
		</body>
		</html>
		];
		exit;
	}
	
	

$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Login Plugin :: Implement Facebook Login", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Facebook Plugin</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox

<blockquote>
  <p><span class="normaltext"><strong>To enable the use of Facebook comments on 'more info' pages, do the following steps:</strong></span></p>
  <p><strong>Step 1:</strong></p>
  <blockquote>
    <p>Go to the PowerSeek Control Panel &gt;&gt; Template Manager &gt;&gt; 1. Default Category/Directory Templates &gt;&gt; Click on <strong>Link Info</strong> and/or<strong> Link Info Premium</strong></p>
  </blockquote>
  <p><strong>Step 2:</strong></p>
  <blockquote>
    <p>Inside the 'more info' template (also called 'link info') place the following where you would like to display the Facebook Comments functionality:</p>
    <blockquote>
      <p><strong>!!facebook_comments!!</strong></p>
    </blockquote>
  </blockquote>
  <p><strong>Additional Notes: </strong></p>
  <ul class="normaltext">
    <li>It will be a good idea to place <strong>!!facebook_comments!!</strong> in both the 'Link Info' template and 'Link Info Premium' template. The Link Info template is used for standard links and the Link Info Premium is used for premium links.</li>
    <li><strong>!!facebook_comments!!</strong> will also work <a href="admin27.cgi" target="_blank">for custom template sets.</a></li>
    <li>It will be a good idea to remove all references to the built-in PowerSeek comments functionalities as Facebook will then replace this functionality.</li>
  </ul>
  <p>&nbsp;</p>
</blockquote>
</body>
</html>
];


}





sub savesettings
{

open (FBCOM, "> $data_dir/fbcomments.dat");
	print FBCOM $q->param('fapi') . "\n";
	print FBCOM $q->param('fwidth') . "\n";
	print FBCOM $q->param('colorscheme') . "\n";
	print FBCOM $q->param('numbercomm') . "\n";
	print FBCOM $q->param('fbuid') . "\n";
	print FBCOM $q->param('modcomments') . "\n";
close (FBCOM);

$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Commetns Plugin :: Configuration Saved", "<a href='p_fbcomments.cgi'>Click Here to Continue</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Facebook Plugin</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}




sub configure
{

######################

$gsettings = new_gsettings acs;
$fapi = $gsettings->{facebookappid};

$fbcsettings = &get_file_contents("$data_dir/fbcomments.dat");  
@fbset = split (/\n/, $fbcsettings);

if ($fbset[0] ne "") { $fapi = $fbset[0]; }

$fwidth 			= $fbset[1];

$colorscheme 	= $fbset[2];
if ($colorscheme eq "dark")
	{
	$darkcheck = "checked";
	}
	else
	{
	$lightcheck = "checked";
	}

$numbercomm = $fbset[3];
$fbuid  =  $fbset[4];
$moderation = $fbset[5];

if ($moderation eq "N")
	{
	$mno = "checked";
	}
	else
	{
	$myes = "checked";
	}



######################

$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Login Plugin :: Configure Facebook Login", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

$jser = acs::get_js_errors;

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Facebook Plugin</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

$jser

<script SRC="$web_url/qtip.js"></script>

<style type="text/css">
<!--
div#qTip {
 padding: 10px;
 border: 1px solid #DBDBDB;
 display: none;
 background: url("$web_url/tooltback.gif");
 color: #000;
 font: 11px Arial, sans-serif;
 text-align: left;
 position: absolute;
 z-index: 1000;
}
-->
</style> 

</head>
<body>
$hbox
<form name="form1" method="post" action="p_fbcomments.cgi" onSubmit="return check_errors_blank('fapi::You have to provide a Facebook App ID::fwidth::You have to provide the width of the comments box::numbercomm::You have to specify how many comments to display on more info pages.::fbuid::You have to provide a Facebook ID');">
  <table width="93%" border="0" align="center" cellpadding="6" cellspacing="1">
    <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td width="22%"><strong><span class="normaltext">Facebook App ID: </span></strong></td>
      <td width="78%"><span class="normaltext">
        <input name="fapi" type="text" id="fapi" value="$fapi" size="30">
      </span></td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top">&nbsp;</td>
      <td valign="top">To get a FaceBook App ID visit <a href="https://developers.facebook.com/apps" target="_blank">https://developers.facebook.com/apps</a> - Log in with your facebook details and click the Create New App button. Supply the details asked from you and you will receive an App ID / API Key - Enter the APP ID / API Key here.</td>
    </tr>
   
    	$module_warning
    
        <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top"><strong>Your Facebook User ID: </strong></td>
          <td valign="top"><input name="fbuid" type="text" id="fbuid" value="$fbuid" size="50" />
            <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('Required so that you can Administrate comments - To add multiple moderators, separate the uids by comma without spaces.');" onMouseOut="tooltip.hide();">

  </td>
        </tr>
        <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top">&nbsp;</td>
          <td valign="top">To get your Facebook ID, go to Facebook and login. After you are logged in click on your name. In the URL field of the browser's address bar you will see something like: http://www.facebook.com/#!/profile.php?id=123456789 - In this example the ID is: 123456789</td>
        </tr>
        <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top"><strong>Moderate Comments? <img src="$web_url/est_help.gif" style="vertical-align:middle" onMouseOver=" tooltip.show('It is strongly recommend that you moderate comments. Doing this enables a moderator interface on Facebook where comments from all plugins administered by your app id can be easily moderated together.');" onMouseOut="tooltip.hide();">

  </strong></td>
          <td valign="top"><input type="radio" name="modcomments" id="modcomments1" value="Y" $myes/>
          Yes (recommended)
  <input type="radio" name="modcomments" id="modcomments2" value="N" $mno /> 
  No 
</td>
        </tr>
        <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top">&nbsp;</td>
          <td valign="top">Comments can be moderated by loading: <a href="http://developers.facebook.com/tools/comments" target="_blank">http://developers.facebook.com/tools/comments</a></td>
        </tr>
        <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top"><strong>Width: </strong></td>
          <td valign="top"><input name="fwidth" type="text" id="fwidth" value="$fwidth" size="8" />
            <strong>PX</strong> (The width of the plugin in pixels. Minimum recommended width: 400px.)</td>
        </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top"><strong>Color Scheme: </strong></td>
          <td valign="top"><input type="radio" name="colorscheme" id="colorscheme" value="light" $lightcheck/>
            Light 
            <input type="radio" name="colorscheme" id="colorscheme2" value="dark" $darkcheck />
            Dark</td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top"><strong>Number of comments to show:</strong></td>
      <td valign="top"><input name="numbercomm" type="text" id="numbercomm" value="$numbercomm" size="5" />        
        (The number of comments to show by default. Minimum: 1)</td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top">&nbsp;</td>
      <td valign="top"><input type="submit" class="psbutton" name="Save" id="Save" value="Save">
      <input name="fct" type="hidden" id="fct" value="savesettings" /></td>
    </tr>
  </table>
</form>
</body>
</html>
];


}




sub start
{

$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Comments Plugin", "Choose an option below");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Facebook Plugin</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox

<ul>
  <li><span class="normaltext"><a href="?fct=configure"><strong>Configure Facebook Comments</strong></a><br>
  Here you need to enter the Facebook App ID and specify other configuration options.</span></li>
</ul>
<ul>
  <li><strong><span class="normaltext"><a href="?fct=instructions">Implement Facebook Comments</a></span></strong><span class="normaltext"><br>
    Instructions on how to implement Facebook Comments so that users can post comments on 'more info' pages of links with Facebook.</span> </li></ul>
    
</body>
</html>
];
 


}






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


