#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;


&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "configure") { &configure; }
if ($q->param('fct') eq "savesettings") { &savesettings; }
if ($q->param('fct') eq "instructions") { &instructions; }

####################################################################################

sub instructions
{

$fbcsettings = &get_file_contents("$data_dir/fblikebutton.dat");  
@fbset = split (/\n/, $fbcsettings);


if ($fbset[0] eq "") 
	{

		$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Like Plugin", "The PowerSeek Facebook Like Plugin needs to be configured. <a href='p_fblike.cgi?fct=configure'>Click Here to configure</a>");

		print qq[
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<title>Facebook Plugin</title>
		$HTML_ENCODING_USE
		<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
		</head>
		<body>
		$hbox
		</body>
		</html>
		];
		exit;
	}
	
	

$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Like Plugin :: Implement Facebook Like Button", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Facebook Plugin</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox

<blockquote>
  <p><span class="normaltext"><strong>To enable the use of the Facebook Like button  on 'more info' pages, do the following steps:</strong></span></p>
  <p><strong>Step 1:</strong></p>
  <blockquote>
    <p>Go to the PowerSeek Control Panel &gt;&gt; Template Manager &gt;&gt; 1. Default Category/Directory Templates &gt;&gt; Click on <strong>Link Info</strong> and/or<strong> Link Info Premium</strong></p>
  </blockquote>
  <p><strong>Step 2:</strong></p>
  <blockquote>
    <p>Inside the 'more info' template (also called 'link info') place the following where you would like to display the Facebook like button:</p>
    <blockquote>
      <p><strong>!!facebook_like!!</strong></p>
    </blockquote>
  </blockquote>
  <p><strong>Additional Notes: </strong></p>
  <ul class="normaltext">
    <li>It will be a good idea to place <strong>!!facebook_like!!</strong> in both the 'Link Info' template and 'Link Info Premium' template. The Link Info template is used for standard links and the Link Info Premium is used for premium links.</li>
    <li><strong>!!facebook_like!!</strong> will also work <a href="admin27.cgi" target="_blank">for custom template sets.</a></li>
  </ul>
  <p>&nbsp;</p>
</blockquote>
</body>
</html>
];

}





sub savesettings
{

open (FBCOM, "> $data_dir/fblikebutton.dat");
	print FBCOM $q->param('fapi') . "\n";
	print FBCOM $q->param('fwidth') . "\n";
	print FBCOM $q->param('showfaces') . "\n";
	print FBCOM $q->param('layoutstyle') . "\n";
	print FBCOM $q->param('colorscheme') . "\n";
	print FBCOM $q->param('font') . "\n";
	print FBCOM $q->param('websitename') . "\n";
close (FBCOM);

$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Like Plugin :: Configuration Saved", "<a href='p_fblike.cgi'>Click Here to Continue</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Facebook Plugin</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}




sub configure
{

######################

$gsettings = new_gsettings acs;
$fapi = $gsettings->{facebookappid};

$fbcsettings = &get_file_contents("$data_dir/fblikebutton.dat");  
@fbset = split (/\n/, $fbcsettings);

if ($fbset[0] ne "") { $fapi = $fbset[0]; }

$fwidth = $fbset[1];
if ($fwidth eq "") { $fwidth = "400"; }

$showfaces = $fbset[2];

if ($showfaces eq "Y")
	{
	$fbshow_y = "checked";
	}
	else
	{
	$fbshow_n = "checked";
	}

$layoutstyle = $fbset[3];
if    ($layoutstyle eq "standard") { $standard_sel = "selected"; }
elsif ($layoutstyle eq "button_count") { $button_count_sel = "selected"; }
elsif ($layoutstyle eq "box_count") { $box_count_sel = "selected"; }
else { $standard_sel = "selected"; }

$colorscheme 	= $fbset[4];
if ($colorscheme eq "dark")
	{
	$darkcheck = "checked";
	}
	else
	{
	$lightcheck = "checked";
	}

$font = $fbset[5];
$fonta[$font] = "selected";

$websitename = $fbset[6];

######################

$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Login Plugin :: Configure Facebook Like Buttons", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

$jser = acs::get_js_errors;

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Facebook Plugin</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

$jser

<script SRC="$web_url/qtip.js"></script>

<style type="text/css">
<!--
div#qTip {
 padding: 10px;
 border: 1px solid #DBDBDB;
 display: none;
 /*background: url("$web_url/tooltback.gif");*/
 background-color: #FFF;
 color: #000;
 font: 11px Arial, sans-serif;
 text-align: left;
 position: absolute;
 z-index: 1000;
}
-->
</style> 

</head>
<body>
$hbox
<form name="form1" method="post" action="p_fblike.cgi" onSubmit="return check_errors_blank('fapi::You have to provide a Facebook App ID or Facebook ID::fwidth::You have to provide a width::websitename::You have to provide the name of your Directory of Web Site');">
  <table width="93%" border="0" align="center" cellpadding="6" cellspacing="1">
    <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td width="27%"><strong><span class="normaltext">Facebook App ID or/and Facebook ID: </span></strong></td>
      <td width="73%"><span class="normaltext">
        <input name="fapi" type="text" id="fapi" value="$fapi" size="60">
      </span></td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top">&nbsp;</td>
      <td valign="top"><p>To get a FaceBook App ID visit <a href="https://developers.facebook.com/apps" target="_blank">https://developers.facebook.com/apps</a> - Log in with your facebook details and click the Create New App button. Supply the details asked from you and you will receive an App ID / API Key - Enter the APP ID / API Key here.
</p>
      <p> To get your Facebook ID, go to Facebook and login. After you are logged in click on your name. In the URL field of the browser's address bar you will see something like: http://www.facebook.com/#!/profile.php?id=123456789 - In this example the ID is: 123456789</p>
      <p>You can add a Facebook App ID and your Facebook ID above by seperating them with a comma (no spaces). Adding IDs here gives you administrative abilities regarding the like buttons from Facebook.</p></td>
    </tr>
   
    	$module_warning
        <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top"><strong>Width in Pixels of Like Button: </strong></td>
          <td valign="top"><input name="fwidth" type="text" id="fwidth" size="8" value="$fwidth" />
            PX</td>
        </tr>
        <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top"><strong>Show faces</strong>:            <strong><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('Show profile pictures below the button');" onmouseout="tooltip.hide();" /></strong></td>
          <td valign="top"><input name="showfaces" type="radio" id="showfaces1" value="Y" checked="checked" $fbshow_y />
Yes
  <input type="radio" name="showfaces" id="showfaces2" value="N" $fbshow_n /> 
  No
</td>
        </tr>
        <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top"><strong>Layout Style: </strong></td>
          <td valign="top"><select name="layoutstyle" id="layoutstyle">
            <option value="standard" $standard_sel>Standard</option>
            <option value="button_count" $button_count_sel>button_count</option>
            <option value="box_count" $box_count_sel>box_count</option>
          </select>
          <strong><img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" 
          tooltip.show('<strong class=\\'normaltext12\\'>Standard:</strong><br><img src=\\'$web_url/fblike1.png\\' width=\\'389\\' height=\\'33\\'><br><strong class=\\'normaltext12\\'>button_count:</strong><br><img src=\\'$web_url/fblike2.png\\' width=\\'91\\' height=\\'33\\'> <br><strong class=\\'normaltext12\\'>box_count:</strong> <br><img src=\\'$web_url/fblike3.png\\' width=\\'63\\' height=\\'57\\'> ');" onmouseout="tooltip.hide();" /> </strong></td>
        </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top"><strong>Color Scheme: </strong></td>
          <td valign="top"><input type="radio" name="colorscheme" id="colorscheme" value="light" $lightcheck/>
            Light 
            <input type="radio" name="colorscheme" id="colorscheme2" value="dark" $darkcheck />
            Dark</td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top"><strong>Font: </strong></td>
      <td valign="top"><select name="font" id="font">
        <option value="0" $fonta[0]>arial</option>
        <option value="1" $fonta[1]>lucida grande</option>
        <option value="2" $fonta[2]>segoe ui</option>
        <option value="3" $fonta[3]>tahoma</option>
        <option value="4" $fonta[4]>trebuchet ms</option>
        <option value="5" $fonta[5]>verdana</option>
      </select></td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top"><strong>Your Web Site Name: <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('A human readable name for your web site or Search Engine & Directory.');" onmouseout="tooltip.hide();" /></strong></td>
      <td valign="top"><input name="websitename" type="text" id="websitename" size="60" value="$websitename" /></td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top">&nbsp;</td>
      <td valign="top"><input type="submit" class="psbutton" name="Save" id="Save" value="Save">
      <input name="fct" type="hidden" id="fct" value="savesettings" /></td>
    </tr>
  </table>
</form>
</body>
</html>
];

}




sub start
{

$hbox = acs::get_heading_box("$web_url/ic_facebook.gif", "Facebook Like Plugin", "Choose an option below");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Facebook Plugin</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox

<ul>
  <li><span class="normaltext"><a href="?fct=configure"><strong>Configure Facebook Like</strong></a><br>
  This section will let you configure the Facebook Like Button functionality.</span></li>
</ul>
<ul>
  <li><strong><span class="normaltext"><a href="?fct=instructions">Implement Facebook Like Buttons</a></span></strong><span class="normaltext"><br>
    Instructions on how to place the Facebook like button on 'more info' pages.</span> </li></ul>
    
</body>
</html>
];
 


}






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


