#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;


&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "configure") { &configure; }
if ($q->param('fct') eq "savesettings") { &savesettings; }
if ($q->param('fct') eq "instructions") { &instructions; }

####################################################################################

sub instructions
{ 

$hbox = acs::get_heading_box("$web_url/ic_greviews.png", "Google Rich snippets - Ratings/Reviews :: Implement Google Rich snippets - Ratings/Reviews", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Google Rich snippets</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox


<blockquote>
  <p><span class="normaltext"><strong>How to place  'Google Rich Snippet Ratings/Reviews' on 'More Info' pages. ('More Info' pages are also referred to as 'Link Info' pages)</strong></span><br>
    The goal of a rating/review rich snippet is to provide users with rating/review information about listings, such as the star rating (1 to 5 stars) number of votes and number of reviews. </p>
  <p><strong>Step 1:</strong></p>
  <blockquote>
    <p>Go to the PowerSeek Control Panel &gt;&gt; Template Manager &gt;&gt; 1. Default Category/Directory Templates &gt;&gt; Click on <strong>Link Info</strong> and/or<strong> Link Info Premium</strong></p>
  </blockquote>
  <p><strong>Step 2:</strong></p>
  <blockquote>
    <p>Inside the 'more info' template (also called 'link info') place the following anywhere between the &lt;body&gt; tags of the template:</p>
    <blockquote>
      <p><strong>!!google_rev_snippet!!</strong></p>
    </blockquote>
  </blockquote>
  <p><strong>Help/Notes: </strong></p>
  <ul>
    <li class="normaltext">It will be a good idea to place <strong>!!google_rev_snippet!! </strong>in both the 'Link Info' template and 'Link Info Premium' template. The Link Info template is used for standard links and the Link Info Premium is used for premium links.</li>
    <li class="normaltext"><strong>!!google_rev_snippet!!</strong> will also work <a href="admin27.cgi" target="_blank">for custom template sets.</a></li>
    <li class="normaltext">If a listing has no rating, votes or reviews then a <em>Google Rich Snippet</em> won't be available in the 'More Info' pages of the specific listing.</li>
    <li class="normaltext">You won't see the  <em>Google Rich Snippet</em>s with the naked eye but the details will be available to Google's Googlebot when it crawls the 'More Info' pages of listings.</li>
    <li class="normaltext">More detailed information on <em>Google Rich Snippet Reviews </em><a href="http://support.google.com/webmasters/bin/answer.py?hl=en&answer=146645&topic=1088474&ctx=topic" target="_blank">are available here.</a></li>
  </ul>
</blockquote>

</body>
</html>
];

}





sub savesettings
{

open (FBCOM, "> $data_dir/googlebutton.dat");
	print FBCOM $q->param('plusone-size') . "\n";
	print FBCOM $q->param('plusone-annotation') . "\n";
	print FBCOM $q->param('fwidth') . "\n";
	print FBCOM $q->param('plusone-lang') . "\n";
close (FBCOM);

$hbox = acs::get_heading_box("$web_url/ic_greviews.png", "Google Plus One Button Plugin :: Configuration Saved", "<a href='p_ggreviews.cgi'>Click Here to Continue</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Google Rich snippets</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}






sub configure
{

######################

$htmlcode = &get_file_contents("$data_dir/p_ggreviews.dat");  

#####################

$hbox = acs::get_heading_box("$web_url/ic_greviews.png", "Google Rich snippets - Ratings/Reviews :: Configure Google Rich snippets - Ratings/Reviews", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

$jser = acs::get_js_errors;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Google Rich snippets</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

$jser

<script SRC="$web_url/qtip.js"></script>

<style type="text/css">
<!--
div#qTip {
 padding: 10px;
 border: 1px solid #DBDBDB;
 display: none;
 /*background: url("$web_url/tooltback.gif");*/
 background-color: #FFF;
 color: #000;
 font: 11px Arial, sans-serif;
 text-align: left;
 position: absolute;
 z-index: 1000;
}
-->
</style> 

</head>
<body>
$hbox

<form name="form1" method="post" action="p_ggreviews.cgi" onSubmit="return check_errors_blank('width::You have to provide a width');">
  <table width="93%" border="0" align="center" cellpadding="6" cellspacing="1">
    $module_warning
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top"><strong>HTML Code that will be placed inside more info pages:<br>
        </strong>The HTML Code below will be placed on 'more info' pages if a listing has a rating, votes or reviews. If a listing does not have a rating, votes or reviews then the criteria indicating the <em>Google Rich Snippet</em> will not be available. </td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top"><textarea name="googlerich" id="googlerich" cols="45" rows="10" style="width:100%"></textarea></td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top"><input type="submit" class="psbutton" name="Save" id="Save" value="Save">
        <input name="fct" type="hidden" id="fct" value="savesettings" /></td>
    </tr>
  </table>
</form>


</body>
</html>

];

}




sub start
{

$hbox = acs::get_heading_box("$web_url/ic_greviews.png", "Google Rich snippets - Ratings/Reviews", "This plugin lets you display rich snippets in Google search results for 'more info' pages. When google displays a link to your 'more info' pages in their search results then you can instruct google to display a rating, the number of votes and reviews for the specific listing in their search results. This results in an increase of traffic sent from google.");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Google Rich snippets</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox

<ul>
  <li><strong><span class="normaltext"><a href="?fct=instructions">Implement 'Google Rich snippets - Ratings/Reviews' on 'More Info' pages.</a></span></strong><span class="normaltext"><br>
    Instructions on how to implement 'Google Rich snippets - Ratings/Reviews' on more info pages.</span>
    </li>
 </ul>

<!--
<ul>
  <li><span class="normaltext"><a href="?fct=configure"><strong>Configure 'Google Rich snippets - Reviews'</strong></a><br>
  This section will let you configure the 'Google Rich snippets - Reviews' functionality.</span></li>
</ul>
-->
   
</body>
</html>
];
 


}






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


