#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Google SiteMaps Plugin
# DIZ: Enables you to edit Google SiteMap settings and SiteMap settings regarding categories and links.
# GRAPHIC: ic_smap.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use glsitemap;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
if ($q->param('fct') eq "view") { &view; exit; }

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "gmapset") { &gmapset; }
if ($q->param('fct') eq "save_path") { &save_path; }
if ($q->param('fct') eq "cats") { &display_cats; }
if ($q->param('fct') eq "links") { &display_links; }
if ($q->param('fct') eq "gen") { &generate_sitemap; }
if ($q->param('fct') eq "overview") { &overview; }
if ($q->param('fct') eq "mass_assign") { &mass_assign; }
if ($q->param('fct') eq "assign_mass_values") { &assign_mass_values; }


####################################################################################

sub assign_mass_values
{

if ($q->param('update_maincat') eq "Y") { $do_update = "Yes"; }
elsif ($q->param('update_mainlinks') eq "Y") { $do_update = "Yes"; }
if ($do_update ne "Yes") {	acs::problem_popup("You have to select 'Assign the Priority and Change Frequency Values to the selected Category' or 'Assign the Priority and Change Frequency Values to links inside the selected Category'"); }

$priority = $q->param('priority');
$change_freq = $q->param('change_freq');
$setting = $priority . "::" . $change_freq;

#if ($priority eq "") { 	acs::problem_popup("You have to specify a 'Priority' setting."); }
#if ($priority > 1) { acs::problem_popup("Valid values for the 'Priority' setting are from 0.00 to 1.00"); }


@citems = split (/-/, $q->param('movecat'));

$lvc = 1;

foreach $cat (@citems)
	{
	$selected_cat = acs::decode_dir($cat);
	$csel = $csel . " (l" . "$lvc = '$selected_cat') AND";
	$lvc++;
	}
	
	$csel = substr($csel, 0, length($csel) - 3);


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

			$nlv = $lvc - 1;
			$sql = "SELECT cid FROM dirs WHERE $csel AND (level = '$nlv')";
			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $wsql";}
			while ( @row = $sth->fetchrow() ) { $orig_cid = $row[0]; }
					


if ($q->param('update_maincat') eq "Y")
	{
		if ($q->param('dont_overwrite') eq "Y") { $no_overw = " AND ((ext3 = '') OR (ext3 IS NULL) OR (ext3 = '::'))"; }

		if (($q->param('update_maincat') eq "Y") and ($q->param('update_subcats') eq "Y"))
			{
			$sql = "UPDATE dirs SET ext3 = '$setting' WHERE $csel $no_overw";
			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $wsql";}
			}
			elsif 
			(($q->param('update_maincat') eq "Y") and ($q->param('update_subcats') ne "Y"))
			{
			$setlevel = $lvc - 1;
			$sql = "UPDATE dirs SET ext3 = '$setting' WHERE $csel AND level = '$setlevel' $no_overw";
			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $wsql";}
			}
	}
elsif ($q->param('update_mainlinks') eq "Y")
	{
	
			if ($q->param('dont_overwrite') eq "Y") { $no_overw_links = " AND ((extf4 = '') OR (extf4 IS NULL) OR (extf4 = '::'))"; }
		
			if (($q->param('update_mainlinks') eq "Y") and ($q->param('update_sublinks') eq "Y"))
				{
				$sql_links = "SELECT cid FROM dirs WHERE $csel";
				$sth = $dbh->prepare($sql_links);
				$sth->execute;
				$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $wsql";}
				while ( @row = $sth->fetchrow() ) 
						{
						$linksupd = $linksupd . " (cid = '$row[0]') OR";
						}
				
				$linksupd = substr($linksupd, 0, length($linksupd) - 2);
				
				$sql_links = "UPDATE links SET extf4 = '$setting' WHERE ($linksupd) $no_overw_links";
				$sth = $dbh->prepare($sql_links);
				$sth->execute;
				$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $wsql";}
				}
				else
				{
				$sql_links = "UPDATE links SET extf4 = '$setting' WHERE (cid = '$orig_cid') $no_overw_links";
				$sth = $dbh->prepare($sql_links);
				$sth->execute;
				$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $wsql";}
				}
	
	}

$sth->finish;
$dbh->disconnect;


$mlv = $q->param('mlv'); 

if ($mlv > 0)
	{
	$mct = $q->param('mct');
	$cid = $q->param('cid');
	}

$dizbox = qq[<a href="$admin_url/p_gmap.cgi?fct=mass_assign&mlv=$mlv&mct=$mct&cid=$cid&ct=$ct">Click Here to Continue</a>];
$hbox = acs::get_heading_box("$web_url/ic_smap.gif", "<a href=\"$admin_url/p_gmap.cgi\">Google SiteMaps Plugin</a> >> Priority and Update Frequencies Assigned", $dizbox);  

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
</body>
</html> 
];


}



sub mass_assign
{

$ct = $q->param('ct'); ### ORIGINAL CAT
$cid = $q->param('cid'); ### ORIGINAL CID
$rid = $q->param('rid'); ### ORIGINAL RID

$mct = $q->param('mct'); ### TO MOVE TO CAT
$mlv = $q->param('mlv'); ### TO MOVE LEVEL 
$mcid = $q->param('mcid'); ### TO MOVE CID

$last_dname = acs::get_last_dirname($mct); 


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
########

if ($mlv == 0)
	{
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '1') AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	}
	else
	{
	$mlv++;
	@adir = split (/-/, $mct);
	
	$querystr = "";

	for ($ms = 0; $ms < 16; $ms++) 
		{
		if ($adir[$ms] ne "") {$adir[$ms] = acs::decode_dir($adir[$ms]);}

		$acnt = $ms + 1;
		if ($acnt != $mlv)
			{
			if ($adir[$ms] ne "")
				{
				$adir[$ms] =~ s/'/\\'/g;
				}
			$querystr = $querystr . " (l" . "$acnt = '$adir[$ms]') and";
			}
		$acnt++;
		}
	$querystr = substr($querystr, 0, length($querystr) - 3);
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '$mlv') AND $querystr AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	}

##############

if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();

$smc = 0;
while ( @row = $sth->fetchrow() )
	{
	$mlv = $row[1];

	$row[2] = acs::encode_dir($row[2]); $dirstring = $row[2];														#1
	if ($row[3] ne "") { $row[3] = acs::encode_dir($row[3]); $dirstring =   $dirstring . "-$row[3]"; } #2
	if ($row[4] ne "") { $row[4] = acs::encode_dir($row[4]); $dirstring =   $dirstring . "-$row[4]"; } #3
	if ($row[5] ne "") { $row[5] = acs::encode_dir($row[5]); $dirstring =   $dirstring . "-$row[5]"; } #4
	if ($row[6] ne "") { $row[6] = acs::encode_dir($row[6]); $dirstring =   $dirstring . "-$row[6]"; } #5
	if ($row[7] ne "") { $row[7] = acs::encode_dir($row[7]); $dirstring =   $dirstring . "-$row[7]"; } #6
	if ($row[8] ne "") { $row[8] = acs::encode_dir($row[8]); $dirstring =   $dirstring . "-$row[8]"; } #7
	if ($row[9] ne "") { $row[9] = acs::encode_dir($row[9]); $dirstring =   $dirstring . "-$row[9]"; } #8
	if ($row[10] ne ""){ $row[10] = acs::encode_dir($row[10]); $dirstring = $dirstring ."-$row[10]"; } #9
	
	if ($row[11] ne ""){ $row[10] = acs::encode_dir($row[11]); $dirstring = $dirstring ."-$row[11]"; } #10
	if ($row[12] ne ""){ $row[10] = acs::encode_dir($row[12]); $dirstring = $dirstring ."-$row[12]"; } #11
	if ($row[13] ne ""){ $row[10] = acs::encode_dir($row[13]); $dirstring = $dirstring ."-$row[13]"; } #12
	if ($row[14] ne ""){ $row[10] = acs::encode_dir($row[14]); $dirstring = $dirstring ."-$row[14]"; } #13
	if ($row[15] ne ""){ $row[10] = acs::encode_dir($row[15]); $dirstring = $dirstring ."-$row[15]"; } #14
	if ($row[16] ne ""){ $row[10] = acs::encode_dir($row[16]); $dirstring = $dirstring ."-$row[16]"; } #15
	if ($row[17] ne ""){ $row[10] = acs::encode_dir($row[17]); $dirstring = $dirstring ."-$row[17]"; } #16

	if ($row[20] eq "") { $row[20] = 0; }

	$locked_stat = "";
	if ($row[22] eq "Y") { $locked_stat = " <img src=\"$web_url/locked.gif\">"; }

	if ($last_dname eq "") { $last_dname = "Root "; }
	if ($smc == 0) 
		{
		$movedirs = $movedirs . " <img src=\"$web_url/dir.gif\"> <b>$last_dname</b> <br>";
		$selbox = "checked";
		}
		else
		{
		$selbox = "";
		}
	$smc++;
	
	$moveval = "$row[0]" . "___MVSPLT___" . "$row[28]";
	
	($dprior, $dfreq) = split (/::/, $row[26]);
	
	if (($dprior ne "") or ($dfreq ne ""))
		{
		if ($dprior eq "") { $dprior = "No Value";}
		if ($dfreq eq "") { $dfreq = "No Value";}
		$priority = "($dprior / $dfreq)";
		}
		else
		{
		$priority = "";
		}
	
	$movedirs = $movedirs . "<input type=\"radio\" name=\"movecat\" $selbox value=\"$dirstring\" onclick=\"get_search_form('$dirstring');\"\> <img src=\"$web_url/subdir.gif\"> <a href=\"$admin_url/p_gmap.cgi?fct=mass_assign&mlv=$mlv&mct=$dirstring&cid=$row[0]&ct=$ct&$selstring\">$row[28]</a></strong> ($row[20]) $locked_stat $priority<br>";
	
	$oid = $row[0];
	}

$sth->finish;
$dbh->disconnect;



#### CURRENT MOVE LOCATION

if ($mct eq "")
	{
	$currentloc = "Root ";
	}
	else
	{
	$currentloc = "<a href=\"$admin_url/p_gmap.cgi?fct=mass_assign&mlv=&mct=&cid=$cid&rid=$rid&ct=$ct&fct=$fct&$selstring&opaction=$opaction&$newsub&linkchk=$linkchk\">Root</a> ";
	
	$n_mlv = 1;
	
	@allds = split (/-/, $mct);
	$ccnr = @allds;

	foreach $aitem (@allds)
		{
		$n_mct = $n_mct . $aitem . "-";
		
		$cdname = acs::decode_dir($aitem);
		
		$cnn_mct = substr($n_mct, 0, length($n_mct) - 1);
		
		if ($ccnr ne $n_mlv)
			{
			$currentloc = $currentloc . " > <a href=\"$admin_url/p_gmap.cgi?fct=mass_assign&mlv=$n_mlv&mct=$cnn_mct&cid=$cid&rid=$rid&ct=$ct&fct=$fct&$selstring&opaction=$opaction&$newsub&linkchk=$linkchk\">$cdname</a> ";
			}
			else
			{
			$currentloc = $currentloc . " > $cdname ";
			}
		
		$n_mlv++;
		}
	
	}

#### 

if ($dirstring !~ /-/)
	{
	$pmct = "";
	}
	else
	{
	$pmct = "$mct";
	}


#####

if ($mlv eq "")
	{
	$create_lv = 0;
	}
	else
	{
	$create_lv = $mlv -1;
	}

if ($rows == 0)
	{
$movedirs = qq[

<p><span class="normaltext"><strong>This category contains no sub
directories/categories. <br>
</strong></span><span class="normaltext">
<a href="" onClick="history.go(-1); return false;">Go Back</a>
</span></p>
];

$nodirs = "true";
	
	}
	elsif ($q->param('fct') eq "")
	{
		$movebut = "<input type=\"submit\" value=\"   Assign   \" name=\"movebutton\" onclick=\"post_value();\">";
	}
	elsif ($q->param('fct') eq "related")
	{
	
		if ($q->param('linkchk') eq "true")
		{
		$movebut = "<input type=\"submit\" value=\"   Assign   \" name=\"movebutton\" onclick=\"post_value3(); return false;\">";
		$linkchk = "true";
		}
		else
		{
		$movebut = "<input type=\"submit\" value=\"   Assign   \" name=\"movebutton\" onclick=\"post_value2(); return false;\">";
		}
		
	}


if ($nodirs ne "true")
{

$mlv = $mlv - 1;

$dizbox = qq[

<form id="form1" name="form1" method="post" action="$admin_url/p_gmap.cgi" style="margin-bottom:0; margin-top:0;" >
<input name="fct" type="hidden" id="fct" value="assign_mass_values">

<input name="mlv" type="hidden" value="$mlv">
<input name="mct" type="hidden" value="$mct">
<input name="cid" type="hidden" value="$cid">

<b>Current Location: </b> $currentloc<BR><BR>
$movedirs

<p> <strong>Priority:</strong>
    <input name="priority" type="text" id="priority" size="7" />
(From 0.00 to 1.00) / <strong>Change Frequency:</strong>
<select name="change_freq" id="gpriority">
  <option value="" selected="selected">Not Available</option>
  <option value="always" >always</option>
  <option value="hourly" >hourly</option>
  <option value="daily" >daily</option>
  <option value="weekly" >weekly</option>
  <option value="monthly" >monthly</option>
  <option value="yearly" >yearly</option>
  <option value="never" >never</option>
</select>
  </p>
  <p>
    <input name="update_maincat" type="checkbox" id="update_maincat" value="Y" />
    <label for="update_maincat"></label> 
    Assign the Priority and Change Frequency Values to the selected Category
<br />
    <input name="update_subcats" type="checkbox" id="update_subcats" value="Y" />
    <label for="update_subcats"></label>
  Update all Sub Categories inside the selected Category.</p>
  <p>
    <input name="update_mainlinks" type="checkbox" id="update_mainlinks" value="Y" />
    <label for="update_mainlinks"></label>
Assign the Priority and Change Frequency Values to Links inside the selected Category<br />
<input name="update_sublinks" type="checkbox" id="update_sublinks" value="Y" /> 
Update Links inside Sub Categories inside the selected Category.</p>
  <p>
    <input name="dont_overwrite" type="checkbox" id="dont_overwrite" value="Y" checked="checked" /> 
    Do not update Categories or Links that already has Priority and Change Frequency Values</p>
  <p>
    <input type="submit" class="psbutton" name="Update" id="Update" value="  Update  " />
    <br />
  </p>
</form>
];

}
else
{
$dizbox = $movedirs;
}


$hbox = acs::get_heading_box("$web_url/ic_smap.gif", "<a href=\"$admin_url/p_gmap.cgi\">Google SiteMaps Plugin</a> >> Mass Assign Priorities and Update Frequencies", $dizbox);  

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
</body>
</html> 
];


}






sub view
{
print "Content-type: text/plain\n\n"; 

$sitemap_path = acs::get_file_contents("$data_dir/sitemap.dat"); 

$smap = acs::get_file_contents("$sitemap_path"); 

print $smap;

}


sub overview
{

$soverview = acs::get_file_contents("$data_dir/gsitemap.dat"); 

$hbox = acs::get_heading_box("$web_url/ic_smap.gif", "<a href=\"p_gmap.cgi\">Google SiteMaps Plugin </a> >> Google SiteMap Overview", qq[Below is an overview of the URLs written to the Google SiteMap file.]);  


print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
<p>$soverview</p>
</body>
</html>
];

}





sub generate_sitemap
{

$sitemap_path = acs::get_file_contents("$data_dir/sitemap.dat"); 

($total_urls, $allfiles) = glsitemap::create_gsitemap;

@allfilesurls = split (/::/, $allfiles);

foreach $allfi (@allfilesurls)
	{
	$alldisp = $alldisp  . "<li>$allfi</li>";
	}

$alldisp = "<ul>$alldisp</ul>";

#Total URLs written: <b>$total_urls</b><br>

$boxdiz = qq[
The following sitemap file(s) was written:
$alldisp
];

#<ul>
#<li><a href="$admin_url/p_gmap.cgi?fct=overview" onclick="popup('$admin_url/p_gmap.cgi?fct=overview',850,600);return false;">Overview of the URLs written to the Google SiteMap file</a></li>
#<li><a href="$admin_url/p_gmap.cgi?fct=view" onclick="popup('$admin_url/p_gmap.cgi?fct=view',850,600);return false;">View SiteMap File</a></li>
#<li><a href="$admin_url/p_gmap.cgi">Click Here to Continue</a></li>
#</ul>


$hbox = acs::get_heading_box("$web_url/ic_smap.gif", "<a href=\"p_gmap.cgi\">Google SiteMaps Plugin </a> >> Google SiteMap Created", $boxdiz);  

$jspopup_code = acs::get_popupjs;

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
 </script>
</head>
<body>
$hbox
</body>
</html>
];

}










sub display_links
{

$lkeywords = $q->param('keywords');

if (length($lkeywords) > 0)
	{
		if ($lkeywords =~ / /)
			{
			@allkeys = split (/ /, $lkeywords);
			foreach $item (@allkeys)
				{
				if (($item ne "") and (length($item) > 2))
					{
					$scrit = $scrit . "((B.title like '%$item%') or (B.description like '%$item%') or (B.keywords like '%$item%') or (B.url like '%$item%')) or";
					}
				}

			$scrit = substr($scrit, 0, length($scrit) -3);
			}
			else
			{
			$scrit = "((B.title like '%$lkeywords%') or (B.description like '%$lkeywords%') or (B.keywords like '%$lkeywords%') or (B.url like '%$lkeywords%'))";
			}
	}



if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

if ($lkeywords ne "")
	{
	$wsql = "SELECT A.*, B.* FROM dirs AS A, links AS B WHERE (A.cid = B.cid) AND ((B.extf4 != '') AND (B.extf4 IS NOT NULL) AND (B.extf4 != '::')) AND ($scrit) ORDER BY B.extf4 DESC";
	}
	else
	{
	$wsql = "SELECT A.*, B.* FROM dirs AS A, links AS B WHERE (A.cid = B.cid) AND ((B.extf4 != '') AND (B.extf4 IS NOT NULL) AND (B.extf4 != '::')) ORDER BY B.extf4 DESC";
	}



$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $wsql";}
$rows = $sth->rows();

$icnt = $rows;
$nr_searchres = 100;

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;


while ( @row = $sth->fetchrow() ) 
	{

	if (($ippc > $st) and ($ippc <= $nd))
    {		

		$lv = $row[1];
		$cats = "";
		$lvc = 0;
		$enc_cats = "";

		for ($ms = 2; $ms < 18; $ms++) 
				{
				if ($row[$ms] ne "")
					{

						if ($lvc == 0) { $enc_cats = $enc_cats . acs::encode_dir($row[$ms]); }
											else
											{ $enc_cats = $enc_cats . "-" . acs::encode_dir($row[$ms]); }
											
						$lvc++;
						$clink = "$admin_url/admin2.cgi?fct=edit_dir&lv=$lvc&cid=$row[0]&ct=$enc_cats";
						$cats = $cats . "<a href=\"$clink\" onclick=\"popup('$clink',850,730);return false;\">$row[$ms]</a> $gsm / ";
						
					}
			}
			
		chop($cats); chop($cats);
		my @prset = split (/::/, $row[61]);
		
		$all_links = $all_links . qq[<p><a href="$row[40]" target="_blank">$row[37]</a> ( <a href="$admin_url/admin56.cgi?itemnrs=1&C0=$row[35]-$row[0]&dropdown=Edit" onclick="popup('$admin_url/admin56.cgi?itemnrs=1&C0=$row[35]-$row[0]&dropdown=Edit',850,730);return false;"><b>$prset[0] $prset[1]</b></a> )<BR>
		$row[38]<BR>
		$cats<BR><BR>
		</p>
		];
	}
	
	$ippc++;
	
	}
	
$sth->finish;
$dbh->disconnect; 



#### PAGES 

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " <span class=\"bordtext2\">[$pg]</span> ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		
		
		$pgstring = $pgstring . "<a href=\"$admin_url/p_gmap.cgi?st=$st1&nd=$nd1&fct=links&keywords=$cat_keywords\" class=\"bordtext2\">$pg</a> ";
		}
	}

if ($pages > 1)
	{
	$pgstring = " <span class=\"bordtext2\">Pages:</span> " . $pgstring;
	}
	else
	{
	$pgstring = "";
	}





### PREV NEXT PAGES

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$admin_url/p_gmap.cgi?st=$st1&nd=$nd1&fct=links&keywords=$cat_keywords\" class=\"bordtext2\">Next Page >></a> ";
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$admin_url/p_gmap.cgi?st=$st1&nd=$nd1&fct=links&keywords=$cat_keywords\" class=\"bordtext2\"><< Prev Page</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";}



	$searchbox = qq[<form method="post" action="$admin_url/p_gmap.cgi" name="addu" style="margin-bottom:0; margin-top:0;">
<input name="fct" type="hidden" id="fct" value="links">
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DBDBDB">
    <tr>
      <td colspan="2" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Found $rows Links that has priorities and update frequencies set</strong></td>
    </tr>
    <tr>
      <td width="20%" align="center" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Search within these links:</b>        </td>
      <td width="80%" valign="top" bgcolor="#FFFFFF" class="normaltext"><input name="keywords" type="text" id="files_loc" size="50">
        <input type="submit" class="psbutton" name="button" id="button" value="Search">        (Search links with priorities and update frequencies)</td>
    </tr>
  </table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
</form>];


if ($rows < 1)
	{
	$all_links = "<p>No match found.</p>";
	}
	else
	{
	$page_crit = $page_crit . "$prevnext <span class=\"bordtext2\">Page $targpage of $pg</span> ";
	}

	$boxd1 = qq[
	Listed below are links where priorities and/or update frequencies for Google SiteMaps have been set. Click the link to edit it's priority and update frequencies.
		You can asign Google SiteMap priorities and update frequencies to any link by editing links from the 'Dir Manager'. Note that Google SiteMap priorities and 
		frequencies will only be available to 'Link Info' or also called 'More Info' pages of links.<br>
	<b>Click the Priority/Frequency settings of the links below to edit the Priorities and Frequencies</b>
	];
	
	$hbox = acs::get_heading_box("$web_url/ic_smap.gif", "<a href=\"p_gmap.cgi\">Google SiteMaps Plugin </a> >> Edit Links", $boxd1);  


$jspopup_code = acs::get_popupjs;

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<title>PowerSeek</title>
		$HTML_ENCODING_USE
		<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
		<script LANGUAGE="JavaScript">
		<!-- Hide
		$jspopup_code 
		 // End Hide -->
		 </script>
		</head>
		<body>
		$hbox
		$searchbox
		<p><b>$page_crit $pgstring</b></p>
		<blockquote>
		$all_links
		</blockquote>
		<p><b>$page_crit $pgstring</b></p>
		
		</body>
		</html>
		];

}





sub display_cats
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


$cat_keywords = $q->param('keywords');

if (length($cat_keywords) > 0)
	{
		if ($cat_keywords =~ / /)
			{
			@allkeys = split (/ /, $cat_keywords);
			foreach $item (@allkeys)
				{
				if (($item ne "") and (length($item) > 2))
					{
					$scrit = $scrit . "((l1 like '%$item%') or (l2 like '%$item%') or (l3 like '%$item%') or (l4 like '%$item%') or (l5 like '%$item%') or (l6 like '%$item%') or (l7 like '%$item%') or (l8 like '%$item%') or (l9 like '%$item%') or (l10 like '%$item%') or (l11 like '%$item%') or (l12 like '%$item%') or  (l13 like '%$item%') or  (l14 like '%$item%') or  (l15 like '%$item%') or  (l16 like '%$item%')) or";
					}
				}

			$scrit = substr($scrit, 0, length($scrit) -3);
			}
			else
			{
			$scrit = "(l1 like '%$cat_keywords%') or (l2 like '%$cat_keywords%') or (l3 like '%$cat_keywords%') or (l4 like '%$cat_keywords%') or (l5 like '%$cat_keywords%') or (l6 like '%$cat_keywords%') or (l7 like '%$cat_keywords%') or (l8 like '%$cat_keywords%') or (l9 like '%$cat_keywords%') or (l10 like '%$cat_keywords%') or (l11 like '%$cat_keywords%') or (l12 like '%$cat_keywords%') or  (l13 like '%$cat_keywords%') or  (l14 like '%$cat_keywords%') or  (l15 like '%$cat_keywords%') or  (l16 like '%$cat_keywords%')";
			}
	}


if (length($cat_keywords) > 0)
	{
	$wsql = "SELECT * FROM dirs WHERE $scrit AND ((ext3 != '') AND (ext3 IS NOT NULL) AND (ext3 != '::'))  ORDER BY l1, shortname";
	}
	else
	{
	$wsql = "SELECT * FROM dirs WHERE (ext3 != '') AND (ext3 IS NOT NULL) AND (ext3 != '::') ORDER BY l1, shortname";
	}




$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $wsql";}
$rows = $sth->rows();

$icnt = $rows;
$nr_searchres = 50;

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;

while ( @row = $sth->fetchrow() ) 
	{
		if (($ippc > $st) and ($ippc <= $nd))
	    {				
				$lv = $row[1];
				$cats = "";
				$lvc = 0;
				$enc_cats = "";

				for ($ms = 2; $ms < 18; $ms++) 
						{
						if ($row[$ms] ne "")
							{
							$lvc++;

							if ($lvc == $row[1])
								{
								$enc_cats = $enc_cats . acs::encode_dir($row[$ms]);

								my @gitems = split (/::/, $row[26]);
								$priority = $gitems[0];
								$freq = $gitems[1];
								$clink = "$admin_url/admin2.cgi?fct=edit_dir&lv=$row[1]&cid=$row[0]&ct=$enc_cats";
								$cats = $cats . "<a href=\"$clink\" onclick=\"popup('$clink',850,730);return false;\">$row[$ms]</a> ( $priority $freq )";
								}
								else
								{
								$cats = $cats . $row[$ms] . " / ";
								$enc_cats = $enc_cats . acs::encode_dir($row[$ms]) . "-";
								}
							}
						}
		
		$all_cats_list = $all_cats_list . $cats . "<BR>";
	 }
	 $ippc++;
	}
 
 $all_cats_list = "<blockquote><p>" . $all_cats_list . "</p></blockquote>";
 
$sth->finish;
$dbh->disconnect; 


#### PAGES 

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " <span class=\"bordtext2\">[$pg]</span>  ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		
		
		$pgstring = $pgstring . " <a href=\"$admin_url/p_gmap.cgi?st=$st1&nd=$nd1&fct=cats&keywords=$cat_keywords\" class=\"bordtext2\">$pg</a> ";
		}
	}

if ($pages > 1)
	{
	$pgstring = " <span class=\"bordtext2\">Pages:</span> " . $pgstring;
	}
	else
	{
	$pgstring = "";
	}





### PREV NEXT PAGES

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$admin_url/p_gmap.cgi?st=$st1&nd=$nd1&fct=cats&keywords=$cat_keywords\" class=\"bordtext2\">Next Page >></a> ";
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$admin_url/p_gmap.cgi?st=$st1&nd=$nd1&fct=cats&keywords=$cat_keywords\" class=\"bordtext2\"><< Prev Page</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";}

if ($rows > 0)
	{
	$page_crit = $page_crit . "$prevnext <span class=\"bordtext2\">Page $targpage of $pg</span>  ";

	$searchbox = qq[<form method="post" action="$admin_url/p_gmap.cgi" name="addu" style="margin-bottom:0; margin-top:0;" >
<input name="fct" type="hidden" id="fct" value="cats">
  <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DBDBDB">
    <tr>

      <td colspan="2" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Found $rows Categories that has priorities and update frequencies set</strong></td>
    </tr>
    <tr>
      <td width="20%" align="center" bgcolor="#FFFFFF" class="normaltext"><b>Search within these categories:</b>        </td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input name="keywords" type="text" id="files_loc" size="50">
      <input type="submit" class="psbutton" name="button" id="button" value="Search">        (Search categories with priorities and update frequencies)</td>
    </tr>
  </table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
</form>];
	
	}
	else
	{
	$searchbox = qq[ <table width="100%" border="0" cellpadding="6" cellspacing="1" bgcolor="#DBDBDB">
    <tr>

      <td background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Found 0 Categories that has priorities and update frequencies set</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><p><b>There are no categories that has Google SiteMap Priorities and Update Frequencies Set at present.</b> You can assign Google SiteMap Priorities and Update Frequencies by editing any category from the 'Dir Manager'.</p></td>
    </tr>
  </table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>];
	}
	


		$boxdj = qq[
		Listed below are categories where priorities and/or update frequencies for Google SiteMaps have been set. Click the category to edit it's priority and update frequencies.
		You can asign Google SiteMap priorities and update frequencies to any category by editing categories in the 'Dir Manager'.
		];
		
		$hbox = acs::get_heading_box("$web_url/ic_smap.gif", "<a href=\"p_gmap.cgi\">Google SiteMaps Plugin </a> >> Edit Categories", $boxdj);
		
		$jspopup_code = acs::get_popupjs;

		print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<title>PowerSeek</title>
		$HTML_ENCODING_USE
		<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
		<script LANGUAGE="JavaScript">
		<!-- Hide
		$jspopup_code 
		 // End Hide -->
		 </script>
		</head>
		<body>
		$hbox
		$searchbox
		<p><b>$page_crit $pgstring</b></p>
		$all_cats_list
		<p><b>$page_crit $pgstring</b></p><BR>
		</body>
		</html> 
		];


}



sub save_path
{

$fpath = $q->param('fpath');

@path_items = split (/\//, $fpath);

$nr = @path_items;

$filename = $path_items[$nr-1];

$path_to_test = $fpath;

$path_to_test =~ s/$filename//gi;

### CHECK IF PATH TO FILE EXISTS

$exists = (-e "$path_to_test");
if ($exists < 1) { acs::problem_popup("The path you '$path_to_test' specified does not exist."); }

if ($q->param('maxurls') < 10000) { acs::problem_popup("The Maximum Number of URLs per file needs to be at least 10 000"); }
if ($q->param('maxurls') > 50000) { acs::problem_popup("The Maximum Number of URLs per file may not be more than 50 000"); }


$maxurls = $q->param('maxurls');


### Check if directory is writable

@diritems = split (/\//, $fpath);

$nritems = @diritems;

for ($ms = 0; $ms < ($nritems-1); $ms++) 
	{
	$dirwrite = $dirwrite . $diritems[$ms] . "/";
	}
chop ($dirwrite);


if ((-w $dirwrite) < 1) 
	{
	$write_msg = qq[
	<span class="normaltext"><strong>Important Note:</strong> The directory: <b>$dirwrite</b> is not writable. If you have more than <strong>$maxurls </strong>urls then PowerSeek will create more than one sitemap file. For this the directory <strong>$dirwrite</strong> will need to be writable. Set the permission seting of <strong>$dirwrite </strong>to 777 now if you have more than $maxurls that will be placed in Google Sitemap files.</span>
	];
	}




### CHECK IF FILE IS WRITABLE

if ((-w $fpath) > 0) 
	{
	$filewritable = "true";
	}



if (((-w $path_to_test) < 1) and ($filewritable ne "true"))
	{
	$ptext = qq[The directory <b>$path_to_test</b> is not writable. This means 
	the scripts doesn't have permission to write to: <b>$path_to_test</b>. 
	To solve the problem create a blank file called: <b>$filename</b> with a text 
	editor (Windows NotePad for example) and then upload it to: <b>$path_to_test</b> - 
	After doing that assign the permission setting of 777 to it. You can normally set 
	file permissions with your FTP program by right clicking files when logged in with FTP. 
	After doing that come back here and <a href="" onClick="history.go(-1); return false;">go back</a> to try again.
	];
	
	acs::problem_popup($ptext);
	}


open (STM, "> $data_dir/sitemapmax.dat");
print STM $q->param('maxurls');
close (STM);

open (STM, "> $data_dir/sitemappre.dat");
print STM $q->param('preapp');
close (STM);

open (STM, "> $data_dir/sitemapapp.dat");
print STM $q->param('app');
close (STM);


		$hbox = acs::get_heading_box("$web_url/ic_smap.gif", "<a href=\"p_gmap.cgi\">Google SiteMaps Plugin </a> >> Path Saved", qq[		<a href="$admin_url/p_gmap.cgi">Click Here</a> to continue.		]);  

		open (STM, "> $data_dir/sitemap.dat");
			print STM $fpath;
		close (STM);

		print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<title>PowerSeek</title>
		$HTML_ENCODING_USE
		<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
		</head>
		<body>
		$hbox
		$write_msg
		</body>
		</html> 
		];


}




sub gmapset
{

$spath = acs::get_file_contents("$data_dir/sitemap.dat"); 
$preapp = acs::get_file_contents("$data_dir/sitemappre.dat"); 
$app = acs::get_file_contents("$data_dir/sitemapapp.dat"); 
$maxurls = acs::get_file_contents("$data_dir/sitemapmax.dat"); 

if ($maxurls eq "") { $maxurls = "40000"; }

	$reffr = $ENV{'HTTP_REFERER'};
	@domain_items = split (/\//, $reffr);
	$domain_name = "http://" . $domain_items[2];
	
	@witems = split (/\//, $web_dir);
	$wnr = @witems;
	
	for ($ms = 0; $ms < ($wnr-1); $ms++) 
		{
		$default_sitemap_path = $default_sitemap_path . $witems[$ms] . "/";
		}
		$default_sitemap_path = $default_sitemap_path . "sitemap.xml";
	
	if ($spath eq "") { $spath = $default_sitemap_path; }
	

$boxdiz = qq[

<form name="form1" method="post" action="" style="margin-bottom:0; margin-top:0;">
  <table width="100%" border="0" cellpadding="6" cellspacing="1">
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext">When the path below has been configured, PowerSeek will create the Google SiteMap file at the location specified when generating HTML files. Note that for PowerSeek to create the SiteMap file that you need
to configure categories and links with 'priority' and 'update frequency' settings. This can be done by editing any category or link. </td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"><strong>Full Server Path with File Name where the Google SiteMap file should be placed:</strong></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"><input name="fpath" type="text" id="textfield"  style="width:100%" value="$spath">
        For example: <strong>$domain_name/sitemap.xml</strong> <strong><br>
        <br>
If you are going to place the SiteMap file in the root of your web site then you will need to do the following:</strong>
        <ul>
          <li>Create a blank file (a file containing nothing) with Windows NotePad and place it here for example: <strong>$domain_name/sitemap.xml</strong></li>
          <li>Now set the file permission setting of the file to 777 - You can normally set file permissions by right clicking the file when you are logged in via FTP with an FTP program.</li>
          <li>If you are going to place the file here: <strong>$domain_name/sitemap.xml</strong> then the path you will need to enter above will need to look like this:<br>
            <strong>$default_sitemap_path</strong><br>
        </li>
        </ul>
        <p><strong>For very large Search Engines &amp; Directories: (Important - Please read)</strong></p>
        <ul>
          <li>If you have tens of thousands of links then PowerSeek will create multiple files because google won't allow more than 50 000 URLs in a single file or a situation where the file is more than 50MB in size. In such a situation you will need to <strong>create a subdirectory</strong> in your <strong>Public Html</strong> directory where PowerSeek places the Sitemap files. This sub directory will need the<strong> permission setting of 777</strong> so that the PowerSeek scripts can write files to this directory. The full server path and file name you provide above will need to be inside this subdirectory. PowerSeek will then create more than one file in this sub directory. If the filename you specify is sitemap.xml then PowerSeek will create for example:<strong>$domain_name/sitemaps/sitemap.xml</strong>, <strong>$domain_name/sitemap2.xml</strong>, <strong>$domain_name/sitemap3.xml</strong>, etc.</li>
        </ul></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"><strong>Maximum Number of URLs per file:</strong>        <input name="maxurls" type="text" id="maxurls" value="$maxurls"> 
        <br>
        A Sitemap file can contain no more than 50,000 URLs and must be no larger than 50MB - Powerseek will produce multiple files if the URLs in the database exceeds the number you specify here.</td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"><strong>Pre-Appended Google SiteMap URLs:</strong></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext">
        <p>
          <textarea name="preapp" id="preapp" cols="45" rows="10" style="width:100%">$preapp</textarea>
          <br>
          If you have external HTML files not related to the Directory (like   <strong>$domain_name/index.html</strong> for example) then you can place entries for them here. The entries here will be placed before the entries created by PowerSeek in the Google SiteMap file.<br>
          The entry for <strong>$domain_name/index.html</strong> would look like this for example:<br>
        </p>
        <blockquote>
          <p>&lt;url&gt;<br>
&lt;loc&gt;$domain_name/index.html&lt;/loc&gt;<br>
&lt;changefreq&gt;weekly&lt;/changefreq&gt;<br>
&lt;priority&gt;1.00&lt;/priority&gt;<br>
&lt;/url&gt;<br>
          </p>
      </blockquote></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"><strong>Appended Google SiteMap URLs:</strong></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"><textarea name="app" id="app" cols="45" rows="10" style="width:100%">$app</textarea>
        <br>
      Entries to be appended to the Google SiteMap file can be placed here.  The entries here will be placed after the entries created by PowerSeek in the Google SiteMap file.<br></td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton" name="Submit" id="Submit" value="   Save   ">
        <input name="fct" type="hidden" id="fct" value="save_path"></td>
    </tr>
  </table>
</form>

];

$hbox = acs::get_heading_box("$web_url/ic_smap.gif", "<a href=\"p_gmap.cgi\">Google SiteMaps Plugin </a> >> Configure", $boxdiz);  

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
</body>
</html> 
];

}





sub start
{

$dizbox = qq[
Enables you to edit Google SiteMap settings and SiteMap settings regarding categories and links. It also allows you to generate a Google SiteMap file or files.
The Google SiteMap file will be automatically updated when HTML files are generated if you run a Static Directory. If you are not running a Static Directory then you will need 
to come to this section to update/generate the sitemap file. You may also update the SiteMap file(s) by executing sitmapgen.cgi with CRON. See the PowerSeek
Manual for more on updating the SiteMap files on a scheduled basis with the Linux CRON program.
<br><br>

<b>Choose an option below:</b><BR>

<ul>
   <li><p><a href="$admin_url/p_gmap.cgi?fct=gmapset"><b>Configure</b></a> - Configure the path where the sitemap file is to be written.</a></p></li>
   <li><p><a href="$admin_url/p_gmap.cgi?fct=cats"><b>Categories</b></a> - View/Edit categories where Google SiteMap priorities and update frequencies has been specified.</p></li>
   <li><p><a href="$admin_url/p_gmap.cgi?fct=links"><b>Links</b></a> - View/Edit links where Google SiteMap priorities and update frequencies has been specified.</p></li>
   <li><p><a href="$admin_url/p_gmap.cgi?fct=mass_assign"><b>Mass Assign Priority and Update Frequency Settings</b></a> - Let's you assign priority and update frequency settings to entire categories with it's links.</p></li>
   <li><p><a href="$admin_url/p_gmap.cgi?fct=gen"><b>Generate Google SiteMap</b></a> - Generate the Google SiteMap according to priorities and update frequencies that has been set for links.</p></li>
</ul>
];

$hbox = acs::get_heading_box("$web_url/ic_smap.gif", "Google SiteMaps Plugin", $dizbox);  

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
</body>
</html> 
];

}


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

