#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;


&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "configure") { &configure; }
if ($q->param('fct') eq "savesettings") { &savesettings; }
if ($q->param('fct') eq "instructions") { &instructions; }

####################################################################################

sub instructions
{

$fbcsettings = &get_file_contents("$data_dir/googlebutton.dat");  
@fbset = split (/\n/, $fbcsettings);


if ($fbset[0] eq "") 
	{

		$hbox = acs::get_heading_box("$web_url/ic_gplusone.png", "Google Plus One Button Plugin", "The PowerSeek Google Plus One Button Plugin needs to be configured. <a href='p_googlep.cgi?fct=configure'>Click Here to configure</a>");

		print qq[
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<title>Google Plus One Button Plugin</title>
		$HTML_ENCODING_USE
		<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
		</head>
		<body>
		$hbox
		</body>
		</html>
		];
		exit;
	}
	
	

$hbox = acs::get_heading_box("$web_url/ic_gplusone.png", "Google Plus One Button Plugin :: Implement Google Plus One Button", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Google Plus One Button</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox

<blockquote>
  <p><span class="normaltext"><strong>To enable the use of the Google Plus One button  on 'more info' pages, do the following steps:</strong></span></p>
  <p><strong>Step 1:</strong></p>
  <blockquote>
    <p>Go to the PowerSeek Control Panel &gt;&gt; Template Manager &gt;&gt; 1. Default Category/Directory Templates &gt;&gt; Click on <strong>Link Info</strong> and/or<strong> Link Info Premium</strong></p>
  </blockquote>
  <p><strong>Step 2:</strong></p>
  <blockquote>
    <p>Inside the 'more info' template (also called 'link info') place the following where you would like to display the Google Plus One button:</p>
    <blockquote>
      <p><strong>!!googleplusone!!</strong></p>
    </blockquote>
  </blockquote>
  <p><strong>Additional Notes: </strong></p>
  <ul class="normaltext">
    <li>It will be a good idea to place <strong>!!googleplusone!!</strong> in both the 'Link Info' template and 'Link Info Premium' template. The Link Info template is used for standard links and the Link Info Premium is used for premium links.</li>
    <li><strong>!!googleplusone!!</strong> will also work <a href="admin27.cgi" target="_blank">for custom template sets.</a></li>
  </ul>
  <p>&nbsp;</p>
</blockquote>
</body>
</html>
];

}





sub savesettings
{

open (FBCOM, "> $data_dir/googlebutton.dat");
	print FBCOM $q->param('plusone-size') . "\n";
	print FBCOM $q->param('plusone-annotation') . "\n";
	print FBCOM $q->param('fwidth') . "\n";
	print FBCOM $q->param('plusone-lang') . "\n";
close (FBCOM);

$hbox = acs::get_heading_box("$web_url/ic_gplusone.png", "Google Plus One Button Plugin :: Configuration Saved", "<a href='p_googlep.cgi'>Click Here to Continue</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Google Plus One Button</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}






sub configure
{

######################

$fbcsettings1 = &get_file_contents("$data_dir/googlebutton.dat");  
@fbcsettings = split (/\n/, $fbcsettings1);


#####################

$plusonesize = $fbcsettings[0];
if ($plusonesize eq "") {$plusonesize = "standard"; }

if ($plusonesize eq "small") 		{ $small_s = "checked"; }
if ($plusonesize eq "standard") 	{ $standard_s = "checked"; }
if ($plusonesize eq "medium") 	{ $medium_s = "checked"; }
if ($plusonesize eq "tall") 		{ $tall_s = "checked"; }

######################

$plusoneannotation = $fbcsettings[1];

if ($plusoneannotation eq "") { $plusoneannotation = "bubble"; }

if ($plusoneannotation eq "bubble") { $bubble_c = "selected"; }
if ($plusoneannotation eq "inline") { $inline_c = "selected"; }
if ($plusoneannotation eq "none") { $none_c = "selected"; }

#######################

$fwidth = $fbcsettings[2];
if ($fwidth eq "") { $fwidth = 450; }

#######################

$plusonelang = $fbcsettings[3];

if ($plusonelang eq "") { $plusonelang = "en-US"; }

if ($plusonelang eq "ar") { $langsel[0] = "selected"; }
if ($plusonelang eq "bg") { $langsel[1] = "selected"; }
if ($plusonelang eq "ca") { $langsel[2] = "selected"; }
if ($plusonelang eq "zh-CN") { $langsel[3] = "selected"; }
if ($plusonelang eq "zh-TW") { $langsel[4] = "selected"; }
if ($plusonelang eq "hr") { $langsel[5] = "selected"; }
if ($plusonelang eq "cs") { $langsel[6] = "selected"; }
if ($plusonelang eq "da") { $langsel[7] = "selected"; }
if ($plusonelang eq "nl") { $langsel[8] = "selected"; }
if ($plusonelang eq "en-US") { $langsel[9] = "selected"; }
if ($plusonelang eq "en-GB") { $langsel[10] = "selected"; }
if ($plusonelang eq "et") { $langsel[11] = "selected"; }

if ($plusonelang eq "fil") { $langsel[12] = "selected"; }
if ($plusonelang eq "fi") { $langsel[13] = "selected"; }
if ($plusonelang eq "fr") { $langsel[14] = "selected"; }
if ($plusonelang eq "de") { $langsel[15] = "selected"; }
if ($plusonelang eq "el") { $langsel[16] = "selected"; }
if ($plusonelang eq "iw") { $langsel[17] = "selected"; }
if ($plusonelang eq "hi") { $langsel[18] = "selected"; }
if ($plusonelang eq "hu") { $langsel[19] = "selected"; }
if ($plusonelang eq "id") { $langsel[20] = "selected"; }
if ($plusonelang eq "it") { $langsel[21] = "selected"; }
if ($plusonelang eq "ja") { $langsel[22] = "selected"; }

if ($plusonelang eq "ko") { $langsel[23] = "selected"; }
if ($plusonelang eq "lv") { $langsel[24] = "selected"; }
if ($plusonelang eq "lt") { $langsel[25] = "selected"; }
if ($plusonelang eq "ms") { $langsel[26] = "selected"; }
if ($plusonelang eq "no") { $langsel[27] = "selected"; }

if ($plusonelang eq "fa") { $langsel[28] = "selected"; }
if ($plusonelang eq "pl") { $langsel[29] = "selected"; }
if ($plusonelang eq "pt-BR") { $langsel[30] = "selected"; }
if ($plusonelang eq "pt-PT") { $langsel[31] = "selected"; }

if ($plusonelang eq "ro") { $langsel[32] = "selected"; }
if ($plusonelang eq "ru") { $langsel[33] = "selected"; }
if ($plusonelang eq "sr") { $langsel[34] = "selected"; }
if ($plusonelang eq "sv") { $langsel[35] = "selected"; }
if ($plusonelang eq "sk") { $langsel[36] = "selected"; }

if ($plusonelang eq "sl") { $langsel[37] = "selected"; }
if ($plusonelang eq "es") { $langsel[38] = "selected"; }
if ($plusonelang eq "es-419") { $langsel[39] = "selected"; }
if ($plusonelang eq "th") { $langsel[40] = "selected"; }
if ($plusonelang eq "tr") { $langsel[41] = "selected"; }

if ($plusonelang eq "uk") { $langsel[42] = "selected"; }
if ($plusonelang eq "vi") { $langsel[43] = "selected"; }


$hbox = acs::get_heading_box("$web_url/ic_gplusone.png", "Google Plus One Button Plugin :: Configure Google Plus One Buttons", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

$jser = acs::get_js_errors;

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Google Plus One Button</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

$jser

<script SRC="$web_url/qtip.js"></script>

<style type="text/css">
<!--
div#qTip {
 padding: 10px;
 border: 1px solid #DBDBDB;
 display: none;
 /*background: url("$web_url/tooltback.gif");*/
 background-color: #FFF;
 color: #000;
 font: 11px Arial, sans-serif;
 text-align: left;
 position: absolute;
 z-index: 1000;
}
-->
</style> 

</head>
<body>
$hbox

<form name="form1" method="post" action="p_googlep.cgi" onSubmit="return check_errors_blank('width::You have to provide a width');">
  <table width="93%" border="0" align="center" cellpadding="6" cellspacing="1">
   
    	$module_warning
        <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td width="27%" valign="top"><strong>Button Size: <img src="$web_url/est_help.gif" style="vertical-align:middle" onmouseover=" tooltip.show('<img src=\\'$web_url/googlebutton.png\\'>');" onmouseout="tooltip.hide();" /></strong></td>
          <td width="73%" valign="top"><div>
            <input id="plusone-size-small" name="plusone-size" value="small" type="radio" group="plusone-size" $small_s />
            <label for="plusone-size-small">Small (15px)</label>
            <br />
            <input id="plusone-size-standard" name="plusone-size" value="standard" type="radio" group="plusone-size" $standard_s />
            <label for="plusone-size-standard">Standard (24px)</label>
         
              <br />
              <input id="plusone-size-medium" name="plusone-size" value="medium" type="radio" group="plusone-size" $medium_s />
              <label for="plusone-size-medium">Medium (20px)</label>
              <br />
              <input id="plusone-size-tall" name="plusone-size" value="tall" type="radio" group="plusone-size" $tall_s />
              <label for="plusone-size-tall">Tall (60px)</label>
          </div></td>
        </tr>
        <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top"><strong>Annotation: </strong></td>
          <td valign="top">
          	<select name="plusone-annotation" id="plusone-annotation">
          	  <option $bubble_c value="bubble" >bubble</option>
          	  <option $inline_c value="inline">inline</option>
          	  <option $none_c value="none">none</option>
          	</select>
          	</td>
        </tr>
        <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top"><strong>Width in Pixels: </strong></td>
          <td valign="top"><input name="fwidth" type="text" id="fwidth" value="$fwidth" size="10" />
            <strong>PX</strong></td>
        </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
          <td valign="top"><strong>Language:</strong></td>
          <td valign="top"><select name="plusone-lang" id="plusone-lang">

<option value="ar">Arabic</option>
    <option $langsel[0] value="ar">Arabic</option>
	 <option $langsel[1] value="bg">Bulgarian</option>
	 <option $langsel[2] value="ca">Catalan</option>
	 <option $langsel[3] value="zh-CN">Chinese (Simplified)</option>
	 <option $langsel[4] value="zh-TW">Chinese (Traditional)</option>
	 <option $langsel[5] value="hr">Croatian</option>
	 <option $langsel[6] value="cs">Czech</option>
	 <option $langsel[7] value="da">Danish</option>
	 <option $langsel[8] value="nl">Dutch</option>
	 <option $langsel[9] value="en-US">English (US) - English &rlm;(US)</option>
	 <option $langsel[10] value="en-GB">English (UK) - English &rlm;(UK)</option>
	 <option $langsel[11] value="et">Estonian</option>
	 <option $langsel[12] value="fil">Filipino</option>
	 <option $langsel[13] value="fi">Finnish</option>
	 <option $langsel[14] value="fr">French</option>
	 <option $langsel[15] value="de">German</option>
	 <option $langsel[16] value="el">Greek</option>
	 <option $langsel[17] value="iw">Hebrew</option>
	 <option $langsel[18] value="hi">Hindi</option>
	 <option $langsel[19] value="hu">Hungarian</option>
	 <option $langsel[20] value="id">Indonesian</option>
	 
	 <option $langsel[21] value="it">Italian</option>
	 <option $langsel[22] value="ja">Japanese</option>
	 <option $langsel[23] value="ko">Korean</option>
	 <option $langsel[24] value="lv">Latvian</option>
	 <option $langsel[25] value="lt">Lithuanian</option>
	 <option $langsel[26] value="ms">Malay</option>
	 <option $langsel[27] value="no">Norwegian</option>
	 <option $langsel[28] value="fa">Persian</option>
	 <option $langsel[29] value="pl">Polish</option>
	 <option $langsel[30] value="pt-BR">Portuguese (Brazil)</option>
	 
	 <option $langsel[31] value="pt-PT">Portuguese (Portugal)</option>
	 <option $langsel[32] value="ro">Romanian</option>
	 <option $langsel[33] value="ru">Russian</option>
	 <option $langsel[34] value="sr">Serbian</option>
	 <option $langsel[35] value="sv">Swedish</option>
	 <option $langsel[36] value="sk">Slovak</option>
	 <option $langsel[37] value="sl">Slovenian</option>
	 <option $langsel[38] value="es">Spanish</option>
	 <option $langsel[39] value="es-419">Spanish (Latin America)</option>
	 <option $langsel[40] value="th">Thai</option>
	 
	 <option $langsel[41] value="tr">Turkish</option>
	 <option $langsel[42] value="uk">Ukrainian</option>
	 <option $langsel[43] value="vi">Vietnamese</option>
 </select></td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top">&nbsp;</td>
      <td valign="top"><input type="submit" class="psbutton" name="Save" id="Save" value="Save">
      <input name="fct" type="hidden" id="fct" value="savesettings" /></td>
    </tr>
  </table>
</form>
</body>
</html>

];

}




sub start
{

$hbox = acs::get_heading_box("$web_url/ic_gplusone.png", "Google Plus One Button Plugin", "Choose an option below");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Google Plus One Button</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox

<ul>
  <li><span class="normaltext"><a href="?fct=configure"><strong>Configure Google Plus One Button</strong></a><br>
  This section will let you configure the Google Plus One Button functionality.</span></li>
</ul>
<ul>
  <li><strong><span class="normaltext"><a href="?fct=instructions">Implement Google Plus One Buttons</a></span></strong><span class="normaltext"><br>
    Instructions on how to place the Google Plus One button on 'more info' pages.</span></li></ul>
    
</body>
</html>
];
 


}






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


