#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Google SiteMaps Plugin
# DIZ: Enables you to edit Google SiteMap settings and SiteMap settings regarding categories and links.
# GRAPHIC: ic_smap.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "conf") { &conf; }
if ($q->param('fct') eq "addfields") { &addfields; }
if ($q->param('fct') eq "addfields2") { &addfields2; }
if ($q->param('fct') eq "implement") { &implement; }
if ($q->param('fct') eq "settings") { &settings; }
if ($q->param('fct') eq "savesettings") { &savesettings; }


##################################################################################

sub savesettings
{

$infowindowcontents = $q->param('infowindowcontents');

$infowindowcontents =~ s/\n//gi;
$crit = chr(10); $infowindowcontents =~ s/$crit//g;
$crit = chr(13); $infowindowcontents =~ s/$crit//g;  

open (GMPS, "> $data_dir/gmapsettings.dat");
	print GMPS $q->param('zoomlevel') . "\n";
	print GMPS $q->param('mapwidth') . "\n";
	print GMPS $q->param('mapheight') . "\n";
	print GMPS $q->param('borderwidth') . "\n";	
	print GMPS $q->param('bordercolor') . "\n";		
	print GMPS $q->param('displayinfowindow') . "\n";		
	print GMPS $infowindowcontents . "\n";		
close (GMPS);

$hbox = acs::get_heading_box("$web_url/ics_googlemap.gif", "Google Maps :: Google Map Settings", "Settings Saved");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<script type="text/javascript" src="$web_url/jscolor.js"></script>
</head>
<body>
$hbox 

<blockquote>
<a href="p_map.cgi" class="normaltext">Click Here to Continue</a>
</blockquote>

</body>
</html>
];


}



sub settings
{

$gmapdata = &get_file_contents("$data_dir/gmapsettings.dat"); 

@gmapsettings = split (/\n/, $gmapdata);

$zoomlevel = $gmapsettings[0];
$mapwidth = $gmapsettings[1];
$mapheight = $gmapsettings[2];
$borderwidth = $gmapsettings[3];
$bordercolor = $gmapsettings[4];
$displayinfowindow = $gmapsettings[5];
$infowindowcontents = $gmapsettings[6];


if (($displayinfowindow eq "") and ($zoomlevel eq ""))  { $displayinfowindow = "Y"; }

if ($displayinfowindow eq "Y") { $checked = "checked"; }

if ($zoomlevel < 1) { $zoomlevel = "12"; }
if ($mapwidth < 1) { $mapwidth = "400"; }
if ($mapheight < 1) { $mapheight = "400"; }
if ($borderwidth < 1) { $borderwidth = "5"; }

if ($bordercolor eq "")	 { $bordercolor = "#CCCCCC"; }

if ($infowindowcontents eq "") { $infowindowcontents = qq[<span class="normaltext"><strong>!!title_without_link!!</strong><br>!!description!!</span>]; }



$hbox = acs::get_heading_box("$web_url/ics_googlemap.gif", "Google Maps :: Google Map Settings", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<script type="text/javascript" src="$web_url/jscolor.js"></script>
</head>
<body>
$hbox 

<form name="form1" method="post" action="">
  <table width="93%" border="0" align="center" cellpadding="6" cellspacing="1">
    <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td><strong><span class="normaltext">Zoom Level of the Map:</span></strong></td>
      <td><span class="normaltext">
        <input name="zoomlevel" type="text" id="zoomlevel" value="$zoomlevel" size="5"> 
        (Valid values are from 1 to 21 where level 1 represents a view of the whole world)</span></td>
    </tr>
    <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td width="22%"><strong><span class="normaltext">Width of the Map: </span></strong></td>
      <td width="78%"><span class="normaltext">
        <input name="mapwidth" type="text" id="mapwidth" value="$mapwidth" size="5"> 
        pixels</span></td>
    </tr>
    <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td><strong><span class="normaltext">Height of Map:</span></strong></td>
      <td><span class="normaltext">
        <input name="mapheight" type="text" id="mapheight" value="$mapheight" size="5">        
      pixels</span></td>
    </tr>
    <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td><strong><span class="normaltext">Border Width:</span></strong></td>
      <td><span class="normaltext">
        <input name="borderwidth" type="text" id="borderwidth" value="$borderwidth" size="5">
      pixels (specify 0 for no border around map)</span></td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td><strong>Border Color:</strong></td>
      <td><input name="bordercolor" type="text" class="color" id="bordercolor" value="$bordercolor" size="5" /></td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td><strong>Display Info Window?</strong></td>
      <td><input name="displayinfowindow" type="checkbox" id="yes" value="Y" $checked> 
        (If checked then an info window will be displayed above the marker on the map)</td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top"><strong> Contents of Info Window: <br>
      </strong>You may use HTML and the <a href="admin78.cgi?fct=explain&t=linkinfo&body=true" target="_blank">following variables</a> are available for use in the info window.</td>
      <td valign="top"><textarea name="infowindowcontents" id="infowindowcontents" cols="45" rows="5" style="width:100%">$infowindowcontents</textarea></td>
    </tr>
    <tr class="normaltext" onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
      <td valign="top">&nbsp;</td>
      <td valign="top"><input type="submit" class="psbutton" name="Save" id="Save" value="Save Settings">
      <input name="fct" type="hidden" id="fct" value="savesettings" /></td>
    </tr>
  </table>
</form>

</body>
</html>
];


}



sub implement
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SHOW COLUMNS FROM links";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}

$found_latlon = "";

while ( @row = $sth->fetchrow() )
	{
		if ($row[0] eq "pslat_cust")
			{
			$found_latlon = "Y";
			}
	} 

$sth->finish;
$dbh->disconnect;

if ($found_latlon eq "Y")
	{


		$hbox = acs::get_heading_box("$web_url/ics_googlemap.gif", "Google Maps :: Implement Google Maps", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

		print qq[
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
					<html xmlns="http://www.w3.org/1999/xhtml">
					<head>
					<title>PowerSeek</title>
					$HTML_ENCODING_USE
					<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
					</head>
					<body>
					$hbox 
			
								<span class="normaltext">
								<blockquote>
								  <p><strong>Step 1: How to display a Google Map on 'More Info' pages:</strong></p>
								  <blockquote>
									 <p> A google map will only display on a 'more info' page if the listing has a <strong>latitude</strong> and <strong>longitude</strong>. If you don't have any listings with <strong>latitudes</strong> and <strong>longitude</strong>s then go to the PowerSeek Control Panel &gt;&gt; Dir Manager &gt;&gt; Edit listings from here to add coordinates.</p>
									 <p>		        Go to the Control Panel &gt;&gt; Template Manager &gt;&gt; 1. Default Category/Directory Templates &gt;&gt; Link Info</p>
									 <p>When clicking on 'Link Info' a popup window will apear where you can edit the 'Link Info' (also referred to as 'more info') template.</p>
									 <p>In this template place the word !!googlemap!! where you would like the google map to display.</p>
									 <p>After you placed !!googlemap!! inside the template a google map will now be displayed for listings on the 'more info' pages. Note that if listings don't have coordinates then the map won't be displayed on the 'more info' pages.</p>
								    <p><strong>Other Notes:</strong></p>
									 <p> !!googlemap!! will also work in the 'more info' templates of <strong>Custom Category/Directory Template Sets</strong></p>
								  </blockquote>
								  <p><strong>Step 2: Let users specify google map coordinates when submitting and modifying listings:</strong></p>
								  <blockquote>
								    <p><strong>1.</strong> Go to the PowerSeek control panel &gt;&gt; <a href="admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; 3. Add URL Templates &gt;&gt; Scroll down to the section reading: User Registration System Add URL Templates &gt;&gt; Click on the Add URL template links to edit the Add URL templates being used. (standard and/or premium)</p>
								    <p>Add the following to the add url templates:  (standard and/or premium)</p>
								    <blockquote>
								      <p><strong>Latitude: &lt;input type="text" name="pslat" size="20" value="!!pslat!!"&gt;<br />
								        Longitude: 
								      </strong>				        <strong>&lt;input type=&quot;text&quot; name=&quot;pslon&quot; size=&quot;20&quot; value=&quot;!!pslon!!&quot;&gt;</strong></p>
								    </blockquote>
							        <p><strong>2.</strong> Now, go to the PowerSeek control panel &gt;&gt; <a href="admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; 3. Add URL Templates &gt;&gt;  Scroll down to the section reading: User Registration System Add URL Templates &gt;&gt; <strong><em>Click on the 'Modify/Edit Link Standard' and/or click on the 'Modify/Edit Link Premium' links to edit the modify templates.</em></strong><em></em></p>
							        <p>Add the following to the modify templates (standard and/or premium)</p>
							        <blockquote>
							          <p><strong>Latitude: &lt;input type=&quot;text&quot; name=&quot;pslat&quot; size=&quot;20&quot; value=&quot;!!pslat!!&quot;&gt;<br />
			Longitude: </strong> <strong>&lt;input type=&quot;text&quot; name=&quot;pslon&quot; size=&quot;20&quot; value=&quot;!!pslon!!&quot;&gt;</strong></p>
						            </blockquote>
								  </blockquote>
								  <p>&nbsp;</p>
								</blockquote>
								</span>
			
			</body>
		</html>
		];
	
	
	}
	else
	{

		$hbox = acs::get_heading_box("$web_url/ics_googlemap.gif", "Google Maps :: Implement Google Maps", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

		print qq[
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<title>PowerSeek</title>
		$HTML_ENCODING_USE
		<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
		</head>
		<body>
		$hbox 

			<span class="normaltext">
								<blockquote>
								  <p><strong>You first need to 'configure' this plugin to work with Google Maps.</strong></p>
								  <p><strong><a href="?fct=conf">Click Here to configure this plugin</a></strong></p>
								  <p>&nbsp;</p>
			</blockquote>
		</span>

		</body>
		</html>
		];
			
		
	}







}




sub addfields2
{

#### Add latitude and longitude extra field

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
 # pslat_cust float(13,10)

$sql_crit = "ALTER TABLE links ADD pslat_cust float(13,10)";
$sth = $dbh->prepare($sql_crit);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}
 
$sql_crit = "ALTER TABLE links ADD pslon_cust float(13,10)";
$sth = $dbh->prepare($sql_crit);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}

$sql_crit = "ALTER TABLE modified ADD pslat_cust float(13,10)";
$sth = $dbh->prepare($sql_crit);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}
 
$sql_crit = "ALTER TABLE modified ADD pslon_cust float(13,10)";
$sth = $dbh->prepare($sql_crit);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}


$sth->finish;
$dbh->disconnect;

open (KDT, ">> $data_dir/keys.dat");
	print KDT 	"pslat" . "\t" . 
					"Yes" . "\t" . 
					"13" . "\t" . 
					"No" . "\t" . 
					"Latitude" . "\t" . 
					"" . "\t" . 
					"No" . "\n";

	print KDT 	"pslon" . "\t" . 
					"Yes" . "\t" . 
					"13" . "\t" . 
					"No" . "\t" . 
					"Longitude" . "\t" . 
					"" . "\t" . 
					"No" . "\n";
close (KDT);

$hbox = acs::get_heading_box("$web_url/ics_googlemap.gif", "Google Maps :: Configuration", "Date Fields created");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox 

<span class="normaltext">
<blockquote>
	<p>Data Fields Created. <a href="p_map.cgi">Click Here to continue.</a></p>
</blockquote>
</span>

</body>
</html>
];

}





sub addfields
{

$hbox = acs::get_heading_box("$web_url/ics_googlemap.gif", "Google Maps :: Configuration :: Adding Extra Fields", "Please Wait...");

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=p_map.cgi?fct=addfields2"> 
</head>
<body>
$hbox 
<img src="$web_url/working.gif">
</body>
</html>
];


}





sub conf
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SHOW COLUMNS FROM links";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}

$found_latlon = "";

while ( @row = $sth->fetchrow() )
	{
		if ($row[0] eq "pslat_cust")
			{
			$found_latlon = "Y";
			}
	} 

$sth->finish;
$dbh->disconnect;


######################################################

if ($found_latlon eq "Y")
	{
		$hbox = acs::get_heading_box("$web_url/ics_googlemap.gif", "Google Maps :: Configuration", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

			print qq[
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title>PowerSeek</title>
			$HTML_ENCODING_USE
			<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
			</head>
			<body>
			$hbox 

			<span class="normaltext">
			<blockquote>
			  <p>The plugin has already been configured.</p>
		    <p><strong><a href='' onClick='history.go(-1); return false;'>Go Back</a></strong></p></blockquote>
		    </span>

			</body>
			</html>
			]; 
	
	}
	else
	{
		$hbox = acs::get_heading_box("$web_url/ics_googlemap.gif", "Google Maps :: Configuration", "<a href='' onClick='history.go(-1); return false;'>Go Back</a>");

			print qq[
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
			<title>PowerSeek</title>
			$HTML_ENCODING_USE
			<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
			</head>
			<body>
			$hbox 

			<span class="normaltext">
			<blockquote>
			  <p>To be able to display a Google Map on the 'more info' pages of listings, each listing requires a <strong>latitude</strong> and <strong>longitude. </strong></p>
			  <p>    Click the<strong> 'Add latitude and longitude extra fields' </strong>button below and these extra data-fields will be added for each listing so that a latitude and longitude can be entered for each listing.</p>
			  <form id="form1" name="form1" method="post" action="">

					<input type="submit" class="psbutton" name="addfields" id="addfields" value="Add latitude and longitude extra fields" />

				 <input name="fct" type="hidden" id="fct" value="addfields" />
			  </form>
			  <p><strong>More notes:</strong></p>
			  <p>When you click the button above  latitude and longitude extra fields will be created for each listing in the database. When adding or editing a listing you will then be able to add a latitude and longitude.</p></blockquote>

			 </span>

			</body>
			</html>
			]; 
	}


 
}





sub start
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SHOW COLUMNS FROM links";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql_crit";}

$found_latlon = "";

while ( @row = $sth->fetchrow() )
	{
		if ($row[0] eq "pslat_cust")
			{
			$found_latlon = "Y";
			}
	} 

$sth->finish;
$dbh->disconnect;

if ($found_latlon eq "Y")
	{
		$confd = qq[
		<ul>
			  <li><strong><a href="?fct=conf">Configuration</a></strong> (Already Configured)<br>
				 This option allows you to configure the way Google Maps is going to work like.</li>
			</ul>
		];
	}
	else
	{
		$confd = qq[
			<ul>
			  <li><strong><a href="?fct=conf">Configuration</a></strong><br>
				 This option allows you to configure the way Google Maps is going to work like.</li>
			</ul>
		];
	}


$hbox = acs::get_heading_box("$web_url/ics_googlemap.gif", "Google Maps", "This plugin allows you to add a google map to the 'more info' pages of listings.");

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox 


<span class="normaltext">
$confd
	
	<ul>
	  <li><strong><a href="?fct=implement">Implement Google Maps</a></strong><br>
	  Display a Map on the 'more info' pages of listings.</li>
	</ul>
	<ul>
	  <li><strong><a href="?fct=settings">Google Map Settings</a></strong><br>
	  Change various settings regarding the map that will be displayed. </li>
	</ul>
	
</span>


</body>
</html>
];

}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################


