#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Text/HTML Add Manager
# DIZ: Allows you to target text/HTML advertisements at specified categories.
# GRAPHIC: ic_sql.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use Time::Local;  

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "group_operations") { &group_operations; }
if ($q->param('fct') eq "add_group_final") { &add_group_final; }
if ($q->param('fct') eq "save_group") { &save_group; }

if ($q->param('fct') eq "advert_group_operations") { &advert_group_operations; }
if ($q->param('fct') eq "add_new_advert_final") { &add_new_advert_final; }
if ($q->param('fct') eq "save_advert") { &save_advert; }

if ($q->param('fct') eq "advert_stats") { &stats_advert; }
if ($q->param('fct') eq "group_stats") { &group_stats; }
if ($q->param('fct') eq "set_defaultadv") { &set_defaultadv; }



sub advert_group_operations
{
if ($q->param('add_b') eq 'Add New Advert') { &add_new_advert; exit; }
if ($q->param('faction') eq 'edit_advert') { &edit_advert; exit; }
if ($q->param('faction') eq 'delete_advert') { &delete_advert; exit; }
if ($q->param('faction') eq 'stats_advert') { &stats_advert; exit; }
if ($q->param('faction') eq 'reset_stats_advert') { &reset_stats_advert; exit; }

}


sub group_operations
{
if ($q->param('set_default') ne "") { &set_default_grp; exit; }
if ($q->param('fct2') eq "editadverts") { &edit_group_adds; exit; }
if ($q->param('add_bgroup') eq "Add New Advert Group") { &add_new_group; exit; }
if (($q->param('add2') eq "   Go   ") and ($q->param('faction') eq "edit_group_properties")) { &edit_group; exit; }
if (($q->param('add2') eq "   Go   ") and ($q->param('faction') eq "delete")) { &del_group; exit; }
if (($q->param('add2') eq "   Go   ") and ($q->param('faction') eq "Edit")) { &edit_group_adds; exit; }
if (($q->param('add2') eq "   Go   ") and ($q->param('faction') eq "get_html_code")) { &get_html_code; exit; }
if (($q->param('add2') eq "   Go   ") and ($q->param('faction') eq "statistics")) { &group_stats; exit; }
if (($q->param('add2') eq "   Go   ") and ($q->param('faction') eq "reset")) { &group_reset; exit; }
if (($q->param('add2') eq "   Go   ") and ($q->param('faction') eq "usage")) { &usage_report; exit; }
}


sub usage_report
{

$bgroup = $q->param('group');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT * FROM advertgrp WHERE groupid = '$bgroup'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

while ( @row = $sth->fetchrow() )
	{
	$groupname = $row[1];
	}


$selectcrit = $groupname . "-" . $bgroup . "-" . "A";

$sql = "SELECT * FROM dirs WHERE (addslot1 = '$selectcrit') or (addslot2 = '$selectcrit') or  (addslot3 = '$selectcrit') or  (addslot4 = '$selectcrit') or  (addslot5 = '$selectcrit') 
											ORDER BY cid ASC";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

while ( @row = $sth->fetchrow() )
	{
	$cats = "";
	for ($ms = 2; $ms < 18; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$cats = $cats . $row[$ms] . "/";
			}
		}
	$categories = $categories . $cats . "<BR>";
	}
	
$sth->finish;
$dbh->disconnect;

if ($categories eq "") { $categories = "This group of Adverts are not in use in any category."; }

########

$boxdiz = qq[
Displaying the categories where Advert group <b>$groupname</b> is in use. You can assign Advert Groups to be rotated in specific categories. See the PowerSeek documentation for information on targeting Advert groups at categories for more information.<BR>
<a href="$admin_url/p_tadd.cgi"><b>Go Back</b></a>
];

$hbox = acs::get_heading_box("$web_url/ic_banner2.gif", "Advert Group Usage Report", $boxdiz);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
<blockquote>
<p>$categories</p>
</blockquote>
</body>
</html>
];

}



sub set_defaultadv
{

$defgroup = $q->param('defgroup');

open (DTAA, "> $data_dir/defadvert.dat");
	print DTAA $defgroup;
close (DTAA);

$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Default Advert Group Configured", qq[<b><a href="$admin_url/p_tadd.cgi">Click Here to Continue</a></b>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
$selbox
</body>
</html>
];




}




sub set_default_grp
{

$defadd = acs::get_file_contents("$data_dir/defadvert.dat"); 


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "SELECT * FROM advertgrp ORDER BY groupname";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

while ( @row = $sth->fetchrow() ) 
	{
	if ($defadd eq "$row[0]-$row[1]") { $selo = "selected"; } else { $selo = ""; } 
	
	$sel_option = $sel_option . qq[<option value="$row[0]-$row[1]" $selo>$row[1]</option>];
	}

$selbox = qq[<form method="POST" action="$admin_url/p_tadd.cgi">
<input type="hidden" name="fct" value="set_defaultadv">
<select name="defgroup" size="1">
<option value="">None</option>
$sel_option
</select>
<input type="submit" class="psbutton" name="defbutton" id="defbutton" value="Set Default Advert Group">
</form>
];




$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Set Default Advert Group", qq[This group of Adverts will be rotated in the event where an Advert group reached it's expiry date or maximum impressions.<br><b><a href="$admin_url/p_tadd.cgi">Go Back</a></b>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
$selbox
</body>
</html>
];

}



sub group_reset
{

$gid = $q->param('group');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "DELETE FROM adlogs WHERE groupid = '$gid'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

$sth->finish;
$dbh->disconnect;

$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "The Statistics have been reset", qq[<a href="$admin_url/p_tadd.cgi">Click Here to Continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}



sub reset_stats_advert
{

$aid = $q->param('adid');
$gid = $q->param('gid');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "SELECT * FROM adverts WHERE aid = '$aid'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

while ( @row = $sth->fetchrow() ) 
	{
	$adname = $row[2];
	}


$sql = "DELETE FROM adlogs WHERE aid = '$aid'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 


$sth->finish;
$dbh->disconnect;

$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "The Statistics For: $adname have been reset", qq[<a href="$admin_url/p_tadd.cgi?group=$gid&faction=Edit&fct=group_operations&fct2=editadverts">Click Here to Continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}



sub group_stats
{

$gid = $q->param('group');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "SELECT * FROM advertgrp WHERE groupid = '$gid'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

while ( @row = $sth->fetchrow() ) 
	{
	$bgroup = $row[1];
	$maximp = $row[2];
	$expirdate = $row[3];
	}

$ogroup = $bgroup;

$s_from_day = $q->param('from_day');
$s_from_month = $q->param('from_month');
$s_from_year = $q->param('from_year');

$s_to_day = $q->param('to_day');
$s_to_month = $q->param('to_month');
$s_to_year = $q->param('to_year');


### PREPARE DATE BOXES FOR STARTUP

if (($s_to_day eq "") and ($s_to_month eq "") and ($s_to_year eq ""))
{

($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
$year = $year + 1900;

$start_day[$mday -1] = "selected";
$start_month[$mon] = "selected";

if ($year eq "2010") { $start_year[0] = "selected"; }
if ($year eq "2011") { $start_year[1] = "selected"; }
if ($year eq "2012") { $start_year[2] = "selected"; }
if ($year eq "2013") { $start_year[3] = "selected"; }
if ($year eq "2014") { $start_year[4] = "selected"; }
if ($year eq "2015") { $start_year[5] = "selected"; }
if ($year eq "2016") { $start_year[6] = "selected"; }
if ($year eq "2017") { $start_year[7] = "selected"; }
if ($year eq "2018") { $start_year[8] = "selected"; }
if ($year eq "2019") { $start_year[9] = "selected"; }
if ($year eq "2020") { $start_year[10] = "selected"; }


$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Advert Group Statistics", qq[<b><a href="$admin_url/p_tadd.cgi">Advert Groups</a> >> <a href="$admin_url/p_tadd.cgi?group=$gid&faction=Edit&fct=group_operations&fct2=editadverts">$bgroup</a> >> Group Statistics</b>]);

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>
$hbox

<form method="POST" action="$admin_url/p_tadd.cgi">
  <input type="hidden" name="fct" value="group_stats">
  <input type="hidden" name="group" value="$gid">
  
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="780" colspan="2" background="$web_url/bar7.gif" class="normaltext"><strong>Advert 
      Group Statistics</strong></td>
    </tr>
    <tr>
      <td width="766" colspan="2" bgcolor="#F4F4F4" class="normaltext">Choose a date range below
      to display statistics:</td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext">From Date: </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><select name="from_day" size="1">
        <option value="1" selected> 1 </option>
        <option value="2"> 2 </option>
        <option value="3"> 3 </option>
        <option value="4"> 4 </option>
        <option value="5"> 5 </option>
        <option value="6"> 6 </option>
        <option value="7"> 7 </option>
        <option value="8"> 8 </option>
        <option value="9"> 9 </option>
        <option value="10"> 10 </option>
        <option value="11"> 11 </option>
        <option value="12"> 12 </option>
        <option value="13"> 13 </option>
        <option value="14"> 14 </option>
        <option value="15"> 15 </option>
        <option value="16"> 16 </option>
        <option value="17"> 17 </option>
        <option value="18"> 18 </option>
        <option value="19"> 19 </option>
        <option value="20"> 20 </option>
        <option value="21"> 21 </option>
        <option value="22"> 22 </option>
        <option value="23"> 23 </option>
        <option value="24"> 24 </option>
        <option value="25"> 25 </option>
        <option value="26"> 26 </option>
        <option value="27"> 27 </option>
        <option value="28"> 28 </option>
        <option value="29"> 29 </option>
        <option value="30"> 30 </option>
        <option value="31"> 31 </option>
      </select> <select name="from_month" size="1">
        <option $start_month[0] value="1"> January </option>
        <option $start_month[1] value="2"> February </option>
        <option $start_month[2] value="3"> March </option>
        <option $start_month[3] value="4"> April </option>
        <option $start_month[4] value="5"> May </option>
        <option $start_month[5] value="6"> June </option>
        <option $start_month[6] value="7"> July </option>
        <option $start_month[7] value="8"> August </option>
        <option $start_month[8] value="9"> September </option>
        <option $start_month[9] value="10"> October </option>
        <option $start_month[10] value="11"> November </option>
        <option $start_month[11] value="12"> December </option>
      </select> <select name="from_year" size="1">
        <option $start_year[0] value="2010"> 2010 </option>
        <option $start_year[1] value="2011"> 2011 </option>
        <option $start_year[2] value="2012"> 2012 </option>
        <option $start_year[3] value="2013"> 2013 </option>
        <option $start_year[4] value="2014"> 2014 </option>
        <option $start_year[5] value="2015"> 2015 </option>
        <option $start_year[6] value="2016"> 2016 </option>
        <option $start_year[7] value="2017"> 2017 </option>
        <option $start_year[8] value="2018"> 2018 </option>
        <option $start_year[9] value="2019"> 2019 </option>
        <option $start_year[10] value="2020"> 2020 </option>
        
        
      </select></td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext">To Date:&nbsp; </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><select name="to_day" size="1">
        <option $start_day[0] value="1"> 1 </option>
        <option $start_day[1] value="2"> 2 </option>
        <option $start_day[2] value="3"> 3 </option>
        <option $start_day[3] value="4"> 4 </option>
        <option $start_day[4] value="5"> 5 </option>
        <option $start_day[5] value="6"> 6 </option>
        <option $start_day[6] value="7"> 7 </option>
        <option $start_day[7] value="8"> 8 </option>
        <option $start_day[8] value="9"> 9 </option>
        <option $start_day[9] value="10"> 10 </option>
        <option $start_day[10] value="11"> 11 </option>
        <option $start_day[11] value="12"> 12 </option>
        <option $start_day[12] value="13"> 13 </option>
        <option $start_day[13] value="14"> 14 </option>
        <option $start_day[14] value="15"> 15 </option>
        <option $start_day[15] value="16"> 16 </option>
        <option $start_day[16] value="17"> 17 </option>
        <option $start_day[17] value="18"> 18 </option>
        <option $start_day[18] value="19"> 19 </option>
        <option $start_day[19] value="20"> 20 </option>
        <option $start_day[20] value="21"> 21 </option>
        <option $start_day[21] value="22"> 22 </option>
        <option $start_day[22] value="23"> 23 </option>
        <option $start_day[23] value="24"> 24 </option>
        <option $start_day[24] value="25"> 25 </option>
        <option $start_day[25] value="26"> 26 </option>
        <option $start_day[26] value="27"> 27 </option>
        <option $start_day[27] value="28"> 28 </option>
        <option $start_day[28] value="29"> 29 </option>
        <option $start_day[29] value="30"> 30 </option>
        <option $start_day[30] value="31"> 31 </option>
      </select> <select name="to_month" size="1">
        <option $start_month[0] value="1"> January </option>
        <option $start_month[1] value="2"> February </option>
        <option $start_month[2] value="3"> March </option>
        <option $start_month[3] value="4"> April </option>
        <option $start_month[4] value="5"> May </option>
        <option $start_month[5] value="6"> June </option>
        <option $start_month[6] value="7"> July </option>
        <option $start_month[7] value="8"> August </option>
        <option $start_month[8] value="9"> September </option>
        <option $start_month[9] value="10"> October </option>
        <option $start_month[10] value="11"> November </option>
        <option $start_month[11] value="12"> December </option>
      </select> <select name="to_year" size="1">
        <option $start_year[0] value="2010"> 2010 </option>
        <option $start_year[1] value="2011"> 2011 </option>
        <option $start_year[2] value="2012"> 2012 </option>
        <option $start_year[3] value="2013"> 2013 </option>
        <option $start_year[4] value="2014"> 2014 </option>
        <option $start_year[5] value="2015"> 2015 </option>
        <option $start_year[6] value="2016"> 2016 </option>
        <option $start_year[7] value="2017"> 2017 </option>
        <option $start_year[8] value="2018"> 2018 </option>
        <option $start_year[9] value="2019"> 2019 </option>
        <option $start_year[10] value="2010"> 2020 </option>
      </select></td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="   Get Statistics   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
</body>
</html>
];

exit;

}


### GET DATE BOXES


$s_from_day = $q->param('from_day'); $ar_from_day[$s_from_day] = "selected";
$s_from_month = $q->param('from_month'); $ar_from_month[$s_from_month] = "selected";
$s_from_year = $q->param('from_year'); 


if ($s_from_year eq "2010") { $start_year[0] = "selected"; }
if ($s_from_year eq "2011") { $start_year[1] = "selected"; }
if ($s_from_year eq "2012") { $start_year[2] = "selected"; }
if ($s_from_year eq "2013") { $start_year[3] = "selected"; }
if ($s_from_year eq "2014") { $start_year[4] = "selected"; }
if ($s_from_year eq "2015") { $start_year[5] = "selected"; }
if ($s_from_year eq "2016") { $start_year[6] = "selected"; }
if ($s_from_year eq "2017") { $start_year[7] = "selected"; }
if ($s_from_year eq "2018") { $start_year[8] = "selected"; }
if ($s_from_year eq "2019") { $start_year[9] = "selected"; }
if ($s_from_year eq "2020") { $start_year[10] = "selected"; }


$s_to_day = $q->param('to_day'); $ar_to_day[$s_to_day] = "selected";
$s_to_month = $q->param('to_month'); $ar_to_month[$s_to_month] = "selected";
$s_to_year = $q->param('to_year');

if ($s_to_year eq "2010") { $end_year[0] = "selected"; }
if ($s_to_year eq "2011") { $end_year[1] = "selected"; }
if ($s_to_year eq "2012") { $end_year[2] = "selected"; }
if ($s_to_year eq "2013") { $end_year[3] = "selected"; }
if ($s_to_year eq "2014") { $end_year[4] = "selected"; }
if ($s_to_year eq "2015") { $end_year[5] = "selected"; }
if ($s_to_year eq "2016") { $end_year[6] = "selected"; }
if ($s_to_year eq "2017") { $end_year[7] = "selected"; }
if ($s_to_year eq "2018") { $end_year[8] = "selected"; }
if ($s_to_year eq "2019") { $end_year[9] = "selected"; }
if ($s_to_year eq "2020") { $end_year[10] = "selected"; }


$sql_start_date = "$s_from_year-$s_from_month-$s_from_day";
$sql_end_date = "$s_to_year-$s_to_month-$s_to_day";


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT adate, aid, impressions, clicks FROM adlogs WHERE 	(groupid = '$gid') 
																					 AND 	(adate >= '$sql_start_date') AND
																					 		(adate <= '$sql_end_date')
		  ORDER BY adate";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}

$stat_cnt = 0;
while ( @row = $sth->fetchrow() )
	{
	if ($current_date ne $row[0])
		{
		$current_date = $row[0];
		$statline[$stat_cnt] = $row[0] . ":" . $row[2] . ":" . $row[3];
		$stat_cnt++;

		if ($row[2] > $high_imp) {$high_imp = $row[2];}
		if ($row[3] > $high_clicks) {$high_clicks = $row[3];}		
		}
		else
		{
		($statdate, $impressions, $clicks) = split (/:/, $statline[$stat_cnt - 1]);
			$impressions = $impressions + $row[2];
			$clicks = $clicks + $row[3];
		$statline[$stat_cnt -1] = $statdate . ":" . $impressions . ":" . $clicks;

		if ($impressions > $high_imp) {$high_imp = $impressions;}
		if ($clicks > $high_clicks) {$high_clicks = $clicks;}				
		}
	
	}

	
$sth->finish;
$dbh->disconnect;

#################


$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Advert Group Statistics", qq[<b><a href="$admin_url/p_tadd.cgi">Advert Groups</a> >> <a href="$admin_url/p_tadd.cgi?group=$gid&faction=Edit&fct=group_operations&fct2=editadverts">$bgroup</a> >> Group Statistics</b>]);




print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
<form method="POST" action="$admin_url/p_tadd.cgi">
  <input type="hidden" name="fct" value="group_stats">
  <input type="hidden" name="group" value="$gid">
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="780"  colspan="2" background="$web_url/bar7.gif" class="normaltext"><strong>Advert 
      Group Statistics</strong></td>
    </tr>
    <tr>
      <td width="766" colspan="2" bgcolor="#F4F4F4" class="normaltext">Choose a date range below
      to display statistics:</td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext">From Date: </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><select name="from_day" size="1">
        <option value="1" $ar_from_day[1]> 1 </option>
        <option value="2" $ar_from_day[2]> 2 </option>
        <option value="3" $ar_from_day[3]> 3 </option>
        <option value="4" $ar_from_day[4]> 4 </option>
        <option value="5" $ar_from_day[5]> 5 </option>
        <option value="6" $ar_from_day[6]> 6 </option>
        <option value="7" $ar_from_day[7]> 7 </option>
        <option value="8" $ar_from_day[8]> 8 </option>
        <option value="9" $ar_from_day[9]> 9 </option>
        <option value="10" $ar_from_day[10]> 10 </option>
        <option value="11" $ar_from_day[11]> 11 </option>
        <option value="12" $ar_from_day[12]> 12 </option>
        <option value="13" $ar_from_day[13]> 13 </option>
        <option value="14" $ar_from_day[14]> 14 </option>
        <option value="15" $ar_from_day[15]> 15 </option>
        <option value="16" $ar_from_day[16]> 16 </option>
        <option value="17" $ar_from_day[17]> 17 </option>
        <option value="18" $ar_from_day[18]> 18 </option>
        <option value="19" $ar_from_day[19]> 19 </option>
        <option value="20" $ar_from_day[20]> 20 </option>
        <option value="21" $ar_from_day[21]> 21 </option>
        <option value="22" $ar_from_day[22]> 22 </option>
        <option value="23" $ar_from_day[23]> 23 </option>
        <option value="24" $ar_from_day[24]> 24 </option>
        <option value="25" $ar_from_day[25]> 25 </option>
        <option value="26" $ar_from_day[26]> 26 </option>
        <option value="27" $ar_from_day[27]> 27 </option>
        <option value="28" $ar_from_day[28]> 28 </option>
        <option value="29" $ar_from_day[29]> 29 </option>
        <option value="30" $ar_from_day[30]> 30 </option>
        <option value="31" $ar_from_day[31]> 31 </option>
      </select> <select name="from_month" size="1">
        <option $ar_from_month[1] value="1"> January </option>
        <option $ar_from_month[2] value="2"> February </option>
        <option $ar_from_month[3] value="3"> March </option>
        <option $ar_from_month[4] value="4"> April </option>
        <option $ar_from_month[5] value="5"> May </option>
        <option $ar_from_month[6] value="6"> June </option>
        <option $ar_from_month[7] value="7"> July </option>
        <option $ar_from_month[8] value="8"> August </option>
        <option $ar_from_month[9] value="9"> September </option>
        <option $ar_from_month[10] value="10"> October </option>
        <option $ar_from_month[11] value="11"> November </option>
        <option $ar_from_month[12] value="12"> December </option>
      </select> <select name="from_year" size="1">
        <option $start_year[0] value="2010"> 2010 </option>
        <option $start_year[1] value="2011"> 2011 </option>
        <option $start_year[2] value="2012"> 2012 </option>
        <option $start_year[3] value="2013"> 2013 </option>
        <option $start_year[4] value="2014"> 2014 </option>
        <option $start_year[5] value="2015"> 2015 </option>
        <option $start_year[6] value="2016"> 2016 </option>
        <option $start_year[7] value="2017"> 2017 </option>
        <option $start_year[8] value="2018"> 2018 </option>
        <option $start_year[9] value="2019"> 2019 </option>
        <option $start_year[10] value="2020"> 2020 </option>
      </select></td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext">To Date:&nbsp; </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><select name="to_day" size="1">
        <option $ar_to_day[1] value="1"> 1 </option>
        <option $ar_to_day[2] value="2"> 2 </option>
        <option $ar_to_day[3] value="3"> 3 </option>
        <option $ar_to_day[4] value="4"> 4 </option>
        <option $ar_to_day[5] value="5"> 5 </option>
        <option $ar_to_day[6] value="6"> 6 </option>
        <option $ar_to_day[7] value="7"> 7 </option>
        <option $ar_to_day[8] value="8"> 8 </option>
        <option $ar_to_day[9] value="9"> 9 </option>
        <option $ar_to_day[10] value="10"> 10 </option>
        <option $ar_to_day[11] value="11"> 11 </option>
        <option $ar_to_day[12] value="12"> 12 </option>
        <option $ar_to_day[13] value="13"> 13 </option>
        <option $ar_to_day[14] value="14"> 14 </option>
        <option $ar_to_day[15] value="15"> 15 </option>
        <option $ar_to_day[16] value="16"> 16 </option>
        <option $ar_to_day[17] value="17"> 17 </option>
        <option $ar_to_day[18] value="18"> 18 </option>
        <option $ar_to_day[19] value="19"> 19 </option>
        <option $ar_to_day[20] value="20"> 20 </option>
        <option $ar_to_day[21] value="21"> 21 </option>
        <option $ar_to_day[22] value="22"> 22 </option>
        <option $ar_to_day[23] value="23"> 23 </option>
        <option $ar_to_day[24] value="24"> 24 </option>
        <option $ar_to_day[25] value="25"> 25 </option>
        <option $ar_to_day[26] value="26"> 26 </option>
        <option $ar_to_day[27] value="27"> 27 </option>
        <option $ar_to_day[28] value="28"> 28 </option>
        <option $ar_to_day[29] value="29"> 29 </option>
        <option $ar_to_day[30] value="30"> 30 </option>
        <option $ar_to_day[31] value="31"> 31 </option>
      </select> <select name="to_month" size="1">
        <option $ar_to_month[1] value="1"> January </option>
        <option $ar_to_month[2] value="2"> February </option>
        <option $ar_to_month[3] value="3"> March </option>
        <option $ar_to_month[4] value="4"> April </option>
        <option $ar_to_month[5] value="5"> May </option>
        <option $ar_to_month[6] value="6"> June </option>
        <option $ar_to_month[7] value="7"> July </option>
        <option $ar_to_month[8] value="8"> August </option>
        <option $ar_to_month[9] value="9"> September </option>
        <option $ar_to_month[10] value="10"> October </option>
        <option $ar_to_month[11] value="11"> November </option>
        <option $ar_to_month[12] value="12"> December </option>
      </select> <select name="to_year" size="1">
        <option $end_year[0] value="2010"> 2010 </option>
        <option $end_year[1] value="2011"> 2011 </option>
        <option $end_year[2] value="2012"> 2012 </option>
        <option $end_year[3] value="2013"> 2013 </option>
        <option $end_year[4] value="2014"> 2014 </option>
        <option $end_year[5] value="2015"> 2015 </option>
        <option $end_year[6] value="2016"> 2016 </option>
        <option $end_year[7] value="2017"> 2017 </option>
        <option $end_year[8] value="2018"> 2018 </option>        
        <option $end_year[9] value="2019"> 2019 </option>
        <option $end_year[10] value="2020"> 2020 </option>
      </select></td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="   Get Statistics   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
<table border="0" cellpadding="6" cellspacing="1" width="100%" style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="20%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Date </strong></td>
    <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Impressions
    </strong></td>
    <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Clicks </strong></td>
    <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Ratio </strong></td>
    <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Imp
    Graph </strong></td>
    <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Clicks
    Graph </strong></td>
  </tr>
];


foreach $item (@statline)
	{
	($statdate, $impressions, $clicks) = split (/:/, $item);

	if (($impressions > 1) and ($high_imp > 1))
		{
		$impgraph = $impressions * 100 / $high_imp;
		}
		
	if ($impgraph > 0)
		{
		#$impgraph = "<hr noshade size=\"5\" color=\"#8080C0\" width=\"$impgraph%\" align=\"left\">";
		
		$liperc = (100 - $impgraph);
		
		$impgraph = qq[<table border="0" cellpadding="0" cellspacing="0" width="100%" style="border: 1px solid rgb(219,219,219)">
		  <tr>
		    <td width="$impgraph%" height="20" background="$web_url/bar.gif"></td>
		    <td width="$liperc%" height="20"></td>
		  </tr>
		</table>];
		
		}
		else
		{
		$impgraph = qq[<table border="0" cellpadding="0" cellspacing="0" width="100%" style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="0" height="20">&nbsp;</td>
  </tr>
</table>];
		}

	########

	if ($high_clicks > 0)
		{
		$clickgraph = $clicks * 100 / $high_clicks;
		}
		
	if ($clickgraph > 0)
		{
		#$clickgraph = qq[<hr noshade size="5" color="#8080C0" width="$clickgraph%" align="left">];
		
		$lperc = (100 - $clickgraph);
		
		$clickgraph = qq[<table border="0" cellpadding="0" cellspacing="0" width="100%" style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="$clickgraph%" height="20" background="$web_url/bar.gif"></td>
    <td width="$lperc%" height="20"></td>
  </tr>
</table>
		];
		}
		else
		{
		$clickgraph = qq[<table border="0" cellpadding="0" cellspacing="0" width="100%" style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="0" height="20">&nbsp;</td>
  </tr>
</table>];
		}
	
	########
	
	if ($impressions > 0)
		{
		$ratio = $clicks * 100 / $impressions;
		$ratio = sprintf("%5.2f",$ratio); 
		$ratio = $ratio . "%";
		}
		else
		{
		$ratio = "0.00%";
		}
	
print qq[
 <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="30%" align="left" valign="top" class="normaltext">$statdate </td>
    <td width="10%" align="center" valign="top" class="normaltext">$impressions </td>
    <td width="10%" align="center" valign="top" class="normaltext">$clicks </td>
    <td width="10%" align="center" valign="top" class="normaltext">$ratio </td>
    <td width="10%" align="left" valign="top" class="normaltext">$impgraph </td>
    <td width="10%" align="left" valign="top" class="normaltext">$clickgraph </td>
  </tr>
];
	
	$total_imp = $total_imp + $impressions;
	$total_clicks = $total_clicks + $clicks;
	}




if ($stat_cnt == 0)
	{
print qq[
<tr align="center" colspan="5">
 <td width="30%" valign="top" align="left" class="normaltext">No Statistics available for selected criteria.</td>
</tr>
];
	}
	else
	{
	if (($total_clicks > 0) and ($total_imp > 0))
		{
		$total_ratio = $total_clicks * 100 / $total_imp;
		$total_ratio = sprintf("%5.2f",$total_ratio); 
		$total_ratio = $total_ratio . "%";
		}
		else
		{
		$total_ratio = 0 . "%";
		}
	
print qq[
 <tr>
  <td  width="30%" align="left" valign="top" class="normaltext"><b>Totals:</b> </td>
  <td  width="10%" align="center" valign="top" class="normaltext"><b>$total_imp</b> </td>
  <td  width="10%" align="center" valign="top" class="normaltext"><b>$total_clicks</b> </td>
  <td  width="10%" align="center" valign="top" class="normaltext"><b>$total_ratio</b> </td>
  <td  width="10%" align="left" valign="top" class="normaltext"> </td>
  <td  width="10%" align="left" valign="top" class="normaltext"> </td>
  </tr>
];
	}

print qq[</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
</body></html>];

}




sub stats_advert
{

$aid = $q->param('adid');
$gid = $q->param('gid');
$bgroup = $q->param('bgroup');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "SELECT * FROM adverts WHERE aid = '$aid'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

while ( @row = $sth->fetchrow() ) 
	{
	$adname = $row[2];
	}

$sth->finish;
$dbh->disconnect; 

#####################################################

$s_from_day = $q->param('from_day');
$s_from_month = $q->param('from_month');
$s_from_year = $q->param('from_year');

$s_to_day = $q->param('to_day');
$s_to_month = $q->param('to_month');
$s_to_year = $q->param('to_year');


if (($s_to_day eq "") and ($s_to_month eq "") and ($s_to_year eq ""))
{
($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
$year = $year + 1900;

#$start_day[$mday -1] = "selected";
$start_month[$mon] = "selected";

if ($year eq "2010") { $start_year[0] = "selected"; }
if ($year eq "2011") { $start_year[1] = "selected"; }
if ($year eq "2012") { $start_year[2] = "selected"; }
if ($year eq "2013") { $start_year[3] = "selected"; }
if ($year eq "2014") { $start_year[4] = "selected"; }
if ($year eq "2015") { $start_year[5] = "selected"; }
if ($year eq "2016") { $start_year[6] = "selected"; }
if ($year eq "2017") { $start_year[7] = "selected"; }
if ($year eq "2018") { $start_year[8] = "selected"; }
if ($year eq "2019") { $start_year[9] = "selected"; }
if ($year eq "2020") { $start_year[10] = "selected"; }


$end_day[$mday-1] = "selected";
$end_month[$mon] = "selected";

if ($year eq "2010") { $end_year[0] = "selected"; }
if ($year eq "2011") { $end_year[1] = "selected"; }
if ($year eq "2012") { $end_year[2] = "selected"; }
if ($year eq "2013") { $end_year[3] = "selected"; }
if ($year eq "2014") { $end_year[4] = "selected"; }
if ($year eq "2015") { $end_year[5] = "selected"; }
if ($year eq "2016") { $end_year[6] = "selected"; }
if ($year eq "2017") { $end_year[7] = "selected"; }
if ($year eq "2018") { $end_year[8] = "selected"; }
if ($year eq "2019") { $end_year[9] = "selected"; }
if ($year eq "2020") { $end_year[10] = "selected"; }

$nostats = "true";

}
else ### GET SELECTED DATES
{

$s_from_day = $q->param('from_day');
$s_from_month = $q->param('from_month'); $s_from_month = $s_from_month - 1;
$s_from_year = $q->param('from_year');

$start_day[$s_from_day -1] = "selected";
$start_month[$s_from_month] = "selected";

if ($s_from_year eq "2010") { $start_year[0] = "selected"; }
if ($s_from_year eq "2011") { $start_year[1] = "selected"; }
if ($s_from_year eq "2012") { $start_year[2] = "selected"; }
if ($s_from_year eq "2013") { $start_year[3] = "selected"; }
if ($s_from_year eq "2014") { $start_year[4] = "selected"; }
if ($s_from_year eq "2015") { $start_year[5] = "selected"; }
if ($s_from_year eq "2016") { $start_year[6] = "selected"; }
if ($s_from_year eq "2017") { $start_year[7] = "selected"; }
if ($s_from_year eq "2018") { $start_year[8] = "selected"; }
if ($s_from_year eq "2019") { $start_year[9] = "selected"; }
if ($s_from_year eq "2020") { $start_year[10] = "selected"; }

$end_day[$s_to_day -1] = "selected";
$end_month[$s_to_month -1] = "selected";

if ($s_to_year eq "2010") { $end_year[0] = "selected"; }
if ($s_to_year eq "2011") { $end_year[1] = "selected"; }
if ($s_to_year eq "2012") { $end_year[2] = "selected"; }
if ($s_to_year eq "2013") { $end_year[3] = "selected"; }
if ($s_to_year eq "2014") { $end_year[4] = "selected"; }
if ($s_to_year eq "2015") { $end_year[5] = "selected"; }
if ($s_to_year eq "2016") { $end_year[6] = "selected"; }
if ($s_to_year eq "2017") { $end_year[7] = "selected"; }
if ($s_to_year eq "2018") { $end_year[8] = "selected"; }
if ($s_to_year eq "2019") { $end_year[9] = "selected"; }
if ($s_to_year eq "2020") { $end_year[10] = "selected"; }

}


if ($nostats ne "true")
	{
	$toptable = qq[<table border="0" cellpadding="6" cellspacing="1" width="100%" style="border: 1px solid rgb(218,218,218)" >
  <tr>
    <td width="19%"  valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Date </strong></td>
    <td width="15%"  align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Impressions</strong></td>
    <td width="16%"  align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Clicks </strong></td>
    <td width="17%"  align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Ratio </strong></td>
    <td width="17%"  align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Imp. Graph </strong></td>
    <td width="16%"  align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Clicks Graph </strong></td>
  </tr>
  ];

		if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
		$dbh = DBI->connect($dsn, $db_username, $db_password);
		if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

		$s_from_month++;
		$sql_start = "$s_from_year-$s_from_month-$s_from_day";
		$sql_end = "$s_to_year-$s_to_month-$s_to_day";


		$sql = "SELECT adate, impressions, clicks
							FROM adlogs
							WHERE (aid = '$aid') AND
							(adate >= '$sql_start') AND
							(adate <= '$sql_end')
							ORDER BY adate";

		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}

		$acnt = 0;
		while ( @row = $sth->fetchrow() )
			{
			if ($row[1] > $high_imp){$high_imp = $row[1];}
			if ($row[2] > $high_clc){$high_clc = $row[2];}

			$bstats[$acnt] = "$row[0]:$row[1]:$row[2]";
			$acnt++;
			}

  
		foreach $item (@bstats)
			{
			($sdate, $bimp, $blick) = split(/:/, $item);

			$total_bimp = $total_bimp + $bimp;
			$total_bclick = $total_bclick + $blick;

			### CLICK RATIO
			if ($bimp != 0)
				{
				$ratio = $blick * 100 / $bimp;
				$ratio = sprintf("%5.2f",$ratio); 
				$ratio = $ratio . "%";
				}
				else
				{
				$ratio = "0.00%"; $blick = 0;
				}

			### IMPRESSIONS GRAPH

			if (($bimp > 0) and ($high_imp != 0))
				{
				$impperc = int($bimp * 100 / $high_imp);
				$imp_min = 100 - $impperc;

				$impgraph = qq[<table border="0" cellpadding="0" cellspacing="0" width="100%" style="border: 1px solid rgb(219,219,219)"><tr><td width="$impperc%" height="20" background="$web_url/bar.gif"></td><td width="$imp_min%" height="20"></td></tr></table>];
				}
				else
				{
				$impgraph = "";
				}

			### CLICKS GRAPH

			if (($blick > 0) and ($high_imp != 0))
				{
				$clickperc = int($blick * 100 / $high_clc);
				$clickmin = 100 - $clickperc;
				$clickgraph = qq[<table border="0" cellpadding="0" cellspacing="0" width="100%" style="border: 1px solid rgb(219,219,219)"><tr><td width="$clickperc%" height="20" background="$web_url/bar.gif"></td><td width="$clickmin%" height="20"></td></tr></table>];
				}
				else
				{
				$clickgraph = qq[<table border="0" cellpadding="0" cellspacing="0" width="100%" style="border: 1px solid rgb(219,219,219)"><tr><td width="100%" height="20">&nbsp;</td></tr></table>];
				}


		$tmiddle = $tmiddle . qq[
		  <tr>
			 <td width="19%" align="left" valign="top" class="normaltext">$sdate </td>
			 <td width="15%" align="center" valign="top" class="normaltext">$bimp</td>
			 <td width="16%" align="center" valign="top" class="normaltext">$blick </td>
			 <td width="17%" align="center" valign="top" class="normaltext">$ratio </td>
			 <td width="17%" valign="top" class="normaltext">$impgraph</td>
			 <td width="16%" valign="top" class="normaltext">$clickgraph </td>
		  </tr>
		];

			}


		if ($acnt == 0)
			{
		$tmiddle = $tmiddle .  qq[
		<tr class="normaltext">
		 <td width="19%" valign="top" align="left" colspan="5">No statistics available for selected criteria.</td> 
		</tr>
		];

			}  


		if (($total_bimp > 0) and ($total_bclick > 0))
			{
			$total_bratio = $total_bclick * 100 / $total_bimp;
			$total_bratio = sprintf("%5.2f",$total_bratio); 
			$total_bratio = $total_bratio . "%";
			}
			else
			{
			$total_bratio = 0;
			if ($total_bimp < 1) { $total_bimp = 0; }
			if ($total_bclick < 1) { $total_bclick = 0; }
			}


		$tbottom = qq[
		 <tr>
			 <td width="19%" align="left" valign="top" class="normaltext"><b>Totals:</b></td>
			 <td width="15%" align="center" valign="top" class="normaltext"><b>$total_bimp</b> </td>
			 <td width="16%" align="center" valign="top" class="normaltext"><b>$total_bclick</b> </td>
			 <td width="17%" align="center" valign="top" class="normaltext"><b>$total_bratio</b> </td>
			 <td width="17%" valign="top" class="normaltext"> </td>
			 <td width="16%" valign="top" class="normaltext"> </td>
		  </tr>
		</table>
		</table>
		<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
		  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
		</table>
		</body>
		</html>
		];
  
	$stat_table = $toptable . $tmiddle . $tbottom;

	}


$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Advert Statistics For: $adname", qq[<a href="$admin_url/p_tadd.cgi?group=$gid&faction=Edit&fct=group_operations&fct2=editadverts">Go Back</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
<span class="normaltext"><a href="$admin_url/p_tadd.cgi"><b>Advert Groups</b></a> &gt;&gt; <a href="$admin_url/p_tadd.cgi?group=$gid&faction=Edit&fct=group_operations&fct2=editadverts"><b>$bgroup</b></a> &gt;&gt; Advert Statistics For: <b>$adname</b></span><BR>
<br>
<form method="POST" action="$admin_url/p_tadd.cgi">
  <input type="hidden" name="fct" value="advert_stats">
  <input name="adid" type="hidden" value="$aid">
  <input type="hidden" name="bgroup" value="$bgroup">
  <input type="hidden" name="gid" value="$gid">
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="780"  colspan="2" background="$web_url/bar7.gif" class="normaltext"><strong>Advert
       Statistics:</strong></td>
    </tr>
    <tr>

      <td width="766" colspan="2" bgcolor="#F4F4F4" class="normaltext">Choose a date range below
      to display statistics:</td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext">From Date: </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><select name="from_day" size="1">
        <option value="1" $start_day[0]> 1 </option>
        <option value="2" $start_day[1]> 2 </option>
        <option value="3" $start_day[2]> 3 </option>
        <option value="4" $start_day[3]> 4 </option>
        <option value="5" $start_day[4]> 5 </option>
        <option value="6" $start_day[5]> 6 </option>
        <option value="7" $start_day[6]> 7 </option>
        <option value="8" $start_day[7]> 8 </option>
        <option value="9" $start_day[8]> 9 </option>
        <option value="10" $start_day[9]> 10 </option>
        <option value="11" $start_day[10]> 11 </option>
        <option value="12" $start_day[11]> 12 </option>
        <option value="13" $start_day[12]> 13 </option>
        <option value="14" $start_day[13]> 14 </option>
        <option value="15" $start_day[14]> 15 </option>
        <option value="16" $start_day[15]> 16 </option>
        <option value="17" $start_day[16]> 17 </option>
        <option value="18" $start_day[17]> 18 </option>
        <option value="19" $start_day[18]> 19 </option>
        <option value="20" $start_day[19]> 20 </option>
        <option value="21" $start_day[20]> 21 </option>
        <option value="22" $start_day[21]> 22 </option>
        <option value="23" $start_day[22]> 23 </option>
        <option value="24" $start_day[23]> 24 </option>
        <option value="25" $start_day[24]> 25 </option>
        <option value="26" $start_day[25]> 26 </option>
        <option value="27" $start_day[26]> 27 </option>
        <option value="28" $start_day[27]> 28 </option>
        <option value="29" $start_day[28]> 29 </option>
        <option value="30" $start_day[29]> 30 </option>
        <option value="31" $start_day[30]> 31 </option>
      </select> <select name="from_month" size="1">

        <option value="1" $start_month[0]> January </option>
        <option value="2" $start_month[1]> February </option>
        <option value="3" $start_month[2]> March </option>
        <option value="4" $start_month[3]> April </option>
        <option value="5" $start_month[4]> May </option>
        <option value="6" $start_month[5]> June </option>
        <option value="7" $start_month[6]> July </option>
        <option value="8" $start_month[7]> August </option>
        <option value="9" $start_month[8]> September </option>
        <option value="10" $start_month[9]> October </option>
        <option value="11" $start_month[10]> November </option>
        <option value="12" $start_month[11]> December </option>
      </select> <select name="from_year" size="1">
        <option value="2010" $start_year[0]>2010</option>
        <option value="2011" $start_year[1]>2011</option>
        <option value="2012" $start_year[2]>2012</option>
        <option value="2013" $start_year[3]>2013</option>
        <option value="2014" $start_year[4]>2014</option>
        <option value="2015" $start_year[5]>2015</option>
        <option value="2016" $start_year[6]>2016</option>
        <option value="2017" $start_year[7]>2017</option>
        <option value="2018" $start_year[8]>2018</option>
        <option value="2019" $start_year[9]>2019</option>
        <option value="2020" $start_year[10]>2020</option>
        
      </select></td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext">To Date: </td>

      <td width="622" bgcolor="#FFFFFF" class="normaltext"><select name="to_day" size="1">
        <option $end_day[0] value="1"> 1 </option>
        <option $end_day[1] value="2"> 2 </option>
        <option $end_day[2] value="3"> 3 </option>
        <option $end_day[3] value="4"> 4 </option>

        <option $end_day[4] value="5"> 5 </option>
        <option $end_day[5] value="6"> 6 </option>
        <option $end_day[6] value="7"> 7 </option>
        <option $end_day[7] value="8"> 8 </option>
        <option $end_day[8] value="9"> 9 </option>

        <option $end_day[9] value="10"> 10 </option>
        <option $end_day[10] value="11"> 11 </option>
        <option $end_day[11] value="12"> 12 </option>
        <option $end_day[12] value="13"> 13 </option>
        <option $end_day[13] value="14"> 14 </option>

        <option $end_day[14] value="15"> 15 </option>
        <option $end_day[15] value="16"> 16 </option>
        <option $end_day[16] value="17"> 17 </option>
        <option $end_day[17] value="18"> 18 </option>
        <option $end_day[18] value="19"> 19 </option>

        <option $end_day[19] value="20"> 20 </option>
        <option $end_day[20] value="21"> 21 </option>
        <option $end_day[21] value="22"> 22 </option>
        <option $end_day[22] value="23"> 23 </option>
        <option $end_day[23] value="24"> 24 </option>

        <option $end_day[24] value="25"> 25 </option>
        <option $end_day[25] value="26"> 26 </option>
        <option $end_day[26] value="27"> 27 </option>
        <option $end_day[27] value="28"> 28 </option>
        <option $end_day[28] value="29"> 29 </option>

        <option $end_day[29] value="30"> 30 </option>
        <option $end_day[30] value="31"> 31 </option>
      </select> <select name="to_month" size="1">
        <option $end_month[0] value="1"> January </option>
        <option $end_month[1] value="2"> February </option>
        <option $end_month[2] value="3"> March </option>
        <option $end_month[3] value="4"> April </option>
        <option $end_month[4] value="5"> May </option>
        <option $end_month[5] value="6"> June </option>
        <option $end_month[6] value="7"> July </option>
        <option $end_month[7] value="8"> August </option>
        <option $end_month[8] value="9"> September </option>
        <option $end_month[9] value="10"> October </option>
        <option $end_month[10] value="11"> November </option>
        <option $end_month[11] value="12"> December </option>
      </select>
      <select name="to_year" size="1" id="to_year">
        <option $end_year[0] value="2010">2010</option>
        <option $end_year[1] value="2011">2011</option>
        <option $end_year[2] value="2012">2012</option>
        <option $end_year[3] value="2013">2013</option>
        <option $end_year[4] value="2014">2014</option>
        <option $end_year[5] value="2015">2015</option>
        <option $end_year[6] value="2016">2016</option>
        <option $end_year[7] value="2017">2017</option>
        <option $end_year[8] value="2018">2018</option>
        <option $end_year[9] value="2019">2019</option>
        <option $end_year[10] value="2020">2020</option>
      </select></td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="submit" class="psbutton"
      value="   Get Statistics   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">

    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

$stat_table

</body>
</html>
];

}




sub get_html_code
{

$group = $q->param('group');


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "SELECT * FROM advertgrp WHERE groupid = '$group'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

while ( @row = $sth->fetchrow() ) 
	{
	$groupname = $row[1];
	$maximp = $row[2];
	$expirdate = $row[3];
	}

$sth->finish;
$dbh->disconnect; 


#$htmlcode = qq[<script language="JavaScript">
#function getHeight_!!gname!!()
#{
#var the_height = document.getElementById('display_iframe_!!gname!!').contentWindow.document.body.scrollHeight;
#document.getElementById('display_iframe_!!gname!!').height = the_height;
#}
#</script>
#
#<iframe width="100%" id="display_iframe_!!gname!!" 
#onLoad="getHeight_!!gname!!();" 
#src="$script_url/tadds.cgi?id=$group&n=$groupname"
#scrolling="NO" 
#frameborder="0" 
#height="1">
#</iframe>
#];

#$htmlcode =~ s/!!gname!!/$groupname/gi;



@domain_items = split (/\//, $script_url);
$domain_name = $domain_items[2];
$dcntr = 0;
foreach $ditem (@domain_items)
	{
		if ($dcntr > 2)
			{
			$domain_items = $domain_items . "/" . $ditem;
			}
	$dcntr++;
	}



$getFPHeight = "get_height_" . $groupname;
$display_iframe = "display_fpiframe_" . $groupname;

$htmlcode = qq[<iframe width="100%" id="$display_iframe"  
onLoad="$getFPHeight();" 
src=""
scrolling="NO" 
frameborder="0" 
height="10">An iframe capable browser is 
required to view this web site.
</iframe>
<script language="JavaScript">
function GetDomain(url) { return url.match(/:\\/\\/(.[^/]+)/)[1];}
function $getFPHeight () {
var the_height = document.getElementById('$display_iframe').contentWindow.document.body.scrollHeight;
document.getElementById('$display_iframe').height = the_height; }
var realurl = 'http://' + GetDomain(document.URL) + '$domain_items/tadds.cgi?id=$group&n=$groupname';
document.getElementById('$display_iframe').src = realurl;
</script>
];



$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Get HTML Code for Use on Other Pages For: $groupname", qq[<a href="$admin_url/p_tadd.cgi">Go Back</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
<table width="100%" border="0" cellpadding="6" cellspacing="1" style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>HTML Code</strong><strong>:</strong></td>
  </tr>
  <tr>
    <td align="left" valign="top" class="normaltext">
      <form name="form1" method="post" action="">
        <label>
          Place the following HTML code in any PowerSeek template or external Web Page to rotate the Adverts:<br>
          <textarea name="htmlcode" id="htmlcode" cols="70" rows="17" style="width:100%">$htmlcode</textarea>
        </label>
        <br>
      </form>
</td>
  </tr>
</table>
<p><a href="$admin_url/p_tadd.cgi"><strong>Go Back</strong></a></p>
</body>
</html>
];

}





sub delete_advert
{

$aid = $q->param('adid');
$gid = $q->param('gid');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "DELETE FROM adverts WHERE aid = '$aid'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 


$sql = "DELETE FROM adlogs WHERE aid = '$aid'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 


$sth->finish;
$dbh->disconnect; 


$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Advert Deleted", qq[<a href="$admin_url/p_tadd.cgi?group=$gid&faction=Edit&fct=group_operations&fct2=editadverts">Click Here to Continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];


}



sub save_advert
{

$gid = $q->param('gid');
$aid = $q->param('aid');

$advert = $q->param('advert'); $advert =~ s/'/\\'/g; 
$weight = $q->param('weight');

$tracker1 = $q->param('tracker1');
$tracker2 = $q->param('tracker2');
$tracker3 = $q->param('tracker3');
$tracker4 = $q->param('tracker4');
$tracker5 = $q->param('tracker5');


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "UPDATE adverts SET 	advert = '$advert',
										weight = '$weight',
										tracker1 = '$tracker1',
										tracker2 = '$tracker2',
										tracker3 = '$tracker3',
										tracker4 = '$tracker4',
										tracker5 = '$tracker5'
										
										WHERE aid = '$aid'
										";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

$sth->finish;
$dbh->disconnect; 


$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Advert Saved", qq[<a href="$admin_url/p_tadd.cgi?group=$gid&faction=Edit&fct=group_operations&fct2=editadverts">Click Here to Continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}




sub add_new_advert_final
{

$adname = $q->param('adname');

if ($adname eq "") { acs::problem_popup("Please supply an Advert Name."); }

for ($ms = 0; $ms < length($adname); $ms++) 
	{
	$oneletter = substr($adname, $ms, 1);
	if ($oneletter !~ /[0-9a-zA-Z]/)
		{
		acs::problem_popup("The Advert name you specified contains invalid characters. Please use only numerical characters or characters present in the english alphabet.");
		}
	}


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  


$gid = $q->param('gid');
$advert = $q->param('advert'); $advert =~ s/'/\\'/g; 
$weight = $q->param('weight');

$tracker1 = $q->param('tracker1'); $tracker1 =~ s/'/\\'/g; 
$tracker2 = $q->param('tracker2'); $tracker2 =~ s/'/\\'/g; 
$tracker3 = $q->param('tracker3'); $tracker3 =~ s/'/\\'/g; 
$tracker4 = $q->param('tracker4'); $tracker4 =~ s/'/\\'/g; 
$tracker5 = $q->param('tracker5'); $tracker5 =~ s/'/\\'/g; 


$sql = "INSERT INTO adverts SET 		groupid = '$gid',
												adname = '$adname',
												advert = '$advert',
												weight = '$weight',
												tracker1 = '$tracker1',
												tracker2 = '$tracker2',
												tracker3 = '$tracker3',
												tracker4 = '$tracker4',
												tracker5 = '$tracker5'
											 ";

$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

$sth->finish;
$dbh->disconnect; 

$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "New Advert Created", qq[<a href="$admin_url/p_tadd.cgi?group=$gid&faction=Edit&fct=group_operations&fct2=editadverts">Click Here to Continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}




sub edit_advert
{

$gid = $q->param('gid');
$bgroup = $q->param('bgroup');
$adid = $q->param('adid');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "SELECT * FROM adverts WHERE aid = '$adid'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

while ( @row = $sth->fetchrow() ) 
	{
	$adname = $row[2];
	$advert = $row[3];
	$weight = $row[4];
	$tracker1 = $row[5];
	$tracker2 = $row[7];
	$tracker3 = $row[9];
	$tracker4 = $row[11];
	$tracker5 = $row[13];
	}

$sth->finish;
$dbh->disconnect; 


$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Editing Advert: $adname", qq[<a href="$admin_url/p_tadd.cgi?group=$gid&faction=Edit&fct=group_operations&fct2=editadverts">Go Back</a>]);

$warray[$weight] = "selected";

$clicktrack1 = "$script_url/taddsc.cgi?id=$adid&c=1";
$clicktrack2 = "$script_url/taddsc.cgi?id=$adid&c=2";
$clicktrack3 = "$script_url/taddsc.cgi?id=$adid&c=3";
$clicktrack4 = "$script_url/taddsc.cgi?id=$adid&c=4";
$clicktrack5 = "$script_url/taddsc.cgi?id=$adid&c=5";


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
<form method="POST" action="$admin_url/p_tadd.cgi">
<span class="normaltext"><a href="$admin_url/p_tadd.cgi"><b>Advert Groups</b></a> &gt;&gt; <a href="$admin_url/p_tadd.cgi?group=$gid&faction=Edit&fct=group_operations&fct2=editadverts"><b>$bgroup</b></a> &gt;&gt; Editing Advert: <b>$adname</b></span><BR>
  <BR>
  <table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DADADA">
    <tr>
      <td  colspan="2" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Edit Advert: $adname</strong><strong></strong></td>
    </tr>
    <tr >
      <td width="21%" align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">Advert Name:</td>
      <td width="79%" valign="top" class="normaltext" bgcolor="#FFFFFF"><label>
        <b>$adname</b></label></td>
    </tr>
    <tr >
      <td align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">HTML/Text of Advert:</td>
      <td valign="top" class="normaltext" bgcolor="#FFFFFF"><label>
        <textarea name="advert" id="advert" cols="45" rows="20" style="width:100%">$advert</textarea>
      </label></td>
    </tr>
    <tr >
      <td align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">Weight of Advert:</td>
      <td valign="top" class="normaltext" bgcolor="#FFFFFF"><select name="weight"
    size="1">
      <option value="1" $warray[1]> 1 </option>
      <option value="2" $warray[2]> 2 </option>
      <option value="3" $warray[3]> 3 </option>
      <option value="4" $warray[4]> 4 </option>
      <option value="5" $warray[5]> 5 </option>
      <option value="6" $warray[6]> 6 </option>
      <option value="7" $warray[7]> 7 </option>
      <option value="8" $warray[8]> 8 </option>
      <option value="9" $warray[9]> 9 </option>
      <option value="10" $warray[10]> 10 </option>
    </select>
      <br>
      The higher the weight, the more the Advert will be rotated.</td>
    </tr>
    <tr >
      <td align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">Click Tracker URL 1:</td>
      <td valign="top" class="normaltext" bgcolor="#FFFFFF"><label>
        <input name="tracker1" type="text" id="tracker1" style="width:100%" value="$tracker1">
      If you would like to track clicks when links are clicked within your HTML/Text Advert then specify a URL above and use the URL below instead of the URL you supplied above:<br>
      <strong>$clicktrack1</strong></label></td>
    </tr>
    <tr >
      <td align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">Click Tracker URL 2:</td>
      <td valign="top" class="normaltext" bgcolor="#FFFFFF"><label>
        <input name="tracker2" type="text" id="tracker2" style="width:100%" value="$tracker2">
        If you would like to track clicks when links are clicked within your HTML/Text Advert then specify a URL above and use the URL below instead of the URL you supplied above:<br>
        <strong>$clicktrack2</strong></label></td>
    </tr>
    <tr >
      <td align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">Click Tracker URL 3:</td>
      <td valign="top" class="normaltext" bgcolor="#FFFFFF"><label>
        <input name="tracker3" type="text" id="tracker3" style="width:100%" value="$tracker3">
        If you would like to track clicks when links are clicked within your HTML/Text Advert then specify a URL above and use the URL below instead of the URL you supplied above:<br>
        <strong>$clicktrack3</strong></label></td>
    </tr>
    <tr >
      <td align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">Click Tracker URL 4:</td>
      <td valign="top" class="normaltext" bgcolor="#FFFFFF"><label>
        <input name="tracker4" type="text" id="tracker4" style="width:100%" value="$tracker4">
        If you would like to track clicks when links are clicked within your HTML/Text Advert then specify a URL above and use the URL below instead of the URL you supplied above:<br>
        <strong>$clicktrack4</strong></label></td>
    </tr>
    <tr >
      <td align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">Click Tracker URL 5:</td>
      <td valign="top" class="normaltext" bgcolor="#FFFFFF"><label>
        <input name="tracker5" type="text" id="tracker5" style="width:100%" value="$tracker5">
        If you would like to track clicks when links are clicked within your HTML/Text Advert then specify a URL above and use the URL below instead of the URL you supplied above:<br>
        <strong>$clicktrack5</strong></label></td>
    </tr>
    <tr >
      <td align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
      <td valign="top" class="normaltext" bgcolor="#FFFFFF"><input type="submit" class="psbutton" value="Save Advert" name="add_b">
        <input type="hidden" name="fct" value="save_advert">
        <input type="hidden" name="gid" value="$gid">
        <input type="hidden" name="aid" value="$adid">
      <a href="$admin_url/p_tadd.cgi"><b>
      <input name="aid" type="hidden" id="aid" value="$aid">
      </b></a></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
</body>
</html>
];


}



sub add_new_advert
{

#$clicktrack1 = "$script_url/taddc.cgi?id=

$gid = $q->param('gid');
$groupname = $q->param('bgroup');

$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Add New Advert to Advert Group: $groupname", qq[<a href="$admin_url/p_tadd.cgi">Go Back</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
<form method="POST" action="$admin_url/p_tadd.cgi">
  <input type="hidden" name="fct" value="add_new_advert_final">
  <input type="hidden" name="gid" value="$gid">
  <span class="normaltext"><a href="$admin_url/p_tadd.cgi"><b>Advert Groups</b></a> &gt;&gt; <a href="$admin_url/p_tadd.cgi?group=$gid&faction=Edit&fct=group_operations&fct2=editadverts"><b>$groupname</b></a> &gt;&gt; <b>Add New Advert</b><b></b></span><BR>
  <BR>
  <table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DADADA">
    <tr>
      <td  colspan="2" valign="top" background="$web_url/bar7.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Add New Advert</strong><strong></strong></td>
    </tr>
    <tr >
      <td width="21%" align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">Advert Name:</td>
      <td width="79%" valign="top" class="normaltext" bgcolor="#FFFFFF"><label>
        <input type="text" name="adname" id="adname">
      <strong>(Required) </strong><br>
      </label>
      Only use alphabetical characters in the English alphabet or numerical characters. </td>
    </tr>
    <tr >
      <td align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">HTML/Text of Advert:</td>
      <td valign="top" class="normaltext" bgcolor="#FFFFFF"><label>
        <textarea name="advert" id="advert" cols="45" rows="20" style="width:100%"></textarea>
      </label></td>
    </tr>
    <tr >
      <td align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">Weight of Advert:</td>
      <td valign="top" class="normaltext" bgcolor="#FFFFFF"><select name="weight"
    size="1">
      <option value="1"> 1 </option>
      <option value="2"> 2 </option>
      <option value="3"> 3 </option>
      <option value="4"> 4 </option>
      <option value="5"> 5 </option>
      <option value="6"> 6 </option>
      <option value="7"> 7 </option>
      <option value="8"> 8 </option>
      <option value="9"> 9 </option>
      <option value="10"> 10 </option>
    </select>
      <br>
      The higher the weight, the more the Advert will be rotated.</td>
    </tr>
    <tr >
      <td align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
      <td valign="top" class="normaltext" bgcolor="#FFFFFF"><input type="submit" class="psbutton" value="Add New Advert" name="add_b"></td>
    </tr>
    <tr >
      <td align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">&nbsp;</td>
      <td valign="top" class="normaltext" bgcolor="#FFFFFF">Note that you can get special URLs to track User Clicks within this Advert by editing it after you created this Advert.</td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
</body>
</html>
];




}





sub add_group_final
{

$groupname = $q->param('groupname');

if ($groupname eq "") { acs::problem_popup("You need to supply a group name."); }

for ($ms = 0; $ms < length($groupname); $ms++) 
	{
	$oneletter = substr($groupname, $ms, 1);
	if ($oneletter !~ /[0-9a-zA-Z]/)
		{
		acs::problem_popup("The group name you specified contains invalid characters. Please use only numerical characters or characters present in the english alphabet.");
		}
	} 

$expirdate = $q->param('expirdate');

if ($expirdate ne "")
	{
	($pyear,$pmonth,$pday) = split (/\//, $expirdate);
	$pmonth = $pmonth - 1;
	
	eval { $time = timelocal(0,0,0, $pday,$pmonth,$pyear);
 		  }; #warn $@ if $@;
 	if ($@ ne "")  
			{
		 	$lnkn = $ms + 1; #<br></b>Reason:</b> $@
		 	acs::problem_popup("The expiry date ($expirdate) that you specified is not a valid date. <br></b>Reason:</b> $@");
		 	} 
	$expirdate =~ s/\//-/g;
	}
	else
	{
	$expirdate = "2050-01-01";
	} 

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$maximp = $q->param('maximp');

$sql = "INSERT INTO advertgrp SET groupname = '$groupname', 
											 maximp = '$maximp',
											 expirdate = '$expirdate'
											 ";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

$sth->finish;
$dbh->disconnect; 


$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "New Text/HTML Advert Group Added", qq[<a href="$admin_url/p_tadd.cgi">Click Here to Continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}





sub add_new_group
{

$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Add a New Text/HTML Advert Group", qq[Rotate and Target Text/HTML at specific Categories]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
<form method="POST" action="$admin_url/p_tadd.cgi">
  <strong><span class="normaltext"><a href="$admin_url/p_tadd.cgi">Advert Groups</a> &gt;&gt; Add a New Advert Group</span></strong><BR>
  <BR>
  <table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DADADA">
    <tr>
      <td colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext" 
    background="$web_url/bar7.gif"><strong>Add a New Advert Group:</strong></td>
    </tr>
    <tr>
      <td width="14%" class="normaltext" valign="top" bgcolor="#FFFFFF"><p align="left">Group
          Name: </td>
      <td width="86%" class="normaltext" valign="top" bgcolor="#FFFFFF"><input type="text"
    name="groupname" size="28" class="normaltext">
        <strong>(Required) </strong><br>
        Only use alphabetical characters in the English alphabet or numerical characters. </td>
    </tr>
    <tr>
      <td width="14%" class="normaltext" valign="top" bgcolor="#FFFFFF">Maximum Impressions: </td>
      <td width="86%" class="normaltext" valign="top" bgcolor="#FFFFFF"><input type="text"
    name="maximp" size="28" class="normaltext">
        <strong>(Optional) </strong><br>
        This is the maximum number of times the Adverts in this group will be displayed. Leave
        blank for unlimited. This is useful when you only want to display Adverts a certain amount
        of times. </td>
    </tr>
    <tr>
      <td width="14%" class="normaltext" valign="top" bgcolor="#FFFFFF">Expiry Date: </td>
      <td width="86%" class="normaltext" valign="top" bgcolor="#FFFFFF"><input type="text"
    name="expirdate" size="14" class="normaltext">
        (YYYY/MM/DD) <strong>(Optional) </strong><br>
        This group of Adverts won't be displayed if the date above has been reached. Leave blank
        for no expiry date. </td>
    </tr>
    <tr>
      <td width="14%" valign="top" class="normaltext" bgcolor="#FFFFFF"></td>
      <td width="86%" valign="top" class="normaltext" bgcolor="#FFFFFF"><p align="left">
          <input
    type="submit" class="psbutton" value="Add New Advert Group" name="add_bgroup">
          <input type="hidden" name="fct" value="add_group_final">
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>
];

}








sub edit_group_adds
{

$groupid = $q->param('group');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "SELECT * FROM advertgrp WHERE groupid = '$groupid'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

while ( @row = $sth->fetchrow() ) 
	{
	$groupname = $row[1];
	$maximp = $row[2];
	$expirdate = $row[3];
	}


$sql = "SELECT SUM(impressions), SUM(clicks), aid  FROM adlogs WHERE groupid = '$groupid' GROUP BY aid";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

while ( @row = $sth->fetchrow() ) 
	{
	$impressions{$row[2]} = $row[0];
	$clicks{$row[2]} = $row[1];
	}



$sql = "SELECT * FROM adverts WHERE groupid = '$groupid' ORDER BY adname";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

$vcnt = 0;
while ( @row = $sth->fetchrow() ) 
	{
	if ($vcnt == 0) { $chval = "checked"; } else { $chval = ""; }
	
	if ($impressions{$row[0]} eq "") { $impressions{$row[0]} = 0; }
	

	if (($impressions{$row[0]} == 0) or ($clicks{$row[0]} == 0))
		{
		$ratio = "0.00";
		}
		else
		{
		$ratio = ($clicks{$row[0]} / $impressions{$row[0]}) * 100;
		$ratio = sprintf("%5.2f",$ratio);
		}
	
	if ($clicks{$row[0]} eq "") { $clicks{$row[0]} = 0; }
	
	$adline = $adline . qq[
	<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
	  <td align="left" valign="top" class="normaltext"><input type="radio" value="$row[0]" name="adid" $chval><b>$row[2]</b></td>
	  <td align="center" valign="top" class="normaltext">$row[4]</td>
	  <td align="center" valign="top" class="normaltext">$impressions{$row[0]}</td>
	  <td align="center" valign="top" class="normaltext">$clicks{$row[0]}</td>
	  <td align="center" valign="top" class="normaltext">$ratio %</td>
	</tr>
	];
	
	$vcnt++;
	}



if ($maximp == 0) { $maximp = ""; }
if ($expirdate eq "2050-01-01") { $expirdate = ""; }

$sth->finish;
$dbh->disconnect; 


$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Edit Adverts in Advert Group: $groupname", qq[<a href="$admin_url/p_tadd.cgi">Go Back</a>]);


if ($vcnt > 0)
	{
	$func_dropdown = qq[    <tr>
   <td width="100%" colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext">
	<select name="faction" size="1">
	  <option value="edit_advert">Edit Selected Advert</option>
	  <option value="delete_advert">Delete Selected Advert</option>
	  <option value="stats_advert">Advert Statistics</option>
	  <option value="reset_stats_advert">Reset Advert Statistics</option>
	</select>
	<input type="submit" class="psbutton" value="   Go   " name="add2">
	</td>
	</tr>
	];
	}
	else
	{
	$adline = qq[
	<tr>
	  <td align="left" valign="top" bgcolor="#FFFFFF" class="normaltext">There are currently no Adverts. Click on 'Add New Advert' to add an Advert.</td>
	  <td width="10%" align="center" valign="top" class="normaltext"> </td>
	  <td width="10%" align="center" valign="top" class="normaltext"> </td>
	  <td width="10%" align="center" valign="top" class="normaltext"> </td>
	</tr>
	];	
	
	}
	
	
print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
<form method="POST" action="$admin_url/p_tadd.cgi">
  <input type="hidden" name="fct" value="advert_group_operations">
  <input type="hidden" name="gid" value="$groupid">
  <input type="hidden" name="bgroup" value="$groupname">
  <span class="normaltext"><a href="$admin_url/p_tadd.cgi"><b>Advert Groups</b></a> &gt;&gt; Editing Advert Group <b>'$groupname'</b></span><BR>
  <BR>
  <table border="0" cellpadding="6" cellspacing="1" width="100%" style="border: 1px solid rgb(218,218,218)">
    <tr>
      <td width="50%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Adverts for: $groupname</strong></td>
      <td width="10%" align="center" valign="top" background="$web_url/bar6.gif"  class="normaltext"><strong>Weight:</strong></td>
      <td width="10%" align="center" valign="top" background="$web_url/bar6.gif"  class="normaltext"><strong>Impressions:</strong></td>
      <td width="10%" align="center" valign="top" background="$web_url/bar6.gif"  class="normaltext"><strong>Clicks:</strong></td>
      <td width="10%" align="center" valign="top" background="$web_url/bar6.gif"  class="normaltext"><strong>Click Ratio:</strong></td>
    </tr>
 $adline
$func_dropdown
    <tr>
      <td width="100%" colspan="2" valign="top" class="normaltext"><input type="submit" class="psbutton" value="Add New Advert" name="add_b"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
</body>
</html>
];



}




sub del_group
{

$id = $q->param('group');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "DELETE FROM advertgrp WHERE groupid = '$id'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

$sql = "DELETE FROM adverts WHERE groupid = '$id'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

$sql = "DELETE FROM adlogs WHERE groupid = '$id'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

$sth->finish;
$dbh->disconnect; 


$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Group Deleted", qq[<a href="$admin_url/p_tadd.cgi">Click Here to Continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];


}




sub save_group
{

$groupid = $q->param('id');

$expirdate = $q->param('expirdate');

if ($expirdate ne "")
	{
	($pyear,$pmonth,$pday) = split (/\//, $expirdate);
	$pmonth = $pmonth - 1;
	
	eval { $time = timelocal(0,0,0, $pday,$pmonth,$pyear);
 		  }; #warn $@ if $@;
 	if ($@ ne "")  
			{
		 	$lnkn = $ms + 1; #<br></b>Reason:</b> $@
		 	acs::problem_popup("The expiry date ($expirdate) that you specified is not a valid date. <br></b>Reason:</b> $@");
		 	} 
	$expirdate =~ s/\//-/g;
	}
	else
	{
	$expirdate = "2050-01-01";
	} 

$maximp = $q->param('maximp');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "UPDATE advertgrp SET maximp = '$maximp',
									  expirdate = '$expirdate',
									  current_imp = '0' 
								WHERE groupid = '$groupid'";

$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

$sth->finish;
$dbh->disconnect; 



$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Advert Group Saved", qq[<a href="$admin_url/p_tadd.cgi">Click Here to Continue</a>]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

}




sub edit_group
{

$group = $q->param('group');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  

$sql = "SELECT * FROM advertgrp WHERE groupid = '$group'";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

while ( @row = $sth->fetchrow() ) 
	{
	$groupname = $row[1];
	$maximp = $row[2];
	$expirdate = $row[3];
	}

if ($maximp == 0) { $maximp = ""; }
if ($expirdate eq "2050-01-01") { $expirdate = ""; }

$expirdate =~ s/-/\//gi;

$sth->finish;
$dbh->disconnect; 

$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Edit Advert Group", qq[<a href="$admin_url/p_tadd.cgi">Go Back</a>]);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
<form method="POST" action="$admin_url/p_tadd.cgi">
  <strong><span class="normaltext"><a href="$admin_url/p_tadd.cgi">Advert Groups</a> &gt;&gt; Edit  Advert Group</span></strong><BR>
  <BR>
  <table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DADADA">
    <tr>
      <td colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext" 
    background="$web_url/bar7.gif"><strong>Add a New Advert Group:</strong></td>
    </tr>
    <tr>
      <td width="14%" class="normaltext" valign="top" bgcolor="#FFFFFF"><p align="left">Group
          Name: </td>
      <td width="86%" class="normaltext" valign="top" bgcolor="#FFFFFF"><strong>$groupname</strong></td>
    </tr>
    <tr>
      <td width="14%" class="normaltext" valign="top" bgcolor="#FFFFFF">Maximum Impressions: </td>
      <td width="86%" class="normaltext" valign="top" bgcolor="#FFFFFF"><input
    name="maximp" type="text" class="normaltext" value="$maximp" size="28">        <strong>(Optional)</strong><br>
        This is the maximum number of times the Adverts in this group will be displayed. Leave
        blank for unlimited. This is useful when you only want to display Adverts a certain amount
      of times. </td>
    </tr>
    <tr>
      <td width="14%" class="normaltext" valign="top" bgcolor="#FFFFFF">Expiry Date: </td>
      <td width="86%" class="normaltext" valign="top" bgcolor="#FFFFFF"><input
    name="expirdate" type="text" class="normaltext" value="$expirdate" size="14">
        (YYYY/MM/DD) <strong>(Optional) </strong><br>
        This group of Adverts won't be displayed if the date above has been reached. Leave blank
        for no expiry date. </td>
    </tr>
    <tr>
      <td width="14%" valign="top" class="normaltext" bgcolor="#FFFFFF"></td>
      <td width="86%" valign="top" class="normaltext" bgcolor="#FFFFFF"><p align="left">
          <input
    type="submit" class="psbutton" value="Save Advert Group" name="add_bgroup">
          <input type="hidden" name="fct" value="save_group">
          <input type="hidden" name="id" value="$group">
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
</body>
</html>
];

}






sub start
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }  


$sql = "SELECT COUNT(*), groupid FROM adverts GROUP BY groupid";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
while ( @row = $sth->fetchrow() ) 
	{
	$oname = "OB" . $row[1];
	$adnumbers{$oname} = $row[0];
	}



$sql = "SELECT SUM(impressions), SUM(clicks), groupid FROM adlogs GROUP BY groupid";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
while ( @row = $sth->fetchrow() ) 
	{
	$impressions{$row[2]} = $row[0];
	$clicks{$row[2]} = $row[1];
	}


$sql = "SELECT * FROM advertgrp ORDER BY groupname";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

$avc = 0;

while ( @row = $sth->fetchrow() )
	{
	if ($avc == 0) { $checkedv = "checked"; } else { $checkedv = ""; }
	
	if ($row[3] eq "2050-01-01") { $expiry = "none"; } else { $expiry = $row[3]; }
	if ($row[2] == 0) { $maxi = "none"; } else { $maxi = $row[2]; }
	
	$totalads = "OB" . $row[0];
	$totalads = $adnumbers{$totalads};
	if ($totalads eq "") { $totalads = 0; }
	
	$gimps = $impressions{$row[0]}; if ($gimps eq "") { $gimps = 0; }
	$gclicks = $clicks{$row[0]}; if ($gclicks eq "") { $gclicks = 0; }

	if (($gclicks == 0) or ($gimps == 0))
		{
		$ratio = "0.00";
		}
		else
		{
		$ratio = ($gclicks / $gimps) * 100;
		$ratio = sprintf("%5.2f",$ratio);
		}
	
	$alines = $alines . qq[<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td align="left" valign="top" class="normaltext"><input type="radio" value="$row[0]" name="group" $checkedv><b>$row[1]</b></td>
    <td align="center" valign="top" class="normaltext">$gimps</td>
    <td align="center" valign="top" class="normaltext">$gclicks</td>
    <td align="center" valign="top" class="normaltext">$ratio %</td>
    <td align="center" valign="top" class="normaltext">$totalads</td>
    <td align="center" valign="top" class="normaltext">$expiry</td>
    <td align="center" valign="top" class="normaltext">$maxi</td>
   </tr>
	];
	
	$avc++;
	}

$sth->finish;
$dbh->disconnect; 


$defadd = acs::get_file_contents("$data_dir/defadvert.dat"); 

if ($defadd eq "")
	{
	$defadd = "Not Set - Please Set";
	}
	else
	{
	($advid, $adname) = split (/-/, $defadd);
	$defadd = "Currently Set To: <b>$adname</b>";
	}


if ($avc > 0)
	{

$func_dropdown = qq[
<select name="faction" size="1">
  <option value="Edit">Add/Edit/Delete Adverts of Group</option>
  <option value="get_html_code">Get HTML Code For Use on Other Pages</option>
  <option value="usage">Directory/Category Usage Report</option>
  <option value="statistics">Group Statistics</option>
  <option value="reset">Reset Advert Group Statistics</option>
  <option value="delete">Delete Advert Group</option>
 <option value="edit_group_properties">Edit Group Properties</option>
</select>
<input type="submit" class="psbutton" value="   Go   " name="add2">
<br><br>
];
	
$func_default = qq[<br><br>
 <input type="submit" class="psbutton" value="Set Default Advert Group" name="set_default">
 <font color="#0000FF"><strong>$defadd</strong></font><br>
 If configured then this group of Adverts will be rotated in the event where an Advert group reached it's expiry date or maximum impressions.
];

	}
	else
	{
	$alines = qq[<tr>
      <td colspan="7" valign="top"  class="normaltext">There are currently no Advert Groups. Click on 'Add New Advert Group' below to add Adverts.</td>
    </tr>
		];
	}




$boxhelp = qq[
<table border="0" cellpadding="3" cellspacing="0" width="100%">
  <tr>
    <td colspan="2" class="normaltext"><font color="#0000FF"><strong>Table Column
    Legend:</strong></font></td>
  </tr>
  <tr>
    <td width="22%" class="normaltext">Impressions:</td>
    <td width="78%" class="normaltext">Total Advert impressions for group </td>
  </tr>
  <tr>
    <td width="22%" class="normaltext">Clicks:</td>
    <td width="78%" class="normaltext">Total Clicks for group </td>
  </tr>
  <tr>
    <td width="22%" class="normaltext">Click Ratio:</td>
    <td width="78%" class="normaltext">Click Through Ratio </td>
  </tr>
  <tr>
    <td width="22%" class="normaltext">Nr of Ads: </td>
    <td width="78%" class="normaltext">Number of Adverts in group</td>
  </tr>
  <tr>
    <td class="normaltext">Expiry:</td>
    <td class="normaltext">Adverts in the group will not be rotated anymore if the expiry date is reached. (If configured)</td>
  </tr>
  <tr>
    <td class="normaltext">Max Impressions:</td>
    <td class="normaltext">Maximum impressions of group. If reached Adverts won't be rotated anymore. (If configured)</td>
  </tr>
  <tr>
    <td colspan="2" class="normaltext"><font color="#0000FF"><strong>DropDown
    Menu Options:</strong></font></td>
  </tr>
  <tr>
    <td width="22%" class="normaltext">Add/Edit/Delete Adverts of Group:</td>
    <td width="78%" class="normaltext">Add/Edit/Delete Adverts within the group that has been
    selected.</td>
  </tr>
  <tr>
    <td class="normaltext">Get HTML Code For Use on Other Pages:</td>
    <td class="normaltext">Enables you to get HTML code to rotate Adverts  inside PowerSeek templates or external web pages.</td>
  </tr>
  <tr>
    <td class="normaltext">Directory/Category Usage Report:</td>
    <td class="normaltext">Shows in what categories, groups of Adverts are
      rotated. </td>
  </tr>
  <tr>
    <td class="normaltext">Group Statistics:</td>
    <td class="normaltext">Displays statistics of the Adverts in the selected
      group. </td>
  </tr>
  <tr>
    <td width="22%" class="normaltext">Delete Advert Group:</td>
    <td width="78%" class="normaltext">Delete the group and all the Adverts that it contains. </td>
  </tr>
  <tr>
    <td width="22%" class="normaltext">Edit Group Properties:</td>
    <td width="78%" class="normaltext">Edit the properties of the selected group. </td>
  </tr>
</table>
];

$helpb = acs::quick_help("Help:",$boxhelp);






$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Text/HTML Category Advert Manager", qq[Rotate and Target Text/HTML at specific Categories]);

print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
<script SRC="$web_url/qtip.js"></script>
<style type="text/css">
<!--
div#qTip { padding: 10px; border: 1px solid #DBDBDB; width:350px; display: none; background: url("$web_url/tooltback.gif"); color: #000; font: 11px Arial, sans-serif; text-align: left; position: absolute; z-index: 1000; }
-->
</style>
</head>
<body>
$hbox

<form method="POST" action="$admin_url/p_tadd.cgi">
  <table border="0" cellpadding="6" cellspacing="1" width="100%" style="border: 1px solid rgb(218,218,218)">
      <tr>
        <td width="30%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Text/HTML Advert Groups: </strong></td>
        <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Impressions:</strong></td>
        <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Clicks:</strong></td>
        <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Click Ratio:</strong></td>
        <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Nr of Ads:</strong></td>
        <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Expiry:</strong></td>
        <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Max Imp:</strong></td>
    </tr>
    $alines
    <tr >
      <td colspan="2" align="left" valign="top" class="normaltext">
      $func_dropdown
        <input type="submit" class="psbutton" value="Add New Advert Group" name="add_bgroup">
        <input type="hidden" name="fct" value="group_operations">
		$func_default
        </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

$helpb
</body>
</html>
];

}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

