#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Master Template Importer
# DIZ: Enables you to specify a master template. This master template will be implemented throughout all PowerSeek templates. The master template will act like a frame with for example your graphics, menu bars, etc.
# GRAPHIC: ic_template.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi";

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use globaltmpl;
#use psfp;
&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
# not below if's - else bypassed...
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "wizard1") {&wizard1;}
if ($q->param('fct') eq "implement") {&implement;}
if ($q->param('fct') eq "restore") {&restore;}
if ($q->param('fct') eq "restore2") {&restore2;}



sub restore
{

$wizard = $q->param('wizard');

$boxdiz = qq[
The templates that will be restored are the templates that are normally used by default when PowerSeek is installed.<BR><BR>
<b>Note that it will overwrite all previous templates used by PowerSeek.</b>
<form method="POST" action="$admin_url/p_tmpglobal.cgi">
<input type="hidden" name="wizard" value="$wizard">
<input type="hidden" name="fct" value="restore2">Are you sure? <input type="submit" class="psbutton" value="  Yes  " name="B1">
</form>
];

$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Restore Default Templates", $boxdiz);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>

];


}




sub restore2
{

opendir(DIR,"$data_dir");
@files = readdir(DIR);
foreach $filename (@files)
	{
	if (substr($filename, length($filename) - 4, 4) eq ".def")
		{
			$orignfn = substr($filename, 0, length($filename) - 4);
			$orignfn = $orignfn . ".html";
			
			$original_templ = acs::get_file_contents("$data_dir/$filename");
			open (DF, "> $data_dir/$orignfn");
				print DF $original_templ;
			close (DF);
			
		}
	}


if ($q->param('wizard') eq "y")
	{
		$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Default PowerSeek Templates Restored", qq[		<a href="$admin_url/startup.cgi?fct=step3">Click Here to Continue</a>		]); 
	
	}
	else
	{
		$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Default PowerSeek Templates Restored", qq[		<a href="$admin_url/p_tmpglobal.cgi">Click Here to Continue</a>		]); 
	}


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox

</body>
</html>
];

}






sub implement
{

### UPLOAD FILE

		### CHECK IF UPLOAD DIR EXISTS
		$upload_dir = "$data_dir/tmp";
		if ((-e $upload_dir) < 1) {
		mkdir ($upload_dir, $default_permissions);
		chmod($default_permissions,"$upload_dir"); }
	
		$upload_filename = $q->param('attatch1'); 
		$ufname = "$data_dir/tmp/temp.html";

		### DO UPLOAD
		$upload_filehandle = $q->param('attatch1');
		open (UPLOADFILE, ">$ufname"); 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close (UPLOADFILE);		


$filesize = (-s "$data_dir/tmp/temp.html"); 

if ($filesize < 1)
	{
	acs::problem_popup("The file was not uploaded due to a problem occurring while trying to upload the file. It may be your firewall blocking this operation or it may be related to your browser. If it's the browser then try using another browser.");
	}

### CHECK FOR ERRORS

$master_tmpl = acs::get_file_contents("$data_dir/tmp/temp.html");

if ($master_tmpl !~ /!!psdata!!/i)
	{
	acs::problem_popup("The master template you uploaded does not contain the !!psdata!! variable.");
	}


if ($master_tmpl !~ /!!pagetitle!!/i)
	{
	acs::problem_popup("The master template you uploaded does not contain the !!pagetitle!! variable.");
	}
	

if ($master_tmpl !~ /<\/head>/i)
	{
	acs::problem_popup("The master template you uploaded does not contain the <head> tags.");
	}


$stylesheet = $q->param('stylesheet');
	open (ODPP, "> $web_dir/globalstyle.css");
			print ODPP $stylesheet;
	close (ODPP);



$def_templates = get_global_templates globaltmpl;

@template_names = globaltmpl::get_tnames;


#### IMPLEMENT TEMPLATES

foreach $item (@template_names)
	{
	
		($iname, $pagetitle) = split (/:/, $item);
		
		if ($pagetitle eq "LINKSTYLE")
			{
				$filename = "$data_dir/" . $iname . ".html";
				open (ODPP, "> $filename");
						print ODPP $def_templates->{$iname};
				close (ODPP);
			}
			else
			{
				$tmp_tmpl = $master_tmpl;
				$tmdata = $def_templates->{$iname};
				
				if ($q->param('usecss') eq "Y")
					{
					$stylesheet_incl = qq[<link href="!build_url!/globalstyle.css" rel="stylesheet" type="text/css">\n</head>];
					$tmp_tmpl =~ s/<\/head>/$stylesheet_incl/;
					}
				
				$tmp_tmpl =~ s/!!psdata!!/$tmdata/;
				$tmp_tmpl =~ s/!!pagetitle!!/$pagetitle/;		
		
				$filename = "$data_dir/" . $iname . ".html";
			
				open (ODPP, "> $filename");
					print ODPP $tmp_tmpl;
				close (ODPP);
			}
	
	}




if ($q->param('wizard') eq "y")
	{

	$boxdiz = qq[
	<BR>	
	<ul>
	  <li><a href="$admin_url/admin2.cgi" target="_blank"><strong>Click Here</strong></a> to go to the Template Manager to View/Preview your new template implementation. (Click 'Preview' next to any category)</li>
	</ul>
	<p>&nbsp;</p>
	<ul>
	  <li>If you are not satisfied with your template then you may <strong><a href="$admin_url/startup.cgi?fct=step3">Go Back</a></strong> and re-implement it.  </li>
	</ul>
	<p>&nbsp;</p>
	<ul>
	  <li>You can also <a href="$admin_url/p_tmpglobal.cgi?fct=restore&wizard=y"><strong>Click Here</strong></a> to restore the original PowerSeek Factory Default Templates. </li>
	</ul>
	<BR>
	];

	$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Global Template Implemented.", $boxdiz);
	}
	else
	{
	$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Global Template Implemented.", qq[	<a href="$admin_url/p_tmpglobal.cgi">Click Here to Continue</a>	]);
	}




print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];



}






sub wizard1
{


### GET LINKS

$gsettings = new_gsettings acs;


if ($gsettings->{dyn_stat} eq "Static")
	{
	$whatsnew = "$web_url/new/";
	$tophits = "$web_url/pop/";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}
	else
	{
	$whatsnew = "$script_url/dirs.cgi?newpop=new";
	$tophits = "$script_url/dirs.cgi?newpop=pop";
	$rgs_login = "$script_url/rgs_login.cgi";
	$register = "$script_url/rgs_register.cgi";
	$advanced_search = "$script_url/searchadv.cgi";
	$favorites = "$script_url/fav.cgi";
	$add_url = "$script_url/addurl.cgi";
	$add_url_premium = "$script_url/addurl.cgi?p=1";
	}



if ($gsettings->{searchmeth} eq "fulltext")
	{
$searchbox = qq[<form method="POST" action="$script_url/search2.cgi">
<p><input type="text" name="keywords" size="33"><input type="submit" class="psbutton" value="Search" name="B1"></p>
</form>];
	}
	else
	{
$searchbox = qq[<form method="POST" action="$script_url/search.cgi">
<p><input type="text" name="keywords" size="33"><input type="submit" class="psbutton" value="Search" name="B1"></p>
</form>];
	}


$searchbox_code = qq[
<form method="POST">
<textarea rows="4" name="S1" cols="69">$searchbox</textarea>
</form>
];


$hbox = acs::get_heading_box("$web_url/ic_template.gif", "Implement a Global Template", qq[Please read the instruction below and upload a template (HTML file)]);

$reffr = $ENV{'HTTP_REFERER'};
@domain_items = split (/\//, $reffr);
$ydomain = "http://" . $domain_items[2];


$jspopup_code = acs::get_popupjs; 

print qq[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">

<style type="text/css">
<!--
.style1 {
	font-size: 18px;
	font-weight: bold;
	color: #0000A0;
}
-->
</style>

<script LANGUAGE="JavaScript">
<!-- Hide
$jspopup_code 
// End Hide -->
</script>

</head>
<body>

$hbox

<p><span class="style1">Important Note:</span> </p>
<blockquote>
  <p><strong>Please note that any changes to existing PowerSeek templates will be lost when a global template is implemented.</strong> All the templates available in the<strong> Control Panel &gt;&gt; Template Manager</strong> will be overwritten with the look and feel of the global template being implemented. </p>
  <p>&nbsp;</p>
</blockquote>

<p class="style1">Step 1 - Create an HTML file that will serve as a frame</p>
<blockquote>
  <p>Create a normal HTML file with your web editor. This file could contain your design layout, company logo, navigational
  buttons, headers, footers, links, etc. This file will be the master template that will be implemented to give all end-user PowerSeek pages the same look and feel. </p>
  <p><strong>Note that this template will need to contain the following links:</strong><br>
  (You will need to place the links below in the HTML file you create that is going to serve as the master template) </p>
  <blockquote>
    <p><strong>What's New: </strong><br>
      This is the link that end users can click to see the latest additions to the Search Engine &amp; Directory. </p>
    <ul>
      <li>
        <p><a href="$whatsnew" target="_blank">$whatsnew</a></p>
      </li>
    </ul>
    <p><strong>Most Popular: (Also Referred to as 'Top Hits')</strong><br>
      This is the link that end users can click to see the most Popular links in the Search Engine &amp; Directory. </p>
    <ul>
      <li>
        <p><a href="$tophits" target="_blank">$tophits</a></p>
      </li>
    </ul>
    <p><strong>Login</strong>:<br>
      This is the login link that end users can click to log into their  accounts to submit or modify  links.</p>
    <ul>
      <li>
        <p><a href="$rgs_login" target="_blank">$rgs_login</a></p>
      </li>
    </ul>
    <p><strong>Register</strong>:<br>
      This is the link that end users can click to register an account to submit a new link.</p>
    <ul>
      <li>
        <p><a href="$register" target="_blank">$register</a></p>
      </li>
    </ul>
    <p><strong>Advanced Search <br>
      </strong>This link can be clicked to do an Advanced Search on the Search Engine &amp; Directory.</p>
    <ul>
      <li>
        <p><a href="$advanced_search" target="_blank">$advanced_search</a></p>
      </li>
    </ul>
    <p><strong>Favorites:</strong><br>
      This is the link end users can click to view their 'Favorite' links.  The favorite links can be added when clicking the 'Add to Favorites'  button or link next to each link when browsing the Search Engine &amp; Directory.</p>
    <ul>
      <li>
        <p><a href="$favorites" target="_blank">$favorites</a></p>
      </li>
    </ul>
    <p><strong>Add URL: </strong><br>
      This is the link that can be clicked to submit a new link.</p>
    <ul>
      <li>
        <p><a href="$add_url" target="_blank">$add_url</a></p>
      </li>
    </ul>
    <p><strong>Add Premium URL:<br>
      </strong>This is the link that can be clicked to submit a new premium link.</p>
    <ul>
      <li>
        <p><a href="$add_url_premium" target="_blank">$add_url_premium</a></p>
      </li>
    </ul>
    <p><strong>Contact Form:<br />
    </strong>This is the link to the contact form.</p>
    <ul>
      <li>
        <p><a href="$script_url/contact.cgi" target="_blank">$script_url/contact.cgi</a></p>
      </li>
    </ul>
<p><strong>Search Box HTML Code:</strong><br>
    (Place the search box HTML code inside the HTML file you create. It will serve as the Search Box of your Search Engine &amp; Directory)    </p>
<p>$searchbox_code</p>
  </blockquote>
  <BR><p><strong>The HTML file you create could for example look something like this: </strong></p><BR>
  <p><img src="$web_url/wiz1.jpg" border="1"> </p>
  <p>&nbsp; </p>
</blockquote>

<p class="style1"><strong>Step 2 - Add !!pagetitle!! word to HTML file</strong></p>
<blockquote>
  <p>You should now have created an HTML file that will act as the master template that will be used. </p>
  <p>Now open the file and between the &lt;TITLE&gt; tags place the  word<strong> !!pagetitle!!</strong></p>
  <p>This  word will be replaced by the 'Titles' of PowerSeek templates or PowerSeek pages being viewed by end users.</p>
</blockquote>
<p>&nbsp;</p>
<p class="style1"><strong>Step 3 - Place the words !!psdata!! inside the HTML file you created. </strong></p>
<blockquote>
  <p>Now insert the word <strong>!!psdata!!</strong> inside the HTML file where you would like PowerSeek to
  place it's functions &amp; options. Functions like displaying links inside categories, login screens, end user control panels, etc. will be displayed where you place this word inside the HTML file. </p>
  <p><strong>The HTML file you create could for example look something like this:</strong></p>
  <p><img src="$web_url/wiz2.jpg" border="1"> </p>
  <p>&nbsp; </p>
</blockquote>

<p class="style1"><strong>Step 4 - Correctly link up images </strong></p>

<blockquote>
  <blockquote>
    <p> You must reference images inside your <strong>HTML file (template)</strong> with the full path to where the images are situated. In other words,  upload the images to your web site. Then view/edit the source of the <strong>HTML file</strong> you created and supply the <strong>full URL paths</strong> to where you <strong>uploaded the images on your web site - for all images.</strong><br>
        <br>
        <strong>For example:</strong></p>
    <p> <strong>&lt;img src="someimage.gif"&gt;</strong> will not work.<br>
        <br>
      You have to indicate the entire URL where <strong>someimage.gif </strong>is located. <strong>For example:</strong><br>
      <br>
      <strong>&lt;img src="$ydomain/someimage.gif"&gt;</strong><br>
      <br>
      The <strong>&lt;img</strong> is an HTML tag indicating that you want to insert an image in the <strong>HTML page</strong>. The <strong>src=</strong> part indicates where the <strong>location </strong>of  the image is situated. Some Web Editors will support inserting images  from a web url and some won't. If your Web Editor does not support  this, insert the image into the HTML page like usual and when finished,  edit the the HTML source code and <strong>manually insert the URL path's to the images. </strong>Ensure that the images are on the server for the URL path's you specify.</p>
    <p><strong> Example: Editing the HTML source code:</strong></p>
    <p> Replace <strong>&lt;img src="someimage.gif"&gt;</strong> with<br>
        <strong>&lt;img src="$ydomain/someimage.gif"&gt;</strong></p>
  </blockquote>
  </blockquote>

<p class="style1">&nbsp;</p>
<form method="POST" action="$admin_url/p_tmpglobal.cgi" ENCTYPE="multipart/form-data">
  <p class="style1">&nbsp;</p>
  <p class="style1"><strong>Step 5 - Style Sheet </strong></p>
  <blockquote>
    <p>The style sheet below will be used inside all templates generated by this wizard. 
    If you are not familiar with style sheets then just ignore this step. 
    You are welcome to change anything rageding the style sheet below. All the PowerSeek texts/functions 
    will be using the styles as indicated below.<BR>
    <strong>$ydomain/globalstyle.css</strong></p>
    <p class="style1">
      <textarea name="stylesheet" cols="120" rows="20" id="stylesheet">/*The page_heading style is used for text indicating the heading of pages*/
.page_heading {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
}

/*The link_title style is used to display titles of link listings*/
.link_title {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
}

/*The link_description style is used to display descriptions of link listings*/
.link_description {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	color: #333333;
	font-weight: normal;
    line-height: 18px;
}

/*The link_url style is used to display URLs with link listings*/
.link_url {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: normal;
	color: #808080;
}

/*The ratings_votes style is used to display ratings/votes with link listings*/
.ratings_votes {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: normal;
	color: #808080;
}

/*The link_functions style is used to display link functions wiht links like 'Rating it', 'Comments', 'More Info'*/
.link_functions {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
}

/*The link_border is used to define a border for tables displaying links*/
.link_border {
	border: 1px solid #DFDFDF;
}

/*The user_comments is used to display user comments to link listings*/
.user_comments {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	color: #333333;
	font-weight: normal;
    line-height: 18px;
}


/*The from_category style is used when displaying categories with links*/
.from_category {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: normal;
}

/*The relevance style is used when displaying match relevance with search results*/
.relevance {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
}

/*The link_approval_status style is used to indicate a links approval status (approved for inclussion in the Index or not)*/
.link_approval_status {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
	color: #0000FF;
}

/*The link_premium_indicate style is used to indicate premium links inside the user control panel*/
.link_premium_indicate {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
	color: #FF0000;
}

/*The parahraph style is used for any other texts displayed on end user PowerSeek pages*/
.plain_text {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;
}


/*The parahraph style is used for any other texts displayed on end user PowerSeek pages*/
p {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;
}
</textarea>

<p><input type="checkbox" name="usecss" value="Y" Checked>Un-tick this box if you don't want to
use the style sheet above.</p>

    </p>
    <p class="style1">&nbsp;</p>
    
  </blockquote>
  <p class="style1"><strong>Step 6 - Upload the HTML file you created.</strong></p>
  <blockquote>
    <p>After you have uploaded the file, all templates used by PowerSeek will be updated with
      the HTML file you uploaded. In other words, the file you uploaded will be used as a
    frame for all pages that your end-users will view when browsing or using your Search Engine &amp; Directory. </p>
    <p><strong>Warning: </strong>Uploading your HTML file will replace any previous templates.
    In other words, if you have made changes to the existing templates then it will be lost. You can always go back to the factory default templates that was available when PowerSeek was first installed. This can be done by going to the Control Panel &gt;&gt; Template Manager &gt;&gt; Template Functions &gt;&gt; Implement Global Template &gt;&gt; Restore PowerSeek's Original Templates </p>
  </blockquote>
  <p><strong>Upload the file you created that will act as the master template:     </strong></p>
  <p>
    <input type="hidden" name="fct" value="implement">
    <input type="file" name="attatch1"
    size="50"> 
  </p>
  <p><input type="submit" class="psbutton" value="   Upload   " name="B1"> 
  Pleas read the notes below before uploading. </p>
</form>
<p class="style1">&nbsp;</p>
<p class="style1"><strong>Other Notes on the importation of a master templates</strong></p>
<blockquote>
  <ul>
    <li>
      <p>You can use <strong><a href="$admin_url/admin17.cgi">Template Includes</a></strong> in the <strong>uploaded HTML file</strong> to have <strong>headers, footers, left menu's, right menu's,</strong> etc. A '<strong>header</strong>' <strong>Template Include</strong> can for example be <strong>edited/altered</strong> and the header will <strong>automatically be changed throughout all the PowerSeek templates. </strong>It is recommended you use Template Includes with the HTML file you upload as it will make changing the header or any other <strong>links or graphics in headers/footers/menu's</strong> an easy task. Refer to the <strong><a href="$admin_url/startup.cgi?fct=step3#ti">Template Include Implementation Instructions</a></strong> below to use<strong> Template Includes</strong> inside the <strong>HTML file</strong> you upload here. </p>
    </li>
    <li>
      <p>You can also use your own <strong>CSS style sheets</strong> with the <strong>HTML file</strong> you upload here. If your style sheets are going to be in a seperate  .css file then you will need to use a full URL path to the .css file  where it is declared inside the HTML file between the &lt;HEAD&gt;  tags. (Just like you linked images inside the HTML file with full URL  paths.)</p>
    </li>
    <li>
      <p>If you run a Static Directory where files  are generated then you will need to generate the HTML files for the  links to work when you click categories from the Front Page of your  Directory. You can generate HTML files by going to the <a href="$admin_url/admin.cgi" target="_blank">PowerSeek Control Panel</a> &gt;&gt; <a href="$admin_url/todo.cgi" target="_blank">To Do</a> &gt;&gt; <a href="$admin_url/admin8.cgi" onclick="popup('$admin_url/admin8.cgi',850,700);return false;">Generate HTML Files</a></p>
    </li>
  </ul>
  <p>&nbsp;</p>
  <p><strong><a name="ti" id="ti"></a>Template Include Implementation Instructions:</strong></p>
  <blockquote>
    <p>With  this instructions we will create a header 'Template Include' and place  the 'Template Include' inside the file you upload here.</p>
    <p><strong>Step 1: </strong></p>
    <blockquote>
      <p>Go to the <strong><a href="$admin_url/admin.cgi" target="_blank">PowerSeek Control Panel</a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <a href="$admin_url/admin17.cgi" onclick="popup('$admin_url/admin17.cgi',850,700);return false;">Create/Edit Template Includes</a></strong></p>
    </blockquote>
    <p><strong>Step 2:</strong></p>
    <blockquote>
      <p>Scroll down to the section reading: '<strong>Add a New Template Include:'</strong></p>
      <p>Specify a<strong> Name</strong> for the 'Template Include' where you are asked for a <strong>Name.</strong> In this example we will use <strong>myheader</strong></p>
      <p>From the HTML file (the one you are going to upload here) <strong>copy</strong> the HTML source code of the <strong>header</strong> and <strong>paste</strong> the HTML source code in the section asking you for '<strong>Template Include HTML      Code:'. </strong>Now click the <strong>'Add New Template Include' button.</strong></p>
      <p><strong><a href="$admin_url/startup.cgi?fct=header" onclick="popup('$admin_url/startup.cgi?fct=header',850,700);return false;">Click Here</a></strong> to see an example of how your header could look like. </p>
    </blockquote>
    <p><strong>Step 3:</strong></p>
    <blockquote>
      <p>We have now created a 'Template Include' called <strong>myheader</strong> - Now place <strong>%%incl_myheader%% </strong>into the HTML file you are about to upload in this section. In other words, you will replace the existing header with <strong>%%incl_myheader%% - </strong>After  doing this scroll up and upload the HTML file you created as instructed  in this step of the Wizard. You can change/alter the header at any time  by going to the <a href="$admin_url/admin.cgi" target="_blank">PowerSeek Control Panel</a> &gt;&gt; <a href="$admin_url/admin6.cgi" target="_blank">Template Manager</a> &gt;&gt; <a href="$admin_url/admin17.cgi" onclick="popup('$admin_url/admin17.cgi',850,700);return false;">Create/Edit Template Includes</a> &gt;&gt; Choose to edit the <strong>'myheader' Template Include.</strong> </p>
      <p><strong><a href="$admin_url/startup.cgi?fct=headerinc" onclick="popup('$admin_url/startup.cgi?fct=headerinc',850,700);return false;">Click Here</a></strong> to see an example of how the template could look like with the <strong>myheader</strong> include.</p>
      <p>&nbsp;</p>
    </blockquote>
  </blockquote>
</blockquote>

</body>
</html>
];


}




sub start
{

$hbox = acs::get_heading_box("$web_url/ic_template_long.gif", "Implement a Global Template", qq[With this functionality you can use one template (as a frame) that will be implemented with all the templates of PowerSeek. This template must be a normal HTML file. The Global Template Functionality is a quick and easy way to implement your own look & feel to the pages/templates your end-users will see. With the Global Template functionality you can include your own logo's/graphics/menu bar/etc. Please keep in mind that you can customize all individual templates and that all Text and HTML displayed to users is fully customizable. You can customize individual pages/templates by clicking the 'Template Manager' tab when in the control panel.]);


print qq[
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>PowerSeek</title>
$HTML_ENCODING_USE
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
</head>
<body>
$hbox

<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/ic_pop2.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><strong><a
    href="$admin_url/p_tmpglobal.cgi?fct=wizard1">Start the Wizard to Implement a Global
    Template </a></strong><br>
    (Note that any changes to existing templates will be lost!) </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/ic_backup1.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><strong><a
    href="$admin_url/p_tmpglobal.cgi?fct=restore">Restore PowerSeek's Original Templates </a><br>
    </strong>(Note that any changes to existing templates will be lost!) </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

</body>
</html>

];


}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

