#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#use FindBin;
#use lib $FindBin::Bin;

use CGI;
#use strict;
use CGI::Carp qw(fatalsToBrowser);
use sn_netbadmin;

use vars qw/$exists $line $data_dir $web_url $scripts_url $scripts_admin $r $q $debug $flocking $rsts $csize $version
           $crit $web_path $sendmail_loc $c_username $c_password/;

$q = CGI->new;

### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################



$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbadmin::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbadmin::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbadmin::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbadmin::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbadmin::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbadmin::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbadmin::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbadmin::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbadmin::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbadmin::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbadmin::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbadmin::get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

sn_netbadmin::check_access($c_username, $c_password, $q->param('c_username'), $q->param('c_password'));


print $q->header();

if ($q->param('fct') eq "fp_templates")  {&fp_templates; exit;}
if ($q->param('fct') eq "edit_template") {&edit_template; exit;}
if ($q->param('fct') eq "save_template") {&save_template; exit;}
if ($q->param('fct') eq "post_msg_templates") {&post_msg_templates; exit;}
if ($q->param('fct') eq "reg_templates") {&reg_templates; exit;}
if ($q->param('fct') eq "search_templates") {&search_templates; exit;}
if ($q->param('fct') eq "mod_templates") {&mod_templates; exit;}

if ($q->param('fct') eq "restore_default1") {&restore_default1; exit;}
if ($q->param('fct') eq "restore_default2") {&restore_default2; exit;}

if ($q->param('fct') eq "global") {&global; exit;}
if ($q->param('fct') eq "topic_templates") {&topic_templates; exit;}
if ($q->param('fct') eq "topic_msg_templates") {&topic_msg_templates; exit;}

if ($q->param('fct') eq "lprev") {&lprev; exit;}





###############################################################################





sub mod_templates
{

&get_template_help;

$template_items[0] = "sn_mod_login::0::PAGETITLE";
$template_items[1] = "";
$template_items[2] = "sn_mod_global::0::PAGETITLE";

$template_items[3] = "";

$template_items[4] = "sn_mod_table_main::2";
$template_items[5] = "sn_mod_cells_cat::3";
$template_items[6] = "sn_mod_cells_forum::3";

$template_items[7] = "";

$template_items[8] = "sn_mod_del_table::2";
$template_items[9] = "sn_mod_del_cells::3";
$template_items[10] = "sn_mod_del_unable::2";

$template_items[11] = "sn_mod_del_error::2";
$template_items[12] = "sn_mod_del_success::2";

$template_items[13] = "";

$template_items[14] = "sn_forum_settings::2";
$template_items[15] = "sn_forum_settings_saved::2";

$template_items[16] = "";

$template_items[17] = "sn_mod_mod_frame::2";
$template_items[18] = "sn_mod_mod_cells::3";
$template_items[19] = "sn_mod_mod_success_appr::2";
$template_items[20] = "sn_mod_mod_del::2";
$template_items[21] = "sn_mod_mod_error::2";

print &get_table(@template_items);

}



sub search_templates
{

&get_template_help;

$template_items[0] = "sn_search_page::0::PAGETITLE";
$template_items[1] = "sn_search_dropdown::2";
$template_items[2] = "sn_search_results_page::0::PAGETITLE";
$template_items[3] = "sn_search_results::2";
$template_items[4] = "sn_search_nomatch::0::PAGETITLE";

print &get_table(@template_items);

}



sub reg_templates
{

&get_template_help;

$template_items[0] = "sn_terms::0::PAGETITLE";
$template_items[1] = "sn_regform::0::PAGETITLE";
$template_items[2] = "sn_reg_success::0::PAGETITLE";
$template_items[3] = "";
$template_items[4] = "sn_edit_profile::0::PAGETITLE";
$template_items[5] = "sn_profile_saved::0::PAGETITLE";
$template_items[6] = "";
$template_items[7] = "sn_view_profile::0::PAGETITLE";
$template_items[8] = "sn_view_profile_login::0::PAGETITLE";
$template_items[9] = "";
$template_items[10] = "sn_login_screen::0::PAGETITLE";
$template_items[11] = "sn_login_success::0::PAGETITLE";
$template_items[12] = "sn_logout_screen::0::PAGETITLE";
$template_items[13] = "sn_retrieveps::0::PAGETITLE";
$template_items[14] = "sn_passwd_sent::0::PAGETITLE";

print &get_table(@template_items);

}



sub restore_default2
{

$template = $q->param('t');


$tdata = sn_netbadmin::get_file_contents("$data_dir/$template.def");

if ($tdata eq "")
	{
	$hbox = sn_netbadmin::get_heading_box("$web_url/sn_templateb.gif", "Error: Could not find: $template.def", qq[
	Unable to restore factory default template.
	]);

	print qq[
	<html>
	<head>
	<title>Problem</title>
	<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
	</head>
	<body>
	$hbox
	</body>
	</html>
	];
	exit;
	}
	else
	{
	open (DATAD, "> $data_dir/$template.html");
	print DATAD $tdata;
	close (DATAD);

	
	$hbox = sn_netbadmin::get_heading_box("$web_url/sn_templateb.gif", "Factory Default Template Restored", qq[
	<a href="$scripts_admin/sn_admin8.cgi?fct=edit_template&template=$template">Click Here to Continue</a>
	]);

	print qq[
	<html>
	<head>
	<title>Restore Complete</title>
	<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
	</head>
	<body>
	$hbox
	</body>
	</html>
	];

	}

}



sub restore_default1
{

$template = $q->param('template');

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_templateb.gif", "Restore Factory Default Template", qq[
This will restore the factory default template to <b>$template.html</b> that came with SiteNet BBS when SiteNet BBS was first installed.
Any changes to the existing template will be lost. <BR><BR>
<b>Are you sure you want to do this? </b>
<b><a href="$scripts_admin/sn_admin8.cgi?t=$template&fct=restore_default2">Yes</a> | <a href="" onClick="history.go(-1); return false;">No</a></b>
]);

print qq[
<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];



}



sub save_template
{

if ($q->param('B2') ne "") { &restore_default1; exit;}

$template = $q->param('template');
$ptname = $template;
$ptname =~ s/\.html//g;

if ($q->param('locsep') ne "") 
	{
	open (TFILE, "> $data_dir/sn_locsep.html");
	print TFILE $q->param('locsep');
	close (TFILE);
	}


if ($q->param('pagetitle') ne "") ### IF WE NEED TO SAVE A PAGE TITLE
	{
	$ptdata = sn_netbadmin::get_file_contents("$data_dir/sn_pagetitles.html");
	@pitems = split (/\n/, $ptdata);

	foreach $item (@pitems)
		{
		if ($item ne "")
		 {
		 ($tname, $tval) = split (/\t/, $item);

			if ($tname ne $ptname)
				{
				$ptowrite = $ptowrite . $item . "\n";
				}
  		 }
		}

   open (PGT, "> $data_dir/sn_pagetitles.html");
   	print PGT $ptname . "\t" . $q->param('pagetitle') . "\n";
   	print PGT $ptowrite;
   close (PGT);
	}





#open (PAGETITLES, "> $data_dir/sn_pagetitles.html");
#close (PAGETITLES);


open (TFILE, "> $data_dir/$template.html");
print TFILE $q->param('etemplate');
close (TFILE);

$hbox = sn_netbadmin::get_heading_box("$web_url/sn_templateb.gif", "Template Saved", qq[
<p><a href="http://" onClick="self.close();return false">Close This Window</a> | <a
href="$scripts_admin/sn_admin8.cgi?fct=edit_template&template=$template">Click Here to Continue Editing Template</a></p>
]);

print qq[
<html>
<head>
<title>Ban Users</title>
<link href="$web_url/sn.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}




sub edit_template
{

$template = $q->param('template');

&get_template_help;

$etemplate = sn_netbadmin::get_file_contents("$data_dir/$template.html");
$etemplate =~ s/&/&amp;/gi;
$etemplate =~ s/</&lt;/gi;
$etemplate =~ s/>/&gt;/gi;


if ($q->param('ebox') eq "locsep") ### IF EDITING GLOBAL LOCATION TEMPLATE
	{
	$locsep = sn_netbadmin::get_file_contents("$data_dir/sn_locsep.html");
	
	$extra_options = qq[
	<BR><BR>
<table border="0" width="100%" cellpadding="0" cellspacing="0">
  <tr>
    <td width="100%" height="30"><strong><font face="Arial" size="2">Specify by what the
    location items should be seperated by:</font></strong></td>
  </tr>
  <tr>
    <td width="100%" height="30"><textarea rows="2" name="locsep" cols="20" style="width:100%">$locsep</textarea></td>
  </tr>
</table>
<BR>
	];
	}
elsif ($q->param('ebox') eq "nextprev") ### IF EDITING GLOBAL LOCATION TEMPLATE
	{
	$locsep = sn_netbadmin::get_file_contents("$data_dir/sn_locsep.html");
	
$extra_options = qq[
	<BR><BR>
<table border="0" width="100%" cellpadding="6" cellspacing="1">
  <tr>
    <td width="100%" height="30" colspan="2"><font face="Arial" size="2"><strong>Extra Options
    Regarding This Template:</strong></font></td>
  </tr>
  <tr>
    <td width="30%" style="border-right: 1px solid rgb(228,228,228)"><font face="Arial"
    size="2">Text indicating a 'Next Page':</font></td>
    <td width="70%"><input type="text" name="nextpage" size="31"></td>
  </tr>
  <tr>
    <td width="30%" style="border-right: 1px solid rgb(228,228,228)"><font face="Arial"
    size="2">Text indicating a 'Previous' Page:</font></td>
    <td width="70%"><input type="text" name="prevpage" size="31"></td>
  </tr>
  <tr>
    <td width="30%" style="border-right: 1px solid rgb(228,228,228)"><font face="Arial"
    size="2">If there is a 'Next Page' and a 'Previous Page' specify a seperator:</font></td>
    <td width="70%"><input type="text" name="nextprev_sep" size="9"></td>
  </tr>
</table>
<BR>
	];
	}


if ($q->param('p') eq "Y") ### IF WE NEED TO RECORD PAGE TITLES
	{
		$ptdata = sn_netbadmin::get_file_contents("$data_dir/sn_pagetitles.html");
		@pitems = split (/\n/, $ptdata);
		foreach $item (@pitems)
		{
		($tname, $tval) = split (/\t/, $item);
		$pgtitle{$tname} = $tval;
		}
	
	$pgbox = qq[
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="100%" height="25"><strong><font face="Verdana" size="2">Page Title when
    displaying this template:</font></strong></td>
  </tr>
  <tr>
    <td width="100%" height="30"><input type="text" name="pagetitle" size="58"
    style="width:100%" value="$pgtitle{$template}"> </td>
  </tr>
</table>
];
	}





print qq[

<html>

<head>
<title>Control Panel</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}

.verd {
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 10px;
	line-height: 18px;
}


p {
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;


}
.normaltext {
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 12px;
	line-height: 18px;

}

.popup
{
COLOR: #0000FF;
CURSOR: help;
TEXT-DECORATION: none
}

</style>

<script LANGUAGE="JavaScript">
	<!-- Hide

	var popupwin = null;
	  function popup(loc,ww,hh)
	   {
	    var mywidth = (ww + 0);
	    var myheight = (hh + 0);
	    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	      if (popupwin == null || popupwin.closed)
				{
	            popupwin = window.open (loc, 'popupwin', myspecs);
	           }
			 else
			   {
	            popupwin.focus();
	            popupwin.location.href = loc;
	          }
	    }

pic = new Image();
pic2 = new Image();
 function flip(pic, r, tsource)
  {
    if(r == 2) { document[pic].src = tsource; }
    if(r == 1) { document[pic].src = tsource; }
  }

var dropdownstat = ['0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0'];
function xmlhttpPost(strURL, display_area, ddown)
	{
    var xmlHttpReq = false;
    var self = this;

  	 if (dropdownstat[ddown] == 1)
  	 	{
  	 	strURL = '$scripts_admin/sn_admin8.cgi?fct=blank'; dropdownstat[ddown] = 0;
  	 	}
  	 else if  (dropdownstat[ddown] == 0)
  	 	{
  	 	dropdownstat[ddown] = 1;
  	 	}

    // Mozilla/Safari
    if (window.XMLHttpRequest) { self.xmlHttpReq = new XMLHttpRequest();  }

    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");}

    self.xmlHttpReq.open('GET', strURL, true);
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	self.xmlHttpReq.onreadystatechange = function()
    	   {
         if (self.xmlHttpReq.readyState == 4)
         		{
         		document.getElementById(display_area).innerHTML  = self.xmlHttpReq.responseText;
         		}
    		}

    // Mozilla/Safari
    if (window.XMLHttpRequest) {self.xmlHttpReq.send(strURL);}

    // IE
    else if (window.ActiveXObject) {self.xmlHttpReq.send();}
	}


// End Hide -->
</script>
</head>

<body>

<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="1%" valign="top" bgcolor="#FFFFFF"><img src="$web_url/sn_templateb.gif"></td>
    <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0"
    cellpadding="6">
      <tr>
        <td background="$web_url/sn_bar6.gif"><strong class="normaltext">Editing Template:
        $data_dir/$template.html</strong></td>
      </tr>
      <tr>
        <td class="normaltext"><b>Editing: $tname{$template}<br>
        </b>$thelp{$template}</td>
      </tr>
    </table>
    </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="100%" bgcolor="#FFFFFF"><font color="#FFFFFF">__</font></td>
  </tr>
</table>

<form method="POST" action="$scripts_admin/sn_admin8.cgi">
  <input type="hidden" name="fct" value="save_template"><input type="hidden" name="template"
  value="$template"><table width="100%" border="0" cellpadding="6" cellspacing="1"
  bordercolor="#DDDDDD" style="border: 1px solid rgb(225,225,225)">
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext" background="$web_url/sn_bar6.gif"><b>Template
      HTML Code:</b> (Copy and paste the HTML code into your web editor to edit). </td>
    </tr>
    <tr>
      <td width="100%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0">
        <tr>
          <td width="99%"><span class="normaltext"><strong><img src="$web_url/sn_lar5.gif"><a
          href="$scripts_admin/sn_admin10.cgi?t=$template"
          onClick="xmlhttpPost('$scripts_admin/sn_admin10.cgi?t=$template', 'result1', 1);return false;">Variables
          Used Inside This Template</a> (Please See)</strong></span></td>
          <td align="right" width="1%"><input type="button" value="    Select All    " name="B5"
          onClick="javascript:this.form.etemplate.focus();this.form.etemplate.select(); return false;"></td>
        </tr>
        <tr>
          <td colspan="2">
          <div id="result1"></div> 
          <textarea rows="25" name="etemplate" cols="101" style="width:100%">$etemplate</textarea>
          $extra_options </td>
        </tr>
      </table>
      $pgbox
      <p><input type="submit" value="Save Template" name="B1"> <input type="submit" value="Restore Factory Default Template" name="B2"></td>
    </tr>
  </table>
</form>

<table width="100%" border="0" cellpadding="3" style="border: 1px solid rgb(223,223,223)">
  <tr>
    <td width="100%" class="normaltext" colspan="2" height="30" background="$web_url/sn_bar6.gif"><strong><font
    face="Verdana" size="2">Template Help</font></strong></td>
  </tr>
  <tr>
    <td width="50%" class="normaltext"><font face="Verdana" size="2"><img
    src="$web_url/sn_lar3.gif"><a
    href="$scripts_admin/sn_admin11.cgi?fct=how_to_edit&amp;t=$template#1"
    onClick="xmlhttpPost('$scripts_admin/sn_admin11.cgi?fct=how_to_edit&amp;t=$template#1', 'result2', 2);return false;">How
    to Edit Templates</a></font></td>
    <td width="50%" class="normaltext"><font face="Verdana" size="2"><img
    src="$web_url/sn_lar3.gif"><a
    href="$scripts_admin/sn_admin11.cgi?fct=manual_edit&amp;t=$template#1"
    onClick="xmlhttpPost('$scripts_admin/sn_admin11.cgi?fct=manual_edit&amp;t=$template#1', 'result2', 3);return false;">How
    to Manually Edit This HTML File</a></font></td>
  </tr>
  <tr>
    <td width="50%" class="normaltext"><font face="Verdana" size="2"><img
    src="$web_url/sn_lar3.gif"><a href="$scripts_admin/sn_admin11.cgi?fct=images&amp;t=$template#1"
    onClick="xmlhttpPost('$scripts_admin/sn_admin11.cgi?fct=images&amp;t=$template#1', 'result2', 4);return false;">How
    to Use Images In Templates</a></font></td>
    <td width="50%" class="normaltext"></td>
  </tr>
  <tr>
    <td width="100%" class="normaltext" colspan="2"><div id="result2"></div></td>
  </tr>
</table>
<BR>


<table width="100%" border="0" cellpadding="6" cellspacing="1" bordercolor="#DDDDDD"
style="border: 1px solid rgb(225,225,225)">
  <tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext" background="$web_url/sn_bar6.gif"><b><font
    face="Verdana" size="2">Template Only Preview:</font></b></td>
  </tr>
  <tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="2"><strong>Important
    Preview Note:</strong> Take note that some templates are combined with other templates to
    form one page. In other words, many templates work together with other templates. This
    preview pane will not display templates combined with other templates and will display the
    preview of the single template being edited now only.</font></td>
  </tr>
  <tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext">
    
      <IFRAME src="$scripts_admin/sn_admin12.cgi?fct=if_prev&template=$template" width="100%" height="500">
	  	    <!--webbot bot="HTMLMarkup" endspan --> <!--webbot bot="HTMLMarkup" startspan -->
 	    </IFRAME>
    
    </td>
  </tr>
</table>

<table border="0" width="100%">
  <tr>
    <td width="100%" height="20"></td>
  </tr>
</table>

<table width="100%" border="0" cellpadding="6" cellspacing="1" bordercolor="#DDDDDD"
style="border: 1px solid rgb(225,225,225)">
  <tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext" background="$web_url/sn_bar6.gif"><b><font
    face="Verdana" size="2">Rendered Preview:</font></b></td>
  </tr>
  <tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext"><font face="Verdana" size="2"><strong>Important
    Preview Note:</strong> This preview pane will display the current template being edited
    combined with other templates (if applicable) to form a complete page. Some templates work
    together with other templates to form one page. Note that in some instances that some
    templates work alone and are not combined with other templates. Take note that most
    hyperlinks in the template displayed below won't work. The display is only for previewing
    purposes.</font></td>
  </tr>
  <tr>
    <td valign="top" bgcolor="#FFFFFF" class="normaltext">
       <IFRAME src="$scripts_admin/sn_admin12.cgi?fct=preview&template=$template" width="100%" height="500">
 	    <!--webbot bot="HTMLMarkup" endspan --> <!--webbot bot="HTMLMarkup" startspan -->
 	    </IFRAME>
    </td>
  </tr>
</table>

</body>
</html>
];


}




sub fp_templates
{
&get_template_help;

$template_items[0] = "sn_fp_frame::";
$template_items[1] = "sn_fp_toptable::2";
$template_items[2] = "sn_fp_celcat::2";
$template_items[3] = "sn_fp_forumcel::2";

print &get_table(@template_items);
}



sub post_msg_templates
{

&get_template_help;

$template_items[0] = "sn_post_topic::0::PAGETITLE";
$template_items[1] = "sn_post_reply::0::PAGETITLE";

$template_items[2] = "sn_post_reply_prev::0::PAGETITLE";

$template_items[3] = "sn_post_success::0::PAGETITLE";
$template_items[4] = "sn_post_success_mod::0::PAGETITLE";

$template_items[5] = "::";

$template_items[6] = "sn_post_poll::0::PAGETITLE";
$template_items[7] = "sn_post_poll_success::0::PAGETITLE";
$template_items[8] = "sn_post_poll_success_mod::0::PAGETITLE";

$template_items[9] = "::";

$template_items[10]  = "sn_not_logged_in::0::PAGETITLE";

$template_items[11] = "::";

$template_items[12] = "sn_edit_msg::0::PAGETITLE";
$template_items[13] = "sn_edit_saved::0::PAGETITLE";
$template_items[14] = "sn_edit_unable::0::PAGETITLE";

$template_items[15] = "::";
$template_items[16] = "sn_msgtags::0::PAGETITLE";

print &get_table(@template_items);

}




sub topic_msg_templates
{

&get_template_help;

$template_items[0] = "sn_topmsg_frame::";
$template_items[1] = "sn_first_msg::1";
$template_items[2] = "sn_reply_msg::1";
$template_items[3] = "sn_quote::2";
$template_items[4] = "sn_poll::";
$template_items[5] = "sn_vote_frame_table::1";
$template_items[6] = "sn_vote_table_cells::2";
$template_items[7] = "sn_results_frame_table::1";
$template_items[8] = "sn_results_table_cells::2";


print &get_table(@template_items);

}



sub topic_templates
{

&get_template_help;

$template_items[0] = "sn_topic_globalframe::";
$template_items[1] = "sn_topic_list_table_top::1";
$template_items[2] = "sn_topic_list_table_cells::1";
$template_items[3] = "sn_topic_list_poll_cells::1";
$template_items[4] = "sn_topic_list_no_topics::1";
$template_items[5] = "";
$template_items[6] = "sn_passwd::0::PAGETITLE";

#$template_items[3] = "topic_display_globalframe";
#$template_items[4] = "topic_display_first_msg";
#$template_items[5] = "topic_display_replies";
#$template_items[6] = "post_button";
#$template_items[7] = "reply_button";

print &get_table(@template_items);

}





sub global
{

&get_template_help;

$template_items[0] = "sn_globalframe";
$template_items[1] = "sn_globlocation";
$template_items[2] = "sn_globalmodstyle";

$template_items[3] = "sn_globalnewdd";
$template_items[4] = "sn_globaljump";

$template_items[5] = "sn_fp_moderators";

$template_items[6] = "sn_last_visitors";

$template_items[7] = "globalprevnext";
$template_items[8] = "globalwhopost";

print &get_table(@template_items);

}




#sub gadgets
#{
#&get_template_help;
#print &get_table(@template_items);
#}






sub get_template_help
{

#### MODERATOR TEMPLATES

$tname{'sn_mod_global'} = "Moderator Global Frame";
$thelp{'sn_mod_global'} = "This template acts like a frame around all moderator functions when logged into the Moderator/Administrator Control Panel.";

####

$tname{'sn_mod_login'} = "Moderator Login";
$thelp{'sn_mod_login'} = "This template prompts a moderator to login when the 'Moderator' button is clicked.";

####

$tname{'sn_mod_table_main'} = "Forum Table Start";
$thelp{'sn_mod_table_main'} = "This template is used to create the table instance displaying forum categories and forums within the categories when a Moderator or Administrator logs in.";

$tname{'sn_mod_cells_cat'} = "Forum Category Table Cells";
$thelp{'sn_mod_cells_cat'} = "This template is used to display the table listing forum categories.";

$tname{'sn_mod_cells_forum'} = "Forum Table Cells";
$thelp{'sn_mod_cells_forum'} = "This template is used to display the table cells containing forums.";

$tname{'sn_mod_del_unable'} = "Unable to Delete Topics Error";
$thelp{'sn_mod_del_unable'} = "When a Forum has messages waiting for approval from a Moderator or Administrator then messages cannot be deleted from the Forum. This table cell will be displayed in such a situation.";




#####

$tname{'sn_mod_del_table'} = "Topic Delete Table Frame";
$thelp{'sn_mod_del_table'} = "When a Moderator or Administrator chooses to delete messages then this template is used to create the table instance displaying topics (topics in table cells) that can be chosen to be deleted.";

$tname{'sn_mod_del_cells'} = "Topic Delete Table Cells";
$thelp{'sn_mod_del_cells'} = "This template displays table cells containing topics that can be chosen to be deleted by Moderators or Administrators.";

$tname{'sn_mod_del_success'} = "Topic Successfully Deleted";
$thelp{'sn_mod_del_success'} = "This template is displayed to a Moderator or Administrator informing him/her that topics has been deleted.";

$tname{'sn_mod_del_error'} = "Topic Delete Error";
$thelp{'sn_mod_del_error'} = "This template is displayed when nothing was selected to be deleted.";

#####

$tname{'sn_forum_settings'} = "Forum Settings";
$thelp{'sn_forum_settings'} = "This template is displayed so that a Moderator or Administrator can set options for the current Forum.";

$tname{'sn_forum_settings_saved'} = "Forum Settings Saved";
$thelp{'sn_forum_settings_saved'} = "This template is displayed when forum settings was saved.";

####

$tname{'sn_mod_mod_frame'} = "Moderation Frame";
$thelp{'sn_mod_mod_frame'} = "When a forum is moderated (messages needs approval by moderators before displaying) then this template will act like a frame/table around messages (in cells) that needs approval.";

$tname{'sn_mod_mod_cells'} = "Moderation Cells";
$thelp{'sn_mod_mod_cells'} = "These cells will contain messages where moderators can select to approve or delete messages that needs approval when moderation is enabled for a forum.";

$tname{'sn_mod_mod_success_appr'} = "Moderation Approval Success";
$thelp{'sn_mod_mod_success_appr'} = "This template is displayed when a moderator has approved messages for display.";

$tname{'sn_mod_mod_del'} = "Moderation Messages Deleted";
$thelp{'sn_mod_mod_del'} = "This template is displayed when messages has been deleted by a moderator when viewing messages to approve/delete for display.";

$tname{'sn_mod_mod_error'} = "Moderation Error No Messages Selected";
$thelp{'sn_mod_mod_error'} = "This template will be displayed when attempting to approve or delete messages and no items was selected.";





#### SEARCH RESULTS TEMPLATES

$tname{'sn_search_page'} = "Search Page/Options";
$thelp{'sn_search_page'} = "This template displays a search form to perform a search.";

$tname{'sn_search_dropdown'} = "Search Page Drop Down Menu Style";
$thelp{'sn_search_dropdown'} = "This template defines the look and feel of the drop down menu listing forums that can be searched.";

$tname{'sn_search_results_page'} = "Search Results Page";
$thelp{'sn_search_results_page'} = "This template defines the look and feel of the page displaying search results.";

$tname{'sn_search_results'} = "Search Results";
$thelp{'sn_search_results'} = "This template defines the look and feel of the search results displayed when a search was displayed.";

$tname{'sn_search_nomatch'} = "No Match Template";
$thelp{'sn_search_nomatch'} = "This template is displayed when no match was found for a search.";




#### REGISTRATION TEMPLATES

$tname{'sn_terms'} = "Registration Terms and Conditions";
$thelp{'sn_terms'} = "This template is displayed when a user chooses to register. The user needs to agree to the terms and conditions before proceeding to register an account.";

$tname{'sn_regform'} = "Registration Form";
$thelp{'sn_regform'} = "This template is displayed prompting the user to complete his/her details to register an account.";

$tname{'sn_reg_success'} = "Registration Success";
$thelp{'sn_reg_success'} = "This template is displayed after a user successfully registered an account.";

$tname{'sn_login_screen'} = "Login";
$thelp{'sn_login_screen'} = "This template is displayed so that a user can login.";

$tname{'sn_logout_screen'} = "Log-Out";
$thelp{'sn_logout_screen'} = "This template is displayed after a user logged out.";

$tname{'sn_login_success'} = "Sucessfully Logged in";
$thelp{'sn_login_success'} = "This template is displayed to tell him/her that he/she has successfully logged in.";

$tname{'sn_edit_profile'} = "Edit Profile";
$thelp{'sn_edit_profile'} = "This template is displayed when a user edits his/her profile.";

$tname{'sn_profile_saved'} = "Profile Saved";
$thelp{'sn_profile_saved'} = "This template is displayed when a user changed details of his/her profile and saved the changes.";

$tname{'sn_view_profile'} = "View User Profiles";
$thelp{'sn_view_profile'} = "This template is used to display user profiles when a user clicks on member names to view profiles.";

$tname{'sn_view_profile_login'} = "Not Logged In To View Profiles";
$thelp{'sn_view_profile_login'} = "This template is displayed to a user trying to view a profile that is not logged in. Users need to be logged in to view profiles.";

$tname{'sn_retrieveps'} = "Retrieve Password";
$thelp{'sn_retrieveps'} = "This template is displayed to enable users to retrieve their passwords.";

$tname{'sn_passwd_sent'} = "Password Retrieved";
$thelp{'sn_passwd_sent'} = "This template is displayed to inform a user that his/her password has been sent to their email address.";



#### MESSAGE/POLL POSTING TEMPLATES

$tname{'sn_post_topic'} = "Post a New Topic";
$thelp{'sn_post_topic'} = "This template is displayed when a user posts a new message.";

$tname{'sn_post_reply'} = "Post a Reply";
$thelp{'sn_post_reply'} = "This template is displayed when a user posts a reply.";

$tname{'sn_post_reply_prev'} = "Message Preview";
$thelp{'sn_post_reply_prev'} = "This template is displayed when a user chooses to preview his/her message before posting it.";

$tname{'sn_icon_style'} = "Icon Display Style";
$thelp{'sn_icon_style'} = "This template defines the way selectable icons are displayed when a user posts a message.";

$tname{'sn_post_poll'} = "Post a New Poll";
$thelp{'sn_post_poll'} = "This template is displayed when a user posts a new poll.";

$tname{'sn_not_logged_in'} = "Not Logged in Message";
$thelp{'sn_not_logged_in'} = "This template is displayed to a user to tell him/her they he/she needs to be logged in to be able to post a new message.";

$tname{'sn_no_post_access'} = "Ip Banned - No Access";
$thelp{'sn_no_post_access'} = "This template is displayed to a user to tell him/her that their IP has been banned and that they can't post inside the forum.";

$tname{'sn_post_success'} = "Message Post Success";
$thelp{'sn_post_success'} = "This template is displayed to a user to tell him/her that their message was successfully posted.";

$tname{'sn_post_success_mod'} = "Message Post Success When Moderated";
$thelp{'sn_post_success_mod'} = "This template is displayed to a user to tell him/her that their message was successfully posted and will apear as soon as a moderator approved it for display. When moderation is turned on for a forum the messages needs to be approved by a moderator before they will be visible.";

$tname{'sn_post_poll_success'} = "Poll Post Success";
$thelp{'sn_post_poll_success'} = "This template is displayed to a user to tell him/her that their poll was successfully posted.";

$tname{'sn_post_poll_success_mod'} = "Poll Post Success When Moderated";
$thelp{'sn_post_poll_success_mod'} = "This template is displayed to a user to tell him/her that the poll they posted will be available as soon as a moderator approved it.";


$tname{'sn_edit_msg'} = "Message Editing";
$thelp{'sn_edit_msg'} = "This template is displayed to enable a User or Moderator or Administrator to edit a message.";

$tname{'sn_edit_unable'} = "Message Editing Problem";
$thelp{'sn_edit_unable'} = "This template is displayed when a user tries to edit a message but does not have access/permission to edit a message.";

$tname{'sn_edit_msg_ma'} = "Message Editing Moderators/Administrators";
$thelp{'sn_edit_msg_ma'} = "This template is used when a Moderator/Administrator edits a message.";

$tname{'sn_edit_saved'} = "Message Saved";
$thelp{'sn_edit_saved'} = "This template is displayed to indicate that a message that was edited is saved.";

$tname{'sn_msgtags'} = "Message Tags";
$thelp{'sn_msgtags'} = "This template is used to display what message tags can be used inside messages.";






### TOPIC/MESSAGE TEMPLATES

$tname{'sn_topmsg_frame'} = "Topic/Message Display Frame";
$thelp{'sn_topmsg_frame'} = "This template acts like a frame around topics and messages being displayed.";

#$tname{'sn_topic_top'} = "Topic/Message Header";
#$thelp{'sn_topic_top'} = "This template acts like a header for pages displaying topics/messages.";

$tname{'sn_first_msg'} = "First Topic/Message Style";
$thelp{'sn_first_msg'} = "This template defines the look and feel of the first message inside a topic.";

$tname{'sn_reply_msg'} = "Reply Messages Style";
$thelp{'sn_reply_msg'} = "This template defines the look and feel of replies in a topic.";

$tname{'sn_quote'} = "Message Quote Style";
$thelp{'sn_quote'} = "This template defines the look and feel when displaying quoted messages inside a message.";

$tname{'sn_poll'} = "Voting Poll Display Style";
$thelp{'sn_poll'} = "This template defines the look and feel when displaying a voting poll.";

$tname{'sn_vote_frame_table'} = "Poll Voting Table Frame";
$thelp{'sn_vote_frame_table'} = "This template defines a table that will contain cells with vote answers to choose from when voting.";

$tname{'sn_vote_table_cells'} = "Poll Voting Cells";
$thelp{'sn_vote_table_cells'} = "This template defines the style of the cells that contains cells with vote answers to choose from when voting.";

$tname{'sn_results_frame_table'} = "Poll Vote Results Table Frame";
$thelp{'sn_results_frame_table'} = "This template defines a table that will contain cells with vote results.";

$tname{'sn_results_table_cells'} = "Poll Vote Results Cells";
$thelp{'sn_results_table_cells'} = "This template defines the style of the cells that contains vote results.";


#### GLOBAL TEMPLATE

$tname{'sn_globalframe'} = "Global Frame Template";
$thelp{'sn_globalframe'} = "This template acts like a frame around all the pages of the forum. Edit this template to include your logo's, menu's, and other links of your web site.";

$tname{'sn_globlocation'} = "Global Location Template";
$thelp{'sn_globlocation'} = "This defines the look and feel of the 'Location Text with Links' indicating the location to end users when end users browse any of the Forum pages.";

$tname{'globalprevnext'} = "Previous Page / Next Page Text";
$thelp{'globalprevnext'} = "The text inside these templates are used to indicate a previous or next pages.";

$tname{'sn_globalmodstyle'} = "Administrator/Moderator Display Style";
$thelp{'sn_globalmodstyle'} = "On many forums the Administrators or Moderators are displayed. This defines the style when displaying the Administrators or Moderators";

$tname{'sn_globalnewdd'} = "Messages Posted In The Last XX Hours/Days";
$thelp{'sn_globalnewdd'} = "This templates defines the style of a Drop Down box that works with JavaScript to display messages in the last XX Hours/Days. Note that when the drop down function is used that a time icon is displayed next to messages to indicate that the message was posted within the last XX Hours/Days";

$tname{'sn_globaljump'} = "Drop Down Category/Forum Junp Box";
$thelp{'sn_globaljump'} = "This templates defines the style of a Drop Down box where users can choose to jump to a forum or forum category.";

$tname{'globalwhopost'} = "Who May Post Text";
$thelp{'globalwhopost'} = "In some locations it is specified who may post. You can customize the texts of who may post here.";






#### FRONT PAGE TEMPLATES

$tname{'sn_fp_frame'} = "Main Front Page Frame";
$thelp{'sn_fp_frame'} = "This template acts like a frame around the elements of the front page listing all Forum categories and Forums.";

$tname{'sn_fp_toptable'} = "Table Top & Declaration";
$thelp{'sn_fp_toptable'} = "This template creates the table instance of the Table listing all forums. Note that you have to know HTML to modify this template as this template is used to construct the table listing categories and forums.";

$tname{'sn_fp_celcat'} = "Category Cell";
$thelp{'sn_fp_celcat'} = "This template creates a table cell to display the category name of the Template. It works in conunction with 'sn_fp_toptable.html' to create a the table listing Forum Categories.";

$tname{'sn_fp_forumcel'} = "Forum Cell";
$thelp{'sn_fp_forumcel'} = "This template creates a table cell to display Forums inside the table listing Forum Categories and Forums. It works in conunction with 'sn_fp_toptable.html' and 'sn_fp_toptable.html' to form a table displaying the Forum Categories and Forums.";

$tname{'fp_modstyle'} = "Moderator/Admin Display Style";
$thelp{'fp_modstyle'} = "This template defines the look and feel when Displaying Moderators/Administrators for Forums from the Forum Front Page and Forum Categories pages.";

$tname{'sn_fp_moderators'} = "Moderators/Administrators style (in Forum Cells)";
$thelp{'sn_fp_moderators'} = "This template defines the style (look and feel) when displaying Moderators or Administrators in forum cells.";

### GADGETS

$tname{'sn_last_visitors'} = "Last Visitors Display Style";
$thelp{'sn_last_visitors'} = "This template defines the style (look and feel) when displaying 'Last Visitors' on Forum Pages.";


### TOPIC TEMPLATES

$tname{'sn_topic_globalframe'} = "Topic List Frame";
$thelp{'sn_topic_globalframe'} = "This template acts like a frame around the elements of the pages displaying Forum topics.";

$tname{'sn_topic_list_table_top'} = "Table Top & Declaration";
$thelp{'sn_topic_list_table_top'} = "This template creates the table instance of the Table listing all topics inside a Forum. Note that you have to know HTML to modify this template as this template is used to construct the table listing forum categories.";

$tname{'sn_topic_list_table_cells'} = "Topic Cells";
$thelp{'sn_topic_list_table_cells'} = "This template creates a table cell to display the Forum Topics. It works in conunction with 'sn_topic_list_table_top.html' to create a the table listing Forum Topics.";

$tname{'sn_topic_list_poll_cells'} = "Poll Cells";
$thelp{'sn_topic_list_poll_cells'} = "This template creates a table cell to display the cells indicating that the topic is a Poll where users can cast votes.";

$tname{'sn_topic_list_no_topics'} = "No Topics Available";
$thelp{'sn_topic_list_no_topics'} = "This table cell is displayed if there are no topics available in the current forum.";

$tname{'sn_passwd'} = "Password Protection Template";
$thelp{'sn_passwd'} = "This template is displayed prompting the user to supply the Forum password if the Forum is password protected.";






#$tname{'topic_display_globalframe'} = "Topic Messages Frame";
#$thelp{'topic_display_globalframe'} = "This template acts like a frame around the elements of the pages displaying the Messages of Forum Topics.";

#$tname{'topic_display_first_msg'} = "First Message";
#$thelp{'topic_display_first_msg'} = "This template defines the style of the first message when viewing a topic.";

#$tname{'topic_display_replies'} = "Topic Replies";
#$thelp{'topic_display_replies'} = "This template defines the style of all replies in a Topic.";

#$tname{'post_button'} = "Post New Message Button";
#$thelp{'post_button'} = "This template defines the style of the 'Post New Topic' button/link.";

#$tname{'reply_button'} = "Reply to Topic Button";
#$thelp{'reply_button'} = "This template defines the style of the 'Post Reply' button/link.";

}





sub get_table
{
my (@table_items) = @_;

my ($item_filename, $spacing, $disp_pagetitle);

$tstart = qq[
<table border="0" cellspacing="0" width="100%" cellpadding="0">
  <tr>
    <td height="25" colspan="2" class="normaltext"><font face="Verdana" size="2"><strong>Template
    Name: </strong>(Click to Edit)</font></td>
    <td width="35%" class="normaltext"><font face="Verdana" size="2"><strong>File Name</strong><a
    href="$admin_url/admin68.cgi?id=55" target="_blank"></a></font></td>
    <td width="10%" align="center" class="normaltext"><font face="Verdana" size="2"><strong>Preview</strong></font></td>
  </tr>
];



foreach $item (@table_items)
{

	  ($item_filename, $spacing, $disp_pagetitle) = split (/::/, $item);
	
		$space_to_add = "";
		for ($ms = 0; $ms < $spacing; $ms++)
			{
			$space_to_add = $space_to_add . "&nbsp;&nbsp; ";
			}
 	
 		if ($space_to_add eq "") { $arr_gr = "sn_lar3.gif"; } else { $arr_gr = "sn_lar6.gif"; }
	
	$extravar = "";
	if ($item_filename eq "sn_globlocation") { $extravar = "ebox=locsep"; }
	
	
	if ($item_filename eq "globalwhopost")
		{
	
	$tmiddle = $tmiddle . qq[
	<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
	<td width="1%" align="right" class="normaltext"></td>
	  <td width="50%" height="25" class="normaltext"><img src="$web_url/$arr_gr" border="0"><a href="$scripts_admin/sn_admin9.cgi?fct=whopost"
	  onClick="popup('$scripts_admin/sn_admin9.cgi?fct=whopost',screen.width-200,screen.height-200);return false;"><strong><span title="Click to edit" class="popup">$tname{$item_filename}</span></strong></a></td>
	<td class="normaltext"><span title=" Settings Only " class="popup">Settings Only</span></td>
	<td align="center" class="normaltext">
	</td>
	</tr>
	];
	
		}
		elsif ($item_filename eq "globalprevnext") 
		{ 

		$tmiddle = $tmiddle . qq[
		<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
		<td width="1%" align="right" class="normaltext"></td>
		  <td width="50%" height="25" class="normaltext"><img src="$web_url/$arr_gr"  border="0"><a href="$scripts_admin/sn_admin9.cgi?fct=prevnext"
		  onClick="popup('$scripts_admin/sn_admin9.cgi?fct=prevnext',screen.width-200,screen.height-200);return false;"><strong><span title="Click to edit" class="popup">$tname{$item_filename}</span></strong></a></td>
		<td class="normaltext"><span title=" Settings Only " class="popup">Settings Only</span></td>
		<td align="center" class="normaltext">
		</td>
		</tr>
		];
		}
		elsif ($item_filename eq "")
		{
		
		$tmiddle = $tmiddle . qq[
		  <tr>
		    <td width="1%" align="right" class="normaltext"></td>
		    <td width="50%" height="10" class="normaltext"></td>
		    <td class="normaltext"></td>
		    <td align="center" class="normaltext"></td>
		  </tr>
		];
		
		}
		else
		{
	
		$help2 = "This file can also be manually edited with your web editor. It can be obtained from: $data_dir/$item_filename.html";
		
		$p = "";
		if ($disp_pagetitle eq "PAGETITLE") { $p = "Y"; }
	
		$tmiddle = $tmiddle . qq[
		   <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
		     <td width="1%" align="right" class="normaltext"></td>
		     <td width="50%" height="25" class="normaltext">$space_to_add<img src="$web_url/$arr_gr" border="0"><a
		     href="$scripts_admin/sn_admin8.cgi?fct=edit_template&amp;template=$item_filename&amp;$extravar&p=$p"
		     onClick="popup('$scripts_admin/sn_admin8.cgi?fct=edit_template&amp;template=$item_filename&amp;$extravar&p=$p',screen.width-200,screen.height-200);return false;"><strong><span
		     title="$thelp{$item_filename}" class="popup">$tname{$item_filename}</span></strong></a></td>
		     <td class="normaltext"><span title=" $help2 " class="popup">$item_filename.html</span></td>
		     <td align="center" class="normaltext"><span
		     title=" Click the 'Preview' link to see a preview of how this template looks like. Note that it may be combined with other templates to form one single page. "
		     class="popup"><a href="$scripts_admin/sn_admin12.cgi?template=$item_filename&fct=preview" target="_blank">Preview</a></span></td>
		  </tr>
		 ];
		}

}

	
$ret_table = $tstart . $tmiddle . "</table>";

return ($ret_table);


}







