#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

package sn_tmpl;

use CGI;
#use strict;
use CGI::Carp qw(fatalsToBrowser);
require Exporter;


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $rsts
				@ISA @EXPORT @EXPORT_OK $csize $web_path $sendmail_loc/;


@ISA = qw(Exporter);

@EXPORT = qw(	get_template_vars
					); ### FUNCTiONS

@EXPORT_OK = qw(
						$return_val); ### RETURN VALUES
						
						
#################################################################################


$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = &get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = &get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = &get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = &get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = &get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = &get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = &get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = &get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = &get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = &get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

			}
	close (STP);

	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}



sub get_setup_line
{
my ($setup_line, $setup_var) = @_;

#print "==> $setup_line - $setup_var <br>";

#### WITHOUT "
$crit = "\"";
if ($setup_line !~ /$crit/)
	{
	$setup_line =~ s/$setup_var//g; 
	$setup_line =~ s/ //g;
	$return_val = $setup_line;
	}
	else
	{
	#$setup_line =~ s/$crit/1:1/;
	
	$setup_line =~ m/$crit/g;
	$r1 = pos($setup_line);
	
	$setup_line =~ m/$crit/g;
	$r2 = pos($setup_line);

	$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
	
	$return_val = $setup_line;
	}

#### WITH "

return ($return_val);
}  



#### END CONFIGURATION ########################################################


sub get_template_vars
{
my ($tname) = @_;

### TEMPATE NAME - VARIABLE - HEAD/DIZ

### sn_globalframe.html

if ($tname eq "sn_globalframe")
{
$details_blob = qq[!!logo!!---
This is replaced by a logo graphic. This graphic can be defined inside the SiteNet BBS Control Panel >> Settings >> Global Forum Settings
-o-
!!forum_name!!---
This is replaced by the name of your forums. This can be defined inside the SiteNet BBS Control Panel >> Settings >> Global Forum Settings
-o-
!!forums!!---
This is replaced by SiteNet BBS functions and other templates. Remember that this template acts like a frame around the Forums with Forum functions inside.
];
}

### sn_globlocation.html

elsif ($tname eq "sn_globlocation")
{
$details_blob = qq[!!location_link!!---
This is replaced by a URL indicating to where a current location is indicated.
-o-
!!location!!---
Replaced by a location name. Part of a string indicating a location where the current user resides.
];
}

### sn_globalmodstyle.html

elsif ($tname eq "sn_globalmodstyle")
{
$details_blob = qq[!!mod_adm_link!!---
This is replaced by a URL when displaying a Moderator or Administrator of a Forum. When clicked the profile of the Moderator/Administrator can be viewed.
-o-
!!mod_adm!!---
Replaced by the name of a Moderator or Administrator.
];
}

### sn_globalnewdd.html

elsif ($tname eq "sn_globalnewdd")
{
$details_blob = qq[!!forum_script!!---
Replaced by the path of the script that will display topics posted in the last xx hours/days.
-o-
!!cid!!---
Replaced by a category ID of a Forum where the new topics will be indicated or topics that had replies in the last xx hours/days.
-o-
!!fid!!---
Replaced by a Forum ID of a Forum where the new topics will be indicated or topics that had replies in the last xx hours/days.

];
}

### sn_globaljump.html

elsif ($tname eq "sn_globaljump")
{
$details_blob = qq[!!global_jump!!---
Replaced by the path to the script that will handle the jump/redirect to the Forum a user chose from the Forum Jump Drop Down Menu.
-o-
!!select_options!!---
Displays categories with forums that can be selected from a drop down menu.
];
}

### sn_fp_moderators.html

elsif ($tname eq "sn_fp_moderators")
{
$details_blob = qq[!!modadm_link!!---
This is replaced by a URL when displaying a Moderator or Administrator of a Forum. When clicked the profile of the Moderator/Administrator can be viewed.
-o-
!!modadm!!---
Replaced by the name of a Moderator or Administrator.
];
}

### sn_last_visitors.html

elsif ($tname eq "sn_last_visitors")
{
$details_blob = qq[!!visitor_link!!---
Replaced by a URL that can be clicked to view the profile of a user/visitor.
-o-
!!visitor_name!!---
Replaced by the name of a 'last visitor'
];
}

########################################################################################
# 2. Forum Front Page & Category Templates
########################################################################################

### sn_fp_frame.html

elsif ($tname eq "sn_fp_frame")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o- 
!!forum_name!!---
Replaced by the name of the Forums. This can be defined inside the SiteNet BBS Control Panel >> Settings >> Global Forum Settings
-o-
!!total_users!!---
Replaced by the total number of registered users.
-o-
!!total_messages!!---
Replaced by the total number of all messages inside all Forums.
-o-
!!total_topics!!---
Replaced by the total number of topics inside all Forums.
-o-
!!total_replies!!---
Replaced by the total number of replies to topics in all Forums.
-o-
!!category_forum_table!!---
Replaced by a table listing the Forum Categories with their Forums.
-o-
!!last_visitors!!---
Replaced by last visitors to the Forums. Works in conjunction with Template Manager >> 1. Global Templates & Gadgets >> Last Visitors Display Style (sn_last_visitors.html)
];
}

### sn_fp_toptable.html

elsif ($tname eq "sn_fp_toptable")
{
$details_blob = qq[
];
}

### sn_fp_celcat.html

elsif ($tname eq "sn_fp_celcat")
{
$details_blob = qq[!!category_links!!---
This is replaced by a URL that when clicked a user will be taken to a Forum Category.
-o-
!!category_names!!---
This is replaced by the name of a Forum Category inside a table cell.
];
}

### sn_fp_forumcel.html

elsif ($tname eq "sn_fp_forumcel")
{
$details_blob = qq[!!whop!!---
Replaced by an icon indicating if all users or moderators/administrators may post messages.
-o-
!!forum_names!!---
Replaced by the name of Forums in table cells.
-o-
!!forum_links!!---
Replaced by URLs to Forums and when clicked the user is taken to the Forum.
-o-
!!forum_description!!---
Replaced by the description of Forums in table cells.
-o-
!!topics!!---
Replaced by the number of topics inside Forums in table cells.
-o-
!!replies!!---
Replaced by the number of replies inside Forums in table cells.
-o-
!!last_post_date!!---
Replaced by the last date a topic was posted to Forums.
-o-
!!last_poster!!---
Replaced by the user who last posted inside Forums.
-o-
!!last_poster_link!!---
Replaced by a URL that can be clicked to the last user who posted inside Forums.
-o-
!!moderators!!---
Replaced by a list of moderators for Forums.
];

}

########################################################################################
# 3. Topic List Display Templates
########################################################################################

### sn_topic_globalframe.html

elsif ($tname eq "sn_topic_globalframe")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!next_page!!---
This is replaced by 'Next Page' / 'Previous Page' links. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Previous Page / Next Page Text (Settings Only)
-o-
!!current_page!!---
Replaced by the number of the current page.
-o-
!!total_pages!!---
Replaced by the total number of pages containing topics.
-o-
!!new_messages_drop_down!!---
Replaced by a drop down menu where a user can select to indicate new messages since xx number of hours/days. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Messages Posted In The Last XX Hours/Days (sn_globalnewdd.html)
-o-
!!total_t!!---
Replaced by a number indicating the total number of topics in the current Forum.
-o-
!!total_r!!---
Replaced by a number indicating the total number of replies in the current Forum.
-o-
!!total_m!!---
Replaced by a number indicating the total number of messages (topics and replies) in the current Forum.
-o-
!!new_topic_button!!---
Replaced by a button that can be clicked to post a new Topic/Message.
-o-
!!new_poll_button!!---
Replaced by a button that can be clicked to post a new Poll.
-o-
!!moderators!!---
Replaced by the moderators of the current Forum a user resides in. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Moderators/Administrators style (in Forum Cells) (sn_fp_moderators.html)
-o-
!!forums!!---
Replaced by the list of Topics available inside the Forum.
-o-
!!pages!!---
Replaced by page numbers with links to these pages containing Topics.
-o-
!!forumjump!!---
Replaced by a drop down menu where users can select a Forum to jump to. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Drop Down Category/Forum Junp Box (sn_globaljump.html)
-o-
!!post_users!!---
Indicates who may post.
-o-
!!last_visitors!!---
Replaced by last visitors to the Forums. Works in conjunction with Template Manager >> 1. Global Templates & Gadgets >> Last Visitors Display Style (sn_last_visitors.html)
];
}

### sn_topic_list_table_top.html
elsif ($tname eq "sn_topic_list_table_top")
{
$details_blob = qq[
];
}

### sn_topic_list_table_cells.html
elsif ($tname eq "sn_topic_list_table_cells")
{
$details_blob = qq[!!icon!!---
Replaced by an icon indicating if the topic is 'sticky', locked or new.
-o-
!!smily!!---
Replaced by a smiley icon that a user selected when posting a new topic.
-o-
!!topic!!---
Replaced by the text of the topic.
-o-
!!topic_link!!---
Replaced by a URL that when clicked takes a user to the topic.
-o-
!!author!!---
Replaced by the author of a topic.
-o-
!!author_link!!---
Replaced by a URL that when clicked takes the user to the profile of the user who posted the topic.
-o-
!!views!!---
Replaced by the number of views the topic received.
-o-
!!replies!!---
Replaced by the number of replies a topic has received.
-o-
!!date!!---
Replaced by the the last date a reply was posted to the topic.
-o-
!!last_poster!!---
Replaced by the name of the user who last posted a reply to the topic.
-o-
!!last_poster_link!!---
Replaced by a URL that when clicked takes a user to the profile of the user who last posted a reply to the topic.
];
}

### sn_topic_list_poll_cells.html

elsif ($tname eq "sn_topic_list_poll_cells")
{
$details_blob = qq[!!icon!!---
Replaced by an icon indicating if poll is new.
-o-
!!smily!!---
Replaced by an icon indicating a poll.
-o-
!!topic!!---
Replaced by the topic of the poll.
-o-
!!topic_link!!---
Replaced by a URL that when clicked takes a user to the section where he/she can view the poll.
-o-
!!author!!---
Replaced by the author of the poll.
-o-
!!author_link!!---
Replaced by the author of a poll.
-o-
!!views!!---
Replaced by the number of views a poll received.
-o-
!!smily!!---
Replaced by an icon indicating a poll.
-o-
!!date!!---
Replaced by the date a poll was posted.
];
}

### sn_topic_list_no_topics.html
elsif ($tname eq "sn_topic_list_no_topics")
{
$details_blob = qq[
];
}

### sn_passwd.html
elsif ($tname eq "sn_passwd")
{
$details_blob = qq[!!forum_ps_link!!---
Replaced by a path to the script that will handle password verification.
-o-
[error1][/error1]---
The text inside these tags are replaced by an error indicating that the password entered was invalid.
];
}



########################################################################################
# 4. Topic/Message Display Templates
########################################################################################

### sn_topmsg_frame.html

elsif ($tname eq "sn_topmsg_frame")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!message_topic!!---
Replaced by the topic title of the message thread.
-o-
!!next_page!!---
Replaced by next page / previous page links to navigate pages containing topics.
-o-
!!current_page!!---
Replaced by the number of the current page.
-o-
!!total_pages!!---
Replaced by the total number of pages containing topics.
-o-
!!new_messages_drop_down!!---
Replaced by a drop down menu where a user can select to indicate new messages since xx number of hours/days. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Messages Posted In The Last XX Hours/Days (sn_globalnewdd.html)
-o-
!!post_reply_button!!---
Replaced by a 'Reply' button to post a reply to the current topic.
-o-
!!new_topic_button!!---
Replaced by a button that can be clicked to post a new Topic/Message.
-o-
!!new_poll_button!!---
Replaced by a button that can be clicked to post a new Poll.
-o-
!!backpname_link!!---
Replaced by a URL that when click takes the user back to where he/she came from.
-o-
!!backpname!!---
Replaced by the topic page number where the user came from to view the current topic.
-o-
!!replies!!---
Replaced by the total number of replies to the current topic.
-o-
!!forums!!---
Replaced by the messages of the current topic.
-o-
!!printer_friendly!!---
Replaced by a URL that when click displays a printer friendly version of the current topic.
-o-
!!pages!!---
Replaced by page numbers with links to the pages containing messages of the current topic.
-o-
!!forumjump!!---
Replaced by a drop down menu where users can select a Forum to jump to. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Drop Down Category/Forum Junp Box (sn_globaljump.html)
-o-
!!raname1!!---
Indicates a New Member.
-o-
!!ra_post2!---
Indicates the number of posts for a 'member'.
-o-
!!raname2!!---
Indicates a 'member'.
-o-
!!ra_post3!!---
Indicates the number of posts for a 'full member'.
-o-
!!raname3!!---
Indicates a 'full member'.
-o-
!!ra_post4!!---
Indicates the number of posts for an 'advanced member'.
-o-
!!raname4!!---
Indicates an 'advanced member'.
-o-
!!ra_post5!!---
Indicates the number of posts for an 'advanced member'.
-o-
!!raname5!!---
Indicates an 'advanced member'.
-o-
!!last_visitors!!---
Replaced by last visitors to the Forums. Works in conjunction with Template Manager >> 1. Global Templates & Gadgets >> Last Visitors Display Style (sn_last_visitors.html)
];
}

### sn_first_msg.html

elsif ($tname eq "sn_first_msg")
{
$details_blob = qq[!!auth_image!!---
This will be replaced by a user image if a user account has an image assigned to his/her account.
-o-
!!auth_name!!---
Replaced by the user name of the author of the current message.
-o-
!!auth_link!!---
Replaced by a link to the current user's profile.
-o-
!!mem_name!!---
Replaced by the 'member' name/status.
-o-
!!mem_icon!!---
Replaced by a graphic indicating the member status.
-o- 
[approv]Needs approval by Moderator[/approv]---
The text between the [approv]tags can be configured/changed and will be displayed when a moderator views the message. The text between the [approv] tags will indicate that the message is not visible and needs to be approved before the message will be displayed.
-o-
!!post_date!!---
Indicates the date the topic was posted.
-o-
!!auth_icon!!---
Replaced by an icon the user have chosen when posting a message.
-o-
!!message_topic!!---
Replaced by the subject of the topic.
-o-
!!message!!---
Replaced by the message of the topic.
-o-
!!join_date!!---
Replaced by the date when the user first registered a user account.
-o-
!!total_mem_posts!!---
Replaced by the total number of posts by the current user who posted the message.
-o-
!!edit_url!!---
Replaced by a URL that will enable a user to edit the message when clicked.
-o-
!!quote_url!!---
Replaced by a URL that will enable a user to quote this message in a reply posted to the current topic.
];
}

### 	sn_reply_msg.html

elsif ($tname eq "sn_reply_msg")
{
$details_blob = qq[!!auth_image!!---
This will be replaced by a user image if a user account has an image assigned to his/her account.
-o-
!!auth_name!!---
Replaced by the user name of the author of the current message.
-o-
!!auth_link!!---
Replaced by a link to the current user's profile.
-o-
!!mem_name!!---
Replaced by the 'member' name/status.
-o-
!!mem_icon!!---
Replaced by a graphic indicating the member status.
-o-
!!auth_icon!!---
Replaced by an icon the user have chosen when posting a message.
-o-
[approv]Needs approval by Moderator[/approv]---
The text between the [approv]tags can be configured/changed and will be displayed when a moderator views the message. The text between the [approv] tags will indicate that the message is not visible and needs to be approved before the message will be displayed.
-o-
!!post_date!!---
Indicates the date the topic was posted.
-o-
!!message!!---
Replaced by the message of the topic.
-o-
!!join_date!!---
Replaced by the date when the user first registered a user account.
-o-
!!total_mem_posts!!---
Replaced by the total number of posts by the current user who posted the message.
-o-
!!edit_url!!---
Replaced by a URL that will enable a user to edit the message when clicked.
-o-
!!quote_url!!---
Replaced by a URL that will enable a user to quote this message in a reply posted to the current topic.
];
}

### 	sn_quote.html

elsif ($tname eq "sn_quote")
{
$details_blob = qq[!!quote!!---
Replaced by a message to be quoted when posting a message.
];
}

### 	sn_poll.html

elsif ($tname eq "sn_poll")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!poll_topic!!---
Replaced by the topic of the poll.
-o-
!!new_messages_drop_down!!---
Replaced by a drop down menu where a user can select to indicate new messages since xx number of hours/days. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Messages Posted In The Last XX Hours/Days (sn_globalnewdd.html)
-o-
!!moderators!!---
Replaced by a list of moderators for the current forum.
-o-
!!auth_image!!---
This will be replaced by a user image if a user account has an image assigned to his/her account.
-o-
!!auth_name!!---
Replaced by the user name of the author of the current message.
-o-
!!auth_link!!---
Replaced by a link to the current user's profile.
-o-
!!mem_name!!---
Replaced by the 'member' name/status.
-o-
!!mem_icon!!---
Replaced by a graphic indicating the member status.
-o-
!!total_mem_posts!!---
Replaced by the total number of posts by the current user who posted the message.
-o-
!!post_date!!---
Indicates the date the topic was posted.
-o-
!!poll_description!!---
Replaced by the description of the current poll.
-o-
!!vote_options_results!!---
Replaced by voting options or voting results.
-o-
!!poll_answers!!---
Replaced by the total number of poll answers.
-o-
!!poll_votes!!---
Replaced by the total number of votes for a poll.
];
}

### 	sn_vote_frame_table.html

elsif ($tname eq "sn_vote_frame_table")
{
$details_blob = qq[!!vote_script!!---
Replaced by the path to the script taking care of votes.
-o-
!!vote_cells!!---
This will be replaced by cells with vote answers or vote results.
];
}

### 	sn_vote_table_cells.html

elsif ($tname eq "sn_vote_table_cells")
{
$details_blob = qq[!!vote_value!!---
Works in conjunction with a radio button and passes on a value when an option is chosen from a poll to vote on.
-o-
!!vote_checked!!---
Works in conjunction with a radio button and defines a name of a vote answer.
-o-
!!checked!!---
Responsible to select the first vote option by default when viewing the poll with voting options.
-o-
!!vote_item!!---
Replaced by the text of an option that can be voted on.
];
}

### 	sn_results_frame_table.html

elsif ($tname eq "sn_results_frame_table")
{
$details_blob = qq[!!results_cells!!---
Replaced by vote result table cells.
];
}

### 	sn_results_table_cells.html

elsif ($tname eq "sn_results_table_cells")
{
$details_blob = qq[!!vote_item!!---
Replaced by a vote option/answer.
-o-
!!votes!!---
Replaced by the number of votes a vote-option received.
-o-
!!vote_perc!!---
Replaced by the percentage of votes for vote options.
];
}

########################################################################################
# 5. Message Posting / Poll Posting / Message Editing
########################################################################################

### sn_post_topic.html

elsif ($tname eq "sn_post_topic")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!post_script!!---
Replaced by the path to the script that will take care of posting messages.
!!topic!!---
This will be replaced by a topic if an error occurs.
-o-
!!message_tags_link!!---
This will be replaced by a link to view the tags available that can be used when posting messages.
-o-
!!message!!---
This will be replaced by a message if an error occurs.
-o-
[error1][/error1]---
The text inside these tags are replaced by an error indicating that the user need to be logged in to post a message.
-o-
[error2][/error2]---
The text inside these tags are replaced by an error indicating that a topic need to be supplied in order to post the message.
-o-
[error3][/error3]---
The text inside these tags are replaced by an error indicating that a message need to be specified to be able to post the message.
-o-
[error4][/error4]---
The text inside these tags are replaced by an error indicating that only moderators are allowed to post in the current Forum.
];
}

### sn_post_reply.html

elsif ($tname eq "sn_post_reply")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!post_script!!---
Replaced by the path to the script that will take care of posting messages.
!!reply_topic!!---
This will be replaced by a topic if an error occurs.
-o-
!!message_tags_link!!---
This will be replaced by a link to view the tags available that can be used when posting messages.
-o-
!!message!!---
This will be replaced by a message if an error occurs.
-o-
[error1][/error1]---
The text inside these tags are replaced by an error indicating that the user need to be logged in to post a message.
-o-
[error2][/error2]---
The text inside these tags are replaced by an error indicating that a topic need to be supplied in order to post the message.
-o-
[error3][/error3]---
The text inside these tags are replaced by an error indicating that a message need to be specified to be able to post the message.
-o-
[error4][/error4]---
The text inside these tags are replaced by an error indicating that only moderators are allowed to post in the current Forum.
];
}

### sn_post_success.html

elsif ($tname eq "sn_post_success")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!topic_link!!---
Replaced by a URL that when clicked the user will be taken to the topic where he/she just posted a message.
-o-
!!posted_forum_name!!---
Replaced by the name of the forum where a message was just posted.
-o-
!!posted_forum_link!!---
Replaced by a URL that when clicked takes the user to the Forum where the user just posted a topic.
-o-
!!forum_link!!---
Replaced by a URL that when clicked takes the user to the main front page of the Forums.
];
}

### sn_post_poll.html

elsif ($tname eq "sn_post_poll")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!poll_script!!---
Replaced by the path to the script that takes care of posting polls.
-o-
!!polltopic!!---
Replaced by the topic of the poll when an error occurs.
-o-
!!message_tags_link!!---
This will be replaced by a link to view the tags available that can be used when posting messages.
-o-
!!polldescription!!---
Replaced by a poll description when an error occurs.
-o-
!!pollq1!!---
Replaced by a poll question when an error occurs.
-o-
!!pollq2!!---
Replaced by a poll question when an error occurs.
-o-
!!pollq3!!---
Replaced by a poll question when an error occurs.
-o-
!!pollq4!!---
Replaced by a poll question when an error occurs.
-o-
!!pollq5!!---
Replaced by a poll question when an error occurs.
-o-
!!pollq6!!---
Replaced by a poll question when an error occurs.
-o-
[error1][/error1]---
The text inside these tags are replaced by an error indicating that the user need to be logged in to post a poll.
-o-
[error2][/error2]---
The text inside these tags are replaced by an error indicating that a topic need to be supplied in order to post the poll.
-o-
[error3][/error3]---
The text inside these tags are replaced by an error indicating that only moderators are allowed to post a poll in the current Forum.
-o-
[error4][/error4]---
The text inside these tags are replaced by an error indicating that a poll has to have at least two answers.
];
}
### sn_post_poll_success.html

elsif ($tname eq "sn_post_poll_success")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!goto_poll!!---
Replaced by a URL that when clicked takes the user to the poll the user has just posted.
-o-
!!posted_forum_link!!---
Replaced by a URL that when clicked takes the user to the Forum where the user just posted a poll.
-o-
!!posted_forum_name!!---
Replaced by the name of the forum where a poll was just posted.
-o-
!!forum_link!!---
Replaced by a URL that when clicked takes the user to the main front page of the Forums.
];
}

### sn_post_poll_success_mod.html

elsif ($tname eq "sn_post_poll_success_mod")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!posted_forum_link!!---
Replaced by a URL that when clicked takes the user to the Forum where the user just posted a poll.
-o-
!!posted_forum_name!!---
Replaced by the name of the forum where a poll was just posted.
-o-
!!forum_link!!---
Replaced by a URL that when clicked takes the user to the main front page of the Forums.
];
}

### sn_not_logged_in.html

elsif ($tname eq "sn_not_logged_in")
{
$details_blob = qq[!!login_script!!---
Replaced by a path to the script that takes care of logging in users.
];
}

### sn_edit_msg.html

elsif ($tname eq "sn_edit_msg")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!edit_script!!---
Replaced by a path to the script that takes care of editing messages.
-o-
!!message!!---
Replaced by the message that the user will edit.
-o-
!!ip!!---
Replaced by the IP address of the user who posted the message that is being edited. Note that the IP address will only be displayed when a moderator is editing the message.
-o-
[mod_adm_ipdisplay][/mod_adm_ipdisplay]---
The text between these tags will be displayed to indicate the IP address of the user who posted the message being edited. Note that the IP address will only be displayed when a moderator is editing the message.
-o-
[del_topic][/del_topic]---
A button is placed between these tags. This button can be clicked to delete the topic where the message resides that is being edited. Note that this button will only be available when a moderator is editing the message.
-o-
[del_msg][/del_msg]---
A button is placed between these tags. This button can be clicked to delete the message that is being edited. Note that this button will only be available when a moderator is editing the message.
-o-
[stick][/stick]---
A button is placed between these tags. This button can be clicked to make the current topic sticky where the current message is edited. Note that this button will only be available when a moderator is editing the message.
-o-
[unstick][/unstick]---
A button is placed between these tags. This button can be clicked to unstick the topic where the current message is being edited. Note that this button will only be available when a moderator is editing the message.
-o-
[lock_topic][/lock_topic]---
A button is placed between these tags. This button can be clicked to lock the topic where the current message is being edited. Note that this button will only be available when a moderator is editing the message.
-o-
[unlock_topic][/unlock_topic]---
A button is placed between these tags. This button can be clicked to unlock the topic where the current message is being edited. Note that this button will only be available when a moderator is editing the message.
];

}

### sn_edit_saved.html

elsif ($tname eq "sn_edit_saved")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!view_message_link!!---
Replaced by a URL that when clicked takes the user to the message the user has just edited.
];
}

### sn_edit_unable.html

elsif ($tname eq "sn_edit_unable")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
];
}

### sn_msgtags.html

########################################################################################
# 6. User Registration / Edit Profiles / View Profiles / Login
########################################################################################

### sn_terms.html

elsif ($tname eq "sn_terms")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!register_script!!---
Replaced by the path to the script that takes care of account registration.
];
}

### sn_regform.html

elsif ($tname eq "sn_regform")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!register_script!!---
Replaced by the path to the script that takes care of account registration.
-o-
!!member_name!!---
Replaced by the user name of a user.
-o-
!!email_address!!---
Replaced by the email address of a user.
-o-
!!home_page!!---
Replaced by the home page of a user.
-o-
!!homepage_diz!!---
Replaced by the home page description of a user.
-o-
!!home_page_url!!---
Replaced by the home page URL of a user.
-o-
!!location_cc!!---
Replaced by the city/country of a user.
-o-
!!interests!!---
Replaced by the interests of a user.
-o-
!!occupation!!---
Replaced by the occupation of a user.
-o-
!!signature!!---
Replaced by the message signature of a user.
-o-
!!image_dropdown!!---
Replaced by a drop down meny where users can select an image to be included with their profile.
-o-
!!image_preview!!---
Replaced by a preview of user images available when a user selects an image from the image drop down menu.
-o-
%%imgbox%%---
Replaced by captcha letters that a user needs to type.
-o-
!!images_link!!---
Replaced by a URL that when clicked displays a preview of user images available that users can choose from for their profiles.
-o-
[error1][/error1]---
The error text between these tags are displayed when the user name chosen contains invalid characters.
-o-
[error2][/error2]---
The error text between these tags are displayed when the user name chosen would create a duplicate or already exists.
-o-
[error3][/error3]---
The error text between these tags are displayed when no user name was specified.
-o-
[error4][/error4]---
The error text between these tags are displayed when no email address was specified.
-o-
[error5][/error5]---
The error text between these tags are displayed when the letters typed did not match according to the letters displayed in images.
];
}

### sn_reg_success.html

elsif ($tname eq "sn_reg_success")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!forum_link!!---
Replaced by a URL that when clicked takes the user to the main front page of the Forums.
-o-
!!forum_name!!---
This is replaced by the name of your forums. This can be defined inside the SiteNet BBS Control Panel >> Settings >> Global Forum Settings
];
}

### sn_edit_profile.html

elsif ($tname eq "sn_edit_profile")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!save_profile_script!!---
Replaced by a path to the script taking care of user registrations.
-o-
!!member_name!!---
Replaced by the user name of a user.
-o-
!!password!!---
Replaced by the password of a user.
-o-
!!email_address!!---
Replaced by the email address of a user.
-o-
!!home_page!!---
Replaced by the home page of a user.
-o-
!!homepage_diz!!---
Replaced by the home page description of a user.
-o-
!!home_page_url!!---
Replaced by the home page URL of a user.
-o-
!!location_cc!!---
Replaced by the city/country of a user.
-o-
!!interests!!---
Replaced by the interests of a user.
-o-
!!occupation!!---
Replaced by the occupation of a user.
-o-
!!signature!!---
Replaced by the message signature of a user.
-o-
!!user_image_display!!---
Displays a user image if there is a user image assigned to the profile of the user.
-o-
!!image_dropdown!!---
Replaced by a drop down meny where users can select an image to be included with their profile.
-o-
!!image_preview!!---
Replaced by a preview of user images available when a user selects an image from the image drop down menu.
-o-
[moderator][/moderator]---
If a moderator profile is being edited then the criteria between these tags are displayed. The criteria between the tags enables a moderator to select if he/she would like to receive notifications of new message posted to Forums where the Moderator is a moderator of. 
-o-
!!upload_script!!---
Replaced by the path to the script that takes care of uploading user images.
-o-
!!member_status!!---
Indicates the member status.
-o-
!!joined!!---
Indicates when the member has created his/her account.
-o-
!!total_posts!!---
Indicates the total amount of messages posted by the current member editing his/her profile.
-o-
[error1][/error1]---
The error text between these tags are displayed when a password was not specified.
-o-
[error2][/error2]---
The error text between these tags are displayed when no email address was specified.
-o-
[error3][/error3]---
The error text between these tags are displayed when an image the user tried to upload exceeds the maximum allowable size.
-o-
[error4][/error4]---
The error text between these tags are displayed when no image file name was specified and the 'upload' button was clicked.
-o-
[error5][/error5]---
The error text between these tags are displayed when a file type other than .gif or .jpg files was attempted to be uploaded.
];
}

### sn_profile_saved.html

elsif ($tname eq "sn_profile_saved")
{
$details_blob = qq[!!forum_name!!---
This is replaced by the name of your forums. This can be defined inside the SiteNet BBS Control Panel >> Settings >> Global Forum Settings
-o-
!!forum_link!!---
Replaced by a URL that when clicked takes the user to the main front page of the Forums.
];
}

### sn_view_profile.html

elsif ($tname eq "sn_view_profile")
{
$details_blob = qq[!!location_link!!---
This is replaced by a URL indicating to where a current location is indicated.
-o-
!!member_name!!---
Replaced by the user name of a user.
-o-
!!homepage_name!!---
Replaced by the home page of a user.
-o-
!!homepage_diz!!---
Replaced by the home page description of a user.
-o-
!!homepage_url!!---
Replaced by the home page URL of a user.
-o-
!!locationcc!!---
Replaced by the city/country of a user.
-o-
!!interests!!---
Replaced by the interests of a user.
-o-
!!occupation!!---
Replaced by the occupation of a user.
-o-
!!member_status!!---
Indicates the member status.
-o-
!!member_since!!---
Indicates when the member has created his/her account.
-o-
!!total_posts!!---
Indicates the total amount of messages posted.
-o-
[na][/na]---
The text between these tags are used to indicate that an item is not available. It will be displayed when the user has for example not specified a home page name, description or URL.
];
}

### sn_view_profile_login.html

elsif ($tname eq "sn_view_profile_login")
{
$details_blob = qq[!!login_script!!---
Replaced by a path to the script that takes care of logging in users.
];
}

### sn_login_screen.html

elsif ($tname eq "sn_login_screen")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!login_script!!---
Replaced by a path to the script that takes care of logging in users.
-o-
[error1][/error1]---
The text between these tags indicates that the user name or password entered was invalid.
-o-
!!retrieve_password_link!!---
Replaced by a URL that when clicked takes the user to a section where the user can retrieve his lost/forgotten password.
];
}

### sn_login_success.html

elsif ($tname eq "sn_login_success")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!forum_name!!---
This is replaced by the name of your forums. This can be defined inside the SiteNet BBS Control Panel >> Settings >> Global Forum Settings
-o-
!!forum_link!!---
Replaced by a URL that when clicked takes the user to the main front page of the Forums.
];
}

### sn_logout_screen.html

elsif ($tname eq "sn_logout_screen")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!forum_name!!---
This is replaced by the name of your forums. This can be defined inside the SiteNet BBS Control Panel >> Settings >> Global Forum Settings
-o-
!!forum_link!!---
Replaced by a URL that when clicked takes the user to the main front page of the Forums.
];
}

### sn_retrieveps.html 	

elsif ($tname eq "sn_retrieveps")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
[error1][/error1]---
The text between these tags indicates that the user name that was entered is invalid.
-o-
!!retrieve_script!!---
Replaced by the script taking care of retrieving a lost/forgotten password.
];
}

### sn_passwd_sent.html

elsif ($tname eq "sn_passwd_sent")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
];
}

########################################################################################
# 7. Search Templates
########################################################################################

### sn_search_page.html

elsif ($tname eq "sn_search_page")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!search_script!!---
Replaced by a path to the script that takes care of searching Forums.
-o-
!!forumsearch_dropdown!!---
Replaced by a drop down containing all Forums.
-o-
[error1][/error1]---
The text between these tags indicates an error that there was no keywords supplied.
-o-
[error2][/error2]---
The text between these tags indicates that a forum need to be selected from the drop down box when searching.
];
}

### sn_search_dropdown.html

elsif ($tname eq "sn_search_dropdown")
{
$details_blob = qq[!!forum_options!!---
This variable is replaced by Forum Categories and Forum names.
];
}

### sn_search_results_page.html

elsif ($tname eq "sn_search_results_page")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!next_page!!---
This is replaced by 'Next Page' / 'Previous Page' links. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Previous Page / Next Page Text (Settings Only)
-o-
!!pages!!---
Replaced by page numbers with links to these pages containing Topics.
-o-
!!keywords!!---
Replaced by keywords specified to search for.
-o-
!!matches!!---
Replaced by the number of matches found.
-o-
!!search_results!!---
Replaced by search results.
-o-
!!search_script!!---
Replaced by a path to the script that takes care of searching Forums.
-o-
!!forumsearch_dropdown!!---
Replaced by a drop down containing all Forums.
];
}

### sn_search_results.html

elsif ($tname eq "sn_search_results")
{
$details_blob = qq[!!nr!!---
Replaced by a number indicating search result positions.
-o-
!!topic_link!!---
Replaced by a URL to a topic displayed as a search result.
-o-
!!topic!!---
Replaced by a topic displayed as a search result.
-o-
!!description!!---
Replaced by a description displayed as a search result.
-o-
!!topic_starter!!---
Replaced by the user who started the topic.
-o-
!!topic_date!!---
Replaced by a topic date.
];
}

### sn_search_nomatch.html

elsif ($tname eq "sn_search_nomatch")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!keywords!!---
Replaced by keywords specified to search for.
-o-
!!search_script!!---
Replaced by a path to the script that takes care of searching Forums.
-o-
!!forumsearch_dropdown!!---
Replaced by a drop down containing all Forums.
];
}


########################################################################################
# 8. Moderator Templates
########################################################################################

### sn_mod_login.html

elsif ($tname eq "sn_mod_login")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!login_script!!---
Replaced by a path to the script that takes care of logging in users.
-o-
!!retrieve_password_link!!---
Replaced by a URL that when clicked takes the user to a section where the user can retrieve his lost/forgotten password.
-o-
[error1][/error1]---
The text inside these tags are replaced by an error indicating that the user name or password entered was invalid.
-o-
[error2][/error2]---
The text inside these tags are replaced by an error indicating that only moderators have access to the moderator area.

];
}

### sn_mod_global.html

elsif ($tname eq "sn_mod_global")
{
$details_blob = qq[!!location!!---
Replaced by the current location where the user is residing. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Global Location Template (globlocation.html)
-o-
!!mcp_home!!---
Replaced by a URL that when clicked takes the user to the main section of the moderator control panel.
-o-
!!view_forums!!---
Replaced by a URL that when clicked takes the user to the main front page of the Forums.
-o-
!!modadm_functions!!---
Replaced by the various modetator functions available.
];
}

### sn_mod_table_main.html 	

elsif ($tname eq "ssn_mod_table_main")
{
$details_blob = qq[
];
}

### sn_mod_cells_cat.html

elsif ($tname eq "sn_mod_cells_cat")
{
$details_blob = qq[!!category_link!!---
Replaced by a URL that when clicked takes the moderator to the Forum category.
-o-
!!category_name!!---
Replaced by a Forum Category Name.
];
}

### sn_mod_cells_forum.html 	

elsif ($tname eq "sn_mod_cells_forum")
{
$details_blob = qq[!!forum_link!!---
Replaced by a URL that when clicked takes the user to the Forum.
-o-
!!forum_name!!---
Replaced by the name of a Forum.
-o-
!!delete_topics!!---
Replaced by a URL that when clicked takes the moderator to a section where he/she can delete topics.
-o-
[modr][/modr]---
The content inside this tag is displayed and linked if there is any messages that requires approval. (moderation)
-o-
!!nr!!---
Replaced by the number of messages requiring approval. (moderation)
-o-
!!forum_settings!!---
Replaced by a URL that when clicked takes the moderator to a section where he/she can change Forum settings.
];
}

### sn_mod_del_table.html

elsif ($tname eq "sn_mod_del_table")
{
$details_blob = qq[!!delete_script!!---
This is replaced by a path to the script that takes care of deleting topics.
-o-
!!current_forum_category!!---
This is replaced by the current forum category the moderator resides in.
-o-
!!forum_name!!---
This is replaced by the current forum the moderator resides in.
-o-
!!delete_cells!!---
This is replaced by table cells containing topics that can be selected to be deleted.
-o-
!!check_all!!---
This is replaced by a URL that when clicked will select all topics listed on the current page.
-o-
!!uncheck_all!!---
This is replaced by a URL that when clicked will de-select all topics listed on the current page.
-o-
!!next_page!!---
This is replaced by 'Next Page' / 'Previous Page' links. Works in conjunction with: Template Manager >> 1. Global Templates & Gadgets >> Previous Page / Next Page Text (Settings Only)
-o-
!!pages!!---
Replaced by page numbers with links to these pages containing Topics.
-o-
!!total_topics!!---
Replaced by the total number of topics listed.
-o-
!!topics_per_page!!---
Replaced by the total number of topics that is being listed on a 'per page' basis.
-o-
!!list_all_topics!!---
Replaced by a URL that when clicked will list all topics in the current section.
];
}

### sn_mod_del_cells.html 	

elsif ($tname eq "sn_mod_del_cells")
{
$details_blob = qq[!!checkbox!!---
Replaced by a checkbox to select the listed item.
-o-
!!icon!!---
Replaced by a topic icon.
-o-
!!topic_link!!---
Replaced by a URL that when clicked takes the user to the topic to view the topic.
-o-
!!topic_subject!!---
Replaced by the topic title.
-o-
!!poster_name!!---
Replaced by the name of the user who posted the topic.
-o-
!!post_time!!---
Replaced by the date the topic was posted.
-o-
!!replies!!---
Replaced by the number of replies for topics.
];
}

### sn_mod_del_unable.html

elsif ($tname eq "sn_mod_del_unable")
{
$details_blob = qq[
];
}

### sn_mod_del_error.html 	

elsif ($tname eq "sn_mod_del_error")
{
$details_blob = qq[
];
}

### sn_mod_del_success.html 	

elsif ($tname eq "sn_mod_del_success")
{
$details_blob = qq[!!delete_area!!---
Replaced by a URL that when clicked will take the moderator back to the previous screen where topics can be chosen to be deleted.
];
}

### sn_forum_settings.html

elsif ($tname eq "sn_forum_settings")
{
$details_blob = qq[!!save_script!!---
Replaced by a path to the script that takes care of saving forum settings.
-o-
!!current_forum_category!!---
This is replaced by the current forum category the moderator resides in.
-o-
!!forum_name!!---
Replaced by the name of the current Forum.
-o-
!!forum_description!!---
Replaced by the description of the current Forum.
-o-
!!reg_select!!/!!mod_select!!---
Used to select if moderators or registered users may post in the Forum.
-o-
!!polls1!!/!!polls2!!---
Used to indicate if users are allowed to post polls or not.
-o-
!!ahtml1!!/!!ahtml2!!---
Used to indicate if users may post HTML with their messages or not.
-o-
!!modr1!!/!!modr2!!---
Used to indicate if the forum is moderated or not.
-o-
!!pspyes!!/!!pspno!!---
Used to indicate if the forum is to password protected or not.
-o-
!!fpassword!!---
Replaced by a password if the forum is password protected.
-o-
!!postprvyes!!/!!postprvno!!---
Used to indicate if the forum is password protected or not.
];
}

### sn_forum_settings_saved.html

elsif ($tname eq "sn_forum_settings_saved")
{
$details_blob = qq[!!mcp_home!!---
Replaced by a URL that when clicked takes the user to the main section of the moderator control panel.
];
}

### sn_mod_mod_frame.html

elsif ($tname eq "sn_mod_mod_frame")
{
$details_blob = qq[!!moderation_script!!---
This is replaced by a URL that when clicked takes care of approving or deleting messages waiting for approval.
-o-
!!current_forum_category!!---
Replaced by the current Forum Category.
-o-
!!forum_name!!---
Replaced by the current Forum name.
-o-
!!message_cells!!---
Replaced by table cells displaying messages that needs approval from a moderator.
];
}

### sn_mod_mod_cells.html

elsif ($tname eq "sn_mod_mod_cells")
{
$details_blob = qq[!!checkbox!!---
Replaced by a checkbox to select the listed item.
-o-
!!icon!!---
Replaced by a topic icon.
-o-
!!message_link!!---
Replaced by a URL that when clicked takes the moderator to the message to view it.
-o-
!!message!!---
Displaying the subject of the message waiting for approval.
-o-
!!poster!!---
Displays the user name of the user who posted the message.
];

}

### sn_mod_mod_success_appr.html

elsif ($tname eq "sn_mod_mod_success_appr")
{
$details_blob = qq[!!current_forum_category!!---
This is replaced by the current forum category the moderator resides in.
-o-
!!forum_name!!---
Replaced by the current Forum name.
-o-
!!appr_area!!---
Replaced by a URL that when clicked takes the moderator back to the area where he/she can approve/delete messages.
-o-
!!mcp_home!!---
Replaced by a URL that when clicked takes the user to the main section of the moderator control panel.
];

}

### sn_mod_mod_del.html 	

elsif ($tname eq "sn_mod_mod_del")
{
$details_blob = qq[!!current_forum_category!!---
This is replaced by the current forum category the moderator resides in.
-o-
!!forum_name!!---
Replaced by the current Forum name.
-o-
!!appr_area!!---
Replaced by a URL that when clicked takes the moderator back to the area where he/she can approve/delete messages.
-o-
!!mcp_home!!---
Replaced by a URL that when clicked takes the user to the main section of the moderator control panel.
];

}

### sn_mod_mod_error.html
 	

my @t_array = split (/-o-/, $details_blob);

return (@t_array);
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;

#print "==> $setup_line - $setup_var <br>";

#### WITHOUT "
$crit = "\"";
if ($setup_line !~ /$crit/)
	{
	$setup_line =~ s/$setup_var//g; 
	$setup_line =~ s/ //g;
	$return_val = $setup_line;
	}
	else
	{
	#$setup_line =~ s/$crit/1:1/;
	
	$setup_line =~ m/$crit/g;
	$r1 = pos($setup_line);
	
	$setup_line =~ m/$crit/g;
	$r2 = pos($setup_line);

	$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
	
	$return_val = $setup_line;
	}

#### WITH "

return ($return_val);
}



1;