#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Empty Category Checker
# DIZ: Enables you to view a list of categories that contains no links.
# GRAPHIC: ic_folders.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") {&start;}


###############################################################


sub start
{

$tlist = qq[

defdir.html
tmplsearch.html
tmplsearch_prem.html
subdirs.html
directories1.html
related1.html
related2.html
linkinfo.html
linkinfop.html


searchres.html
searchadv.html
lsearchres_loc.html
lsearchres_loc_prem.html
nomatch.html
flood.html


searchresdir.html
lsearchres_locdir.html

rgs_msgregister.html
rgs_register.html


rgs_regsuccess.html
rgs_actsuccess.html
rgs_actfailed.html
rgs_resend.html
rgs_sent.html
rgs_login.html
rgs_logout.html


rgs_retrievepass.html
rgs_retrievepass_ok.html



rgs_cpmain.html
rgs_acclinks.html
rgs_acclinksp.html
rgs_nolinks.html

rgs_editacc.html
rgs_saveacc.html

rgs_add_url_med.html
rgs_add_url.html
rgs_add_url_medp.html
rgs_add_urlp.html
rgs_add_url_instructions.html
rgs_locked.html
rgs_add_url_problem.html
rgs_add_url_success.html



rgs_modify_link_edit.html
rgs_modify_link_editp.html
rgs_modify_link_problem.html
rgs_modify_link_success.html
rgs_modify_instructions.html


rgs_rcomment.html
rgs_rrate.html


rate_it.html
rate_it_success.html
rate_it_fail.html
gethtml.html


review_it.html
reviewlinks.html
reviewadded.html
reviewproblem.html


whatsnew_main.html
whatsnew_lists.html
whatsnew_lists_prem.html


tophits_main.html
tophits_listings.html
tophits_listings_prem.html


brokenlink.html
brokenlink_success.html


fav_main.html
fav_standard.html
fav_premium.html
fav_none.html


mlist1.html
mlist2.html
mlist3.html


add_url_med.html
add_url.html
add_url_medp.html
add_urlp.html
add_url_instructions.html
locked.html
add_url_problem.html
add_url_success.html


modify_link.html
modify_link_problem.html
modify_link_success.html
modify_link_edit.html
modify_link_editp.html
modify_instructions.html
retrievepass.html
retrievepass_ok.html
retrievepass_prb.html

];


@templ = split (/\n/, $tlist);

foreach $item (@templ)
	{
	if ($item ne "")
		{
		$tmpl = acs::get_file_contents("$data_dir/$item"); 
		#$tmpl =~ s/line-height: : 20px;//gi; 
		
		print "-> $item<BR>";
		
		open (TWR, "> $data_dir/crawler/$item");
		print TWR $tmpl;
		close (TWR);
		}
	
	}


}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	$HTML_ENCODING_USE = acs::get_html_encoding;
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

