#!/usr/bin/perl

##########################################################################
# COPYRIGHT NOTICE:
# 
# Copyright FocalMedia.Net
# 
# This program is free to use for commercial and non commercial use. 
# This script may be used and modified by anyone, so long as this copyright 
# notice and the header above remain intact. Selling the code for this 
# program without prior written consent is expressly forbidden.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied.
#
##########################################################################

use FindBin;
use lib $FindBin::Bin;

use CGI;
use CGI::Carp qw(fatalsToBrowser);


### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################


$q = CGI->new;

### GET SETUP

&get_setup;

$mainlayout = &get_file_contents("$data_dir/layout.html");
if ($mainlayout eq "") { print "Could not find $data_dir/main_layout.html or the file is empty"; exit;}

##############################

if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "save") {&save_page;}



sub start
{

print "Content-type: text/html\n\n";

$preflayout = &get_file_contents("$data_dir/preferences.html");
$mainlayout =~ s/!!replacement_data!!/$preflayout/g;
$mainlayout =~ s/!!script_url!!/$script_url/g;
$mainlayout =~ s/!!web_url!!/$web_url/g;

print $mainlayout;

}


################################################

sub save_page
{

$query = new CGI;

$results = $q->param('results');
$new_window = $q->param('new_window');


#SET COOKIE;
$thecookie1 = $query->cookie(-name=>'results',
			    					  -value=>$results,
			    					  -expires=>'+300d',
			    					  -path=>'/');

$thecookie2 = $query->cookie(	-name=>'new_window',
			    						-value=>$new_window,
			    						-expires=>'+300d',
			    						-path=>'/');

print $query->header(-cookie=>[$thecookie1, $thecookie2]); 

$preflayout = &get_file_contents("$data_dir/preferences_saved.html");
$mainlayout =~ s/!!replacement_data!!/$preflayout/g;
$mainlayout =~ s/!!script_url!!/$script_url/g;
$mainlayout =~ s/!!web_url!!/$web_url/g;

print "$mainlayout";

}




sub get_file_contents
{

my ($filename) = @_;
my ($filesize, $filesize, $thefile);

$filesize = (-s "$filename");
open (TFILECNTS, "$filename");
	read(TFILECNTS,$thefile,$filesize);
close (TFILECNTS);

return ($thefile);
}





#### GET CONFIGURATION ########################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}
if ($line =~ /^WEBROOT/){$webroot = &get_setup_line($line, WEBROOT);}
if ($line =~ /^URLROOT/){$urlroot = &get_setup_line($line, URLROOT);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}

if ($line =~ /^USE_MYSQL/){$use_mysql = &get_setup_line($line, USE_MYSQL);}
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^RG/){$rg = &get_setup_line($line, RG);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

			}
	close (STP);
	
	}
	else
	{
	print "Could not find $config_cgi"; exit;
	
	}
}



sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

