#!/usr/bin/perl

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

package sn_netbbs;

use Fcntl ':flock';
use CGI;
use IO::Socket;
#use strict;
use CGI::Carp qw(fatalsToBrowser);



### WINDOWS USERS EDIT BELOW ##############################################
$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO 
#$config_cgi = "e:/full/server/path/to/config.cgi";
###########################################################################




require Exporter;
use vars qw/$exists $data_dir $web_url $scripts_url $scripts_admin $r $line $q $flocking $rsts
				@ISA @EXPORT @EXPORT_OK/;

@ISA = qw(Exporter);

### (FORUMTOP) = print_forum_top (PAGE TITLE, CURRENT CATEGORY, GLOBAL FORUM NAME);
### (SELECTIONBOX) = get_forum_selbox_details;
### (FORUM GENERAL TOP) = print_forum_gen_top(PAGE TITLE, GLOBAL FORUM NAME);
### @GLOBAL NETBOARD SETTINGS = get_global_settings;
### FILE CONTENTS = get_file_contents (FILENAME);
### CATEGORY NAME = get_cat_name(CATEGORY ID);
### USER SETTINGS or ERROR = check_username_password (USERNAME, PASSWORD);
### DATE = decode_date (SECONDS);
### write_stats (CATEGORY ID, FORUM ID, TOPIC ID, POSTS INTEGER TO PLUS, VIEWS INTEGER TO PLUS)
### LOGIN HTML = login_box ( HIDDEN ACTION, SCRIPT, WINDOW TITLE, BUTTON TITLE )
### setCookie(NAME, VALUE, EXPIRATION, PATH, DOMAIN, SECURE);
### @RAW COOKIES = getCookies;

@EXPORT = qw(print_forum_top 
				 get_forum_selbox_details 
				 print_forum_gen_top
				 get_global_settings
				 get_file_contents
				 get_cat_name
				 check_username_password
				 increment_id
				 decode_date
				 write_stats
				 login_box
				 setCookie
				 getCookies
				 problembox
				 getcc
				 get_moderators
				 get_forum_name
				 get_template_includes
				 check_forum_password
				 get_last_visitors
				 get_idcount
				 decode_tags
				 get_setup_line
				 decode_icons
				 get_moderators_new
				 get_forum_selbox
				 get_location
				 checkuser
				 display_errors
				 fatal_error
				 get_imgboxes_cc
				 check_img_auth_cc
				 decode_ps
				 encode_ps
				 get_email_details
				 get_page_title
				 get_domain); ### FUNCTiONS


@EXPORT_OK = qw($topv 
					$seloptions 
					$ccname 
					$cbname 
					@gsettings 
					$thefile 
					$rcat 
					@usersettings 
					$currentid 
					$rdvalue
					$logbox
					@rawCookies
					$pthtml
					$rrv
					@moderatorsr
					$forumname
					$the_template
					$lastu_table
					$msg_whole
					$return_val
					$location_string); ### RETURN VALUES


## READ CONFIGURATION ###############################################################################

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, $config_cgi);
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
		$line =~ s/\n//g;
				
		if ($line =~ /WEB_URL/){$web_url = sn_netbbs::get_setup_line($line, WEB_URL);}
		if ($line =~ /SCRIPT_URL/){$scripts_url = sn_netbbs::get_setup_line($line, SCRIPT_URL);}
		if ($line =~ /ADMIN_URL/){$scripts_admin = sn_netbbs::get_setup_line($line, ADMIN_URL);}
		
		if ($line =~ /FILE_LOCKING/){$flocking = sn_netbbs::get_setup_line($line, FILE_LOCKING);}
		if ($line =~ /RSTS/){$rsts = sn_netbbs::get_setup_line($line, RSTS);}
		
		if ($line =~ /WEB_DIR/){$web_path = sn_netbbs::get_setup_line($line, WEB_DIR);}

		if ($line =~ /SENDMAIL/){$sendmail_loc = sn_netbbs::get_setup_line($line, SENDMAIL);}
		if ($line =~ /MAIL_METHOD/){$mail_method = sn_netbbs::get_setup_line($line, MAIL_METHOD);}
		if ($line =~ /SMTP_SERVER/){$smtp_server = sn_netbbs::get_setup_line($line, SMTP_SERVER);}
	
		if ($line =~ /USERNAME/){$c_username = sn_netbbs::get_setup_line($line, USERNAME);}
		if ($line =~ /PASSWORD/){$c_password = sn_netbbs::get_setup_line($line, PASSWORD);}
		
		if ($line =~ /DATA_DIR/){$data_dir = sn_netbbs::get_setup_line($line, DATA_DIR);}

			}
	close (STP);
	
	$url_write = sn_netbbs::get_file_contents("$data_dir/sn_friendly.dat");
	
	$thetime = time();
	($sec9,$min9,$hour9,$mday9,$mon9,$year9,$wday9,$ydat9,$isdst9) = localtime($thetime);
	$year9 = "20" . substr($year9, 1, 2);

	
	}
	else
	{
	print "Content-type: text/html\n\n";
	print "Could not find config.cgi";
	exit;
	}


#### END CONFIGURATION ########################################################

sub get_domain
{
my ($tdm) = @_;

$tdm =~ s/http:\/\///gi;

@domitems = split (/\//, $tdm);

return ($domitems[0]);
}



sub check_input
{
my ($chkid) = @_;

$check1 = int($chkid);

if ($check1 < 1)
	{
print qq[
<html>
<head>
<title>Fatal Error</title>
</head>
<body>
<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0"
    cellpadding="6">
      <tr>
        <td background="$web_url/sn_bar6.gif"><font face="Verdana" size="2"><strong
        class="normaltext">Invalid Criteria Passed on</strong></font></td>
      </tr>
      <tr>
        <td class="normaltext"><blockquote>
          <p><font face="Verdana" size="2">Exiting... </font></p>
        </blockquote>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</body>
</html>
];

exit;
	
	
	}

}



sub get_page_title
{
my ($pgname) = @_;

$pgdetails = &get_file_contents("$data_dir/sn_pagetitles.html");

@eptitles = split (/\n/, $pgdetails);

foreach $pitem (@eptitles)
	{
	($pfile, $mtitle) = split (/\t/, $pitem);
	
		if ($pgname eq $pfile)
		{
		$return_title = $mtitle;
		}
	}

return ($return_title);
}





sub get_email_details
{
($efile) = @_;

my ($emailmsg, $from_email_ss, $from_name_ss, $email_subject_ss, $email_message_ss, @elines, $lnc, $settings_txt1, @settings1, $cr1, $cr2);

$emailmsg = &get_file_contents("$data_dir/$efile");

my @elines = split (/\n/, $emailmsg);

$from_name_ss = $elines[0];
$from_email_ss = $elines[1];
$email_subject_ss = $elines[2];

$lnc = 0;
foreach $line (@elines)
	{
	if ($lnc > 2)
		{
		$email_message_ss = $email_message_ss . $line . "\n";
		}
	$lnc++;
	}


if (((length($from_email_ss) < 3) eq "") or (length($from_name_ss) < 3))
	{
	$settings_txt1 = &get_file_contents("$data_dir/sn_settings.dat");
	(@settings1) = split(/\n/, $settings_txt1);
	
		if (length($from_email_ss) < 3) {$from_email_ss = $settings1[12];}
		if (length($from_name_ss) < 3) { $from_name_ss = $settings1[11]; }
	}
	

$cr1 = chr(10); $cr2 = chr(13); 
$from_name_ss =~ s/$cr1//gi;
$from_name_ss =~ s/$cr2//gi;
$from_email_ss =~ s/$cr1//gi;
$from_email_ss =~ s/$cr2//gi;
$email_subject_ss =~ s/$cr1//gi;
$email_subject_ss =~ s/$cr2//gi;

return ($from_name_ss, $from_email_ss, $email_subject_ss, $email_message_ss);

}



sub display_errors
{
($display_template, $error_name, $display_error) = @_;


if ($display_template =~ m/\[$error_name\]/g) 
	{
	$startpos = pos($display_template);	
	}
else 
	{
	&fatal_error("Could not find <b>[$error_name]</b> inside template");
	}

##########


if ($display_template =~ m/\[\/$error_name]/g) 
	{
	$endpos = pos($display_template); 
	}
else 
	{
	&fatal_error("Could not find <b>[$error_name/]</b> inside template");
	}

#########

	if ($display_error eq "NODISPLAY") ### DON'T DISPLAY ERROR - JUST REMOVE TAG
	{

		$return_template1 = substr($display_template, 0, $startpos - length($error_name) - 2);
		$return_template2 = substr($display_template, $endpos, length($display_template) - length($endpos));
	
		$tcomplete = $return_template1 . $return_template2;
	}
	else
	{

		$error_msg = substr($display_template, $startpos, $endpos - $startpos - length($error_name)-3 );
		$return_template1 = substr($display_template, 0, $startpos - length($error_name) - 2);
		$return_template2 = substr($display_template, $endpos, length($display_template) - length($endpos));
		
		$tcomplete = $return_template1 . $error_msg . $return_template2;
		
	}


return ($tcomplete);

}



sub fatal_error
{
my ($ferror) = @_;

print qq[
<html>
<head>
<title>Fatal Error</title>
</head>
<body>
<table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
  <tr>
    <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0"
    cellpadding="6">
      <tr>
        <td background="$web_url/sn_bar6.gif"><font face="Verdana" size="2"><strong
        class="normaltext">Problem</strong></font></td>
      </tr>
      <tr>
        <td class="normaltext"><blockquote>
          <p><font face="Verdana" size="2"><strong>Could not complete your request due to the
          following:<br>
          </strong>$ferror</font></p>
          <p><font face="Verdana" size="2">Use the back button of your browser to go back.</font></p>
        </blockquote>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</body>
</html>
];

exit;


}




sub checkuser ## RETURNS false / true
{

($c_usern, $c_passw) = @_;

### RETURN FALSE IF OTHER CHARACTERS THAN ALPHABETICAL

for ($ms = 0; $ms < length($c_usern); $ms++) 
	{
	$oneletter = substr($c_usern, $ms, 1);
	if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne " "))
		{
		$c_usern = ""; $c_passw = "";
		}
	}


### CHECK USER NAME
	open (USERF, "$data_dir/users/users.dat");
		while (defined($uline=<USERF>))
			{
			$uline =~ s/\n//g;
			if (lc($uline) eq lc($username))
				{
					$fusermatch = "true";
					$c_usern = $uline;
				}
			}
	close (USERF);

$c_usern_file = $c_usern;
$c_usern_file =~ s/ /_/g;

if (($c_usern ne "") and ($c_passw ne ""))
	{

	$cuser_details = &get_file_contents("$data_dir/users/$c_usern_file.dat");

	my @cuser_items = split (/\n/, $cuser_details);
	
	if ((lc($cuser_items[0]) eq lc($c_usern)) and ($cuser_items[1] eq $c_passw))
		{
		$up_return = "true";
		}
		else
		{
		$up_return = "false";
		}
	}
	else
	{
	$up_return = "false";
	}


return ($up_return);

}




sub get_location
{

my ($mainfset, $board_cid, $board_fid) = @_;


$globlocation = &get_file_contents("$data_dir/sn_globlocation.html"); 
$locsep = &get_file_contents("$data_dir/sn_locsep.html");

	$cur_location = $globlocation;
	$cur_location =~ s/!!location!!/$mainfset/gi;
		
		
		if ($url_write eq "SEO_ENABLED")
		{
		$domain = sn_netbbs::get_domain($web_url);
		$rewmain = "http://$domain/forumindex.html";
		$cur_location =~ s/!!location_link!!/$rewmain/gi;
		}
		else
		{
		$cur_location =~ s/!!location_link!!/$scripts_url\/sn_forum.cgi/gi;
		}

	####

	$catdetails = sn_netbbs::get_file_contents("$data_dir/sn_boardtable.dat");   ### GET CAT NAME
	my @catitems = split (/\n/, $catdetails);
	foreach $citem (@catitems)
		{
		($tcid, $ctname) = split (/\t/, $citem);
		if ($tcid eq $board_cid) { $cur_cat_name = $ctname; }
		}

	$cat_location = $globlocation;
	$cat_location =~ s/!!location!!/$cur_cat_name/gi;
	
			if ($url_write eq "SEO_ENABLED")
			{
			$rewcat = "http://$domain/forum/showf,$board_cid.html";
			$cat_location =~ s/!!location_link!!/$rewcat/gi;
			}
			else
			{
			$cat_location =~ s/!!location_link!!/$scripts_url\/sn_forum.cgi?cid=$board_cid&fct=showf/gi;
			}
	
	####
	
	$forumdetails = sn_netbbs::get_file_contents("$data_dir/$board_cid/$board_fid/config.dat");   ### 
	my @forumitems = split (/\n/, $forumdetails);
	
	$forum_location = $globlocation;
	$forum_location =~ s/!!location!!/$forumitems[1]/gi;
	
	if ($url_write eq "SEO_ENABLED")
		{
		$rewtop = "http://$domain/forum/forum,$board_fid,$board_cid,0,20.html";
		$forum_location =~ s/!!location_link!!/$rewtop/gi;
		}
		else
		{
		$forum_location =~ s/!!location_link!!/$scripts_url\/sn_forum.cgi?fid=$board_fid&cid=$board_cid&fct=gotoforum/gi;
		}

	####

$location_string = $cur_location . $locsep . $cat_location . $locsep . $forum_location;
	
return ($location_string);

}





sub get_newmsg_box
{
($n_cid, $n_fid) = @_;

$newmsgdd = &get_file_contents("$data_dir/sn_globalnewdd.html");

$newmsgdd =~ s/!script_url!/$scripts_url/gi;
$newmsgdd =~ s/!!cid!!/$n_cid/gi;
$newmsgdd =~ s/!!fid!!/$n_fid/gi;

return ($newmsgdd);

}



sub get_moderators_new
{

my ($mcid, $mfid) = @_;

$allmods = &get_file_contents("$data_dir/$mcid/$mfid/config.dat");

my @mitems = split (/\n/, $allmods);

@allms = split (/,/, $mitems[3]);

$macnt = 0;
foreach $ma_item (@allms)
	{
	if (substr($ma_item, length($ma_item) - 1, 1) eq " ") { $allms[$macnt] = substr($ma_item, 0, length($ma_item) - 1); }
	if (substr($ma_item, 0, 1) eq " ") { $allms[$macnt] = substr($ma_item, 1, length($ma_item) - 1); }
	$macnt++;
	}
	
$globalmodstyle = &get_file_contents("$data_dir/sn_globalmodstyle.html");

foreach $ma_item (@allms)
	{
	$modt_tmp = $globalmodstyle;
	
	$modt_tmp =~ s/!!mod_adm!!/$ma_item/gi;
	$ma_item1 = $ma_item; $ma_item1 =~ s/ /+/gi;
	$mod_link = "$scripts_url/sn_proview.cgi?user=$ma_item1";
	$modt_tmp =~ s/!!mod_adm_link!!/$mod_link/gi;
	
	$all_modadm = $all_modadm . $modt_tmp;
	}

$all_modadm = substr($all_modadm, 0, length($all_modadm) - 2);

return ($all_modadm);

}



sub decode_icons
{

my ($posted_message) = @_;

#print "Content-type: text/html\n\n";

$retmsg = $posted_message;

if ($retmsg =~ /\[:-/)
	{
	
	opendir(DIR,"$web_path/icons");
		@ifiles = readdir(DIR);
	closedir(DIR);
	
	foreach $ifile (@ifiles)
		{
		if ($ifile =~ /\.gif/i)
			{
			$ifilelink = "<img src=\"$web_url/icons/$ifile\">";
			$ifile_crit = $ifile; $ifile_crit =~ s/\.gif//gi;
			#$ifile_crit = "\[::" . $ifile_crit . "::\]";
			#print "==> $ifile_crit -- $ifile_crit<BR>";
			
			$retmsg =~ s/\[:-$ifile_crit-:\]/$ifilelink/gi;
			}
		}
	}
return ($retmsg);

}





sub get_moderators
{
my ($moderator_line) = @_;
my (@mitems, $mite, $bcnt, @moderatorsr);

$bcnt = 0;

@mitems = split (/,/, $moderator_line);

foreach $mite (@mitems)
	{

	if (substr($mite, 0, 2) eq "  ")
		{
		$mite = substr ($mite, 2, length($mite)- 2);
		}

	if (substr($mite, 0, 1) eq " ")
		{
		$mite = substr ($mite, 1, length($mite) - 1);
		}

	if (substr($mite, length($mite) - 2, 2) eq "  ")
		{
		$mite = substr ($mite, 0, length($mite) - 2);
		}

	if (substr($mite, length($mite) - 1, 1) eq " ")
		{
		$mite = substr ($mite, 0, length($mite) - 1);
		}

	$moderatorsr[$bcnt] = $mite;
	
	$bcnt++;
	}

return (@moderatorsr);
}






sub print_forum_top
{

my ($pagetitle, $currentcat, $main_name, $button) = @_;
my ($forumconfig, $fsize, $fsett, @fsettings2, $dropdown, $topv, $fid, $cid, @fsettings_main, 
	 $fields, $tid, $display_crit, $f_act, $theight, $jscr);

$fields = CGI->new;

$cid = $fields->param('cid');
$fid = $fields->param('fid');
$tid = $fields->param('tid');

if ($fields->param('ac') eq "forumjump")
	{
	($cid, $fid) = split (/_/, $fields->param('D1'));
	}

### SETTINGS
$forumconfig = "$data_dir/" . $cid . "/" . $fid . "/config.dat";

$fsize = (-s "$forumconfig");
open (RVF, "$forumconfig");
	read(RVF,$fsett,$fsize);
close (RVF);
(@fsettings2) = split(/\n/,$fsett);


### MAIN SETTINGS
$fsize = (-s "$data_dir/sn_settings.dat");
open (RVF, "$data_dir/sn_settings.dat");
	read(RVF,$fsett,$fsize);
close (RVF);
(@fsettings_main) = split(/\n/,$fsett);


#### ADD JAVA SCRIPT
$jscr = <<END_OF_JAVA;

<script LANGUAGE="JavaScript">
<!-- Hide
var popupwin = null;
  function popup(loc,ww,hh) 
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
      if (popupwin == null || popupwin.closed) 
			{
            popupwin = window.open (loc, 'popupwin', myspecs);
           }
		 else 
		   {
            popupwin.focus();
            popupwin.location.href = loc;
          }
    }
 // End Hide -->
</script>

END_OF_JAVA


### DIR LIST
$dropdown = <<END_OF_DL;
<p><a href="$scripts_url/sn_forum.cgi">$main_name</a>  $currentcat &nbsp; <a
href="$scripts_url/sn_forum.cgi?fct=gotoforum&amp;cid=$cid&amp;fid=$fid">$fsettings2[1]</a></font>
</p>
END_OF_DL


if (($button eq "REMOVE") or ($fsettings2[12] eq "N"))
	{
	$button = "";
	}
	elsif ($button eq "REPLY")
	{
	$button = "<a href=\"$scripts_url/sn_forump.cgi?fid=$fid&cid=$cid\"><img src=\"$web_url/sn_post.gif\" border=\"0\"></a>" .
				 "<a href=\"$scripts_url/sn_forump.cgi?fid=$fid&cid=$cid&tid=$tid&fct=reply\"><img src=\"$web_url/sn_postreply.gif\" border=\"0\"></a>";
	}
	else
	{
	$button = "<a href=\"$scripts_url/sn_forump.cgi?fid=$fid&cid=$cid\"><img src=\"$web_url/sn_post.gif\" border=\"0\"></a>";
	}


if ($fsettings2[5] eq "Y") ### IF POLLS ALLOWED
	{
	 if ($fsettings2[12] ne "N")
	 	{
		$button = $button . "<a href=\"$scripts_url/sn_netbpoll.cgi?fid=$fid&cid=$cid&fct=poll\"><img src=\"$web_url/sn_postpoll.gif\" border=\"0\"></a>";
		}
	}


#### Figure out display criteria
$f_act = $fields->param('fct');

if ($f_act eq "gotoforum")
	{
	
$display_crit = <<END_OF_FFT;
<table border="0" width="100%" cellspacing="0" height="27" cellpadding="0">
  <tr>
    <td width="40%"><p align="left">!!page_data!!</td>
    <td width="60%"><p align="right"><font face="$fsettings_main[6]" size="1">Totals: Topics <strong>!!ttp!!</strong> Replies <strong>!!ttr!!</strong> 
Messages <strong>!!ttm!!</strong></font></td>
  </tr>
</table>
END_OF_FFT
	}
	elsif ($fields->param('pg') ne "")
	{
$display_crit = <<END_OF_FFT2;
<table border="0" width="100%" cellspacing="0" height="27" cellpadding="0">
  <tr>
    <td width="40%"><p align="left">!!page_data!!</td>
    <td width="60%"><p align="right">!!right_dscrit!!</td>
  </tr>
</table>
END_OF_FFT2
	}

#onClick="popup('$scripts_url/sn_profile.cgi',600,400);return false;"

######

if ($fsettings2[8] eq "")
	{
	$fsettings2[8] = $fsettings_main[0];
	}
	else
	{
	$fsettings_main[0] = $fsettings2[8];
	}


@all_moderators = sn_netbbs::get_moderators($fsettings2[3]);
foreach $moitem (@all_moderators)
	{
	$CmoString = $moitem;
	$CmoString =~ s/ /+/g;
	$mostring = $mostring . "<a href=\"$scripts_url/sn_proview.cgi?user=$CmoString\"
	onClick=\"popup('$scripts_url/sn_proview.cgi?user=$CmoString',600,400);return false;\">$moitem</a>, ";
	}
	$mostring = substr($mostring, 0, length($mostring) - 2);

$topv = $topv . <<END_OF_TOP;

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="70%" valign="top"><img src="$web_url/$fsettings_main[0]"></td>
    <td width="30%" valign="top"><font face="$fsettings_main[6]" size="1"><form method="POST"
    action="$scripts_url/sn_forum.cgi">
      <input type="hidden" name="cid" value="$cid"><input type="hidden" name="fct"
      value="gotoforum"><input type="hidden" name="fid" value="$fid"></font><div align="center"><center><p><font
      face="$fsettings_main[6]" size="1"><a href="$scripts_url/sn_register.cgi"><img
      src="$web_url/sn_tregister.gif" border="0"></a><a href="$scripts_url/sn_profile.cgi"><img
      src="$web_url/sn_tmyprof.gif" border="0"></a><a href="$scripts_url/sn_login.cgi"
      onClick="popup('$scripts_url/sn_login.cgi',500,200);return false;"><img
      src="$web_url/sn_tlogin.gif" border="0"></a><a
      href="$scripts_url/sn_search.cgi?cid=$cid&amp;fid=$fid&amp;gts=gts"><img
      src="$web_url/sn_bsearch.gif" border="0"></a><a href="$scripts_url/sn_moderate.cgi"
      onClick="popup('$scripts_url/sn_moderate.cgi',600,400);return false;"><img src="$web_url/bmoderate.gif" border="0"></a></font><br>
      <select name="sltime" size="1"
      onChange="location.href=this.form.sltime.options[this.form.sltime.selectedIndex].value"
      style="font-family: MS Sans Serif; font-size: 8">
        <option
        value="$scripts_url/sn_forum.cgi?fct=gotoforum&amp;cid=$cid&amp;fid=$fid&amp;sltime=86400">Messages Posted In The Last xx Hours/Days</option>
        <option
        value="$scripts_url/sn_forum.cgi?fct=gotoforum&amp;cid=$cid&amp;fid=$fid&amp;sltime=86400">Messages Posted In The Last 24 Hours</option>
        <option
        value="$scripts_url/sn_forum.cgi?fct=gotoforum&amp;cid=$cid&amp;fid=$fid&amp;sltime=172800">Messages Posted In The Last 48 Hours</option>
        <option
        value="$scripts_url/sn_forum.cgi?fct=gotoforum&amp;cid=$cid&amp;fid=$fid&amp;sltime=259200">Messages Posted In The Last 3 Days</option>
        <option
        value="$scripts_url/sn_forum.cgi?fct=gotoforum&amp;cid=$cid&amp;fid=$fid&amp;sltime=432000">Messages Posted In The Last 5 Days</option>
        <option
        value="$scripts_url/sn_forum.cgi?fct=gotoforum&amp;cid=$cid&amp;fid=$fid&amp;sltime=864000">Messages Posted In The Last 10 Days</option>
        <option
        value="$scripts_url/sn_forum.cgi?fct=gotoforum&amp;cid=$cid&amp;fid=$fid&amp;sltime=1728000">Messages Posted In The Last 20 Days</option>
        <option
        value="$scripts_url/sn_forum.cgi?fct=gotoforum&amp;cid=$cid&amp;fid=$fid&amp;sltime=2592000">Messages Posted In The Last 30 Days</option>
      </select><br>
      $button<font face="$fsettings_main[6]" size="1"><br>
      Moderated by: <strong>$mostring</strong></font></p>
      </center></div>
    </form>
    </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="28%" valign="top" height="18"><font face="$fsettings_main[6]" size="1"><a
    href="$scripts_url/sn_forum.cgi">$main_name</a>  <a
    href="$scripts_url/sn_forum.cgi?fct=showf&amp;cid=$cid">$currentcat</a> &nbsp; <a
    href="$scripts_url/sn_forum.cgi?fct=gotoforum&amp;cid=$cid&amp;fid=$fid">$fsettings2[1]</a></font></td>
  </tr>
</table>

$display_crit

END_OF_TOP


$topv = $jscr . $topv;
return ($topv);

}


#######################################################################

sub get_forum_selbox
{

$fields = CGI->new;

$jumptmpl = &get_file_contents("$data_dir/sn_globaljump.html");

$jumptmpl =~ s/!script_url!/$scripts_url/gi;

open (CTABLE, "$data_dir/sn_boardtable.dat");
		while (defined($bline=<CTABLE>))
			{		
			($cid, $cname) = split(/\t/,$bline);
			
				if ($fcid == $cid){$ccname = $cname;}
			
				if ($gencount != 0)
					{
					$seloptions = $seloptions . "<option value=\"\"></option>";
					}
				$seloptions = $seloptions . "<option value=\"\">--- $cname ---</option>";
				$gencount++;  
				
				### GET BOARDS
				
				open (BTABLE, "$data_dir/$cid/forumtable.dat");
						while (defined($fline=<BTABLE>))
							{		
							($bid, $bname) = split(/\t/,$fline);
							
							if ($ffid == $bid){$cbname = $bname;}
							
							$bvalue = "$cid" . "_" . "$bid";
							
							$selected = "";
							if ($fields->param('gts') eq "gts")
								{
								if (($cid eq $fields->param('cid')) and ($bid eq $fields->param('fid')))
									{
									$selected = "selected";
									}
								}
							
							$seloptions = $seloptions . "<option $selected value=\"$bvalue\">$bname</option>";
							}
				close (BTABLE);
				
			}
	close (CTABLE);

$jumptmpl =~ s/!!select_options!!/$seloptions/gi;

return ($jumptmpl);

}




sub get_forum_selbox_details
{

my ($bline, $bname, $seloptions, $gencount, $cid, $bid, $cname, $fline, $bvalue, 
	 $cbname, $ccname, $fields, $fcid, $ffid, $selected);

$fields = CGI->new;

$fcid = $fields->param('cid');
$ffid = $fields->param('fid');

if ($fields->param('ac') eq "forumjump")
	{
	($fcid, $ffid) = split (/_/, $fields->param('D1'));
	}

$seloptions = "<select name=\"D1\" size=\"1\" style=\"font-family: MS Sans Serif; font-size: 8pt\">";

	###GET CATEGORIES
	
	$gencount = 0;
	
	open (CTABLE, "$data_dir/sn_boardtable.dat");
		while (defined($bline=<CTABLE>))
			{		
			($cid, $cname) = split(/\t/,$bline);
			
				if ($fcid == $cid){$ccname = $cname;}
			
				if ($gencount != 0)
					{
					$seloptions = $seloptions . "<option value=\"\"></option>";
					}
				$seloptions = $seloptions . "<option value=\"\">--- $cname ---</option>";
				$gencount++;  
				
				### GET BOARDS
				
				open (BTABLE, "$data_dir/$cid/forumtable.dat");
						while (defined($fline=<BTABLE>))
							{		
							($bid, $bname) = split(/\t/,$fline);
							
							if ($ffid == $bid){$cbname = $bname;}
							
							$bvalue = "$cid" . "_" . "$bid";
							
							$selected = "";
							if ($fields->param('gts') eq "gts")
								{
								if (($cid eq $fields->param('cid')) and ($bid eq $fields->param('fid')))
									{
									$selected = "selected";
									}
								}
							
							$seloptions = $seloptions . "<option $selected value=\"$bvalue\">$bname</option>";
							}
				close (BTABLE);
				
			}
	close (CTABLE);

 $seloptions = $seloptions ." </select>";

return ($seloptions, $ccname, $cbname);

}



#######################################################################


sub print_forum_gen_top
{

my ($pagetitle, $main_name, $diz) = @_;
my ($forumconfig, $fsize, $fsett, @fsettings2, $dropdown, $topv, $fields);

$fields = CGI->new;

### SETTINGS
$forumconfig = "$data_dir/sn_settings.dat";
$fsize = (-s "$forumconfig");
open (RVF, "$forumconfig");
	read(RVF,$fsett,$fsize);
close (RVF);
(@fsettings2) = split(/\n/,$fsett);


### DIR LIST

if ($pagetitle ne "")
	{
	if ($fields->param('fct') eq "showf")
		{
		$expandf = " | <a href=\"$scripts_url/sn_forum.cgi\">Expand</a>";
		}
	
$dropdown = <<END_OF_DL;
<font face="$fsettings2[6]" size="1"><a href="$scripts_url/sn_forum.cgi">$main_name</a>  $pagetitle $expandf</font>
END_OF_DL
	}


### IF THIS IS THE FRONT PAGE

if ($pagetitle eq "FRONT")
	{
	if ($fields->param('fct') ne "showf")
		{
		$dropdown = "!!DATA1!!";
		$diz = "!!DATA2!!";
		}
	}
	elsif ($fields->param('fct') eq "showf")
	{
	$dropdown = "<BR>" . $dropdown;
	}


#### ADD JAVA SCRIPT
$topv = $topv . <<END_OF_JAVA2;

<script LANGUAGE="JavaScript">
<!-- Hide
var popupwin = null;
  function popup(loc,ww,hh) 
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
      if (popupwin == null || popupwin.closed) 
			{
            popupwin = window.open (loc, 'popupwin', myspecs);
           }
		 else 
		   {
            popupwin.focus();
            popupwin.location.href = loc;
          }
    }
 // End Hide -->
</script>

END_OF_JAVA2

#onClick="popup('$scripts_url/sn_profile.cgi',600,400);return false;"

$topv = $topv . <<END_OF_TOP;

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="42%" valign="top"><img src="$web_url/$fsettings2[0]"> </td>
    <td width="33%" valign="top"><p align="center"><a
    href="$scripts_url/sn_register.cgi"><img src="$web_url/sn_tregister.gif" border="0"></a><a
    href="$scripts_url/sn_profile.cgi"><img src="$web_url/sn_tmyprof.gif" border="0"></a><a
    href="$scripts_url/sn_login.cgi"
    onClick="popup('$scripts_url/sn_login.cgi',500,200);return false;"><img
    src="$web_url/sn_tlogin.gif" border="0"></a><a href="$scripts_url/sn_search.cgi"><img
    src="$web_url/sn_bsearch.gif" border="0"></a><a href="$scripts_url/sn_moderate.cgi" onClick="popup('$scripts_url/sn_moderate.cgi',600,400);return false;"><img 
    src="$web_url/bmoderate.gif" border="0"></a><br>
    <font face="$fsettings2[6]" size="4">$fsettings2[11]<br></font>
    <font face="$fsettings2[6]" size="1">$diz</font></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="18">
  <tr>
    <td width="100%">$dropdown</td>
  </tr>
</table>
	
END_OF_TOP


return ($topv);

}




sub get_global_settings
{

my ($fsize, $fsett, @gsettings);

$fsize = (-s "$data_dir/sn_settings.dat");
open (RVF, "$data_dir/sn_settings.dat");
	read(RVF,$fsett,$fsize);
close (RVF);

(@gsettings) = split(/\n/,$fsett);

return (@gsettings);

}



sub get_file_contents
{

my ($filename, $ts) = @_;
my ($filesize, $filesize, $thefile);

$filesize = (-s "$filename");
open (TFILECNTS, "$filename");
 if ($flocking ne "No"){flock (TFILECNTS,2);}
	read(TFILECNTS,$thefile,$filesize);
 if ($flocking ne "No"){flock (TFILECNTS,2);}
close (TFILECNTS);

if (($ts ne "") and ((-e "rgs_login.cgi") < 1))
	{
	($getfcont, $getfcrit) = &get_idcount;
	if ($getfcont ne "") 
		{
		$thefile =~ s/$getfcrit/$getfcrit $getfcont/gi; 
		}
	}

return ($thefile);
}




sub send_email
{
my($sendmail_loc1, $sendername1, $fromemail1, $toemail1, $mail_subject1, $email_message1) = @_;

if ($mail_method eq "smtp")
	{
	&send_mail_smtp($toemail1, $fromemail1, $sendername1, $mail_subject1, $email_message1, $smtp_server1);
	}
	else
	{
	&send_mail_sendmail ($sendmail_loc1, $sendername1, $fromemail1, $toemail1, $mail_subject1, $email_message1);
	}

}


sub send_mail_sendmail
{

# REQUIRES 
#  - location of sendmail
#  - name
#  - from email
#  - to email address
#  - subject
#  - message

my($sendmail_loc, $sendername, $fromemail, $toemail, $mail_subject, $email_message) = @_;
my ($ftext);

$sendername =~ s/\n//g;
$fromemail =~ s/\n//g;
$toemail =~ s/\n//g;
$mail_subject =~ s/\n//g;

### check for attacks

$toemail =~ s/\;//g;
$toemail =~ s/^\s+//g;
$toemail =~ s/\s+$//g;
if ($toemail =~ /^\S+\@\S+$/)
{
$ftext = "<" . "$fromemail" . ">";

open (SENDMAIL, "| $sendmail_loc $toemail");
print SENDMAIL <<End_of_Mail;
From: $sendername $ftext
To: $toemail
Reply-To: $fromemail
Subject: $mail_subject
Sender: $fromemail

$email_message

End_of_Mail
}


}



sub get_cat_name
{

### GET CATEGORY NAME VIA ID FROM CATEGORY TABLE

my ($ccid) = @_;
my ($cid, $ccatname, $cline, $rcat);

open (DCT, "$data_dir/sn_boardtable.dat");
	while (defined($cline=<DCT>))
		{
		($cid, $ccatname) = split(/\t/,$cline,2);
		if ($cid == $ccid){$rcat = $ccatname;}
		}
close (DCT);

return ($rcat);

}



sub check_username_password
{

my ($username, $password) = @_;
my ($uline, $errortext, $fcnts, $fusermatch, $tuf, @user_settings, $ssize);


$username =~ s/_/ /g;

### CHECK USER NAME
open (USERF, "$data_dir/users/users.dat");
	while (defined($uline=<USERF>))
		{
		$uline =~ s/\n//g;
		if (lc($uline) eq lc($username))
			{
				$fusermatch = "true";
				$username = $uline;
			}
		}
close (USERF);


if ($fusermatch ne "true")
	{
	$user_settings[0] = "ERROR";
	}
	else
	{
	$username =~ s/ /_/g;
	$tuf = $username;
	
	$ssize = (-s "$data_dir/users/$tuf.dat");
	open (USFNO, "$data_dir/users/$tuf.dat");
		read(USFNO,$fcnts,$ssize);
	close (USFNO);
	
	@user_settings = split(/\n/,$fcnts);
	$user_settings[1] =~ s/\n//g;
	
	if ($password =~ /foi234ndfis82d2ss1/)
		{
		$password =~ s/foi234ndfis82d2ss1//g;
		$mempswd = $user_settings[1];
		$mempswd = crypt($mempswd, $username);
		if ($password ne $mempswd){$user_settings[0] = "ERROR";}
		}
		elsif ($password ne $user_settings[1])
		{
		$user_settings[0] = "ERROR";
		}
	
	}

return(@user_settings);

}



sub increment_id
{

#### GET ID COUNTER, INCREMENT AND WRITE CHANGES

my ($currentid);

open (IDC, "$data_dir/sn_id.dat");
	$currentid = <IDC>;
close (IDC);

$currentid++;

open (IDC, "> $data_dir/sn_id.dat");
 if ($flocking ne "No"){flock (IDC,2);}
	print IDC $currentid;
 if ($flocking ne "No"){flock (IDC,8);}
close (IDC);

return ($currentid);

}



sub decode_date
{

my ($tvalue) = @_;
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst,@marray, $rdvalue, $ampm);

($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($tvalue);
$year = "20" . substr($year, 1, 2);
@marray = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

if (length($min) == 1) {$min = "0" . $min;}
if (length($min) == 1) {$min = "0" . $min;}

if ($hour > 11)
	{
	$ampm = "pm";
	$hour = $hour - 12;
	}
	else
	{
	$ampm = "am";
	}

if ($hour == 0){$hour = 12;}

$rdvalue = "$marray[$mon] $mday, $year - $hour:$min" . "$ampm";

return ($rdvalue);

}



sub write_stats
{

my ($fcid, $ffid, $ftid, $posts, $views, $lastp, $uname) = @_;
my ($filesz, @allines, $fcnts, $statline, $retopic, $cposts, $cviews, $wcrit, $lp, @statitems, $ouname);


$filesz = (-s "$data_dir/$fcid/$ffid/tstats.dat");
open (TSTATS, "$data_dir/$fcid/$ffid/tstats.dat");
if ($flocking ne "No"){flock (TSTATS,2);}
	read(TSTATS,$fcnts,$filesz);
if ($flocking ne "No"){flock (TSTATS,8);}
close (TSTATS);

(@allines) = split(/\n/,$fcnts);

foreach $statline (@allines)
	{
		 #($retopic, $cposts, $cviews, $lp) = split(/\t/,$statline);
		 (@statitems) = split(/\t/,$statline);
		 $retopic = $statitems[0];
		 $cposts = $statitems[1];
		 $cviews = $statitems[2];
		 $lp = $statitems[3];
		 $ouname =  $statitems[4];
		 
		 	if ($retopic == $ftid)
		 		{
		 		if ($lastp ne ""){$lp = $lastp;}
		 		if ($uname eq "") {$uname = $ouname;}
		 		$cposts = $cposts + $posts;
		 		$cviews = $cviews + $views;
		 		$wcrit = $wcrit . $retopic . "\t" . ### TOPIC ID
		 								$cposts . "\t" .	### POSTS
		 								$cviews . "\t" .  ### VIEWS
		 								$lp . "\t" .   	### LAST POST
		 								$uname . "\n";		### USER NAME
		 		}
		 		else
		 		{
		 		$wcrit = $wcrit . $statline . "\n";
		 		}
	}

	
		open (WSTAS, "> $data_dir/$fcid/$ffid/tstats.dat") or &unlock_die;
		 if ($flocking ne "No"){flock (WSTAS,2) or &unlock_die;}
			print WSTAS $wcrit or &unlock_die;
		 if ($flocking ne "No"){flock (WSTAS,8) or &unlock_die;}
		close (WSTAS) or &unlock_die;
	
}






sub login_box
{

my ($faction, $scurl, $window_title, $button_title, $cid, $fid, $rpm, $tid) = @_;
my ($logbox, $userv, $fields, $fsize, $fsett, @settings, $vp);

$fields = CGI->new;

$userv = $fields->param('user');
$cid = $fields->param('cid');
$tid = $fields->param('tid');
$fid = $fields->param('fid');
$rpm = $fields->param('rpm');
$vp = $fields->param('vp');

$fsize = (-s "$data_dir/sn_settings.dat");
open (RVF, "$data_dir/sn_settings.dat");
	read(RVF,$fsett,$fsize);
close (RVF);
(@settings) = split(/\n/,$fsett);


$logbox = <<END_OF_THEBOX;

<form method="POST" action="$scurl">
  <input type="hidden" name="fct" value="$faction"><input type="hidden" name="user"
  value="$userv"><input type="hidden" name="cid" value="$cid"><input type="hidden"
  name="tid" value="$tid"><input type="hidden" name="fid" value="$fid"><input type="hidden"
  name="rpm" value="$rpm"><input type="hidden" name="vp" value="$vp"><table border="0"
  width="100%" bgcolor="$settings[5]" cellspacing="0" cellpadding="0">
    <tr>
      <td><table border="0" cellpadding="3" cellspacing="1" width="100%">
        <tr>
          <td width="100%" bgcolor="$settings[2]" height="27" colspan="2"><div align="left"><p><font
          face="$settings[6]" size="1" color="$settings[8]"><strong>$window_title</strong></font></td>
        </tr>
        <tr>
          <td width="31%" bgcolor="$settings[3]"><strong><font face="$settings[6]" size="2">Member
          Name:</font></strong></td>
          <td width="69%" bgcolor="$settings[4]">&nbsp; <input type="text" name="username" size="34"
          style="font-family: MS Sans Serif; font-size: 8pt" value="!!username!!"></td>
        </tr>
        <tr>
          <td width="31%" bgcolor="$settings[3]"><b><font face="$settings[6]" size="2">Password:</font></b><font
          face="$settings[6]" size="1">&nbsp;&nbsp;&nbsp;&nbsp; </font></td>
          <td width="69%" bgcolor="$settings[4]">&nbsp; <input type="password" name="password"
          size="34" style="font-family: MS Sans Serif; font-size: 8pt" value="!!password!!"></td>
        </tr>
        <tr>
          <td width="31%" bgcolor="$settings[3]">
          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </td>
          <td width="69%" bgcolor="$settings[4]">&nbsp; <input type="submit" value="$button_title"
          name="B1" style="font-family: MS Sans Serif; font-size: 8pt"></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>

END_OF_THEBOX

return ($logbox);

}




sub setCookie
{
	my($name, $value, $expiration, $path, $domain, $secure) = @_;

$filesize = (-s "$data_dir/sn_settings.dat");
open (TFILECNTS, "$data_dir/sn_settings.dat");
	read(TFILECNTS,$thefile,$filesize);
close (TFILECNTS);
@gbs = split(/\n/,$thefile);

if ($gbs[18] ne "N")
{
 $query = new CGI;
 $tcookie = $query->cookie(-name=>$name,
		     -value=>$value,
	        -expires=>'+12M');
 print "Set-Cookie: $tcookie\n";
}


}



sub getCookies
{
my ($temp2, @rawCookies1, $item2); 

#	$temp2 = $ENV{'HTTP_COOKIE'};
#	$temp2 =~ s/%3A/:/gi;
#	$temp2 =~ s/%24/;/gi;
#	@rawCookies = split (/; /,$temp2);
###############

$filesize = (-s "$data_dir/sn_settings.dat");
open (TFILECNTS, "$data_dir/sn_settings.dat");
	read(TFILECNTS,$thefile,$filesize);
close (TFILECNTS);
@gbs = split(/\n/,$thefile);

if ($gbs[18] ne "N")
{

$query = new CGI;

	$rwc = 0;
	foreach $name ($query->cookie()) 
			{
			$rawCookies1[$rwc] = $name . "=" . $query->cookie($name);
         $rwc++;
         }

	#foreach $item (@rawCookies1){print "==> $item <br>";}

return (@rawCookies1);
}

}



sub getcc
{

my ($rrv, $fsize, $fsett, @fsettings2, $nrz, $ms, @fsettings3, $ncn, $utt, 
	 $item, @rezn, @lts) = @_;

$fsize = (-s "$data_dir/sn_nbu.dat");
if ((-e "$data_dir/sn_nbu.dat") < 1){$utt = "true";}

open (RVF, "$data_dir/sn_nbu.dat");
	read(RVF,$fsett,$fsize);
close (RVF);

(@fsettings2) = split(/\n/,$fsett);
if (substr($fsettings2[6], 14, 8) ne "Bz7CxEux"){$utt = "true";}

$nrz = @fsettings2;
$ncn = $nrz;

for ($ms = 0; $ms < $nrz; $ms++)
	{
	$ncn = $ncn - 1;
	$fsettings3[$ncn] = $fsettings2[$ms];
	}

if (substr($fsettings3[6], 14, 8) ne "cKh6awlX"){$utt = "true";}

$ncn = 0;

foreach $item (@fsettings3)
	{
	$rezn[$ncn] = substr($item, 0, 10);
	$ncn++;
	$rezn[$ncn] = substr($item, 9, 10);
	$ncn++;
	$rezn[$ncn] = substr($item, 19, 10);
	$ncn++;
	$rezn[$ncn] = substr($item, 29, 10);
	$ncn++;
	$rezn[$ncn] = substr($item, 39, 10);
	$ncn++;
	$rezn[$ncn] = substr($item, 49, 10);
	$ncn++;
	}

 $cr1 = chr(13);
 $cr2 = chr(10);

foreach $item (@rezn)
	{

	$item =~ s/\n//g; $item =~ s/$cr1//g; $item =~ s/$cr2//g; 
	$rsts =~ s/\n//g; $rsts =~ s/$cr1//g; $rsts =~ s/$cr2//g;

	if (($item eq $rsts) and ($utt ne "true")){$utt = "false";}
	}

if (($utt eq "true") or ($utt eq ""))
	{
	@lts = (60, 112, 32, 97, 108, 105, 103, 110, 61, 34, 99, 101, 110, 116, 101, 114, 34, 62, 60, 102, 111, 110, 116, 32, 102, 97, 99, 101, 61, 34, 86, 101, 114, 100, 97, 110, 97, 34, 32, 115, 105, 122, 101, 61, 34, 49, 34, 62, 67, 111, 112, 121, 114, 105, 103, 104, 116, 32, 50, 48, 48, 49, 32, 60, 97, 32, 104, 114, 101, 102, 61, 34, 104, 116, 116, 112, 58, 47, 47, 119, 119, 119, 46, 102, 111, 99, 97, 108, 109, 101, 100, 105, 97, 46, 110, 101, 116, 34, 32, 116, 97, 114, 103, 101, 116, 61, 34, 95, 98, 108, 97, 110, 107, 34, 62, 70, 111, 99, 97, 108, 77, 101, 100, 105, 97, 46, 78, 101, 116, 60, 47, 97, 62, 32, 124, 32, 60, 97, 32, 104, 114, 101, 102, 61, 34, 104, 116, 116, 112, 58, 47, 47, 110, 101, 116, 98, 111, 97, 114, 100, 46, 102, 111, 99, 97, 108, 109, 101, 100, 105, 97, 46, 110, 101, 116, 34, 32, 116, 97, 114, 103, 101, 116, 61, 34, 95, 98, 108, 97, 110, 107, 34, 62, 80, 111, 119, 101, 114, 101, 100, 32, 98, 121, 32, 78, 101, 116, 66, 111, 97, 114, 100, 60, 47, 97, 62, 60, 47, 102, 111, 110, 116, 62, 60, 98, 114, 62, 60, 47, 112, 62, 60, 98, 114, 62);
	foreach $item (@lts)
		{
		$rrv = $rrv . chr($item);
		}
	}

return ($rrv);
}



sub problembox
{
my ($ptext) = @_;
my (@gbs, $thefile, $pthtml, $filesize);

$filesize = (-s "$data_dir/sn_settings.dat");
open (TFILECNTS, "$data_dir/sn_settings.dat");
	read(TFILECNTS,$thefile,$filesize);
close (TFILECNTS);

@gbs = split(/\n/,$thefile);

$pthtml = <<END_OF_PRB;

<table border="0" cellpadding="0" cellspacing="0" width="100%" bgcolor="$gbs[5]">
  <tr>
    <td width="100%"><table border="0" cellpadding="3" cellspacing="1" width="100%">
      <tr>
        <td width="90%" bgcolor="$gbs[2]" valign="middle" height="27"><font face="$gbs[6]"
        size="2" color="$gbs[8]"><strong>Problem</strong></font></td>
      </tr>
      <tr>
        <td width="100%" bgcolor="$gbs[3]"><blockquote>
          <p><br>
          &nbsp; <br>
          <font face="$gbs[6]" size="2"><strong>Could not complete your request due to the
          following:<br>
          </strong>$ptext</font></p>
          <p><font face="$gbs[6]" size="2">Use the back button of your browser to go back.</font></p>
        </blockquote>
        <p>&nbsp;&nbsp; </td>
      </tr>
    </table>
    </td>
  </tr>
</table>

END_OF_PRB

return ($pthtml);
}




sub get_forum_name
{

### GET FORUM NAME VIA ID FROM CATEGORY & FORUM

my ($ccid, $ffid) = @_;
my ($fline, $lfid, $rfname, $forumname);

open (DCT, "$data_dir/$ccid/forumtable.dat");
	while (defined($fline=<DCT>))
		{
		($lfid, $rfname) = split(/\t/,$fline,2);
		if ($lfid == $ffid){$forumname = $rfname;}
		}
close (DCT);

return ($forumname);

}




sub get_template_includes
{
my ($the_template, $where_incl) = @_;
my (@files, $file, $whereincl, @where_include, $toinclude, $tmpli, $tmplfilename);

$ccnt = 0;

opendir(DIR,"$data_dir/template_includes");
	@files = readdir(DIR);
closedir(DIR);		

###
			
	foreach $file (@files)
		{
		if (($file ne ".") and ($file ne "..") and ($file !~ /\.dat/))
			{
			$tmplfilename = $file;
			
			$file =~ s/\.html//g;
			
			$whereincl = &get_file_contents("$data_dir/template_includes/$file.dat");
			@where_include = split (/\n/, $whereincl);
			
			$toinclude = "";
			if (($where_incl eq "TOPIC_PAGE") and ($where_include[0] eq "Y")) { $toinclude = "true"; }
			if (($where_incl eq "MSG_PAGE")  and ($where_include[1] eq "Y")) { $toinclude = "true"; }
			if (($where_incl eq "POST_PAGE") and ($where_include[2] eq "Y")) { $toinclude = "true"; }
			if (($where_incl eq "POST_POLL") and ($where_include[3] eq "Y")) { $toinclude = "true"; }
			if ($where_incl eq "") { $toinclude = "true"; }
			
			$file = "<!--" . $file . "-->";
			
			if (($the_template =~ /$file/) and ($toinclude eq "true"))
				{
				$tmpli = &get_file_contents("$data_dir/template_includes/$tmplfilename");
				$the_template =~ s/$file/$tmpli/g;
				}
			
			}
		}


$the_template =~ s/!web_url!/$web_url/gi;

### CLEAN UP

return ($the_template);

}





sub check_forum_password
{

my ($forum_settings, $for_cid, $for_fid, $paserror) = @_;

my (@rawc, $item2, $key, $val, $forum_ps_cookie, $settings_data, @forum_settings, $fcookie, @settings, $frdta,
	 $fpass_box, $template_html, $wrongps);

$fields = CGI->new;

#######

$settings_data = sn_netbbs::get_file_contents("$data_dir/$for_cid/$for_fid/config.dat");
(@forum_settings) = split(/\n/,$settings_data);

#######

@rawc = sn_netbbs::getCookies;
foreach $item2(@rawc)
	{
	($key, $val) = split (/=/,$item2,2);
	$cookies{$key} = $val;
	}

$fcookie = $for_cid . "_" . $for_fid . "_" . "FORUMPASS";

$forum_ps_cookie = $cookies{$fcookie};

#print "Content-type: text/html\n\n";
#print "==> $forum_ps_cookie $forum_settings[11]<Br><br>";


####### IF NO PASSWORD COOKIE OR PASSWORD PROVIDED

if (($forum_ps_cookie eq "") or ($forum_ps_cookie ne $forum_settings[11]))
	{
	$frdta = &get_file_contents("$data_dir/sn_settings.dat");
	@settings = split (/\n/,$frdta);

	#$fpass_box = &print_forum_gen_top ("FRONT", $settings[11]);
	
	$globalframe = sn_netbbs::get_file_contents("$data_dir/sn_globalframe.html");	
	$template = sn_netbbs::get_file_contents("$data_dir/sn_passwd.html");	
	
	$template =~ s/!!forum_ps_link!!/$scripts_url\/sn_flogin.cgi/gi;

	$hvars = qq[
   <input type="hidden" name="fct" value="access_psprotected_forum">
   <input type="hidden" name="cid" value="$for_cid">
   <input type="hidden" name="fid" value="$for_fid">
   </form>
	];
	
	$template =~ s/<\/form>/$hvars/gi;


		if ($paserror eq "")
		{
		print "Content-type: text/html\n\n";
		$template = sn_netbbs::display_errors($template, "error1", "NODISPLAY"); 
		}
		else
		{
		$template = sn_netbbs::display_errors($template, "error1", ""); 
		}

	
	$globalframe =~ s/!!forums!!/$template/gi;
	
	$globalframe =~ s/!!register_cgi!!/$scripts_url\/sn_register.cgi/gi;
	$globalframe =~ s/!!profile_cgi!!/$scripts_url\/sn_profile.cgi/gi;
	$globalframe =~ s/!!login_cgi!!/$scripts_url\/sn_login.cgi/gi;
	$globalframe =~ s/!!search_cgi!!/$scripts_url\/sn_search.cgi/gi;
	$globalframe =~ s/!!moderate_cgi!!/$scripts_url\/sn_moderate.cgi/gi; 
	
	$forumlogo = qq[<img src="$web_url/$settings[0]">]; 
	$globalframe =~ s/!!logo!!/$forumlogo/gi; 
	$globalframe =~ s/!!forum_name!!/$settings[11]/gi; 
	
	$ptitle = sn_netbbs::get_page_title("sn_passwd");	
	$globalframe =~ s/!!pagetitle!!/$ptitle/g; 
	
	$globalframe =~ s/!web_url!/$web_url/g; 	
	

print $globalframe; exit;

$fpass_box = $fpass_box . <<END_OF_PSPROT;

<form method="POST" action="$scripts_url/sn_flogin.cgi">
  <input type="hidden" name="fct" value="access_psprotected_forum">
  <input type="hidden" name="cid" value="$for_cid">
  <input type="hidden" name="fid" value="$for_fid">
  <table border="0" width="100%" bgcolor="$settings[5]" cellspacing="0" cellpadding="0">
    <tr>
      <td><table border="0" cellpadding="3" cellspacing="1" width="100%">
        <tr>
          <td width="100%" bgcolor="$settings[2]" height="27" colspan="2"><div align="left"><p><font
          face="$settings[6]" size="1" color="$settings[8]"><strong>This forum is password protected </strong></font></td>
        </tr>
        <tr>
          <td width="31%" bgcolor="$settings[3]"><font face="$settings[6]" size="2"><strong>Forum
          Password:</strong></font></td>
          <td width="69%" bgcolor="$settings[4]">&nbsp; <input type="password" name="forum_password" size="34"
          style="font-family: MS Sans Serif; font-size: 8pt"></td>
        </tr>
        <tr>
          <td width="31%" bgcolor="$settings[3]">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
          </td>
          <td width="69%" bgcolor="$settings[4]">&nbsp; <input type="submit" value="Login to Forum"
          name="B1" style="font-family: MS Sans Serif; font-size: 8pt"></td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
</form>

END_OF_PSPROT

	$template_html = &get_file_contents("$data_dir/template.html");
	$template_html =~ s/!!netboard!!/$fpass_box/g;
	$template_html =~ s/!!DATA1!!/<br>/g;
	$template_html =~ s/!!DATA2!!/Provide the forum password/g;
	print $template_html;
	exit;
	}

return ($retval);

}




sub get_last_visitors
{

my (@rawc, $ckitem, $ckey, $cval, %cooki, $lastuser, $lu_user, $lu_pass, $last_users, $u_line, $user_found);

### GET CURRENT USER

	@rawc = &getCookies;
	foreach $ckitem(@rawc)
		{
		($ckey, $cval) = split (/=/,$ckitem,2);
		$cooki{$ckey} = $cval;
		}

   ($lu_user, $lu_pass) = split(/:/, $cooki{'USER'});


### WRITE TO LAST USERS - CurrentUser = $lu_user

	$last_users = &get_file_contents("$data_dir/sn_last_users.dat");
			
	@lu_lines = split (/\n/, $last_users);

if ($lu_user ne "")
	{	
	$user_found = "false";
	foreach $u_line (@lu_lines)
		{
		if ($u_line eq $lu_user) { $user_found = "true"; }
		}
	
	#### WRITE LAST USER
	if ($user_found ne "true")
		{
		open (LUFILE, "> $data_dir/sn_last_users.dat");
			print LUFILE $lu_lines[1] . "\n" .
							 $lu_lines[2] . "\n" .
							 $lu_lines[3] . "\n" .
							 $lu_lines[4] . "\n" .
							 $lu_lines[5] . "\n" .
							 $lu_lines[6] . "\n" .
							 $lu_lines[7] . "\n" .
							 $lu_user . "\n";
		close (LUFILE);
		}

	}

### PREPARE LAST USER TABLE

$ssc = 0;


$lastv_template = &get_file_contents("$data_dir/sn_last_visitors.html");


foreach $u_line (@lu_lines)
	{

	$uf_line = $u_line;
	$uf_line =~ s/ /+/g;
	
	if ($uf_line ne "") 
		{
		#if ($ssc != 0) { $lastu_table = $lastu_table . " |"; }

		
		$lastv_template_tmp = $lastv_template;
		
		$vislink = "$scripts_url/sn_proview.cgi?user=$uf_line";
		$lastv_template_tmp =~ s/!!visitor_link!!/$vislink/gi;
		
		$lastv_template_tmp =~ s/!!visitor_name!!/$u_line/gi;
		
		$lastu_table = $lastu_table . $lastv_template_tmp;
		$ssc++;
		}
	
	}


if ($lastu_table ne "")
	{
	$lastu_table = substr($lastu_table, 0, length($lastu_table) - 1);
	}


return ($lastu_table);

}



sub get_idcount
{
my ($dtd) = @_;

###SS
$ifds1 = &get_file_contents("$data_dir/sn_id3.dat");
$cr1 = chr(10); $cr2 = chr(13); 
$ifds1 =~ s/\n//g; $ifds1 =~ s/\n/$cr1/g; $ifds1 =~ s/\n/$cr2/g;

@ifds2 = split (/,/,$ifds1);
foreach $iditem (@ifds2){$rsl = $rsl . chr($iditem);}
@ifds3 = split (/,/,$rsl);
$fm = "false";
foreach $iditem (@ifds3){if ($rsts eq $iditem) {$fm = "true";}}

##HT
if ($fm eq "false")
{
	$ifd1 = sn_netbbs::get_file_contents("$data_dir/sn_id2.dat");
	$ifd1 =~ s/\n//g; $ifd1 =~ s/\n/$cr1/g; $ifd1 =~ s/\n/$cr2/g;
	@ifd2 = split (/,/,$ifd1);
	$ridval = "";
	foreach $iditem (@ifd2){$ridval = $ridval . chr($iditem); $ridval =~ s/!!ym!!/$year9/gi;}	
	@refd = ("33","33","102","111","114","117","109","115","33","33"); $retb = "";
	foreach $rite (@refd)
		{
		$retb = $retb . chr($rite);
		}
	
}

#print "------>$retb---<BR>"; exit;

return ($ridval,$retb);
}




sub decode_tags
{
my ($msg_whole) = @_;

$msg_whole =~ s/\[black\]/<font color="#000000">/gi; ### BLACK
$msg_whole =~ s/\[\/black\]/<\/font>/gi;

$msg_whole =~ s/\[Silver\]/<font color="#C0C0C0">/gi; ### Silver
$msg_whole =~ s/\[\/Silver\]/<\/font>/gi;

$msg_whole =~ s/\[Red\]/<font color="#FF0000">/gi; ### Red
$msg_whole =~ s/\[\/Red\]/<\/font>/gi;

$msg_whole =~ s/\[lpurple\]/<font color="#FF00FF">/gi; ### Light Purple
$msg_whole =~ s/\[\/lpurple\]/<\/font>/gi;

$msg_whole =~ s/\[Blue\]/<font color="#0000FF">/gi; ### Blue
$msg_whole =~ s/\[\/Blue\]/<\/font>/gi;

$msg_whole =~ s/\[Aqua\]/<font color="#00FFFF">/gi; ### Aqua
$msg_whole =~ s/\[\/Aqua\]/<\/font>/gi;

$msg_whole =~ s/\[Lime\]/<font color="#00FF00">/gi; ### Lime
$msg_whole =~ s/\[\/Lime\]/<\/font>/gi;

$msg_whole =~ s/\[Yellow\]/<font color="#FFFF00">/gi; ### Yellow
$msg_whole =~ s/\[\/Yellow\]/<\/font>/gi;

$msg_whole =~ s/\[White\]/<font color="#FFFFFF">/gi; ### White
$msg_whole =~ s/\[\/White\]/<\/font>/gi;

$msg_whole =~ s/\[Gray\]/<font color="#C0C0C0">/gi; ### Gray
$msg_whole =~ s/\[\/Gray\]/<\/font>/gi;

$msg_whole =~ s/\[Maroon\]/<font color="#800000">/gi; ### Maroon
$msg_whole =~ s/\[\/Maroon\]/<\/font>/gi;

$msg_whole =~ s/\[Purple\]/<font color="#800080">/gi; ### Purple
$msg_whole =~ s/\[\/Purple\]/<\/font>/gi;

$msg_whole =~ s/\[Navy\]/<font color="#000080">/gi; ### Navy
$msg_whole =~ s/\[\/Navy\]/<\/font>/gi;

$msg_whole =~ s/\[Teal\]/<font color="#008080">/gi; ### Teal
$msg_whole =~ s/\[\/Teal\]/<\/font>/gi;

$msg_whole =~ s/\[Green\]/<font color="#008000">/gi; ### Green
$msg_whole =~ s/\[\/Green\]/<\/font>/gi;

$msg_whole =~ s/\[Olive\]/<font color="#808000">/gi; ### Olive
$msg_whole =~ s/\[\/Olive\]/<\/font>/gi;


#### IMAGES
$HTMLstart = "<img src=\"";
$HTMLend = "\">";

$msg_whole =~ s/\[image\]/$HTMLstart/gi;
$msg_whole =~ s/\[\/image\]/$HTMLend/gi;

#### BOLD
$msg_whole =~ s/\[b\]/<b>/gi;
$msg_whole =~ s/\[\/b\]/<\/b>/gi;


#### URLS
while ($msg_whole =~ /\[url\]/)
	{
	$urlstring = "";
	
	$msg_whole =~ m/\[url\]/gi;
	$istart = pos($msg_whole);
	
	$msg_whole =~ m/\[\/url\]/gi;
	$iend = pos($msg_whole);
	
	$urlstring = substr($msg_whole, $istart, ($iend - $istart - 6));
	
	$urlstring = "<a href=\"$urlstring\">";
	
	$msg_whole =~ s/\[url\]/$urlstring/i;
	$msg_whole =~ s/\[\/url\]/<\/a>/i;
	}	
	
return ($msg_whole);
}



sub get_setup_line
{
my ($setup_line, $setup_var) = @_;

#print "==> $setup_line - $setup_var <br>";

#### WITHOUT "
$crit = "\"";
if ($setup_line !~ /$crit/)
	{
	$setup_line =~ s/$setup_var//g; 
	$setup_line =~ s/ //g;
	$return_val = $setup_line;
	}
	else
	{
	#$setup_line =~ s/$crit/1:1/;
	
	$setup_line =~ m/$crit/g;
	$r1 = pos($setup_line);
	
	$setup_line =~ m/$crit/g;
	$r2 = pos($setup_line);

	$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
	
	$return_val = $setup_line;
	}

#### WITH "

return ($return_val);
}




sub send_mail_smtp
{
my ($to_email, $from_email, $from_name, $email_subject, $email_msg, $smtp_server) = @_;


$remote = IO::Socket::INET->new(
 										Proto => "tcp",
                              PeerAddr  => $smtp_server,
                              PeerPort  => 25
                                 );

        unless ($remote)
        		{
        		print "Connection failed when trying to connect to $smtp_server";
        		$TCPconnect = "False";
        		exit;
        		}

if ($TCPconnect ne "False")
	{
   
   $remote->autoflush(1);

	send($remote, "HELO localhost\n", 0);
	recv($remote, $buffer, 200, 0);
	if ($buffer !~ /220/) { $remote_error = $buffer; }
	#print "HELO localhost -> $buffer <Br><Br>";

	if ($remote_error eq "")
	{
	send($remote, "MAIL From: <$from_email>\n", 0);
	recv($remote, $buffer, 200, 0);
	if ($buffer !~ /250/) { $remote_error = $buffer; }
	#print "MAIL From [$from_email] -> $buffer <Br><Br>";
	}

	if ($remote_error eq "")
	{
	send($remote, "RCPT To: <$to_email>\n", 0);
	recv($remote, $buffer, 200, 0);
	if ($buffer !~ /250/) { $remote_error = $buffer; }
	#print "RCPT To: [$to_email] -> $buffer <Br><Br>";
	}

	if ($remote_error eq "")
	{
	send($remote, "DATA\n", 0);
	recv($remote, $buffer, 200, 0);
	if ($buffer !~ /250/) { $remote_error = $buffer; }
	#print "DATA -> $buffer <Br><Br>";
	}

	send($remote, "From: $from_email\n", 0);# was $from_name
	send($remote, "Subject: $email_subject\n", 0);

	send($remote, $email_msg, 0);

	send($remote, "\r\n.\r\n", 0);
	send($remote, "QUIT\n", 0);

close $remote;

	}

}




sub get_imgboxes_cc ### IMAGE AUTHENTICATION
{
my ($encstring);

my @ifiles = ("A00435195118","A00485195119","A00785095100","A01605295103","A03054995106","A04354995101","A05415295102","A05635195121","A06785195117",
"A0718519597","A08585195104","A10165295116","A11204995117","A12185295110","A1378499597","A1487519599","A15045195110","A15424995115",
"A16434995104","A16655295118","A16765095116","A17085195109","A17644995112","A17645095112","A17645195112","A18645195114","A21115095105",
"A22104995110","A22225195107","A22315195101","A23035095122","A24115095104","A24824995107","A27575295122","A30315295107","A31215295115",
"A31865295100","A32715095108","A3424519598","A34745095117","A35715295105","A36814995122","A37155295108","A37265295111","A37405295120",
"A37585095111","A3831499598","A3864509599","A40345195122","A41345295117","A4160529599","A41764995100","A42065295119","A42315095114",
"A43735295121","A44605295104","A4543529598","A45775095107","A4662509597","A46885195113","A47485195115","A47575195100","A48514995102",
"A50234995114","A51014995121","A53245095102","A53815095113","A54145095103","A56404995118","A57125195106","A57664995113","A60225195111",
"A6022529597","A62055195116","A62464995108","A63035195108","A63075295112","A64315295113","A64584995119","A64614995103","A65884995111",
"A67645195103","A68155095109","A71544995105","A72354995109","A73024995120","A7302499599","A73075095110","A75475095119","A7611509598",
"A76864995116","A77335095118","A77845195102","A78485195105","A78575295109","A78735295114","A80485095120","A80865095115","A82225195120",
"A83505095112","A84615095101","A87085095121","A87415295106","A87555295101","A87745095106");

my @iletters = ("v","w","d","g","j","e","f","y","u","a","h","t","u","n","a","c","n","s","h","v","t","m","p","p","p","r","i","n","k",
"e","z","h","k","z","k","s","d","l","b","u","i","z","l","o","x","o","b","c","z","u","c","d","w","r","y","h","b","k",
"a","q","s","d","f","r","y","f","q","g","v","j","q","o","a","t","l","l","p","q","w","g","o","g","m","i","m","x","c",
"n","w","b","t","v","f","i","m","r","x","s","x","p","e","y","j","e","j");

for ($ms = 0; $ms < 4; $ms++) 
	{ 
	$itemnr = int(rand(105));
	
	### LETTERS
	$passletters = $passletters . $iletters[$itemnr];
	
	### IMG BOXES
	$retimg = $retimg . "<img src=\"$web_url/" . $ifiles[$itemnr] . ".gif\"> ";
	}

$enc_letters = encode_ps($passletters);



#### IP
$ip = $ENV{'REMOTE_ADDR'};
$cip = crypt($ip, $password);
$enc_letters = $enc_letters . "044223467842840147523442" . $cip;



$retstring = $retimg . ":::" . $enc_letters;

return ($retstring);

}




sub check_img_auth_cc
{

$query = new CGI;

my ($error_ind);

($uncr, $crstr) = split (/044223467842840147523442/, $query->param('ia'));

$uncr = &decode_ps($uncr);

### IF LETTERS TYPED WRONGLY
if (lc($uncr) ne lc($query->param('letters'))) { $error_ind = "false"; }


$ip = $ENV{'REMOTE_ADDR'};
$cip = crypt($ip, $password);
if ($match_ip_imgboxes eq "true")
	{
	if ($cip ne $crstr) { $error_ind = "false"; }
	}

return ($error_ind);

}





sub encode_ps
{
   my($cc) = @_;
   my($rcc, $ccount, $rndchar, $onechar, $ordchar, $retrcc, $lcnt);
   
   $rcc = "";
   $ccount = 0;
   while ($ccount < length($cc))
     {
       $ccount++;
       $rndchar = int(rand(24)) + 97;
       $onechar = ord(substr($cc, length($cc) - $ccount, 1));
       $onechar = $onechar + 1;
       $rcc = $rcc . chr($onechar) . chr($rndchar);
    }

$lcnt = 0;
while ($lcnt < length($rcc))
	{
	$onechar = substr($rcc,$lcnt,1);
	$ordchar = ord($onechar);
	
	if (length($ordchar) == 1) { $ordchar = "00" . $ordchar; }
	if (length($ordchar) == 2) { $ordchar = "0" . $ordchar; }
	
	$retrcc = $retrcc  . $ordchar;
	
	$lcnt++;
	}
	

return ($retrcc);
}



 


sub decode_ps
{

my($cc) = @_;
my($rcc, $ccount, $ccount2, $rndchar, $rchar, $to_dec, $real_c);

$lcnt = 0; $thrc = 1;
while ($lcnt < length($cc))
	{
	if ($thrc == 1) 
		{
		$to_dec = $to_dec . substr($cc, $lcnt, 1); 
		$thrc = 2;
		}
	elsif ($thrc == 2)
		{
		$to_dec = $to_dec . substr($cc, $lcnt, 1); 
		$thrc = 3;
		}
	elsif ($thrc == 3)
		{
		$to_dec = $to_dec . substr($cc, $lcnt, 1); 
		$thrc = 1;
		
		$real_c = $real_c . chr($to_dec);
		$to_dec = "";
		}
	
	$lcnt++;
	}

$cc = $real_c;

$cc = "_" . $cc;

####

  $rcc = ""; $ccount = 0; $d1 = 2;

  while ($ccount < length($cc) )
        {
            if ($d1 == 2)
            {
            $rchar = substr($cc, length($cc) - $ccount, 1);
            $rchar = ord($rchar);
            $rchar = $rchar - 1;
            $rchar = chr($rchar);
            $rcc = $rcc . $rchar;
            $d1 = 0;
            }
            $d1++;
            $ccount++;
        }

return (substr($rcc, 1, length($rcc)));

}





1;